#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "66625d4f94cdf2ecc7b7689ea147277ffe16f1c1";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "lexer";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"util\" as util",
  "import \"unicode\" as unicode",
  "import \"mgcollections\" as collections",
  "import \"errormessages\" as errormessages",
  "",
  "method padl(s, l, w) {",
  "    if (s.size >= l) then {",
  "        return s",
  "    }",
  "    var s' := s",
  "    while {s'.size < l} do {",
  "        s' := w ++ s'",
  "    }",
  "    return s'",
  "}",
  "",
  "def LexerClass = object {",
  "    method asString { \"LexerClass object\" }",
  "    method new {",
  "        var lineNumber := 1",
  "        var linePosition := 0",
  "        var startPosition := 1",
  "        var indentLevel := 0",
  "        var startLine := 1",
  "        var stringStart",
  "",
  "        class Token.new() {",
  "            def line = lineNumber",
  "            def indent = indentLevel",
  "            def linePos = startPosition",
  "",
  "            var next := false",
  "            var prev := false",
  "",
  "            method ==(other) {",
  "                if (other == false) then {",
  "                    false",
  "                } else {",
  "                    (other.line == line) && (other.linePos == linePos)",
  "                }",
  "            }",
  "        }",
  "",
  "        class IdentifierToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"identifier\"",
  "            def value = s",
  "            def size = s.size",
  "        }",
  "        class StringToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"string\"",
  "            def value = s",
  "            def size = linePosition - stringStart + 1",
  "        }",
  "        class MultiLineStringToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"string\"",
  "            def value = s",
  "            def size = s.size + 2",
  "            def line' = startLine",
  "            def linePos' = stringStart",
  "            method line is override { line' }",
  "            method linePos is override { linePos' }",
  "        }",
  "        class CommentToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"comment\"",
  "            def value = s",
  "            def size = s.size + 2",
  "        }",
  "        class LBraceToken.new {",
  "            inherits Token.new",
  "            def kind = \"lbrace\"",
  "            def value = \"\\{\"",
  "            def size = 1",
  "        }",
  "        class RBraceToken.new {",
  "            inherits Token.new",
  "            def kind = \"rbrace\"",
  "            def value = \"}\"",
  "            def size = 1",
  "        }",
  "        class LParenToken.new {",
  "            inherits Token.new",
  "            def kind = \"lparen\"",
  "            def value = \"(\"",
  "            def size = 1",
  "        }",
  "        class RParenToken.new {",
  "            inherits Token.new",
  "            def kind = \"rparen\"",
  "            def value = \")\"",
  "            def size = 1",
  "        }",
  "        class LSquareToken.new {",
  "            inherits Token.new",
  "            def kind = \"lsquare\"",
  "            def value = \"[\"",
  "            def size = 1",
  "        }",
  "        class RSquareToken.new {",
  "            inherits Token.new",
  "            def kind = \"rsquare\"",
  "            def value = \"]\"",
  "            def size = 1",
  "        }",
  "        class CommaToken.new {",
  "            inherits Token.new",
  "            def kind = \"comma\"",
  "            def value = \",\"",
  "            def size = 1",
  "        }",
  "        class ColonToken.new {",
  "            inherits Token.new",
  "            def kind = \"colon\"",
  "            def value = \":\"",
  "            def size = 1",
  "        }",
  "        class DotToken.new {",
  "            inherits Token.new",
  "            def kind = \"dot\"",
  "            def value = \".\"",
  "            def size = 1",
  "        }",
  "        class NumToken.new(v, b) {",
  "            inherits Token.new",
  "            def kind = \"num\"",
  "            def value = v",
  "            def base = b",
  "            def size = linePosition - startPosition",
  "        }",
  "        class KeywordToken.new(v) {",
  "            inherits Token.new",
  "            def kind = \"keyword\"",
  "            def value = v",
  "            def size = v.size",
  "        }",
  "        class OpToken.new(v) {",
  "            inherits Token.new",
  "            def kind = \"op\"",
  "            def value = v",
  "            def size = v.size",
  "        }",
  "        class ArrowToken.new {",
  "            inherits Token.new",
  "            def kind = \"arrow\"",
  "            def value = \"->\"",
  "            def size = 2",
  "        }",
  "        class BindToken.new {",
  "            inherits Token.new",
  "            def kind = \"bind\"",
  "            def value = \":=\"",
  "            def size = 2",
  "        }",
  "        class SemicolonToken.new {",
  "            inherits Token.new",
  "            def kind = \"semicolon\"",
  "            def value = \";\"",
  "            def size = 1",
  "        }",
  "        class LGenericToken.new {",
  "            inherits Token.new",
  "            def kind = \"lgeneric\"",
  "            def value = \"<\"",
  "            def size = 1",
  "        }",
  "        class RGenericToken.new {",
  "            inherits Token.new",
  "            def kind = \"rgeneric\"",
  "            def value = \">\"",
  "            def size = 1",
  "        }",
  "",
  "        object {",
  "            // When a new lexical class has begun, add to the tokens list",
  "            // the token corresponding to the previous accumulated data.",
  "            // mode is the previous lexical mode (a string), and accum the",
  "            // accumulated characters since that mode began. Modes are:",
  "",
  "            //   n           Whitespace       i   Identifier",
  "            //   \"           Quoted string    q   extended string",
  "            //   m           Number           o   Any operator",
  "            //   p           Pragma           d   Indentation",
  "            //   c           Comment",
  "            //   ,.{}()[]<>; The corresponding literal character",
  "            //",
  "            // There are three special cases for mode o. If accum is \"->\",",
  "            // \":=\", or \"=\", the corresponding special token is created.",
  "            // For mode i, a keyword token is created for an identifier",
  "            // whose name is a reserved keyword.",
  "            method modechange(tokens, mode, accum) {",
  "                var isDone := false",
  "                var tok := 0",
  "                if ((mode != \"n\") || (accum.size > 0)) then {",
  "                    if (mode == \"i\") then {",
  "                        tok := IdentifierToken.new(accum)",
  "                        if ((accum == \"object\") || (accum == \"method\")",
  "                            || (accum == \"var\") || (accum == \"type\")",
  "                            || (accum == \"import\") || (accum == \"class\")",
  "                            || (accum == \"return\") || (accum == \"def\")",
  "                            || (accum == \"inherits\") || (accum == \"is\")",
  "                            || (accum == \"dialect\") || (accum == \"factory\")) then {",
  "                            tok := KeywordToken.new(accum)",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    }",
  "                    if (mode == \"I\") then {",
  "                        tok := IdentifierToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"\\\"\") then {",
  "                        tok := StringToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"q\") then {",
  "                        tok := MultiLineStringToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"x\") then {",
  "                        ProgrammingError.raise \"obsolete Octet-token mode in lexer\\n\"",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \",\") then {",
  "                        tok := CommaToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \".\") then {",
  "                        tok := DotToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"\\{\") then {",
  "                        tok := LBraceToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"}\") then {",
  "                        tok := RBraceToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"(\") then {",
  "                        tok := LParenToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \")\") then {",
  "                        tok := RParenToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"[\") then {",
  "                        tok := LSquareToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    }",
  "                    if (mode == \"]\") then {",
  "                        tok := RSquareToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"<\") then {",
  "                        tok := LGenericToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \">\") then {",
  "                        tok := RGenericToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \";\") then {",
  "                        tok := SemicolonToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"m\") then {",
  "                        if ((tokens.size > 1).andAlso {tokens.last.kind == \"dot\"}) then {",
  "                            def dot = tokens.pop",
  "                            if (tokens.last.kind == \"num\") then {",
  "                                if (tokens.last.base == 10) then {",
  "                                    tok := tokens.pop",
  "                                    var decimal := makeNumToken(accum)",
  "                                    if(decimal.base == 10) then {",
  "                                        tok := NumToken.new(tok.value ++ \".\" ++ accum, 10)",
  "                                    } else {",
  "                                        def suggestions = []",
  "                                        var suggestion := errormessages.suggestion.new",
  "                                        suggestion.replaceRange(dot.linePos + 1, linePosition - 1)with(decimal.value)onLine(lineNumber)",
  "                                        suggestions.push(suggestion)",
  "                                        suggestion := errormessages.suggestion.new",
  "                                        suggestion.deleteRange(dot.linePos, linePosition - 1)onLine(lineNumber)",
  "                                        suggestions.push(suggestion)",
  "                                        errormessages.syntaxError(\"The fractional part of a number must be in base 10.\")atRange(",
  "                                            lineNumber, dot.linePos + 1, linePosition - 1)withSuggestions(suggestions)",
  "                                    }",
  "                                } else {",
  "                                    def suggestions = []",
  "                                    var suggestion := errormessages.suggestion.new",
  "                                    suggestion.replaceRange(tokens.last.linePos, dot.linePos - 1)with(tokens.last.value)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.deleteChar(dot.linePos)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A number in base {tokens.last.base} cannot have a fractional part.\")atRange(",
  "                                        lineNumber, dot.linePos, linePosition - 1)withSuggestions(suggestions)",
  "                                }",
  "                            } else {",
  "                                if(tokens.last.kind == \"string\") then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceChar(dot.linePos)with(\"++\")onLine(dot.line)",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'. \"",
  "                                        ++ \"To join a number to a string, use '++'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)withSuggestion(suggestion)",
  "                                } elseif((tokens.last.kind == \"op\") || (tokens.last.kind == \"bind\")) then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.insert(\"0\")atPosition(dot.linePos)onLine(dot.line)",
  "                                    errormessages.syntaxError(\"A number must have a digit before the decimal point.\")atPosition(",
  "                                        dot.line, dot.linePos)withSuggestion(suggestion)",
  "                                } elseif(tokens.last.kind == \"identifier\") then {",
  "                                    def suggestions = []",
  "                                    if(tokens.last.value == \"o\") then {",
  "                                        def suggestion = errormessages.suggestion.new",
  "                                        suggestion.replaceChar(tokens.last.linePos)with(\"0\")onLine(tokens.last.line)",
  "                                        suggestions.push(suggestion)",
  "                                    }",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceRange(dot.linePos, linePosition - 1)with(\"({accum})\")onLine(tokens.last.line)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)withSuggestions(suggestions)",
  "                                } else {",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)",
  "                                }",
  "                            }",
  "                        } else {",
  "                            tok := makeNumToken(accum)",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"o\") then {",
  "                        tok := OpToken.new(accum)",
  "                        if (accum == \"->\") then {",
  "                            tok := ArrowToken.new",
  "                        } elseif (accum == \":=\") then {",
  "                            tok := BindToken.new",
  "                        } elseif (accum == \":\") then {",
  "                            tok := ColonToken.new",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"d\") then {",
  "                        indentLevel := linePosition - 1",
  "                        isDone := true",
  "                    } elseif (mode == \"n\") then {",
  "                        isDone := true",
  "                    } elseif (mode == \"c\") then {",
  "                        def cmt = accum.substringFrom(3)to(accum.size)",
  "                        tokens.push(CommentToken.new(cmt))",
  "                        isDone := true",
  "                    } elseif (mode == \"p\") then {",
  "                        if (accum.substringFrom(1)to(8) == \"#pragma \") then {",
  "                            util.processExtension(",
  "                                accum.substringFrom(9)to(accum.size))",
  "                        }",
  "                    } elseif (isDone) then {",
  "                        //print(mode, accum, tokens)",
  "                    } else {",
  "                        errormessages.syntaxError(\"Lexing error: no handler for mode {mode} with accum {accum}.\")atPosition(lineNumber, linePosition)",
  "                    }",
  "                }",
  "                startPosition := linePosition",
  "            }",
  "",
  "            method fromBase(str, base) {",
  "                var val := 0",
  "                var i := 0",
  "                for (str) do {c->",
  "                    def n = c.ord",
  "                    val := val * base",
  "                    var inc := 0",
  "                    if ((n >= 48) && (n <= 57)) then {",
  "                        inc := n - 48 // 0",
  "                    } elseif((n >= 65) && (n <= 90)) then {",
  "                        inc := n - 55 // 'A' - 10",
  "                    } else {",
  "                        inc := n - 87 // 'a' - 10",
  "                    }",
  "                    if (inc >= base) then {",
  "                        if((str[1] == \"0\") && (inc < 16)) then {",
  "                            def suggestion = errormessages.suggestion.new",
  "                            suggestion.insert(\"x\")atPosition(linePosition - str.size + 1)onLine(lineNumber)",
  "                            errormessages.syntaxError(\"A number in base 16 must start with '0x'.\")atPosition(",
  "                                lineNumber, linePosition - str.size + 1)withSuggestion(suggestion)",
  "                        } else {",
  "                            def suggestion = errormessages.suggestion.new",
  "                            if(str.size == 1) then {",
  "                                suggestion.deleteRange(linePosition - str.size - 1, linePosition - 1)onLine(lineNumber)",
  "                            } else {",
  "                                suggestion.deleteChar(linePosition - str.size + i)onLine(lineNumber)",
  "                            }",
  "                            def validDigits = if(base <= 10) then {",
  "                                \"'0' to '{base - 1}'\"",
  "                            } else {",
  "                                \"'0' to '9', 'a' to '{unicode.create(87 + base)}'\"",
  "                            }",
  "                            errormessages.syntaxError(\"'{c}' is not a valid digit in base {base}. Valid digits are {validDigits}.\")atRange(",
  "                                lineNumber, linePosition - str.size + i, linePosition - str.size + i)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                    val := val + inc",
  "                    i := i + 1",
  "                }",
  "                val",
  "            }",
  "                    ",
  "            method hexdecchar(c) {",
  "            // Return the numeric value of the single hexadecimal digit c.",
  "                def AOrd = \"A\".ord",
  "                def aOrd = \"a\".ord",
  "                def zeroOrd = \"0\".ord",
  "                def cOrd = c.ord",
  "                if ( (cOrd >= AOrd) && (cOrd <= \"F\".ord) ) then {",
  "                    cOrd - AOrd + 10",
  "                } elseif { (cOrd >= aOrd) && (cOrd <= \"f\".ord) } then {",
  "                    cOrd - aOrd + 10",
  "                } elseif { (cOrd >= zeroOrd) && (cOrd <= \"9\".ord) } then {",
  "                    cOrd - zeroOrd",
  "                } else {",
  "                    errormessages.syntaxError(\"The character '{c}' must be a hexadecimal digit\")",
  "                        atRange(lineNumber, linePosition, linePosition)",
  "                }",
  "            }",
  "",
  "            method makeNumToken(accum) {",
  "                var base := 10",
  "                var baseSet := false",
  "                var sofar := \"\"",
  "                var i := 0",
  "                for (accum) do {c->",
  "                    if ((c == \"x\") && (!baseSet)) then {",
  "                        base := sofar.asNumber",
  "                        baseSet := true",
  "                        if (base == 0) then {",
  "                            base := 16",
  "                        }",
  "                        if((base < 2) || (base > 36)) then {",
  "                            def suggestions = []",
  "                            var suggestion := errormessages.suggestion.new",
  "                            suggestion.replaceChar(linePosition - accum.size + i)with(\"*\")onLine(lineNumber)",
  "                            suggestions.push(suggestion)",
  "                            suggestion := errormessages.suggestion.new",
  "                            suggestion.deleteRange(linePosition - accum.size, linePosition - accum.size + i)onLine(lineNumber)",
  "                            suggestions.push(suggestion)",
  "                            errormessages.syntaxError(\"Base {base} is not a valid numerical base.\")atRange(",
  "                                lineNumber, linePosition - accum.size, linePosition - accum.size + i - 1)withSuggestions(suggestions)",
  "                        }",
  "                        sofar := \"\"",
  "                    } else {",
  "                        sofar := sofar ++ c",
  "                    }",
  "                    i := i + 1",
  "                }",
  "                if(sofar == \"\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteRange(linePosition - accum.size + i - 1, linePosition - 1)onLine(lineNumber)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"0\")atPosition(linePosition)onLine(lineNumber)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"At least one digit must follow the 'x' in a number.\")atPosition(",
  "                        lineNumber, linePosition - accum.size + i)withSuggestions(suggestions)",
  "                }",
  "                NumToken.new(fromBase(sofar, base).asString, base)",
  "            }",
  "            // True if ov is a valid identifier character. Identifier",
  "            // characters are Unicode letters, Unicode numbers, apostrophe,",
  "            // and (currently) underscore.",
  "            method isidentifierchar(ov) {",
  "                if (unicode.isLetter(ov)) then {",
  "                    return true",
  "                }",
  "                if (unicode.isNumber(ov)) then {",
  "                    return true",
  "                }",
  "                if ((ov == 95) || (ov == 39)) then {",
  "                    // 95 is _, 39 is '",
  "                    true",
  "                } else {",
  "                    false",
  "                }",
  "            }",
  "",
  "            // True if c (with codepoint ordval) is a valid operator character.",
  "            method isoperatorchar(c, ordval) {",
  "                if ((c == \"-\") || (c == \"&\") || (c == \"|\") || (c == \":\")",
  "                    || (c == \"%\") || (c == \"^\") || (c == \"@\") || (c == \"?\")",
  "                    || (c == \"*\") || (c == \"/\") || (c == \"+\") || (c == \"!\")",
  "                    ) then {",
  "                    return true",
  "                }",
  "                if (unicode.isSymbolMathematical(ordval)) then {",
  "                    return true",
  "                } elseif (unicode.iscategory(c, \"So\")) then {",
  "                    return true",
  "                }",
  "                return false",
  "            }",
  "",
  "            // Read the program text from util.infile and return a list of",
  "            // tokens.",
  "            method lexfile(file) {",
  "                util.log_verbose(\"reading source.\")",
  "                def lines = []",
  "                def cLines = []",
  "                var line := \"\"",
  "                var cLine := \"\"",
  "                var source := \"\"",
  "                for(file.read) do { c ->",
  "                    if((c == \"\\n\") || (c == \"\\l\")) then {",
  "                        lines.push(line)",
  "                        cLines.push(cLine)",
  "                        line := \"\"",
  "                        cLine := \"\"",
  "                    } elseif(c == \"\\r\") then {",
  "                    } elseif(c == \"\\\\\") then {",
  "                        line := line ++ \"\\\\\"",
  "                        cLine := cLine ++ \"\\\\\\\\\"",
  "                    } elseif(c == \"\\\"\") then {",
  "                        line := line ++ \"\\\"\"",
  "                        cLine := cLine ++ \"\\\\\\\"\"",
  "                    } else {",
  "                        line := line ++ c",
  "                        cLine := cLine ++ c",
  "                    }",
  "                    source := source ++ c",
  "                }",
  "                if(line != \"\") then {",
  "                    lines.push(line)",
  "                    cLines.push(cLine)",
  "                }",
  "                util.lines := lines",
  "                util.cLines := cLines",
  "                lexinput(source)",
  "            }",
  "",
  "            method lexinput(input) {",
  "                // tokens is a doubly-linked list of tokens.",
  "                var tokens := object {",
  "                    var first := false",
  "                    var last := false",
  "                    var size' := 0",
  "",
  "                    method push(t) {",
  "                        if(first == false) then {",
  "                            first := t",
  "                            last := t",
  "                        } else {",
  "                            last.next := t",
  "                            t.prev := last",
  "                            last := t",
  "                        }",
  "                        size' := size' + 1",
  "                    }",
  "",
  "                    method pop {",
  "                        if(last != false) then {",
  "                            def popped = last",
  "                            last := last.prev",
  "                            if(last == false) then {",
  "                                first := false",
  "                            }",
  "                            size' := size' - 1",
  "                            popped",
  "                        }",
  "                    }",
  "",
  "                    method poll {",
  "                        if(first != false) then {",
  "                            def polled = first",
  "                            first := first.next",
  "                            if(first == false) then {",
  "                                last := false",
  "                            }",
  "                            size' := size' - 1",
  "                            polled",
  "                        }",
  "                    }",
  "",
  "                    method size {",
  "                        size' + 0",
  "                    }",
  "",
  "                    method iter {",
  "                        object {",
  "                            var n := first",
  "                            method havemore {",
  "                                n != false",
  "                            }",
  "                            method hasNext {",
  "                                n != false",
  "                            }",
  "                            method next {",
  "                                def ret = n",
  "                                n := n.next",
  "                                ret",
  "                            }",
  "                        }",
  "                    }",
  "",
  "                    method iterator {",
  "                        iter",
  "                    }",
  "                }",
  "",
  "                var mode := \"d\"",
  "                var newmode := mode",
  "                var inStr := false",
  "                var inBackticks := false",
  "                var backtickIdent := false",
  "                var accum := \"\"",
  "                var escaped := false",
  "                var prev := \"\"",
  "                var unichars := 0",
  "                var codepoint := 0",
  "                var interpdepth := 0",
  "                var interpString := false",
  "                var atStart := true",
  "                var newlineFound := false",
  "                linePosition := 0",
  "                util.log_verbose(\"lexing.\")",
  "                def badSeparator = unicode.pattern(\"Z\", 9)not(32, 160)",
  "                    // 32 is SPACE, and 160 NO-BREAK SPACE",
  "                def badControl =  unicode.pattern(\"C\")not(10, 13)",
  "                def selfModes = unicode.pattern(\"(\".ord, \")\".ord, \",\".ord,",
  "                    \".\".ord, \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord, \";\".ord)",
  "                def brackets = unicode.pattern(\"(\".ord, \")\".ord,",
  "                    \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord)",
  "                def identifierChar = unicode.pattern(\"L\", \"N\", 95, 39) // 95 = _, 39 = '",
  "                def digit = unicode.pattern(\"0\".ord, \"1\".ord, \"2\".ord, \"3\".ord,",
  "                    \"4\".ord, \"5\".ord, \"6\".ord, \"7\".ord, \"8\".ord, \"9\".ord)",
  "                def operatorChar = unicode.pattern(\"Sm\", \"So\",",
  "                    \"-\".ord, \"&\".ord, \"|\".ord, \":\".ord,",
  "                   \"%\".ord, \"^\".ord, \"@\".ord, \"?\".ord,",
  "                   \"*\".ord, \"/\".ord, \"+\".ord, \"!\".ord",
  "                    )",
  "                def iGTLT = unicode.pattern(\"i\".ord, \"<\".ord, \">\".ord)",
  "                def mainBlock = { c->",
  "                    var ct := \"\"",
  "                    var ordval := c.ord // String.ord gives the codepoint",
  "                    if (badSeparator.match(ordval).andAlso { mode != \"q\" }) then {",
  "                        // Character is whitespace, but not an ASCII space or",
  "                        // Unicode NO-BREAK SPACE.  For example, a tab",
  "                        def suggestion = errormessages.suggestion.new",
  "                        suggestion.replaceChar(linePosition)with(\" \")onLine(lineNumber)",
  "                        if (ordval == 9) then {",
  "                            if (inStr) then {",
  "                                suggestion.replaceRange(linePosition, linePosition)",
  "                                    with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                    onLine(lineNumber)",
  "                                errormessages.syntaxError(\"tabs cannot be \"",
  "                                    ++ \"written in the source code; \"",
  "                                    ++ \"use the Unicode escape \\\\u\"",
  "                                    ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                    ++ \" instead\")",
  "                                    atRange(lineNumber, linePosition, linePosition)",
  "                                    withSuggestion(suggestion)",
  "                            }",
  "                            errormessages.syntaxError(\"Tabs are not allowed; use spaces instead.\")atRange(lineNumber,",
  "                                linePosition, linePosition)withSuggestion(suggestion)",
  "                        } else {",
  "                            if (mode == \"\\\"\") then {",
  "                                suggestion.replaceRange(linePosition, linePosition)",
  "                                    with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                    onLine(lineNumber)",
  "                                errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                    ++ \"is not a valid whitespace character\"",
  "                                    ++ \" and cannot be \"",
  "                                    ++ \"written in the source code; \"",
  "                                    ++ \"use the Unicode escape \\\\u\"",
  "                                    ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                    ++ \" instead\")",
  "                                    atRange(lineNumber, linePosition, linePosition)",
  "                                    withSuggestion(suggestion)",
  "                            }",
  "                            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                ++ \"is not a valid whitespace character; use spaces instead.\")atRange(lineNumber,",
  "                                linePosition, linePosition)withSuggestion(suggestion)",
  "                        }",
  "                    } elseif {badControl.match(ordval).andAlso { mode != \"q\" }} then {",
  "                        // Character is a control character other than",
  "                        // carriage return or line feed.",
  "                        def suggestion = errormessages.suggestion.new",
  "                        if (inStr) then {",
  "                            suggestion.replaceRange(linePosition, linePosition)",
  "                                with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                onLine(lineNumber)",
  "                            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                ++ \"is a control character and cannot be \"",
  "                                ++ \"written in the source code; \"",
  "                                ++ \"use the Unicode escape \\\\u\"",
  "                                ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                ++ \" instead\")",
  "                                atRange(lineNumber, linePosition, linePosition)",
  "                                withSuggestion(suggestion)",
  "                        }",
  "                        suggestion.deleteChar(linePosition)onLine(lineNumber)",
  "                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                            ++ \"is a control character and cannot be written in the source code; consider using spaces instead.\")atRange(lineNumber,",
  "                            linePosition, linePosition)withSuggestion(suggestion)",
  "                    }",
  "                    if (atStart) then {",
  "                        if (linePosition == 1) then {",
  "                            if (c == \"#\") then {",
  "                                mode := \"p\"",
  "                                newmode := mode",
  "                            } else {",
  "                                atStart := false",
  "                            }",
  "                        }",
  "                    }",
  "                    if (inStr) then {",
  "",
  "                    } elseif ( (mode != \"c\") && (mode != \"p\") ) then {",
  "                        // Not in a comment or pragma, so look for a mode.",
  "                        if ((c == \" \") && (mode != \"d\")) then {",
  "                            newmode := \"n\"",
  "                        }",
  "                        if (c == \"\\\"\") then {",
  "                            // Beginning of a string",
  "                            newmode := \"\\\"\"",
  "                            inStr := true",
  "                            stringStart := linePosition",
  "                        } elseif { c == \"‹\" } then {",
  "                            // Beginning of a multi-line string",
  "                            newmode := \"q\"",
  "                            inStr := true",
  "                            startLine := lineNumber",
  "                            stringStart := linePosition",
  "                        } elseif { identifierChar.match(ordval) } then {",
  "                            newmode := \"i\"",
  "                        }",
  "                        if (digit.match(ordval)) then {",
  "                            // This may overwrite newmode := \"i\"",
  "                            // established 5 lines up",
  "                            if (mode != \"i\") then {",
  "                                newmode := \"m\"",
  "                            }",
  "                        }",
  "                        if (mode == \"m\") then {",
  "                            if ((ordval >= 97) && (ordval <=122)) then {",
  "                                newmode := \"m\"",
  "                            } else {",
  "                                if ((ordval >= 65) && (ordval <= 90)) then {",
  "                                    newmode := \"m\"",
  "                                }",
  "                            }",
  "                        }",
  "                        if ((mode == \"i\") && (c == \"<\")) then {",
  "                            newmode := \"<\"",
  "                        } elseif (iGTLT.match(mode)",
  "                            && (c == \">\")) then {",
  "                            if (mode == \">\") then {",
  "                                modechange(tokens, mode, accum)",
  "                            }",
  "                            newmode := \">\"",
  "                        } elseif (operatorChar.match(ordval)) then {",
  "                            newmode := \"o\"",
  "                        }",
  "                        if (selfModes.match(ordval)) then {",
  "                            newmode := c",
  "                        }",
  "                        if (c == \"#\") then {",
  "                            if (mode != \"p\") then {",
  "                                if(util.lines.at(lineNumber).substringFrom(1)to(7) == \"#pragma\") then {",
  "                                    if(tokens.size == 0) then {",
  "                                        def suggestion = errormessages.suggestion.new",
  "                                        suggestion.addLine(1, util.lines.at(lineNumber))",
  "                                        suggestion.addLine(lineNumber, \"\")",
  "                                        errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                            lineNumber)withSuggestion(suggestion)",
  "                                    } else {",
  "                                        errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                            lineNumber)",
  "                                    }",
  "                                } else {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceChar(linePosition)with(\"//\")onLine(lineNumber)",
  "                                    errormessages.syntaxError(\"'#' is not allowed here. For a comment use '//'.\")atRange(",
  "                                        lineNumber, linePosition, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                            }",
  "                        }",
  "                        if (c == \".\") then {",
  "                            if (accum == \".\") then {",
  "                                // Special handler for .. operator",
  "                                mode := \"o\"",
  "                                newmode := mode",
  "                            }",
  "                            if (accum == \"..\") then {",
  "                                // Special handler for ... identifier",
  "                                mode := \"n\"",
  "                                newmode := mode",
  "                                modechange(tokens, \"i\", \"...\")",
  "                                accum := \"\"",
  "                            }",
  "                        }",
  "                        if (c == \"/\") then {",
  "                            if (accum == \"/\") then {",
  "                                // Start of comment",
  "                                mode := \"c\"",
  "                                newmode := mode",
  "                            }",
  "                        }",
  "                        if (mode == \"n\") then {",
  "                            if (mode == newmode) then {",
  "                                if (unicode.isSeparator(ordval).not) then {",
  "                                    if (unicode.isControl(ordval).not) then {",
  "                                        if (ordval != 10) then {",
  "                                            if (ordval != 13) then {",
  "                                                if (ordval != 32) then {",
  "                                                    if (c != \".\") then{",
  "                                                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                                            ++ \"is not a valid character; use spaces instead.\")atRange(",
  "                                                            lineNumber, linePosition, linePosition)",
  "                                                    }",
  "                                                }",
  "                                            }",
  "                                        }",
  "                                    }",
  "                                }",
  "                            }",
  "                        }",
  "                    }",
  "                    if (mode == \"\\\"\") then {",
  "                        if (c == \"\\\"\") then {",
  "                            if (escaped.not) then {",
  "                                // End of string literal",
  "                                newmode := \"n\"",
  "                                inStr := false",
  "                                if (interpString) then {",
  "                                    modechange(tokens, mode, accum)",
  "                                    modechange(tokens, \")\", \")\")",
  "                                    mode := newmode",
  "                                    interpString := false",
  "                                }",
  "                            }",
  "                        }",
  "                    } elseif {mode == \"q\"} then {",
  "                        if (c == \"›\") then {",
  "                            //end of literal",
  "                            newmode := \"n\"",
  "                            inStr := false",
  "                        }",
  "                    }",
  "                    if (newmode != mode) then {",
  "                        // This character is the beginning of a different",
  "                        // lexical mode - process the old one now.",
  "                        modechange(tokens, mode, accum)",
  "                        if (interpdepth > 0) then {",
  "                            if (newmode == \"}\") then {",
  "                                // Find the position of the opening brace to ",
  "                                // check if the interpolation is empty.",
  "                                if (util.lines.at(tokens.last.line)[tokens.last.linePos] == \"\\{\") then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.deleteRange(linePosition - 1, linePosition)onLine(lineNumber)",
  "                                    errormessages.syntaxError(\"A string interpolation cannot be empty.\")atRange(",
  "                                        lineNumber, tokens.last.linePos, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                                modechange(tokens, \")\", \")\")",
  "                                modechange(tokens, \"o\", \"++\")",
  "                                newmode := \"\\\"\"",
  "                                inStr := true",
  "                                interpdepth := interpdepth - 1",
  "                            }",
  "                        }",
  "                        mode := newmode",
  "                        if (inStr) then {",
  "                            // String accum should skip the opening quote, but",
  "                            // other modes' should include their first",
  "                            // character.",
  "                            accum := \"\"",
  "                        } else {",
  "                            accum := c",
  "                        }",
  "                        if (brackets.match(mode)) then {",
  "                            modechange(tokens, mode, accum)",
  "                            mode := \"n\"",
  "                            newmode := \"n\"",
  "                            accum := \"\"",
  "                        }",
  "                    } elseif (mode == \"\\\"\") then {",
  "                        if (c == \"\\n\") then {",
  "                            if (interpdepth > 0) then {",
  "                                // Find closest {.",
  "                                var line := lineNumber",
  "                                var i := util.lines.at(line).size",
  "                                while { util.lines.at(line)[i] != \"\\{\" } do {",
  "                                    i := i - 1",
  "                                    if(i == 0) then {",
  "                                        lineNumber := line - 1",
  "                                        i := util.lines.at(line).size",
  "                                    }",
  "                                }",
  "                                def suggestions = []",
  "                                var suggestion := errormessages.suggestion.new",
  "                                suggestion.insert(\"\\\\\")atPosition(i)onLine(line)",
  "                                suggestions.push(suggestion)",
  "                                if((line == lineNumber) && (i == (linePosition - 2))) then {",
  "                                    errormessages.syntaxError(\"For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                        line, i)withSuggestions(suggestions)",
  "                                } else {",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.insert(\"}\")atPosition(linePosition - accum.size - 1)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A string interpolation must end with a '}'. For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                        lineNumber, linePosition - accum.size - 1)withSuggestions(suggestions)",
  "                                }",
  "                            } else {",
  "                                def errorLine = util.lines.at(lineNumber)",
  "                                def nextLine = if(util.lines.size >= (lineNumber + 1)) then {",
  "                                    util.lines.at(lineNumber + 1)",
  "                                } else {",
  "                                    \"\"",
  "                                }",
  "                                // Count the number of literal quotes in the next line.",
  "                                var i := 1",
  "                                var count := 0",
  "                                while { i <= nextLine.size } do {",
  "                                    if(nextLine[i] == \"\\\"\") then { count := count + 1 }",
  "                                    elseif(nextLine[i] == \"\\\\\") then { i := i + 1 }",
  "                                    i := i + 1",
  "                                }",
  "                                if ((count % 2) == 1) then {",
  "                                    def suggestions = []",
  "                                    var suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ nextLine)",
  "                                    suggestion.addLine(lineNumber + 1, \"\")",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                    suggestion.addLine(lineNumber + 1, \"    ++ \\\"\" ++ nextLine)",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\\n\" ++ nextLine)",
  "                                    suggestion.addLine(lineNumber + 1, \"\")",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A string must end with a '\\\"'. To insert a newline in a string use '\\\\n'. \"",
  "                                        ++ \"To split a string over multiple lines use '++' to join strings together.\")atRange(",
  "                                        lineNumber, linePosition, linePosition)withSuggestions(suggestions)",
  "                                } else {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                    errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                                        lineNumber, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                            }",
  "                        }",
  "                        if (escaped) then {",
  "                            if (c == \"n\") then {",
  "                                // Newline escape",
  "                                accum := accum ++ \"\\u000a\"",
  "                            } elseif (c == \"u\") then {",
  "                                // Beginning of a four-digit Unicode escape",
  "                                // (for a BMP codepoint).",
  "                                unichars := 4",
  "                                codepoint := 0",
  "                            } elseif (c == \"U\") then {",
  "                                // Beginning of a six-digit Unicode escape",
  "                                // (for a general codepoint).",
  "                                unichars := 6",
  "                                codepoint := 0",
  "                            } elseif (c == \"t\") then {",
  "                                // Tab escape",
  "                                accum := accum ++ \"\\u0009\"",
  "                            } elseif (c == \"r\") then {",
  "                                // Carriage return escape",
  "                                accum := accum ++ \"\\u000d\"",
  "                            } elseif (c == \"b\") then {",
  "                                // Backspace escape",
  "                                accum := accum ++ \"\\u0008\"",
  "                            } elseif (c == \"l\") then {",
  "                                // LINE SEPARATOR escape",
  "                                accum := accum ++ \"\\u2028\"",
  "                            } elseif (c == \"f\") then {",
  "                                // Form feed/page down escape",
  "                                accum := accum ++ \"\\u000c\"",
  "                            } elseif (c == \"e\") then {",
  "                                // Escape escape",
  "                                accum := accum ++ \"\\u001b\"",
  "                            } elseif (c == \"_\") then {",
  "                                // non-breaking space",
  "                                accum := accum ++ \"\\u00a0\"",
  "                            } else {",
  "                                // For any other character preceded by \\,",
  "                                // insert it literally.",
  "                                accum := accum ++ c",
  "                            }",
  "                            escaped := false",
  "                        } elseif (c == \"\\\\\") then {",
  "                            // Begin an escape sequence",
  "                            escaped := true",
  "                        } elseif (unichars > 0) then {",
  "                            // There are still hex digits to read for a",
  "                            // Unicode escape. Use the current character",
  "                            // as a hex digit and update the codepoint",
  "                            // being calculated with its value.",
  "                            unichars := unichars - 1",
  "                            codepoint := codepoint * 16",
  "                            codepoint := codepoint + hexdecchar(c)",
  "                            if (unichars == 0) then {",
  "                                // At the end of the sequence construct",
  "                                // the character in the unicode library.",
  "                                accum := accum ++ unicode.create(codepoint)",
  "                            }",
  "                        } elseif (c == \"\\{\") then {",
  "                            if (interpString.not) then {",
  "                                modechange(tokens, \"(\", \"(\")",
  "                                interpString := true",
  "                            }",
  "                            modechange(tokens, mode, accum)",
  "                            modechange(tokens, \"o\", \"++\")",
  "                            modechange(tokens, \"(\", \"(\")",
  "                            mode := \"n\"",
  "                            newmode := \"n\"",
  "                            accum := \"\"",
  "                            inStr:= false",
  "                            interpdepth := interpdepth + 1",
  "                        } else {",
  "                            accum := accum ++ c",
  "                        }",
  "                    } elseif ((c == \"\\n\") || (c == \"\\r\") || (c == \"\\l\")) then {",
  "                        newlineFound := true",
  "                        if (mode == \"q\") then {",
  "                            accum := accum ++ c",
  "                        } else {",
  "                            // Linebreaks terminate any open tokens",
  "                            newlineFound := true",
  "                            modechange(tokens, mode, accum)",
  "                            mode := \"d\"",
  "                            newmode := \"d\"",
  "                            accum := \"\"",
  "                        }",
  "                    } else {",
  "                        accum := accum ++ c",
  "                    }",
  "                    if (accum == \"...\") then {",
  "                        if (mode == \"o\") then {",
  "                            modechange(tokens, \"i\", \"...\")",
  "                            newmode := \"n\"",
  "                            mode := newmode",
  "                            accum := \"\"",
  "                        }",
  "                    }",
  "                    if (newlineFound) then {",
  "                        // Linebreaks increment the line counter and insert a",
  "                        // special \"line\" token, which the parser can use to",
  "                        // track the origin of AST nodes for later error",
  "                        // reporting.",
  "                        newlineFound := false",
  "                        lineNumber := lineNumber + 1",
  "                        linePosition := 0",
  "                        startPosition := 1",
  "                    }",
  "                }",
  "                for (input) do { c ->",
  "                    linePosition := linePosition + 1",
  "                    if (c == \" \") then {",
  "                        if (mode == \"d\") then {",
  "                        } else {",
  "                            if (mode != \"n\") then {",
  "                                mainBlock.apply(c)",
  "                            }",
  "                        }",
  "                    } else {",
  "                        mainBlock.apply(c)",
  "                    }",
  "                    prev := c",
  "                }",
  "                linePosition := linePosition + 1",
  "                if (inStr) then {",
  "                    if (mode == \"\\\"\") then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        suggestion.addLine(lineNumber, util.lines.at(lineNumber) ++ \"\\\"\")",
  "                        errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                            lineNumber, linePosition)withSuggestion(suggestion)",
  "                    } elseif {mode == \"q\"} then {",
  "                        errormessages.syntaxError(\"A multi-line string must end with a '›'.\\nString opened on line {startLine} and unclosed at end of input.\")",
  "                            atRange(startLine, stringStart, util.lines.at(startLine).size)",
  "                    }",
  "                }",
  "                modechange(tokens, mode, accum)",
  "                tokens",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method Lexer {",
  "    LexerClass",
  "}",
  NULL
};
Object reader_lexer_outer_26(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_36(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_39(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_line_40(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_indent_41(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_linePos_42(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_next_43(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_lexer_next_43(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_lexer_prev_44(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_lexer_prev_44(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_lexer_outer_73(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_76(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_77(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_78(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_79(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_87(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_90(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_91(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_92(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_93(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_109(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_line_39__113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_linePos_39__114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_lexer_outer_132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_135(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_136(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_137(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_138(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_150(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_154(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_155(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_156(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_164(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_167(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_168(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_183(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_184(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_192(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_195(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_196(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_197(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_198(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_206(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_209(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_210(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_211(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_212(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_220(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_223(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_224(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_225(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_226(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_248(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_268(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_276(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_279(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_280(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_281(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_base_282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_size_283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_outer_292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_311(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_312(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_320(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_323(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_324(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_325(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_326(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_354(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_362(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_365(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_366(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_368(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_382(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_390(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_1819(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_first_1820(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_first_1820(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_last_1821(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_lexer_last_1821(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_lexer_size_39__1822(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_lexer_size_39__1822(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_lexer_outer_1930(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_n_1931(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_n_1931(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_util;
Object module_util_init();
Object module_unicode;
Object module_unicode_init();
Object module_mgcollections;
Object module_mgcollections_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass25;
static Object strlit28;
static ClassData objclass35;
static ClassData objclass38;
static ClassData objclass72;
static ClassData objclass75;
static Object strlit82;
static ClassData objclass86;
static ClassData objclass89;
static Object strlit96;
static ClassData objclass105;
static ClassData objclass108;
static Object strlit123;
static ClassData objclass131;
static ClassData objclass134;
static Object strlit141;
static ClassData objclass149;
static ClassData objclass152;
static Object strlit159;
static Object strlit160;
static ClassData objclass163;
static ClassData objclass166;
static Object strlit173;
static Object strlit174;
static ClassData objclass177;
static ClassData objclass180;
static Object strlit187;
static Object strlit188;
static ClassData objclass191;
static ClassData objclass194;
static Object strlit201;
static Object strlit202;
static ClassData objclass205;
static ClassData objclass208;
static Object strlit215;
static Object strlit216;
static ClassData objclass219;
static ClassData objclass222;
static Object strlit229;
static Object strlit230;
static ClassData objclass233;
static ClassData objclass236;
static Object strlit243;
static Object strlit244;
static ClassData objclass247;
static ClassData objclass250;
static Object strlit257;
static Object strlit258;
static ClassData objclass261;
static ClassData objclass264;
static Object strlit271;
static Object strlit272;
static ClassData objclass275;
static ClassData objclass278;
static Object strlit286;
static ClassData objclass291;
static ClassData objclass294;
static Object strlit301;
static ClassData objclass305;
static ClassData objclass308;
static Object strlit315;
static ClassData objclass319;
static ClassData objclass322;
static Object strlit329;
static Object strlit330;
static ClassData objclass333;
static ClassData objclass336;
static Object strlit343;
static Object strlit344;
static ClassData objclass347;
static ClassData objclass350;
static Object strlit357;
static Object strlit358;
static ClassData objclass361;
static ClassData objclass364;
static Object strlit371;
static Object strlit372;
static ClassData objclass375;
static ClassData objclass378;
static Object strlit385;
static Object strlit386;
static ClassData objclass389;
static Object strlit404;
static Object strlit410;
static Object strlit419;
static Object strlit425;
static Object strlit431;
static Object strlit437;
static Object strlit443;
static Object strlit449;
static Object strlit455;
static Object strlit461;
static Object strlit467;
static Object strlit473;
static Object strlit479;
static Object strlit484;
static Object strlit507;
static Object strlit519;
static Object strlit531;
static Object strlit543;
static Object strlit547;
static Object strlit557;
static Object strlit569;
static Object strlit581;
static Object strlit593;
static Object strlit605;
static Object strlit617;
static Object strlit629;
static Object strlit641;
static Object strlit653;
static Object strlit665;
static Object strlit677;
static Object strlit689;
static Object strlit697;
static Object strlit716;
static Object strlit748;
static Object strlit794;
static Object strlit842;
static Object strlit850;
static Object strlit862;
static Object strlit876;
static Object strlit882;
static Object strlit884;
static Object strlit896;
static Object strlit905;
static Object strlit918;
static Object strlit925;
static Object strlit933;
static Object strlit943;
static Object strlit959;
static Object strlit979;
static Object strlit983;
static Object strlit994;
static Object strlit1003;
static Object strlit1020;
static Object strlit1028;
static Object strlit1036;
static Object strlit1044;
static Object strlit1056;
static Object strlit1068;
static Object strlit1075;
static Object strlit1091;
static Object strlit1096;
static Object strlit1113;
static Object strlit1118;
static Object strlit1122;
static Object strlit1193;
static Object strlit1204;
static Object strlit1216;
static Object strlit1269;
static Object strlit1277;
static Object strlit1281;
static Object strlit1291;
static Object strlit1296;
static Object strlit1301;
static Object strlit1306;
static Object strlit1310;
static Object strlit1347;
static Object strlit1350;
static Object strlit1353;
static Object strlit1361;
static Object strlit1381;
static Object strlit1401;
static Object strlit1415;
static Object strlit1419;
static Object strlit1426;
static Object strlit1437;
static Object strlit1479;
static Object strlit1507;
static Object strlit1511;
static Object strlit1532;
static Object strlit1547;
static Object strlit1581;
static Object strlit1586;
static Object strlit1629;
static Object strlit1635;
static Object strlit1641;
static Object strlit1647;
static Object strlit1653;
static Object strlit1659;
static Object strlit1665;
static Object strlit1671;
static Object strlit1677;
static Object strlit1683;
static Object strlit1689;
static Object strlit1694;
static Object strlit1715;
static Object strlit1721;
static Object strlit1725;
static Object strlit1726;
static Object strlit1727;
static Object strlit1736;
static Object strlit1741;
static Object strlit1749;
static Object strlit1751;
static Object strlit1755;
static Object strlit1760;
static Object strlit1764;
static Object strlit1769;
static Object strlit1775;
static Object strlit1779;
static Object strlit1784;
static Object strlit1804;
static ClassData objclass1818;
static ClassData objclass1929;
static Object strlit1966;
static Object strlit1970;
static Object strlit1972;
static Object strlit1982;
static Object strlit1985;
static Object strlit1991;
static Object strlit1997;
static Object strlit2000;
static Object strlit2003;
static Object strlit2006;
static Object strlit2009;
static Object strlit2012;
static Object strlit2015;
static Object strlit2018;
static Object strlit2021;
static Object strlit2026;
static Object strlit2029;
static Object strlit2032;
static Object strlit2035;
static Object strlit2038;
static Object strlit2041;
static Object strlit2045;
static Object strlit2046;
static Object strlit2052;
static Object strlit2055;
static Object strlit2058;
static Object strlit2061;
static Object strlit2064;
static Object strlit2067;
static Object strlit2070;
static Object strlit2073;
static Object strlit2076;
static Object strlit2079;
static Object strlit2083;
static Object strlit2084;
static Object strlit2086;
static Object strlit2089;
static Object strlit2092;
static Object strlit2095;
static Object strlit2098;
static Object strlit2101;
static Object strlit2104;
static Object strlit2107;
static Object strlit2110;
static Object strlit2113;
static Object strlit2116;
static Object strlit2119;
static Object strlit2124;
static Object strlit2127;
static Object strlit2130;
static Object strlit2135;
static Object strlit2143;
static Object strlit2155;
static Object strlit2165;
static Object strlit2173;
static Object strlit2180;
static Object strlit2186;
static Object strlit2194;
static Object strlit2202;
static Object strlit2205;
static Object strlit2207;
static Object strlit2214;
static Object strlit2218;
static Object strlit2223;
static Object strlit2231;
static Object strlit2238;
static Object strlit2244;
static Object strlit2252;
static Object strlit2260;
static Object strlit2263;
static Object strlit2266;
static Object strlit2269;
static Object strlit2272;
static Object strlit2280;
static Object strlit2288;
static Object strlit2294;
static Object strlit2308;
static Object strlit2311;
static Object strlit2319;
static Object strlit2327;
static Object strlit2333;
static Object strlit2345;
static Object strlit2359;
static Object strlit2367;
static Object strlit2374;
static Object strlit2380;
static Object strlit2388;
static Object strlit2396;
static Object strlit2399;
static Object strlit2402;
static Object strlit2405;
static Object strlit2413;
static Object strlit2421;
static Object strlit2427;
static Object strlit2442;
static Object strlit2445;
static Object strlit2453;
static Object strlit2461;
static Object strlit2467;
static Object strlit2482;
static Object strlit2485;
static Object strlit2494;
static Object strlit2499;
static Object strlit2506;
static Object strlit2511;
static Object strlit2515;
static Object strlit2519;
static Object strlit2522;
static Object strlit2529;
static Object strlit2532;
static Object strlit2541;
static Object strlit2548;
static Object strlit2551;
static Object strlit2555;
static Object strlit2570;
static Object strlit2584;
static Object strlit2589;
static Object strlit2594;
static Object strlit2598;
static Object strlit2603;
static Object strlit2612;
static Object strlit2617;
static Object strlit2622;
static Object strlit2630;
static Object strlit2635;
static Object strlit2640;
static Object strlit2670;
static Object strlit2673;
static Object strlit2676;
static Object strlit2683;
static Object strlit2686;
static Object strlit2690;
static Object strlit2695;
static Object strlit2698;
static Object strlit2703;
static Object strlit2706;
static Object strlit2710;
static Object strlit2711;
static Object strlit2713;
static Object strlit2717;
static Object strlit2722;
static Object strlit2725;
static Object strlit2730;
static Object strlit2764;
static Object strlit2769;
static Object strlit2772;
static Object strlit2780;
static Object strlit2788;
static Object strlit2794;
static Object strlit2803;
static Object strlit2808;
static Object strlit2814;
static Object strlit2822;
static Object strlit2823;
static Object strlit2830;
static Object strlit2835;
static Object strlit2838;
static Object strlit2855;
static Object strlit2860;
static Object strlit2887;
static Object strlit2894;
static Object strlit2895;
static Object strlit2898;
static Object strlit2899;
static Object strlit2901;
static Object strlit2912;
static Object strlit2920;
static Object strlit2922;
static Object strlit2924;
static Object strlit2928;
static Object strlit2933;
static Object strlit2951;
static Object strlit2992;
static Object strlit3011;
static Object strlit3019;
static Object strlit3033;
static Object strlit3068;
static Object strlit3084;
static Object strlit3095;
static Object strlit3135;
static Object strlit3146;
static Object strlit3157;
static Object strlit3171;
static Object strlit3181;
static Object strlit3187;
static Object strlit3189;
static Object strlit3198;
static Object strlit3203;
static Object strlit3208;
static Object strlit3212;
static Object strlit3218;
static Object strlit3227;
static Object strlit3236;
static Object strlit3240;
static Object strlit3246;
static Object strlit3250;
static Object strlit3256;
static Object strlit3260;
static Object strlit3266;
static Object strlit3270;
static Object strlit3276;
static Object strlit3280;
static Object strlit3286;
static Object strlit3290;
static Object strlit3296;
static Object strlit3300;
static Object strlit3312;
static Object strlit3351;
static Object strlit3358;
static Object strlit3359;
static Object strlit3366;
static Object strlit3367;
static Object strlit3370;
static Object strlit3371;
static Object strlit3373;
static Object strlit3375;
static Object strlit3377;
static Object strlit3393;
static Object strlit3399;
static Object strlit3404;
static Object strlit3413;
static Object strlit3424;
static Object strlit3426;
static Object strlit3428;
static Object strlit3436;
static Object strlit3441;
static Object strlit3445;
static Object strlit3446;
static Object strlit3448;
static Object strlit3451;
static Object strlit3476;
static Object strlit3481;
static Object strlit3486;
static Object strlit3504;
static Object strlit3513;
static Object strlit3522;
static Object strlit3526;
static Object strlit3531;
static Object strlit3535;
Object meth_lexer__apply9(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_l = getfromclosure(closure, 0);
  Object *var_s_39_ = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  int op_slot_right_10 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe12 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s_39_ (depth = 7)
  partcv[0] = 0;
  Object call13 = callmethod(*var_s_39_, "size",
    1, partcv, params);
  gc_frame_end(callframe12);
// compiled call node returning call13 (depth = 6)
// compiled member node returning call13 (depth = 5)
  int op_slot_left_10 = gc_frame_newslot(call13);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult14 = callmethod(call13, "<", 1, partcv, params);
// compiled op node returning opresult14 (depth = 4)
  gc_frame_end(frame);
  return opresult14;
}
Object meth_lexer__apply17(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s_39_ = getfromclosure(closure, 0);
  Object *var_w = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s_39_ (depth = 6)
  int op_slot_right_18 = gc_frame_newslot(*var_s_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_w (depth = 6)
  int op_slot_left_18 = gc_frame_newslot(*var_w);
  params[0] = *var_s_39_;
  partcv[0] = 1;
  Object opresult20 = callmethod(*var_w, "++", 1, partcv, params);
// compiled op node returning opresult20 (depth = 5)
  *var_s_39_ = opresult20;
  if (opresult20 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_padl0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "padl");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method padl");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for padl (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_w = &(stackframe->slots[2]);
  *var_w = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for padl");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s'");
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  int op_slot_right_2 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call5 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe4);
// compiled call node returning call5 (depth = 5)
// compiled member node returning call5 (depth = 4)
  int op_slot_left_2 = gc_frame_newslot(call5);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult6 = callmethod(call5, ">=", 1, partcv, params);
// compiled op node returning opresult6 (depth = 3)
  Object if1 = done;
  if (istrue(opresult6)) {
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  return *var_s;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if1 = undefined;
  } else {
  }
// compiled if node returning if1 (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  *var_s_39_ = *var_s;
  if (*var_s == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8 = alloc_Block(NULL, NULL, "lexer", 14);
  gc_frame_newslot(block8);
// method _apply
  block_savedest(block8);
  Object closure9 = createclosure(3, "_apply");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_l);
  addtoclosure(closure9, var_s_39_);
  addtoclosure(closure9, selfslot);
  struct UserObject *uo9 = (struct UserObject*)block8;
  uo9->data[0] = (Object)closure9;
  Method *meth_meth_lexer__apply9 = addmethod2pos(block8, "_apply", &meth_lexer__apply9, 0);
  int argcv_meth_lexer__apply9[] = {0};
  meth_meth_lexer__apply9->type = alloc_MethodType(1, argcv_meth_lexer__apply9);
  meth_meth_lexer__apply9->definitionModule = modulename;
  meth_meth_lexer__apply9->definitionLine = 10;
// compiled block node returning block8 (depth = 3)
  gc_frame_newslot(block8);
// starting to compile block node (depth = 3)
  Object block16 = alloc_Block(NULL, NULL, "lexer", 14);
  gc_frame_newslot(block16);
// method _apply
  block_savedest(block16);
  Object closure17 = createclosure(3, "_apply");
  setclosureframe(closure17, stackframe);
  addtoclosure(closure17, var_s_39_);
  addtoclosure(closure17, var_w);
  addtoclosure(closure17, selfslot);
  struct UserObject *uo17 = (struct UserObject*)block16;
  uo17->data[0] = (Object)closure17;
  Method *meth_meth_lexer__apply17 = addmethod2pos(block16, "_apply", &meth_lexer__apply17, 0);
  int argcv_meth_lexer__apply17[] = {0};
  meth_meth_lexer__apply17->type = alloc_MethodType(1, argcv_meth_lexer__apply17);
  meth_meth_lexer__apply17->definitionModule = modulename;
  meth_meth_lexer__apply17->definitionLine = 14;
// compiled block node returning block16 (depth = 3)
  gc_frame_newslot(block16);
// call case 5: prelude request
  params[0] = block8;
  params[1] = block16;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call23 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7);
// compiled call node returning call23 (depth = 2)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s_39_ (depth = 3)
  return *var_s_39_;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_Lexer24(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Lexer");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_LexerClass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Lexer (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for Lexer");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_LexerClass (depth = 2)
  gc_frame_end(frame);
  return *var_LexerClass;
}
Object meth_lexer_asString27(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit28 == NULL) {
    strlit28 = alloc_String("LexerClass object");
    gc_root(strlit28);
  }
// compiled string node returning strlit28 (depth = 3)
  gc_frame_end(frame);
  return strlit28;
}
Object meth_lexer__61__61_45(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool48 = alloc_Boolean(0);
// compiled identifier node returning bool48 (depth = 8)
  int op_slot_right_47 = gc_frame_newslot(bool48);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  int op_slot_left_47 = gc_frame_newslot(*var_other);
  params[0] = bool48;
  partcv[0] = 1;
  Object opresult50 = callmethod(*var_other, "==", 1, partcv, params);
// compiled op node returning opresult50 (depth = 7)
  Object if46 = done;
  if (istrue(opresult50)) {
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool51 = alloc_Boolean(0);
// compiled identifier node returning bool51 (depth = 7)
    gc_frame_newslot(bool51);
    if46 = bool51;
  } else {
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe54 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call55 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe54);
// compiled call node returning call55 (depth = 10)
// compiled member node returning call55 (depth = 9)
  int op_slot_right_53 = gc_frame_newslot(call55);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe57 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_other (depth = 11)
  partcv[0] = 0;
  Object call58 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe57);
// compiled call node returning call58 (depth = 10)
// compiled member node returning call58 (depth = 9)
  int op_slot_left_53 = gc_frame_newslot(call58);
  params[0] = call55;
  partcv[0] = 1;
  Object opresult59 = callmethod(call58, "==", 1, partcv, params);
// compiled op node returning opresult59 (depth = 8)
  int op_slot_right_52 = gc_frame_newslot(opresult59);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe62 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call63 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe62);
// compiled call node returning call63 (depth = 10)
// compiled member node returning call63 (depth = 9)
  int op_slot_right_61 = gc_frame_newslot(call63);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe65 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_other (depth = 11)
  partcv[0] = 0;
  Object call66 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe65);
// compiled call node returning call66 (depth = 10)
// compiled member node returning call66 (depth = 9)
  int op_slot_left_61 = gc_frame_newslot(call66);
  params[0] = call63;
  partcv[0] = 1;
  Object opresult67 = callmethod(call66, "==", 1, partcv, params);
// compiled op node returning opresult67 (depth = 8)
  int op_slot_left_52 = gc_frame_newslot(opresult67);
  params[0] = opresult59;
  partcv[0] = 1;
  Object opresult68 = callmethod(opresult67, "&&", 1, partcv, params);
// compiled op node returning opresult68 (depth = 7)
    gc_frame_newslot(opresult68);
    if46 = opresult68;
  }
// compiled if node returning if46 (depth = 6)
  gc_frame_end(frame);
  return if46;
}
Object meth_lexer_new37(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject38 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj38 = alloc_userobj2(8,7, objclass38);
  gc_frame_newslot(obj38);
if (objclass38 == NULL) {
  glfree(obj38->class->name);
  obj38->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj38, self, 0);
  addmethodreal(obj38,"outer", &reader_lexer_outer_39);
  Object oldself38 = self;
  struct StackFrameObject *oldstackframe38 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe38);
  gc_frame_newslot((Object)stackframe);
  self = obj38;
  Object *oldselfslot38 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter38 = (*(struct UserObject *)self).data[0], lowerouter38 = thisouter38;
  if (inheritingObject38) {
    struct UserObject *inho38 = (struct UserObject *)inheritingObject38;
    while (inho38->super != GraceDefaultObject) inho38 = (struct UserObject *)inho38->super;
    inho38->super = obj38;
    self = inheritingObject38;
    *selfslot = self;
    lowerouter38 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter38;
  }
if (objclass38 == NULL) {
  Method *reader40 = addmethodrealflags(obj38, "line",&reader_lexer_line_40, MFLAG_DEF);
  reader40->definitionModule = modulename;
  reader40->definitionLine = 32;
}
adddatum2(obj38, alloc_Undefined(), 1);
if (objclass38 == NULL) {
  Method *reader41 = addmethodrealflags(obj38, "indent",&reader_lexer_indent_41, MFLAG_DEF);
  reader41->definitionModule = modulename;
  reader41->definitionLine = 33;
}
adddatum2(obj38, alloc_Undefined(), 2);
if (objclass38 == NULL) {
  Method *reader42 = addmethodrealflags(obj38, "linePos",&reader_lexer_linePos_42, MFLAG_DEF);
  reader42->definitionModule = modulename;
  reader42->definitionLine = 35;
}
adddatum2(obj38, alloc_Undefined(), 3);
if (objclass38 == NULL) {
  Method *reader43 = addmethodrealflags(obj38, "next",&reader_lexer_next_43, 0);
  Method *writer43 = addmethodrealflags(obj38, "next:=",&writer_lexer_next_43, 0);
  reader43->definitionModule = modulename;
  writer43->definitionModule = modulename;
  reader43->definitionLine = 36;
  writer43->definitionLine = 36;
}
obj38->flags |= OFLAG_MUTABLE;
adddatum2(obj38, alloc_Undefined(), 4);
if (objclass38 == NULL) {
  Method *reader44 = addmethodrealflags(obj38, "prev",&reader_lexer_prev_44, 0);
  Method *writer44 = addmethodrealflags(obj38, "prev:=",&writer_lexer_prev_44, 0);
  reader44->definitionModule = modulename;
  writer44->definitionModule = modulename;
  reader44->definitionLine = 38;
  writer44->definitionLine = 38;
}
obj38->flags |= OFLAG_MUTABLE;
adddatum2(obj38, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo45 = (struct UserObject*)obj38;
  uo45->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_45 = addmethod2pos(obj38, "==", &meth_lexer__61__61_45, 6);
  int argcv_meth_lexer__61__61_45[] = {1};
  meth_meth_lexer__61__61_45->type = alloc_MethodType(1, argcv_meth_lexer__61__61_45);
  meth_meth_lexer__61__61_45->definitionModule = modulename;
  meth_meth_lexer__61__61_45->definitionLine = 38;
  sourceObject = obj38;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  adddatum2(obj38, *var_lineNumber, 1);
  sourceObject = obj38;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indentLevel (depth = 6)
  adddatum2(obj38, *var_indentLevel, 2);
  sourceObject = obj38;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  adddatum2(obj38, *var_startPosition, 3);
  sourceObject = obj38;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 6)
  adddatum2(obj38, bool69, 4);
  sourceObject = obj38;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool70 = alloc_Boolean(0);
// compiled identifier node returning bool70 (depth = 6)
  adddatum2(obj38, bool70, 5);
  sourceObject = obj38;
objclass38 = obj38->class;
  objclass38->definitionModule = modulename;
  objclass38->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter38;
  self = oldself38;
  selfslot = oldselfslot38;
  stackframe = oldstackframe38;
  gc_frame_end(frame);
  return obj38;
}
Object meth_lexer_new37_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject38 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj38 = alloc_userobj2(8,7, objclass38);
  gc_frame_newslot(obj38);
if (objclass38 == NULL) {
  glfree(obj38->class->name);
  obj38->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj38, self, 0);
  addmethodreal(obj38,"outer", &reader_lexer_outer_39);
  Object oldself38 = self;
  struct StackFrameObject *oldstackframe38 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe38);
  gc_frame_newslot((Object)stackframe);
  self = obj38;
  Object *oldselfslot38 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter38 = (*(struct UserObject *)self).data[0], lowerouter38 = thisouter38;
  if (inheritingObject38) {
    struct UserObject *inho38 = (struct UserObject *)inheritingObject38;
    while (inho38->super != GraceDefaultObject) inho38 = (struct UserObject *)inho38->super;
    inho38->super = obj38;
    self = inheritingObject38;
    *selfslot = self;
    lowerouter38 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter38;
  }
if (objclass38 == NULL) {
  Method *reader40 = addmethodrealflags(obj38, "line",&reader_lexer_line_40, MFLAG_DEF);
  reader40->definitionModule = modulename;
  reader40->definitionLine = 32;
}
adddatum2(obj38, alloc_Undefined(), 1);
if (objclass38 == NULL) {
  Method *reader41 = addmethodrealflags(obj38, "indent",&reader_lexer_indent_41, MFLAG_DEF);
  reader41->definitionModule = modulename;
  reader41->definitionLine = 33;
}
adddatum2(obj38, alloc_Undefined(), 2);
if (objclass38 == NULL) {
  Method *reader42 = addmethodrealflags(obj38, "linePos",&reader_lexer_linePos_42, MFLAG_DEF);
  reader42->definitionModule = modulename;
  reader42->definitionLine = 35;
}
adddatum2(obj38, alloc_Undefined(), 3);
if (objclass38 == NULL) {
  Method *reader43 = addmethodrealflags(obj38, "next",&reader_lexer_next_43, 0);
  Method *writer43 = addmethodrealflags(obj38, "next:=",&writer_lexer_next_43, 0);
  reader43->definitionModule = modulename;
  writer43->definitionModule = modulename;
  reader43->definitionLine = 36;
  writer43->definitionLine = 36;
}
obj38->flags |= OFLAG_MUTABLE;
adddatum2(obj38, alloc_Undefined(), 4);
if (objclass38 == NULL) {
  Method *reader44 = addmethodrealflags(obj38, "prev",&reader_lexer_prev_44, 0);
  Method *writer44 = addmethodrealflags(obj38, "prev:=",&writer_lexer_prev_44, 0);
  reader44->definitionModule = modulename;
  writer44->definitionModule = modulename;
  reader44->definitionLine = 38;
  writer44->definitionLine = 38;
}
obj38->flags |= OFLAG_MUTABLE;
adddatum2(obj38, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo45 = (struct UserObject*)obj38;
  uo45->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_45 = addmethod2pos(obj38, "==", &meth_lexer__61__61_45, 6);
  int argcv_meth_lexer__61__61_45[] = {1};
  meth_meth_lexer__61__61_45->type = alloc_MethodType(1, argcv_meth_lexer__61__61_45);
  meth_meth_lexer__61__61_45->definitionModule = modulename;
  meth_meth_lexer__61__61_45->definitionLine = 38;
  sourceObject = obj38;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  adddatum2(obj38, *var_lineNumber, 1);
  sourceObject = obj38;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indentLevel (depth = 6)
  adddatum2(obj38, *var_indentLevel, 2);
  sourceObject = obj38;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  adddatum2(obj38, *var_startPosition, 3);
  sourceObject = obj38;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 6)
  adddatum2(obj38, bool69, 4);
  sourceObject = obj38;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool70 = alloc_Boolean(0);
// compiled identifier node returning bool70 (depth = 6)
  adddatum2(obj38, bool70, 5);
  sourceObject = obj38;
objclass38 = obj38->class;
  objclass38->definitionModule = modulename;
  objclass38->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter38;
  self = oldself38;
  selfslot = oldselfslot38;
  stackframe = oldstackframe38;
  gc_frame_end(frame);
  return obj38;
}
Object meth_lexer_new74(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject75 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj75 = alloc_userobj2(4,5, objclass75);
  gc_frame_newslot(obj75);
if (objclass75 == NULL) {
  glfree(obj75->class->name);
  obj75->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj75, self, 0);
  addmethodreal(obj75,"outer", &reader_lexer_outer_76);
  Object oldself75 = self;
  struct StackFrameObject *oldstackframe75 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe75);
  gc_frame_newslot((Object)stackframe);
  self = obj75;
  Object *oldselfslot75 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter75 = (*(struct UserObject *)self).data[0], lowerouter75 = thisouter75;
  if (inheritingObject75) {
    struct UserObject *inho75 = (struct UserObject *)inheritingObject75;
    while (inho75->super != GraceDefaultObject) inho75 = (struct UserObject *)inho75->super;
    inho75->super = obj75;
    self = inheritingObject75;
    *selfslot = self;
    lowerouter75 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter75;
  }
if (objclass75 == NULL) {
  Method *reader77 = addmethodrealflags(obj75, "kind",&reader_lexer_kind_77, MFLAG_DEF);
  reader77->definitionModule = modulename;
  reader77->definitionLine = 50;
}
adddatum2(obj75, alloc_Undefined(), 1);
if (objclass75 == NULL) {
  Method *reader78 = addmethodrealflags(obj75, "value",&reader_lexer_value_78, MFLAG_DEF);
  reader78->definitionModule = modulename;
  reader78->definitionLine = 51;
}
adddatum2(obj75, alloc_Undefined(), 2);
if (objclass75 == NULL) {
  Method *reader79 = addmethodrealflags(obj75, "size",&reader_lexer_size_79, MFLAG_DEF);
  reader79->definitionModule = modulename;
  reader79->definitionLine = 52;
}
adddatum2(obj75, alloc_Undefined(), 3);
  sourceObject = obj75;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe80 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call81 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe80);
// compiled call node returning call81 (depth = 6)
  struct UserObject *obj75_uo = (struct UserObject *)obj75;
  obj75_uo->super = call81;
  sourceObject = obj75;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit82 == NULL) {
    strlit82 = alloc_String("identifier");
    gc_root(strlit82);
  }
// compiled string node returning strlit82 (depth = 6)
  adddatum2(obj75, strlit82, 1);
  sourceObject = obj75;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj75, *var_s, 2);
  sourceObject = obj75;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe83 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call84 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe83);
// compiled call node returning call84 (depth = 7)
// compiled member node returning call84 (depth = 6)
  adddatum2(obj75, call84, 3);
objclass75 = obj75->class;
  objclass75->definitionModule = modulename;
  objclass75->definitionLine = 47;
  (*(struct UserObject *)self).data[0] = lowerouter75;
  self = oldself75;
  selfslot = oldselfslot75;
  stackframe = oldstackframe75;
  gc_frame_end(frame);
  return obj75;
}
Object meth_lexer_new74_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject75 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj75 = alloc_userobj2(4,5, objclass75);
  gc_frame_newslot(obj75);
if (objclass75 == NULL) {
  glfree(obj75->class->name);
  obj75->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj75, self, 0);
  addmethodreal(obj75,"outer", &reader_lexer_outer_76);
  Object oldself75 = self;
  struct StackFrameObject *oldstackframe75 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe75);
  gc_frame_newslot((Object)stackframe);
  self = obj75;
  Object *oldselfslot75 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter75 = (*(struct UserObject *)self).data[0], lowerouter75 = thisouter75;
  if (inheritingObject75) {
    struct UserObject *inho75 = (struct UserObject *)inheritingObject75;
    while (inho75->super != GraceDefaultObject) inho75 = (struct UserObject *)inho75->super;
    inho75->super = obj75;
    self = inheritingObject75;
    *selfslot = self;
    lowerouter75 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter75;
  }
if (objclass75 == NULL) {
  Method *reader77 = addmethodrealflags(obj75, "kind",&reader_lexer_kind_77, MFLAG_DEF);
  reader77->definitionModule = modulename;
  reader77->definitionLine = 50;
}
adddatum2(obj75, alloc_Undefined(), 1);
if (objclass75 == NULL) {
  Method *reader78 = addmethodrealflags(obj75, "value",&reader_lexer_value_78, MFLAG_DEF);
  reader78->definitionModule = modulename;
  reader78->definitionLine = 51;
}
adddatum2(obj75, alloc_Undefined(), 2);
if (objclass75 == NULL) {
  Method *reader79 = addmethodrealflags(obj75, "size",&reader_lexer_size_79, MFLAG_DEF);
  reader79->definitionModule = modulename;
  reader79->definitionLine = 52;
}
adddatum2(obj75, alloc_Undefined(), 3);
  sourceObject = obj75;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe80 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call81 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe80);
// compiled call node returning call81 (depth = 6)
  struct UserObject *obj75_uo = (struct UserObject *)obj75;
  obj75_uo->super = call81;
  sourceObject = obj75;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit82 == NULL) {
    strlit82 = alloc_String("identifier");
    gc_root(strlit82);
  }
// compiled string node returning strlit82 (depth = 6)
  adddatum2(obj75, strlit82, 1);
  sourceObject = obj75;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj75, *var_s, 2);
  sourceObject = obj75;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe83 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call84 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe83);
// compiled call node returning call84 (depth = 7)
// compiled member node returning call84 (depth = 6)
  adddatum2(obj75, call84, 3);
objclass75 = obj75->class;
  objclass75->definitionModule = modulename;
  objclass75->definitionLine = 47;
  (*(struct UserObject *)self).data[0] = lowerouter75;
  self = oldself75;
  selfslot = oldselfslot75;
  stackframe = oldstackframe75;
  gc_frame_end(frame);
  return obj75;
}
Object meth_lexer_new88(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_stringStart = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject89 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj89 = alloc_userobj2(4,5, objclass89);
  gc_frame_newslot(obj89);
if (objclass89 == NULL) {
  glfree(obj89->class->name);
  obj89->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj89, self, 0);
  addmethodreal(obj89,"outer", &reader_lexer_outer_90);
  Object oldself89 = self;
  struct StackFrameObject *oldstackframe89 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe89);
  gc_frame_newslot((Object)stackframe);
  self = obj89;
  Object *oldselfslot89 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter89 = (*(struct UserObject *)self).data[0], lowerouter89 = thisouter89;
  if (inheritingObject89) {
    struct UserObject *inho89 = (struct UserObject *)inheritingObject89;
    while (inho89->super != GraceDefaultObject) inho89 = (struct UserObject *)inho89->super;
    inho89->super = obj89;
    self = inheritingObject89;
    *selfslot = self;
    lowerouter89 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter89;
  }
if (objclass89 == NULL) {
  Method *reader91 = addmethodrealflags(obj89, "kind",&reader_lexer_kind_91, MFLAG_DEF);
  reader91->definitionModule = modulename;
  reader91->definitionLine = 56;
}
adddatum2(obj89, alloc_Undefined(), 1);
if (objclass89 == NULL) {
  Method *reader92 = addmethodrealflags(obj89, "value",&reader_lexer_value_92, MFLAG_DEF);
  reader92->definitionModule = modulename;
  reader92->definitionLine = 57;
}
adddatum2(obj89, alloc_Undefined(), 2);
if (objclass89 == NULL) {
  Method *reader93 = addmethodrealflags(obj89, "size",&reader_lexer_size_93, MFLAG_DEF);
  reader93->definitionModule = modulename;
  reader93->definitionLine = 58;
}
adddatum2(obj89, alloc_Undefined(), 3);
  sourceObject = obj89;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe94 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call95 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe94);
// compiled call node returning call95 (depth = 6)
  struct UserObject *obj89_uo = (struct UserObject *)obj89;
  obj89_uo->super = call95;
  sourceObject = obj89;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit96 == NULL) {
    strlit96 = alloc_String("string");
    gc_root(strlit96);
  }
// compiled string node returning strlit96 (depth = 6)
  adddatum2(obj89, strlit96, 1);
  sourceObject = obj89;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj89, *var_s, 2);
  sourceObject = obj89;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num98 = alloc_Float64(1);
// compiled num node returning num98 (depth = 7)
  int op_slot_right_97 = gc_frame_newslot(num98);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stringStart (depth = 8)
  int op_slot_right_100 = gc_frame_newslot(*var_stringStart);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_100 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_stringStart;
  partcv[0] = 1;
  Object diff102 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff102 (depth = 7)
  int op_slot_left_97 = gc_frame_newslot(diff102);
  params[0] = num98;
  partcv[0] = 1;
  Object sum103 = callmethod(diff102, "+", 1, partcv, params);
// compiled op node returning sum103 (depth = 6)
  adddatum2(obj89, sum103, 3);
objclass89 = obj89->class;
  objclass89->definitionModule = modulename;
  objclass89->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter89;
  self = oldself89;
  selfslot = oldselfslot89;
  stackframe = oldstackframe89;
  gc_frame_end(frame);
  return obj89;
}
Object meth_lexer_new88_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_stringStart = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject89 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj89 = alloc_userobj2(4,5, objclass89);
  gc_frame_newslot(obj89);
if (objclass89 == NULL) {
  glfree(obj89->class->name);
  obj89->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj89, self, 0);
  addmethodreal(obj89,"outer", &reader_lexer_outer_90);
  Object oldself89 = self;
  struct StackFrameObject *oldstackframe89 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe89);
  gc_frame_newslot((Object)stackframe);
  self = obj89;
  Object *oldselfslot89 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter89 = (*(struct UserObject *)self).data[0], lowerouter89 = thisouter89;
  if (inheritingObject89) {
    struct UserObject *inho89 = (struct UserObject *)inheritingObject89;
    while (inho89->super != GraceDefaultObject) inho89 = (struct UserObject *)inho89->super;
    inho89->super = obj89;
    self = inheritingObject89;
    *selfslot = self;
    lowerouter89 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter89;
  }
if (objclass89 == NULL) {
  Method *reader91 = addmethodrealflags(obj89, "kind",&reader_lexer_kind_91, MFLAG_DEF);
  reader91->definitionModule = modulename;
  reader91->definitionLine = 56;
}
adddatum2(obj89, alloc_Undefined(), 1);
if (objclass89 == NULL) {
  Method *reader92 = addmethodrealflags(obj89, "value",&reader_lexer_value_92, MFLAG_DEF);
  reader92->definitionModule = modulename;
  reader92->definitionLine = 57;
}
adddatum2(obj89, alloc_Undefined(), 2);
if (objclass89 == NULL) {
  Method *reader93 = addmethodrealflags(obj89, "size",&reader_lexer_size_93, MFLAG_DEF);
  reader93->definitionModule = modulename;
  reader93->definitionLine = 58;
}
adddatum2(obj89, alloc_Undefined(), 3);
  sourceObject = obj89;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe94 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call95 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe94);
// compiled call node returning call95 (depth = 6)
  struct UserObject *obj89_uo = (struct UserObject *)obj89;
  obj89_uo->super = call95;
  sourceObject = obj89;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit96 == NULL) {
    strlit96 = alloc_String("string");
    gc_root(strlit96);
  }
// compiled string node returning strlit96 (depth = 6)
  adddatum2(obj89, strlit96, 1);
  sourceObject = obj89;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj89, *var_s, 2);
  sourceObject = obj89;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num98 = alloc_Float64(1);
// compiled num node returning num98 (depth = 7)
  int op_slot_right_97 = gc_frame_newslot(num98);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stringStart (depth = 8)
  int op_slot_right_100 = gc_frame_newslot(*var_stringStart);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_100 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_stringStart;
  partcv[0] = 1;
  Object diff102 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff102 (depth = 7)
  int op_slot_left_97 = gc_frame_newslot(diff102);
  params[0] = num98;
  partcv[0] = 1;
  Object sum103 = callmethod(diff102, "+", 1, partcv, params);
// compiled op node returning sum103 (depth = 6)
  adddatum2(obj89, sum103, 3);
objclass89 = obj89->class;
  objclass89->definitionModule = modulename;
  objclass89->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter89;
  self = oldself89;
  selfslot = oldselfslot89;
  stackframe = oldstackframe89;
  gc_frame_end(frame);
  return obj89;
}
Object meth_lexer_line115(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "line");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for line (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for line");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call117 = callmethodflags(self, "line'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 7)
// compiled member node returning call117 (depth = 6)
  gc_frame_end(frame);
  return call117;
}
Object meth_lexer_linePos118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "linePos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linePos (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for linePos");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe119 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call120 = callmethodflags(self, "linePos'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe119);
// compiled call node returning call120 (depth = 7)
// compiled member node returning call120 (depth = 6)
  gc_frame_end(frame);
  return call120;
}
Object meth_lexer_new107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startLine = getfromclosure(closure, 1);
  Object *var_stringStart = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj108 = alloc_userobj2(8,9, objclass108);
  gc_frame_newslot(obj108);
if (objclass108 == NULL) {
  glfree(obj108->class->name);
  obj108->class->name = "MultiLineStringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj108, self, 0);
  addmethodreal(obj108,"outer", &reader_lexer_outer_109);
  Object oldself108 = self;
  struct StackFrameObject *oldstackframe108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe108);
  gc_frame_newslot((Object)stackframe);
  self = obj108;
  Object *oldselfslot108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter108 = (*(struct UserObject *)self).data[0], lowerouter108 = thisouter108;
  if (inheritingObject108) {
    struct UserObject *inho108 = (struct UserObject *)inheritingObject108;
    while (inho108->super != GraceDefaultObject) inho108 = (struct UserObject *)inho108->super;
    inho108->super = obj108;
    self = inheritingObject108;
    *selfslot = self;
    lowerouter108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter108;
  }
if (objclass108 == NULL) {
  Method *reader110 = addmethodrealflags(obj108, "kind",&reader_lexer_kind_110, MFLAG_DEF);
  reader110->definitionModule = modulename;
  reader110->definitionLine = 62;
}
adddatum2(obj108, alloc_Undefined(), 1);
if (objclass108 == NULL) {
  Method *reader111 = addmethodrealflags(obj108, "value",&reader_lexer_value_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 63;
}
adddatum2(obj108, alloc_Undefined(), 2);
if (objclass108 == NULL) {
  Method *reader112 = addmethodrealflags(obj108, "size",&reader_lexer_size_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 64;
}
adddatum2(obj108, alloc_Undefined(), 3);
if (objclass108 == NULL) {
  Method *reader113 = addmethodrealflags(obj108, "line'",&reader_lexer_line_39__113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 65;
}
adddatum2(obj108, alloc_Undefined(), 4);
if (objclass108 == NULL) {
  Method *reader114 = addmethodrealflags(obj108, "linePos'",&reader_lexer_linePos_39__114, MFLAG_DEF);
  reader114->definitionModule = modulename;
  reader114->definitionLine = 66;
}
adddatum2(obj108, alloc_Undefined(), 5);
// method line
  struct UserObject *uo115 = (struct UserObject*)obj108;
  uo115->data[6] = emptyclosure;
  Method *meth_meth_lexer_line115 = addmethod2pos(obj108, "line", &meth_lexer_line115, 6);
  int argcv_meth_lexer_line115[] = {0};
  meth_meth_lexer_line115->type = alloc_MethodType(1, argcv_meth_lexer_line115);
  meth_meth_lexer_line115->definitionModule = modulename;
  meth_meth_lexer_line115->definitionLine = 66;
// method linePos
  struct UserObject *uo118 = (struct UserObject*)obj108;
  uo118->data[7] = emptyclosure;
  Method *meth_meth_lexer_linePos118 = addmethod2pos(obj108, "linePos", &meth_lexer_linePos118, 7);
  int argcv_meth_lexer_linePos118[] = {0};
  meth_meth_lexer_linePos118->type = alloc_MethodType(1, argcv_meth_lexer_linePos118);
  meth_meth_lexer_linePos118->definitionModule = modulename;
  meth_meth_lexer_linePos118->definitionLine = 67;
  sourceObject = obj108;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe121 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call122 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe121);
// compiled call node returning call122 (depth = 6)
  struct UserObject *obj108_uo = (struct UserObject *)obj108;
  obj108_uo->super = call122;
  sourceObject = obj108;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit123 == NULL) {
    strlit123 = alloc_String("string");
    gc_root(strlit123);
  }
// compiled string node returning strlit123 (depth = 6)
  adddatum2(obj108, strlit123, 1);
  sourceObject = obj108;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj108, *var_s, 2);
  sourceObject = obj108;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num125 = alloc_Float64(2);
// compiled num node returning num125 (depth = 7)
  int op_slot_right_124 = gc_frame_newslot(num125);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call128 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 8)
// compiled member node returning call128 (depth = 7)
  int op_slot_left_124 = gc_frame_newslot(call128);
  params[0] = num125;
  partcv[0] = 1;
  Object sum129 = callmethod(call128, "+", 1, partcv, params);
// compiled op node returning sum129 (depth = 6)
  adddatum2(obj108, sum129, 3);
  sourceObject = obj108;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startLine (depth = 6)
  adddatum2(obj108, *var_startLine, 4);
  sourceObject = obj108;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringStart (depth = 6)
  adddatum2(obj108, *var_stringStart, 5);
  sourceObject = obj108;
  sourceObject = obj108;
objclass108 = obj108->class;
  objclass108->definitionModule = modulename;
  objclass108->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter108;
  self = oldself108;
  selfslot = oldselfslot108;
  stackframe = oldstackframe108;
  gc_frame_end(frame);
  return obj108;
}
Object meth_lexer_new107_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startLine = getfromclosure(closure, 1);
  Object *var_stringStart = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj108 = alloc_userobj2(8,9, objclass108);
  gc_frame_newslot(obj108);
if (objclass108 == NULL) {
  glfree(obj108->class->name);
  obj108->class->name = "MultiLineStringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj108, self, 0);
  addmethodreal(obj108,"outer", &reader_lexer_outer_109);
  Object oldself108 = self;
  struct StackFrameObject *oldstackframe108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe108);
  gc_frame_newslot((Object)stackframe);
  self = obj108;
  Object *oldselfslot108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter108 = (*(struct UserObject *)self).data[0], lowerouter108 = thisouter108;
  if (inheritingObject108) {
    struct UserObject *inho108 = (struct UserObject *)inheritingObject108;
    while (inho108->super != GraceDefaultObject) inho108 = (struct UserObject *)inho108->super;
    inho108->super = obj108;
    self = inheritingObject108;
    *selfslot = self;
    lowerouter108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter108;
  }
if (objclass108 == NULL) {
  Method *reader110 = addmethodrealflags(obj108, "kind",&reader_lexer_kind_110, MFLAG_DEF);
  reader110->definitionModule = modulename;
  reader110->definitionLine = 62;
}
adddatum2(obj108, alloc_Undefined(), 1);
if (objclass108 == NULL) {
  Method *reader111 = addmethodrealflags(obj108, "value",&reader_lexer_value_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 63;
}
adddatum2(obj108, alloc_Undefined(), 2);
if (objclass108 == NULL) {
  Method *reader112 = addmethodrealflags(obj108, "size",&reader_lexer_size_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 64;
}
adddatum2(obj108, alloc_Undefined(), 3);
if (objclass108 == NULL) {
  Method *reader113 = addmethodrealflags(obj108, "line'",&reader_lexer_line_39__113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 65;
}
adddatum2(obj108, alloc_Undefined(), 4);
if (objclass108 == NULL) {
  Method *reader114 = addmethodrealflags(obj108, "linePos'",&reader_lexer_linePos_39__114, MFLAG_DEF);
  reader114->definitionModule = modulename;
  reader114->definitionLine = 66;
}
adddatum2(obj108, alloc_Undefined(), 5);
// method line
  struct UserObject *uo115 = (struct UserObject*)obj108;
  uo115->data[6] = emptyclosure;
  Method *meth_meth_lexer_line115 = addmethod2pos(obj108, "line", &meth_lexer_line115, 6);
  int argcv_meth_lexer_line115[] = {0};
  meth_meth_lexer_line115->type = alloc_MethodType(1, argcv_meth_lexer_line115);
  meth_meth_lexer_line115->definitionModule = modulename;
  meth_meth_lexer_line115->definitionLine = 66;
// method linePos
  struct UserObject *uo118 = (struct UserObject*)obj108;
  uo118->data[7] = emptyclosure;
  Method *meth_meth_lexer_linePos118 = addmethod2pos(obj108, "linePos", &meth_lexer_linePos118, 7);
  int argcv_meth_lexer_linePos118[] = {0};
  meth_meth_lexer_linePos118->type = alloc_MethodType(1, argcv_meth_lexer_linePos118);
  meth_meth_lexer_linePos118->definitionModule = modulename;
  meth_meth_lexer_linePos118->definitionLine = 67;
  sourceObject = obj108;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe121 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call122 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe121);
// compiled call node returning call122 (depth = 6)
  struct UserObject *obj108_uo = (struct UserObject *)obj108;
  obj108_uo->super = call122;
  sourceObject = obj108;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit123 == NULL) {
    strlit123 = alloc_String("string");
    gc_root(strlit123);
  }
// compiled string node returning strlit123 (depth = 6)
  adddatum2(obj108, strlit123, 1);
  sourceObject = obj108;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj108, *var_s, 2);
  sourceObject = obj108;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num125 = alloc_Float64(2);
// compiled num node returning num125 (depth = 7)
  int op_slot_right_124 = gc_frame_newslot(num125);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call128 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 8)
// compiled member node returning call128 (depth = 7)
  int op_slot_left_124 = gc_frame_newslot(call128);
  params[0] = num125;
  partcv[0] = 1;
  Object sum129 = callmethod(call128, "+", 1, partcv, params);
// compiled op node returning sum129 (depth = 6)
  adddatum2(obj108, sum129, 3);
  sourceObject = obj108;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startLine (depth = 6)
  adddatum2(obj108, *var_startLine, 4);
  sourceObject = obj108;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringStart (depth = 6)
  adddatum2(obj108, *var_stringStart, 5);
  sourceObject = obj108;
  sourceObject = obj108;
objclass108 = obj108->class;
  objclass108->definitionModule = modulename;
  objclass108->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter108;
  self = oldself108;
  selfslot = oldselfslot108;
  stackframe = oldstackframe108;
  gc_frame_end(frame);
  return obj108;
}
Object meth_lexer_new133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj134 = alloc_userobj2(4,5, objclass134);
  gc_frame_newslot(obj134);
if (objclass134 == NULL) {
  glfree(obj134->class->name);
  obj134->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj134, self, 0);
  addmethodreal(obj134,"outer", &reader_lexer_outer_135);
  Object oldself134 = self;
  struct StackFrameObject *oldstackframe134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe134);
  gc_frame_newslot((Object)stackframe);
  self = obj134;
  Object *oldselfslot134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter134 = (*(struct UserObject *)self).data[0], lowerouter134 = thisouter134;
  if (inheritingObject134) {
    struct UserObject *inho134 = (struct UserObject *)inheritingObject134;
    while (inho134->super != GraceDefaultObject) inho134 = (struct UserObject *)inho134->super;
    inho134->super = obj134;
    self = inheritingObject134;
    *selfslot = self;
    lowerouter134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter134;
  }
if (objclass134 == NULL) {
  Method *reader136 = addmethodrealflags(obj134, "kind",&reader_lexer_kind_136, MFLAG_DEF);
  reader136->definitionModule = modulename;
  reader136->definitionLine = 72;
}
adddatum2(obj134, alloc_Undefined(), 1);
if (objclass134 == NULL) {
  Method *reader137 = addmethodrealflags(obj134, "value",&reader_lexer_value_137, MFLAG_DEF);
  reader137->definitionModule = modulename;
  reader137->definitionLine = 73;
}
adddatum2(obj134, alloc_Undefined(), 2);
if (objclass134 == NULL) {
  Method *reader138 = addmethodrealflags(obj134, "size",&reader_lexer_size_138, MFLAG_DEF);
  reader138->definitionModule = modulename;
  reader138->definitionLine = 74;
}
adddatum2(obj134, alloc_Undefined(), 3);
  sourceObject = obj134;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe139 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call140 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe139);
// compiled call node returning call140 (depth = 6)
  struct UserObject *obj134_uo = (struct UserObject *)obj134;
  obj134_uo->super = call140;
  sourceObject = obj134;
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit141 == NULL) {
    strlit141 = alloc_String("comment");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 6)
  adddatum2(obj134, strlit141, 1);
  sourceObject = obj134;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj134, *var_s, 2);
  sourceObject = obj134;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num143 = alloc_Float64(2);
// compiled num node returning num143 (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(num143);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call146 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe145);
// compiled call node returning call146 (depth = 8)
// compiled member node returning call146 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(call146);
  params[0] = num143;
  partcv[0] = 1;
  Object sum147 = callmethod(call146, "+", 1, partcv, params);
// compiled op node returning sum147 (depth = 6)
  adddatum2(obj134, sum147, 3);
objclass134 = obj134->class;
  objclass134->definitionModule = modulename;
  objclass134->definitionLine = 69;
  (*(struct UserObject *)self).data[0] = lowerouter134;
  self = oldself134;
  selfslot = oldselfslot134;
  stackframe = oldstackframe134;
  gc_frame_end(frame);
  return obj134;
}
Object meth_lexer_new133_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj134 = alloc_userobj2(4,5, objclass134);
  gc_frame_newslot(obj134);
if (objclass134 == NULL) {
  glfree(obj134->class->name);
  obj134->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj134, self, 0);
  addmethodreal(obj134,"outer", &reader_lexer_outer_135);
  Object oldself134 = self;
  struct StackFrameObject *oldstackframe134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe134);
  gc_frame_newslot((Object)stackframe);
  self = obj134;
  Object *oldselfslot134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter134 = (*(struct UserObject *)self).data[0], lowerouter134 = thisouter134;
  if (inheritingObject134) {
    struct UserObject *inho134 = (struct UserObject *)inheritingObject134;
    while (inho134->super != GraceDefaultObject) inho134 = (struct UserObject *)inho134->super;
    inho134->super = obj134;
    self = inheritingObject134;
    *selfslot = self;
    lowerouter134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter134;
  }
if (objclass134 == NULL) {
  Method *reader136 = addmethodrealflags(obj134, "kind",&reader_lexer_kind_136, MFLAG_DEF);
  reader136->definitionModule = modulename;
  reader136->definitionLine = 72;
}
adddatum2(obj134, alloc_Undefined(), 1);
if (objclass134 == NULL) {
  Method *reader137 = addmethodrealflags(obj134, "value",&reader_lexer_value_137, MFLAG_DEF);
  reader137->definitionModule = modulename;
  reader137->definitionLine = 73;
}
adddatum2(obj134, alloc_Undefined(), 2);
if (objclass134 == NULL) {
  Method *reader138 = addmethodrealflags(obj134, "size",&reader_lexer_size_138, MFLAG_DEF);
  reader138->definitionModule = modulename;
  reader138->definitionLine = 74;
}
adddatum2(obj134, alloc_Undefined(), 3);
  sourceObject = obj134;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe139 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call140 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe139);
// compiled call node returning call140 (depth = 6)
  struct UserObject *obj134_uo = (struct UserObject *)obj134;
  obj134_uo->super = call140;
  sourceObject = obj134;
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit141 == NULL) {
    strlit141 = alloc_String("comment");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 6)
  adddatum2(obj134, strlit141, 1);
  sourceObject = obj134;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj134, *var_s, 2);
  sourceObject = obj134;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num143 = alloc_Float64(2);
// compiled num node returning num143 (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(num143);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call146 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe145);
// compiled call node returning call146 (depth = 8)
// compiled member node returning call146 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(call146);
  params[0] = num143;
  partcv[0] = 1;
  Object sum147 = callmethod(call146, "+", 1, partcv, params);
// compiled op node returning sum147 (depth = 6)
  adddatum2(obj134, sum147, 3);
objclass134 = obj134->class;
  objclass134->definitionModule = modulename;
  objclass134->definitionLine = 69;
  (*(struct UserObject *)self).data[0] = lowerouter134;
  self = oldself134;
  selfslot = oldselfslot134;
  stackframe = oldstackframe134;
  gc_frame_end(frame);
  return obj134;
}
Object meth_lexer_new151(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_lexer_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
if (objclass152 == NULL) {
  Method *reader154 = addmethodrealflags(obj152, "kind",&reader_lexer_kind_154, MFLAG_DEF);
  reader154->definitionModule = modulename;
  reader154->definitionLine = 78;
}
adddatum2(obj152, alloc_Undefined(), 1);
if (objclass152 == NULL) {
  Method *reader155 = addmethodrealflags(obj152, "value",&reader_lexer_value_155, MFLAG_DEF);
  reader155->definitionModule = modulename;
  reader155->definitionLine = 79;
}
adddatum2(obj152, alloc_Undefined(), 2);
if (objclass152 == NULL) {
  Method *reader156 = addmethodrealflags(obj152, "size",&reader_lexer_size_156, MFLAG_DEF);
  reader156->definitionModule = modulename;
  reader156->definitionLine = 80;
}
adddatum2(obj152, alloc_Undefined(), 3);
  sourceObject = obj152;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe157 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call158 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe157);
// compiled call node returning call158 (depth = 6)
  struct UserObject *obj152_uo = (struct UserObject *)obj152;
  obj152_uo->super = call158;
  sourceObject = obj152;
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit159 == NULL) {
    strlit159 = alloc_String("lbrace");
    gc_root(strlit159);
  }
// compiled string node returning strlit159 (depth = 6)
  adddatum2(obj152, strlit159, 1);
  sourceObject = obj152;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit160 == NULL) {
    strlit160 = alloc_String("{");
    gc_root(strlit160);
  }
// compiled string node returning strlit160 (depth = 6)
  adddatum2(obj152, strlit160, 2);
  sourceObject = obj152;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num161 = alloc_Float64(1);
// compiled num node returning num161 (depth = 6)
  adddatum2(obj152, num161, 3);
objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 75;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_lexer_new151_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_lexer_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
if (objclass152 == NULL) {
  Method *reader154 = addmethodrealflags(obj152, "kind",&reader_lexer_kind_154, MFLAG_DEF);
  reader154->definitionModule = modulename;
  reader154->definitionLine = 78;
}
adddatum2(obj152, alloc_Undefined(), 1);
if (objclass152 == NULL) {
  Method *reader155 = addmethodrealflags(obj152, "value",&reader_lexer_value_155, MFLAG_DEF);
  reader155->definitionModule = modulename;
  reader155->definitionLine = 79;
}
adddatum2(obj152, alloc_Undefined(), 2);
if (objclass152 == NULL) {
  Method *reader156 = addmethodrealflags(obj152, "size",&reader_lexer_size_156, MFLAG_DEF);
  reader156->definitionModule = modulename;
  reader156->definitionLine = 80;
}
adddatum2(obj152, alloc_Undefined(), 3);
  sourceObject = obj152;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe157 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call158 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe157);
// compiled call node returning call158 (depth = 6)
  struct UserObject *obj152_uo = (struct UserObject *)obj152;
  obj152_uo->super = call158;
  sourceObject = obj152;
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit159 == NULL) {
    strlit159 = alloc_String("lbrace");
    gc_root(strlit159);
  }
// compiled string node returning strlit159 (depth = 6)
  adddatum2(obj152, strlit159, 1);
  sourceObject = obj152;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit160 == NULL) {
    strlit160 = alloc_String("{");
    gc_root(strlit160);
  }
// compiled string node returning strlit160 (depth = 6)
  adddatum2(obj152, strlit160, 2);
  sourceObject = obj152;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num161 = alloc_Float64(1);
// compiled num node returning num161 (depth = 6)
  adddatum2(obj152, num161, 3);
objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 75;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_lexer_new165(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject166 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj166 = alloc_userobj2(4,5, objclass166);
  gc_frame_newslot(obj166);
if (objclass166 == NULL) {
  glfree(obj166->class->name);
  obj166->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj166, self, 0);
  addmethodreal(obj166,"outer", &reader_lexer_outer_167);
  Object oldself166 = self;
  struct StackFrameObject *oldstackframe166 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe166);
  gc_frame_newslot((Object)stackframe);
  self = obj166;
  Object *oldselfslot166 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter166 = (*(struct UserObject *)self).data[0], lowerouter166 = thisouter166;
  if (inheritingObject166) {
    struct UserObject *inho166 = (struct UserObject *)inheritingObject166;
    while (inho166->super != GraceDefaultObject) inho166 = (struct UserObject *)inho166->super;
    inho166->super = obj166;
    self = inheritingObject166;
    *selfslot = self;
    lowerouter166 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter166;
  }
if (objclass166 == NULL) {
  Method *reader168 = addmethodrealflags(obj166, "kind",&reader_lexer_kind_168, MFLAG_DEF);
  reader168->definitionModule = modulename;
  reader168->definitionLine = 84;
}
adddatum2(obj166, alloc_Undefined(), 1);
if (objclass166 == NULL) {
  Method *reader169 = addmethodrealflags(obj166, "value",&reader_lexer_value_169, MFLAG_DEF);
  reader169->definitionModule = modulename;
  reader169->definitionLine = 85;
}
adddatum2(obj166, alloc_Undefined(), 2);
if (objclass166 == NULL) {
  Method *reader170 = addmethodrealflags(obj166, "size",&reader_lexer_size_170, MFLAG_DEF);
  reader170->definitionModule = modulename;
  reader170->definitionLine = 86;
}
adddatum2(obj166, alloc_Undefined(), 3);
  sourceObject = obj166;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe171 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call172 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe171);
// compiled call node returning call172 (depth = 6)
  struct UserObject *obj166_uo = (struct UserObject *)obj166;
  obj166_uo->super = call172;
  sourceObject = obj166;
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit173 == NULL) {
    strlit173 = alloc_String("rbrace");
    gc_root(strlit173);
  }
// compiled string node returning strlit173 (depth = 6)
  adddatum2(obj166, strlit173, 1);
  sourceObject = obj166;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit174 == NULL) {
    strlit174 = alloc_String("}");
    gc_root(strlit174);
  }
// compiled string node returning strlit174 (depth = 6)
  adddatum2(obj166, strlit174, 2);
  sourceObject = obj166;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num175 = alloc_Float64(1);
// compiled num node returning num175 (depth = 6)
  adddatum2(obj166, num175, 3);
objclass166 = obj166->class;
  objclass166->definitionModule = modulename;
  objclass166->definitionLine = 81;
  (*(struct UserObject *)self).data[0] = lowerouter166;
  self = oldself166;
  selfslot = oldselfslot166;
  stackframe = oldstackframe166;
  gc_frame_end(frame);
  return obj166;
}
Object meth_lexer_new165_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject166 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj166 = alloc_userobj2(4,5, objclass166);
  gc_frame_newslot(obj166);
if (objclass166 == NULL) {
  glfree(obj166->class->name);
  obj166->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj166, self, 0);
  addmethodreal(obj166,"outer", &reader_lexer_outer_167);
  Object oldself166 = self;
  struct StackFrameObject *oldstackframe166 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe166);
  gc_frame_newslot((Object)stackframe);
  self = obj166;
  Object *oldselfslot166 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter166 = (*(struct UserObject *)self).data[0], lowerouter166 = thisouter166;
  if (inheritingObject166) {
    struct UserObject *inho166 = (struct UserObject *)inheritingObject166;
    while (inho166->super != GraceDefaultObject) inho166 = (struct UserObject *)inho166->super;
    inho166->super = obj166;
    self = inheritingObject166;
    *selfslot = self;
    lowerouter166 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter166;
  }
if (objclass166 == NULL) {
  Method *reader168 = addmethodrealflags(obj166, "kind",&reader_lexer_kind_168, MFLAG_DEF);
  reader168->definitionModule = modulename;
  reader168->definitionLine = 84;
}
adddatum2(obj166, alloc_Undefined(), 1);
if (objclass166 == NULL) {
  Method *reader169 = addmethodrealflags(obj166, "value",&reader_lexer_value_169, MFLAG_DEF);
  reader169->definitionModule = modulename;
  reader169->definitionLine = 85;
}
adddatum2(obj166, alloc_Undefined(), 2);
if (objclass166 == NULL) {
  Method *reader170 = addmethodrealflags(obj166, "size",&reader_lexer_size_170, MFLAG_DEF);
  reader170->definitionModule = modulename;
  reader170->definitionLine = 86;
}
adddatum2(obj166, alloc_Undefined(), 3);
  sourceObject = obj166;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe171 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call172 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe171);
// compiled call node returning call172 (depth = 6)
  struct UserObject *obj166_uo = (struct UserObject *)obj166;
  obj166_uo->super = call172;
  sourceObject = obj166;
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit173 == NULL) {
    strlit173 = alloc_String("rbrace");
    gc_root(strlit173);
  }
// compiled string node returning strlit173 (depth = 6)
  adddatum2(obj166, strlit173, 1);
  sourceObject = obj166;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit174 == NULL) {
    strlit174 = alloc_String("}");
    gc_root(strlit174);
  }
// compiled string node returning strlit174 (depth = 6)
  adddatum2(obj166, strlit174, 2);
  sourceObject = obj166;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num175 = alloc_Float64(1);
// compiled num node returning num175 (depth = 6)
  adddatum2(obj166, num175, 3);
objclass166 = obj166->class;
  objclass166->definitionModule = modulename;
  objclass166->definitionLine = 81;
  (*(struct UserObject *)self).data[0] = lowerouter166;
  self = oldself166;
  selfslot = oldselfslot166;
  stackframe = oldstackframe166;
  gc_frame_end(frame);
  return obj166;
}
Object meth_lexer_new179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(4,5, objclass180);
  gc_frame_newslot(obj180);
if (objclass180 == NULL) {
  glfree(obj180->class->name);
  obj180->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_lexer_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
if (objclass180 == NULL) {
  Method *reader182 = addmethodrealflags(obj180, "kind",&reader_lexer_kind_182, MFLAG_DEF);
  reader182->definitionModule = modulename;
  reader182->definitionLine = 90;
}
adddatum2(obj180, alloc_Undefined(), 1);
if (objclass180 == NULL) {
  Method *reader183 = addmethodrealflags(obj180, "value",&reader_lexer_value_183, MFLAG_DEF);
  reader183->definitionModule = modulename;
  reader183->definitionLine = 91;
}
adddatum2(obj180, alloc_Undefined(), 2);
if (objclass180 == NULL) {
  Method *reader184 = addmethodrealflags(obj180, "size",&reader_lexer_size_184, MFLAG_DEF);
  reader184->definitionModule = modulename;
  reader184->definitionLine = 92;
}
adddatum2(obj180, alloc_Undefined(), 3);
  sourceObject = obj180;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe185 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call186 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe185);
// compiled call node returning call186 (depth = 6)
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = call186;
  sourceObject = obj180;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit187 == NULL) {
    strlit187 = alloc_String("lparen");
    gc_root(strlit187);
  }
// compiled string node returning strlit187 (depth = 6)
  adddatum2(obj180, strlit187, 1);
  sourceObject = obj180;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit188 == NULL) {
    strlit188 = alloc_String("(");
    gc_root(strlit188);
  }
// compiled string node returning strlit188 (depth = 6)
  adddatum2(obj180, strlit188, 2);
  sourceObject = obj180;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num189 = alloc_Float64(1);
// compiled num node returning num189 (depth = 6)
  adddatum2(obj180, num189, 3);
objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
  gc_frame_end(frame);
  return obj180;
}
Object meth_lexer_new179_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(4,5, objclass180);
  gc_frame_newslot(obj180);
if (objclass180 == NULL) {
  glfree(obj180->class->name);
  obj180->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_lexer_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
if (objclass180 == NULL) {
  Method *reader182 = addmethodrealflags(obj180, "kind",&reader_lexer_kind_182, MFLAG_DEF);
  reader182->definitionModule = modulename;
  reader182->definitionLine = 90;
}
adddatum2(obj180, alloc_Undefined(), 1);
if (objclass180 == NULL) {
  Method *reader183 = addmethodrealflags(obj180, "value",&reader_lexer_value_183, MFLAG_DEF);
  reader183->definitionModule = modulename;
  reader183->definitionLine = 91;
}
adddatum2(obj180, alloc_Undefined(), 2);
if (objclass180 == NULL) {
  Method *reader184 = addmethodrealflags(obj180, "size",&reader_lexer_size_184, MFLAG_DEF);
  reader184->definitionModule = modulename;
  reader184->definitionLine = 92;
}
adddatum2(obj180, alloc_Undefined(), 3);
  sourceObject = obj180;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe185 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call186 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe185);
// compiled call node returning call186 (depth = 6)
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = call186;
  sourceObject = obj180;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit187 == NULL) {
    strlit187 = alloc_String("lparen");
    gc_root(strlit187);
  }
// compiled string node returning strlit187 (depth = 6)
  adddatum2(obj180, strlit187, 1);
  sourceObject = obj180;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit188 == NULL) {
    strlit188 = alloc_String("(");
    gc_root(strlit188);
  }
// compiled string node returning strlit188 (depth = 6)
  adddatum2(obj180, strlit188, 2);
  sourceObject = obj180;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num189 = alloc_Float64(1);
// compiled num node returning num189 (depth = 6)
  adddatum2(obj180, num189, 3);
objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
  gc_frame_end(frame);
  return obj180;
}
Object meth_lexer_new193(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject194 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj194 = alloc_userobj2(4,5, objclass194);
  gc_frame_newslot(obj194);
if (objclass194 == NULL) {
  glfree(obj194->class->name);
  obj194->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj194, self, 0);
  addmethodreal(obj194,"outer", &reader_lexer_outer_195);
  Object oldself194 = self;
  struct StackFrameObject *oldstackframe194 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe194);
  gc_frame_newslot((Object)stackframe);
  self = obj194;
  Object *oldselfslot194 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter194 = (*(struct UserObject *)self).data[0], lowerouter194 = thisouter194;
  if (inheritingObject194) {
    struct UserObject *inho194 = (struct UserObject *)inheritingObject194;
    while (inho194->super != GraceDefaultObject) inho194 = (struct UserObject *)inho194->super;
    inho194->super = obj194;
    self = inheritingObject194;
    *selfslot = self;
    lowerouter194 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter194;
  }
if (objclass194 == NULL) {
  Method *reader196 = addmethodrealflags(obj194, "kind",&reader_lexer_kind_196, MFLAG_DEF);
  reader196->definitionModule = modulename;
  reader196->definitionLine = 96;
}
adddatum2(obj194, alloc_Undefined(), 1);
if (objclass194 == NULL) {
  Method *reader197 = addmethodrealflags(obj194, "value",&reader_lexer_value_197, MFLAG_DEF);
  reader197->definitionModule = modulename;
  reader197->definitionLine = 97;
}
adddatum2(obj194, alloc_Undefined(), 2);
if (objclass194 == NULL) {
  Method *reader198 = addmethodrealflags(obj194, "size",&reader_lexer_size_198, MFLAG_DEF);
  reader198->definitionModule = modulename;
  reader198->definitionLine = 98;
}
adddatum2(obj194, alloc_Undefined(), 3);
  sourceObject = obj194;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe199 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call200 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe199);
// compiled call node returning call200 (depth = 6)
  struct UserObject *obj194_uo = (struct UserObject *)obj194;
  obj194_uo->super = call200;
  sourceObject = obj194;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit201 == NULL) {
    strlit201 = alloc_String("rparen");
    gc_root(strlit201);
  }
// compiled string node returning strlit201 (depth = 6)
  adddatum2(obj194, strlit201, 1);
  sourceObject = obj194;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit202 == NULL) {
    strlit202 = alloc_String(")");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 6)
  adddatum2(obj194, strlit202, 2);
  sourceObject = obj194;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num203 = alloc_Float64(1);
// compiled num node returning num203 (depth = 6)
  adddatum2(obj194, num203, 3);
objclass194 = obj194->class;
  objclass194->definitionModule = modulename;
  objclass194->definitionLine = 93;
  (*(struct UserObject *)self).data[0] = lowerouter194;
  self = oldself194;
  selfslot = oldselfslot194;
  stackframe = oldstackframe194;
  gc_frame_end(frame);
  return obj194;
}
Object meth_lexer_new193_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject194 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj194 = alloc_userobj2(4,5, objclass194);
  gc_frame_newslot(obj194);
if (objclass194 == NULL) {
  glfree(obj194->class->name);
  obj194->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj194, self, 0);
  addmethodreal(obj194,"outer", &reader_lexer_outer_195);
  Object oldself194 = self;
  struct StackFrameObject *oldstackframe194 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe194);
  gc_frame_newslot((Object)stackframe);
  self = obj194;
  Object *oldselfslot194 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter194 = (*(struct UserObject *)self).data[0], lowerouter194 = thisouter194;
  if (inheritingObject194) {
    struct UserObject *inho194 = (struct UserObject *)inheritingObject194;
    while (inho194->super != GraceDefaultObject) inho194 = (struct UserObject *)inho194->super;
    inho194->super = obj194;
    self = inheritingObject194;
    *selfslot = self;
    lowerouter194 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter194;
  }
if (objclass194 == NULL) {
  Method *reader196 = addmethodrealflags(obj194, "kind",&reader_lexer_kind_196, MFLAG_DEF);
  reader196->definitionModule = modulename;
  reader196->definitionLine = 96;
}
adddatum2(obj194, alloc_Undefined(), 1);
if (objclass194 == NULL) {
  Method *reader197 = addmethodrealflags(obj194, "value",&reader_lexer_value_197, MFLAG_DEF);
  reader197->definitionModule = modulename;
  reader197->definitionLine = 97;
}
adddatum2(obj194, alloc_Undefined(), 2);
if (objclass194 == NULL) {
  Method *reader198 = addmethodrealflags(obj194, "size",&reader_lexer_size_198, MFLAG_DEF);
  reader198->definitionModule = modulename;
  reader198->definitionLine = 98;
}
adddatum2(obj194, alloc_Undefined(), 3);
  sourceObject = obj194;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe199 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call200 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe199);
// compiled call node returning call200 (depth = 6)
  struct UserObject *obj194_uo = (struct UserObject *)obj194;
  obj194_uo->super = call200;
  sourceObject = obj194;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit201 == NULL) {
    strlit201 = alloc_String("rparen");
    gc_root(strlit201);
  }
// compiled string node returning strlit201 (depth = 6)
  adddatum2(obj194, strlit201, 1);
  sourceObject = obj194;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit202 == NULL) {
    strlit202 = alloc_String(")");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 6)
  adddatum2(obj194, strlit202, 2);
  sourceObject = obj194;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num203 = alloc_Float64(1);
// compiled num node returning num203 (depth = 6)
  adddatum2(obj194, num203, 3);
objclass194 = obj194->class;
  objclass194->definitionModule = modulename;
  objclass194->definitionLine = 93;
  (*(struct UserObject *)self).data[0] = lowerouter194;
  self = oldself194;
  selfslot = oldselfslot194;
  stackframe = oldstackframe194;
  gc_frame_end(frame);
  return obj194;
}
Object meth_lexer_new207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject208 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj208 = alloc_userobj2(4,5, objclass208);
  gc_frame_newslot(obj208);
if (objclass208 == NULL) {
  glfree(obj208->class->name);
  obj208->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj208, self, 0);
  addmethodreal(obj208,"outer", &reader_lexer_outer_209);
  Object oldself208 = self;
  struct StackFrameObject *oldstackframe208 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe208);
  gc_frame_newslot((Object)stackframe);
  self = obj208;
  Object *oldselfslot208 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter208 = (*(struct UserObject *)self).data[0], lowerouter208 = thisouter208;
  if (inheritingObject208) {
    struct UserObject *inho208 = (struct UserObject *)inheritingObject208;
    while (inho208->super != GraceDefaultObject) inho208 = (struct UserObject *)inho208->super;
    inho208->super = obj208;
    self = inheritingObject208;
    *selfslot = self;
    lowerouter208 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter208;
  }
if (objclass208 == NULL) {
  Method *reader210 = addmethodrealflags(obj208, "kind",&reader_lexer_kind_210, MFLAG_DEF);
  reader210->definitionModule = modulename;
  reader210->definitionLine = 102;
}
adddatum2(obj208, alloc_Undefined(), 1);
if (objclass208 == NULL) {
  Method *reader211 = addmethodrealflags(obj208, "value",&reader_lexer_value_211, MFLAG_DEF);
  reader211->definitionModule = modulename;
  reader211->definitionLine = 103;
}
adddatum2(obj208, alloc_Undefined(), 2);
if (objclass208 == NULL) {
  Method *reader212 = addmethodrealflags(obj208, "size",&reader_lexer_size_212, MFLAG_DEF);
  reader212->definitionModule = modulename;
  reader212->definitionLine = 104;
}
adddatum2(obj208, alloc_Undefined(), 3);
  sourceObject = obj208;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe213 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call214 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 6)
  struct UserObject *obj208_uo = (struct UserObject *)obj208;
  obj208_uo->super = call214;
  sourceObject = obj208;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit215 == NULL) {
    strlit215 = alloc_String("lsquare");
    gc_root(strlit215);
  }
// compiled string node returning strlit215 (depth = 6)
  adddatum2(obj208, strlit215, 1);
  sourceObject = obj208;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit216 == NULL) {
    strlit216 = alloc_String("[");
    gc_root(strlit216);
  }
// compiled string node returning strlit216 (depth = 6)
  adddatum2(obj208, strlit216, 2);
  sourceObject = obj208;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num217 = alloc_Float64(1);
// compiled num node returning num217 (depth = 6)
  adddatum2(obj208, num217, 3);
objclass208 = obj208->class;
  objclass208->definitionModule = modulename;
  objclass208->definitionLine = 99;
  (*(struct UserObject *)self).data[0] = lowerouter208;
  self = oldself208;
  selfslot = oldselfslot208;
  stackframe = oldstackframe208;
  gc_frame_end(frame);
  return obj208;
}
Object meth_lexer_new207_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject208 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj208 = alloc_userobj2(4,5, objclass208);
  gc_frame_newslot(obj208);
if (objclass208 == NULL) {
  glfree(obj208->class->name);
  obj208->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj208, self, 0);
  addmethodreal(obj208,"outer", &reader_lexer_outer_209);
  Object oldself208 = self;
  struct StackFrameObject *oldstackframe208 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe208);
  gc_frame_newslot((Object)stackframe);
  self = obj208;
  Object *oldselfslot208 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter208 = (*(struct UserObject *)self).data[0], lowerouter208 = thisouter208;
  if (inheritingObject208) {
    struct UserObject *inho208 = (struct UserObject *)inheritingObject208;
    while (inho208->super != GraceDefaultObject) inho208 = (struct UserObject *)inho208->super;
    inho208->super = obj208;
    self = inheritingObject208;
    *selfslot = self;
    lowerouter208 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter208;
  }
if (objclass208 == NULL) {
  Method *reader210 = addmethodrealflags(obj208, "kind",&reader_lexer_kind_210, MFLAG_DEF);
  reader210->definitionModule = modulename;
  reader210->definitionLine = 102;
}
adddatum2(obj208, alloc_Undefined(), 1);
if (objclass208 == NULL) {
  Method *reader211 = addmethodrealflags(obj208, "value",&reader_lexer_value_211, MFLAG_DEF);
  reader211->definitionModule = modulename;
  reader211->definitionLine = 103;
}
adddatum2(obj208, alloc_Undefined(), 2);
if (objclass208 == NULL) {
  Method *reader212 = addmethodrealflags(obj208, "size",&reader_lexer_size_212, MFLAG_DEF);
  reader212->definitionModule = modulename;
  reader212->definitionLine = 104;
}
adddatum2(obj208, alloc_Undefined(), 3);
  sourceObject = obj208;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe213 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call214 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 6)
  struct UserObject *obj208_uo = (struct UserObject *)obj208;
  obj208_uo->super = call214;
  sourceObject = obj208;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit215 == NULL) {
    strlit215 = alloc_String("lsquare");
    gc_root(strlit215);
  }
// compiled string node returning strlit215 (depth = 6)
  adddatum2(obj208, strlit215, 1);
  sourceObject = obj208;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit216 == NULL) {
    strlit216 = alloc_String("[");
    gc_root(strlit216);
  }
// compiled string node returning strlit216 (depth = 6)
  adddatum2(obj208, strlit216, 2);
  sourceObject = obj208;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num217 = alloc_Float64(1);
// compiled num node returning num217 (depth = 6)
  adddatum2(obj208, num217, 3);
objclass208 = obj208->class;
  objclass208->definitionModule = modulename;
  objclass208->definitionLine = 99;
  (*(struct UserObject *)self).data[0] = lowerouter208;
  self = oldself208;
  selfslot = oldselfslot208;
  stackframe = oldstackframe208;
  gc_frame_end(frame);
  return obj208;
}
Object meth_lexer_new221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject222 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj222 = alloc_userobj2(4,5, objclass222);
  gc_frame_newslot(obj222);
if (objclass222 == NULL) {
  glfree(obj222->class->name);
  obj222->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj222, self, 0);
  addmethodreal(obj222,"outer", &reader_lexer_outer_223);
  Object oldself222 = self;
  struct StackFrameObject *oldstackframe222 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe222);
  gc_frame_newslot((Object)stackframe);
  self = obj222;
  Object *oldselfslot222 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter222 = (*(struct UserObject *)self).data[0], lowerouter222 = thisouter222;
  if (inheritingObject222) {
    struct UserObject *inho222 = (struct UserObject *)inheritingObject222;
    while (inho222->super != GraceDefaultObject) inho222 = (struct UserObject *)inho222->super;
    inho222->super = obj222;
    self = inheritingObject222;
    *selfslot = self;
    lowerouter222 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter222;
  }
if (objclass222 == NULL) {
  Method *reader224 = addmethodrealflags(obj222, "kind",&reader_lexer_kind_224, MFLAG_DEF);
  reader224->definitionModule = modulename;
  reader224->definitionLine = 108;
}
adddatum2(obj222, alloc_Undefined(), 1);
if (objclass222 == NULL) {
  Method *reader225 = addmethodrealflags(obj222, "value",&reader_lexer_value_225, MFLAG_DEF);
  reader225->definitionModule = modulename;
  reader225->definitionLine = 109;
}
adddatum2(obj222, alloc_Undefined(), 2);
if (objclass222 == NULL) {
  Method *reader226 = addmethodrealflags(obj222, "size",&reader_lexer_size_226, MFLAG_DEF);
  reader226->definitionModule = modulename;
  reader226->definitionLine = 110;
}
adddatum2(obj222, alloc_Undefined(), 3);
  sourceObject = obj222;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 6)
  struct UserObject *obj222_uo = (struct UserObject *)obj222;
  obj222_uo->super = call228;
  sourceObject = obj222;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit229 == NULL) {
    strlit229 = alloc_String("rsquare");
    gc_root(strlit229);
  }
// compiled string node returning strlit229 (depth = 6)
  adddatum2(obj222, strlit229, 1);
  sourceObject = obj222;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit230 == NULL) {
    strlit230 = alloc_String("]");
    gc_root(strlit230);
  }
// compiled string node returning strlit230 (depth = 6)
  adddatum2(obj222, strlit230, 2);
  sourceObject = obj222;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num231 = alloc_Float64(1);
// compiled num node returning num231 (depth = 6)
  adddatum2(obj222, num231, 3);
objclass222 = obj222->class;
  objclass222->definitionModule = modulename;
  objclass222->definitionLine = 105;
  (*(struct UserObject *)self).data[0] = lowerouter222;
  self = oldself222;
  selfslot = oldselfslot222;
  stackframe = oldstackframe222;
  gc_frame_end(frame);
  return obj222;
}
Object meth_lexer_new221_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject222 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj222 = alloc_userobj2(4,5, objclass222);
  gc_frame_newslot(obj222);
if (objclass222 == NULL) {
  glfree(obj222->class->name);
  obj222->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj222, self, 0);
  addmethodreal(obj222,"outer", &reader_lexer_outer_223);
  Object oldself222 = self;
  struct StackFrameObject *oldstackframe222 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe222);
  gc_frame_newslot((Object)stackframe);
  self = obj222;
  Object *oldselfslot222 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter222 = (*(struct UserObject *)self).data[0], lowerouter222 = thisouter222;
  if (inheritingObject222) {
    struct UserObject *inho222 = (struct UserObject *)inheritingObject222;
    while (inho222->super != GraceDefaultObject) inho222 = (struct UserObject *)inho222->super;
    inho222->super = obj222;
    self = inheritingObject222;
    *selfslot = self;
    lowerouter222 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter222;
  }
if (objclass222 == NULL) {
  Method *reader224 = addmethodrealflags(obj222, "kind",&reader_lexer_kind_224, MFLAG_DEF);
  reader224->definitionModule = modulename;
  reader224->definitionLine = 108;
}
adddatum2(obj222, alloc_Undefined(), 1);
if (objclass222 == NULL) {
  Method *reader225 = addmethodrealflags(obj222, "value",&reader_lexer_value_225, MFLAG_DEF);
  reader225->definitionModule = modulename;
  reader225->definitionLine = 109;
}
adddatum2(obj222, alloc_Undefined(), 2);
if (objclass222 == NULL) {
  Method *reader226 = addmethodrealflags(obj222, "size",&reader_lexer_size_226, MFLAG_DEF);
  reader226->definitionModule = modulename;
  reader226->definitionLine = 110;
}
adddatum2(obj222, alloc_Undefined(), 3);
  sourceObject = obj222;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 6)
  struct UserObject *obj222_uo = (struct UserObject *)obj222;
  obj222_uo->super = call228;
  sourceObject = obj222;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit229 == NULL) {
    strlit229 = alloc_String("rsquare");
    gc_root(strlit229);
  }
// compiled string node returning strlit229 (depth = 6)
  adddatum2(obj222, strlit229, 1);
  sourceObject = obj222;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit230 == NULL) {
    strlit230 = alloc_String("]");
    gc_root(strlit230);
  }
// compiled string node returning strlit230 (depth = 6)
  adddatum2(obj222, strlit230, 2);
  sourceObject = obj222;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num231 = alloc_Float64(1);
// compiled num node returning num231 (depth = 6)
  adddatum2(obj222, num231, 3);
objclass222 = obj222->class;
  objclass222->definitionModule = modulename;
  objclass222->definitionLine = 105;
  (*(struct UserObject *)self).data[0] = lowerouter222;
  self = oldself222;
  selfslot = oldselfslot222;
  stackframe = oldstackframe222;
  gc_frame_end(frame);
  return obj222;
}
Object meth_lexer_new235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(4,5, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_lexer_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
if (objclass236 == NULL) {
  Method *reader238 = addmethodrealflags(obj236, "kind",&reader_lexer_kind_238, MFLAG_DEF);
  reader238->definitionModule = modulename;
  reader238->definitionLine = 114;
}
adddatum2(obj236, alloc_Undefined(), 1);
if (objclass236 == NULL) {
  Method *reader239 = addmethodrealflags(obj236, "value",&reader_lexer_value_239, MFLAG_DEF);
  reader239->definitionModule = modulename;
  reader239->definitionLine = 115;
}
adddatum2(obj236, alloc_Undefined(), 2);
if (objclass236 == NULL) {
  Method *reader240 = addmethodrealflags(obj236, "size",&reader_lexer_size_240, MFLAG_DEF);
  reader240->definitionModule = modulename;
  reader240->definitionLine = 116;
}
adddatum2(obj236, alloc_Undefined(), 3);
  sourceObject = obj236;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe241 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call242 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 6)
  struct UserObject *obj236_uo = (struct UserObject *)obj236;
  obj236_uo->super = call242;
  sourceObject = obj236;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit243 == NULL) {
    strlit243 = alloc_String("comma");
    gc_root(strlit243);
  }
// compiled string node returning strlit243 (depth = 6)
  adddatum2(obj236, strlit243, 1);
  sourceObject = obj236;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit244 == NULL) {
    strlit244 = alloc_String(",");
    gc_root(strlit244);
  }
// compiled string node returning strlit244 (depth = 6)
  adddatum2(obj236, strlit244, 2);
  sourceObject = obj236;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num245 = alloc_Float64(1);
// compiled num node returning num245 (depth = 6)
  adddatum2(obj236, num245, 3);
objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 111;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_lexer_new235_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(4,5, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_lexer_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
if (objclass236 == NULL) {
  Method *reader238 = addmethodrealflags(obj236, "kind",&reader_lexer_kind_238, MFLAG_DEF);
  reader238->definitionModule = modulename;
  reader238->definitionLine = 114;
}
adddatum2(obj236, alloc_Undefined(), 1);
if (objclass236 == NULL) {
  Method *reader239 = addmethodrealflags(obj236, "value",&reader_lexer_value_239, MFLAG_DEF);
  reader239->definitionModule = modulename;
  reader239->definitionLine = 115;
}
adddatum2(obj236, alloc_Undefined(), 2);
if (objclass236 == NULL) {
  Method *reader240 = addmethodrealflags(obj236, "size",&reader_lexer_size_240, MFLAG_DEF);
  reader240->definitionModule = modulename;
  reader240->definitionLine = 116;
}
adddatum2(obj236, alloc_Undefined(), 3);
  sourceObject = obj236;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe241 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call242 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 6)
  struct UserObject *obj236_uo = (struct UserObject *)obj236;
  obj236_uo->super = call242;
  sourceObject = obj236;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit243 == NULL) {
    strlit243 = alloc_String("comma");
    gc_root(strlit243);
  }
// compiled string node returning strlit243 (depth = 6)
  adddatum2(obj236, strlit243, 1);
  sourceObject = obj236;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit244 == NULL) {
    strlit244 = alloc_String(",");
    gc_root(strlit244);
  }
// compiled string node returning strlit244 (depth = 6)
  adddatum2(obj236, strlit244, 2);
  sourceObject = obj236;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num245 = alloc_Float64(1);
// compiled num node returning num245 (depth = 6)
  adddatum2(obj236, num245, 3);
objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 111;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_lexer_new249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj250 = alloc_userobj2(4,5, objclass250);
  gc_frame_newslot(obj250);
if (objclass250 == NULL) {
  glfree(obj250->class->name);
  obj250->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj250, self, 0);
  addmethodreal(obj250,"outer", &reader_lexer_outer_251);
  Object oldself250 = self;
  struct StackFrameObject *oldstackframe250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe250);
  gc_frame_newslot((Object)stackframe);
  self = obj250;
  Object *oldselfslot250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter250 = (*(struct UserObject *)self).data[0], lowerouter250 = thisouter250;
  if (inheritingObject250) {
    struct UserObject *inho250 = (struct UserObject *)inheritingObject250;
    while (inho250->super != GraceDefaultObject) inho250 = (struct UserObject *)inho250->super;
    inho250->super = obj250;
    self = inheritingObject250;
    *selfslot = self;
    lowerouter250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter250;
  }
if (objclass250 == NULL) {
  Method *reader252 = addmethodrealflags(obj250, "kind",&reader_lexer_kind_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 120;
}
adddatum2(obj250, alloc_Undefined(), 1);
if (objclass250 == NULL) {
  Method *reader253 = addmethodrealflags(obj250, "value",&reader_lexer_value_253, MFLAG_DEF);
  reader253->definitionModule = modulename;
  reader253->definitionLine = 121;
}
adddatum2(obj250, alloc_Undefined(), 2);
if (objclass250 == NULL) {
  Method *reader254 = addmethodrealflags(obj250, "size",&reader_lexer_size_254, MFLAG_DEF);
  reader254->definitionModule = modulename;
  reader254->definitionLine = 122;
}
adddatum2(obj250, alloc_Undefined(), 3);
  sourceObject = obj250;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe255 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call256 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe255);
// compiled call node returning call256 (depth = 6)
  struct UserObject *obj250_uo = (struct UserObject *)obj250;
  obj250_uo->super = call256;
  sourceObject = obj250;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit257 == NULL) {
    strlit257 = alloc_String("colon");
    gc_root(strlit257);
  }
// compiled string node returning strlit257 (depth = 6)
  adddatum2(obj250, strlit257, 1);
  sourceObject = obj250;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit258 == NULL) {
    strlit258 = alloc_String(":");
    gc_root(strlit258);
  }
// compiled string node returning strlit258 (depth = 6)
  adddatum2(obj250, strlit258, 2);
  sourceObject = obj250;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num259 = alloc_Float64(1);
// compiled num node returning num259 (depth = 6)
  adddatum2(obj250, num259, 3);
objclass250 = obj250->class;
  objclass250->definitionModule = modulename;
  objclass250->definitionLine = 117;
  (*(struct UserObject *)self).data[0] = lowerouter250;
  self = oldself250;
  selfslot = oldselfslot250;
  stackframe = oldstackframe250;
  gc_frame_end(frame);
  return obj250;
}
Object meth_lexer_new249_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj250 = alloc_userobj2(4,5, objclass250);
  gc_frame_newslot(obj250);
if (objclass250 == NULL) {
  glfree(obj250->class->name);
  obj250->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj250, self, 0);
  addmethodreal(obj250,"outer", &reader_lexer_outer_251);
  Object oldself250 = self;
  struct StackFrameObject *oldstackframe250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe250);
  gc_frame_newslot((Object)stackframe);
  self = obj250;
  Object *oldselfslot250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter250 = (*(struct UserObject *)self).data[0], lowerouter250 = thisouter250;
  if (inheritingObject250) {
    struct UserObject *inho250 = (struct UserObject *)inheritingObject250;
    while (inho250->super != GraceDefaultObject) inho250 = (struct UserObject *)inho250->super;
    inho250->super = obj250;
    self = inheritingObject250;
    *selfslot = self;
    lowerouter250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter250;
  }
if (objclass250 == NULL) {
  Method *reader252 = addmethodrealflags(obj250, "kind",&reader_lexer_kind_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 120;
}
adddatum2(obj250, alloc_Undefined(), 1);
if (objclass250 == NULL) {
  Method *reader253 = addmethodrealflags(obj250, "value",&reader_lexer_value_253, MFLAG_DEF);
  reader253->definitionModule = modulename;
  reader253->definitionLine = 121;
}
adddatum2(obj250, alloc_Undefined(), 2);
if (objclass250 == NULL) {
  Method *reader254 = addmethodrealflags(obj250, "size",&reader_lexer_size_254, MFLAG_DEF);
  reader254->definitionModule = modulename;
  reader254->definitionLine = 122;
}
adddatum2(obj250, alloc_Undefined(), 3);
  sourceObject = obj250;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe255 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call256 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe255);
// compiled call node returning call256 (depth = 6)
  struct UserObject *obj250_uo = (struct UserObject *)obj250;
  obj250_uo->super = call256;
  sourceObject = obj250;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit257 == NULL) {
    strlit257 = alloc_String("colon");
    gc_root(strlit257);
  }
// compiled string node returning strlit257 (depth = 6)
  adddatum2(obj250, strlit257, 1);
  sourceObject = obj250;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit258 == NULL) {
    strlit258 = alloc_String(":");
    gc_root(strlit258);
  }
// compiled string node returning strlit258 (depth = 6)
  adddatum2(obj250, strlit258, 2);
  sourceObject = obj250;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num259 = alloc_Float64(1);
// compiled num node returning num259 (depth = 6)
  adddatum2(obj250, num259, 3);
objclass250 = obj250->class;
  objclass250->definitionModule = modulename;
  objclass250->definitionLine = 117;
  (*(struct UserObject *)self).data[0] = lowerouter250;
  self = oldself250;
  selfslot = oldselfslot250;
  stackframe = oldstackframe250;
  gc_frame_end(frame);
  return obj250;
}
Object meth_lexer_new263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject264 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj264 = alloc_userobj2(4,5, objclass264);
  gc_frame_newslot(obj264);
if (objclass264 == NULL) {
  glfree(obj264->class->name);
  obj264->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj264, self, 0);
  addmethodreal(obj264,"outer", &reader_lexer_outer_265);
  Object oldself264 = self;
  struct StackFrameObject *oldstackframe264 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe264);
  gc_frame_newslot((Object)stackframe);
  self = obj264;
  Object *oldselfslot264 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter264 = (*(struct UserObject *)self).data[0], lowerouter264 = thisouter264;
  if (inheritingObject264) {
    struct UserObject *inho264 = (struct UserObject *)inheritingObject264;
    while (inho264->super != GraceDefaultObject) inho264 = (struct UserObject *)inho264->super;
    inho264->super = obj264;
    self = inheritingObject264;
    *selfslot = self;
    lowerouter264 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter264;
  }
if (objclass264 == NULL) {
  Method *reader266 = addmethodrealflags(obj264, "kind",&reader_lexer_kind_266, MFLAG_DEF);
  reader266->definitionModule = modulename;
  reader266->definitionLine = 126;
}
adddatum2(obj264, alloc_Undefined(), 1);
if (objclass264 == NULL) {
  Method *reader267 = addmethodrealflags(obj264, "value",&reader_lexer_value_267, MFLAG_DEF);
  reader267->definitionModule = modulename;
  reader267->definitionLine = 127;
}
adddatum2(obj264, alloc_Undefined(), 2);
if (objclass264 == NULL) {
  Method *reader268 = addmethodrealflags(obj264, "size",&reader_lexer_size_268, MFLAG_DEF);
  reader268->definitionModule = modulename;
  reader268->definitionLine = 128;
}
adddatum2(obj264, alloc_Undefined(), 3);
  sourceObject = obj264;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe269 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call270 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe269);
// compiled call node returning call270 (depth = 6)
  struct UserObject *obj264_uo = (struct UserObject *)obj264;
  obj264_uo->super = call270;
  sourceObject = obj264;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit271 == NULL) {
    strlit271 = alloc_String("dot");
    gc_root(strlit271);
  }
// compiled string node returning strlit271 (depth = 6)
  adddatum2(obj264, strlit271, 1);
  sourceObject = obj264;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit272 == NULL) {
    strlit272 = alloc_String(".");
    gc_root(strlit272);
  }
// compiled string node returning strlit272 (depth = 6)
  adddatum2(obj264, strlit272, 2);
  sourceObject = obj264;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num273 = alloc_Float64(1);
// compiled num node returning num273 (depth = 6)
  adddatum2(obj264, num273, 3);
objclass264 = obj264->class;
  objclass264->definitionModule = modulename;
  objclass264->definitionLine = 123;
  (*(struct UserObject *)self).data[0] = lowerouter264;
  self = oldself264;
  selfslot = oldselfslot264;
  stackframe = oldstackframe264;
  gc_frame_end(frame);
  return obj264;
}
Object meth_lexer_new263_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject264 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj264 = alloc_userobj2(4,5, objclass264);
  gc_frame_newslot(obj264);
if (objclass264 == NULL) {
  glfree(obj264->class->name);
  obj264->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj264, self, 0);
  addmethodreal(obj264,"outer", &reader_lexer_outer_265);
  Object oldself264 = self;
  struct StackFrameObject *oldstackframe264 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe264);
  gc_frame_newslot((Object)stackframe);
  self = obj264;
  Object *oldselfslot264 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter264 = (*(struct UserObject *)self).data[0], lowerouter264 = thisouter264;
  if (inheritingObject264) {
    struct UserObject *inho264 = (struct UserObject *)inheritingObject264;
    while (inho264->super != GraceDefaultObject) inho264 = (struct UserObject *)inho264->super;
    inho264->super = obj264;
    self = inheritingObject264;
    *selfslot = self;
    lowerouter264 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter264;
  }
if (objclass264 == NULL) {
  Method *reader266 = addmethodrealflags(obj264, "kind",&reader_lexer_kind_266, MFLAG_DEF);
  reader266->definitionModule = modulename;
  reader266->definitionLine = 126;
}
adddatum2(obj264, alloc_Undefined(), 1);
if (objclass264 == NULL) {
  Method *reader267 = addmethodrealflags(obj264, "value",&reader_lexer_value_267, MFLAG_DEF);
  reader267->definitionModule = modulename;
  reader267->definitionLine = 127;
}
adddatum2(obj264, alloc_Undefined(), 2);
if (objclass264 == NULL) {
  Method *reader268 = addmethodrealflags(obj264, "size",&reader_lexer_size_268, MFLAG_DEF);
  reader268->definitionModule = modulename;
  reader268->definitionLine = 128;
}
adddatum2(obj264, alloc_Undefined(), 3);
  sourceObject = obj264;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe269 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call270 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe269);
// compiled call node returning call270 (depth = 6)
  struct UserObject *obj264_uo = (struct UserObject *)obj264;
  obj264_uo->super = call270;
  sourceObject = obj264;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit271 == NULL) {
    strlit271 = alloc_String("dot");
    gc_root(strlit271);
  }
// compiled string node returning strlit271 (depth = 6)
  adddatum2(obj264, strlit271, 1);
  sourceObject = obj264;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit272 == NULL) {
    strlit272 = alloc_String(".");
    gc_root(strlit272);
  }
// compiled string node returning strlit272 (depth = 6)
  adddatum2(obj264, strlit272, 2);
  sourceObject = obj264;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num273 = alloc_Float64(1);
// compiled num node returning num273 (depth = 6)
  adddatum2(obj264, num273, 3);
objclass264 = obj264->class;
  objclass264->definitionModule = modulename;
  objclass264->definitionLine = 123;
  (*(struct UserObject *)self).data[0] = lowerouter264;
  self = oldself264;
  selfslot = oldselfslot264;
  stackframe = oldstackframe264;
  gc_frame_end(frame);
  return obj264;
}
Object meth_lexer_new277(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj278 = alloc_userobj2(5,6, objclass278);
  gc_frame_newslot(obj278);
if (objclass278 == NULL) {
  glfree(obj278->class->name);
  obj278->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj278, self, 0);
  addmethodreal(obj278,"outer", &reader_lexer_outer_279);
  Object oldself278 = self;
  struct StackFrameObject *oldstackframe278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe278);
  gc_frame_newslot((Object)stackframe);
  self = obj278;
  Object *oldselfslot278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter278 = (*(struct UserObject *)self).data[0], lowerouter278 = thisouter278;
  if (inheritingObject278) {
    struct UserObject *inho278 = (struct UserObject *)inheritingObject278;
    while (inho278->super != GraceDefaultObject) inho278 = (struct UserObject *)inho278->super;
    inho278->super = obj278;
    self = inheritingObject278;
    *selfslot = self;
    lowerouter278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter278;
  }
if (objclass278 == NULL) {
  Method *reader280 = addmethodrealflags(obj278, "kind",&reader_lexer_kind_280, MFLAG_DEF);
  reader280->definitionModule = modulename;
  reader280->definitionLine = 132;
}
adddatum2(obj278, alloc_Undefined(), 1);
if (objclass278 == NULL) {
  Method *reader281 = addmethodrealflags(obj278, "value",&reader_lexer_value_281, MFLAG_DEF);
  reader281->definitionModule = modulename;
  reader281->definitionLine = 133;
}
adddatum2(obj278, alloc_Undefined(), 2);
if (objclass278 == NULL) {
  Method *reader282 = addmethodrealflags(obj278, "base",&reader_lexer_base_282, MFLAG_DEF);
  reader282->definitionModule = modulename;
  reader282->definitionLine = 134;
}
adddatum2(obj278, alloc_Undefined(), 3);
if (objclass278 == NULL) {
  Method *reader283 = addmethodrealflags(obj278, "size",&reader_lexer_size_283, MFLAG_DEF);
  reader283->definitionModule = modulename;
  reader283->definitionLine = 135;
}
adddatum2(obj278, alloc_Undefined(), 4);
  sourceObject = obj278;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe284 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call285 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe284);
// compiled call node returning call285 (depth = 6)
  struct UserObject *obj278_uo = (struct UserObject *)obj278;
  obj278_uo->super = call285;
  sourceObject = obj278;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit286 == NULL) {
    strlit286 = alloc_String("num");
    gc_root(strlit286);
  }
// compiled string node returning strlit286 (depth = 6)
  adddatum2(obj278, strlit286, 1);
  sourceObject = obj278;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj278, *var_v, 2);
  sourceObject = obj278;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  adddatum2(obj278, *var_b, 3);
  sourceObject = obj278;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startPosition (depth = 7)
  int op_slot_right_287 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_287 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff289 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff289 (depth = 6)
  adddatum2(obj278, diff289, 4);
objclass278 = obj278->class;
  objclass278->definitionModule = modulename;
  objclass278->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter278;
  self = oldself278;
  selfslot = oldselfslot278;
  stackframe = oldstackframe278;
  gc_frame_end(frame);
  return obj278;
}
Object meth_lexer_new277_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject278 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj278 = alloc_userobj2(5,6, objclass278);
  gc_frame_newslot(obj278);
if (objclass278 == NULL) {
  glfree(obj278->class->name);
  obj278->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj278, self, 0);
  addmethodreal(obj278,"outer", &reader_lexer_outer_279);
  Object oldself278 = self;
  struct StackFrameObject *oldstackframe278 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe278);
  gc_frame_newslot((Object)stackframe);
  self = obj278;
  Object *oldselfslot278 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter278 = (*(struct UserObject *)self).data[0], lowerouter278 = thisouter278;
  if (inheritingObject278) {
    struct UserObject *inho278 = (struct UserObject *)inheritingObject278;
    while (inho278->super != GraceDefaultObject) inho278 = (struct UserObject *)inho278->super;
    inho278->super = obj278;
    self = inheritingObject278;
    *selfslot = self;
    lowerouter278 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter278;
  }
if (objclass278 == NULL) {
  Method *reader280 = addmethodrealflags(obj278, "kind",&reader_lexer_kind_280, MFLAG_DEF);
  reader280->definitionModule = modulename;
  reader280->definitionLine = 132;
}
adddatum2(obj278, alloc_Undefined(), 1);
if (objclass278 == NULL) {
  Method *reader281 = addmethodrealflags(obj278, "value",&reader_lexer_value_281, MFLAG_DEF);
  reader281->definitionModule = modulename;
  reader281->definitionLine = 133;
}
adddatum2(obj278, alloc_Undefined(), 2);
if (objclass278 == NULL) {
  Method *reader282 = addmethodrealflags(obj278, "base",&reader_lexer_base_282, MFLAG_DEF);
  reader282->definitionModule = modulename;
  reader282->definitionLine = 134;
}
adddatum2(obj278, alloc_Undefined(), 3);
if (objclass278 == NULL) {
  Method *reader283 = addmethodrealflags(obj278, "size",&reader_lexer_size_283, MFLAG_DEF);
  reader283->definitionModule = modulename;
  reader283->definitionLine = 135;
}
adddatum2(obj278, alloc_Undefined(), 4);
  sourceObject = obj278;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe284 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call285 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe284);
// compiled call node returning call285 (depth = 6)
  struct UserObject *obj278_uo = (struct UserObject *)obj278;
  obj278_uo->super = call285;
  sourceObject = obj278;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit286 == NULL) {
    strlit286 = alloc_String("num");
    gc_root(strlit286);
  }
// compiled string node returning strlit286 (depth = 6)
  adddatum2(obj278, strlit286, 1);
  sourceObject = obj278;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj278, *var_v, 2);
  sourceObject = obj278;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  adddatum2(obj278, *var_b, 3);
  sourceObject = obj278;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startPosition (depth = 7)
  int op_slot_right_287 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_287 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff289 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff289 (depth = 6)
  adddatum2(obj278, diff289, 4);
objclass278 = obj278->class;
  objclass278->definitionModule = modulename;
  objclass278->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter278;
  self = oldself278;
  selfslot = oldselfslot278;
  stackframe = oldstackframe278;
  gc_frame_end(frame);
  return obj278;
}
Object meth_lexer_new293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject294 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj294 = alloc_userobj2(4,5, objclass294);
  gc_frame_newslot(obj294);
if (objclass294 == NULL) {
  glfree(obj294->class->name);
  obj294->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj294, self, 0);
  addmethodreal(obj294,"outer", &reader_lexer_outer_295);
  Object oldself294 = self;
  struct StackFrameObject *oldstackframe294 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe294);
  gc_frame_newslot((Object)stackframe);
  self = obj294;
  Object *oldselfslot294 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter294 = (*(struct UserObject *)self).data[0], lowerouter294 = thisouter294;
  if (inheritingObject294) {
    struct UserObject *inho294 = (struct UserObject *)inheritingObject294;
    while (inho294->super != GraceDefaultObject) inho294 = (struct UserObject *)inho294->super;
    inho294->super = obj294;
    self = inheritingObject294;
    *selfslot = self;
    lowerouter294 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter294;
  }
if (objclass294 == NULL) {
  Method *reader296 = addmethodrealflags(obj294, "kind",&reader_lexer_kind_296, MFLAG_DEF);
  reader296->definitionModule = modulename;
  reader296->definitionLine = 139;
}
adddatum2(obj294, alloc_Undefined(), 1);
if (objclass294 == NULL) {
  Method *reader297 = addmethodrealflags(obj294, "value",&reader_lexer_value_297, MFLAG_DEF);
  reader297->definitionModule = modulename;
  reader297->definitionLine = 140;
}
adddatum2(obj294, alloc_Undefined(), 2);
if (objclass294 == NULL) {
  Method *reader298 = addmethodrealflags(obj294, "size",&reader_lexer_size_298, MFLAG_DEF);
  reader298->definitionModule = modulename;
  reader298->definitionLine = 141;
}
adddatum2(obj294, alloc_Undefined(), 3);
  sourceObject = obj294;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe299 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call300 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 6)
  struct UserObject *obj294_uo = (struct UserObject *)obj294;
  obj294_uo->super = call300;
  sourceObject = obj294;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit301 == NULL) {
    strlit301 = alloc_String("keyword");
    gc_root(strlit301);
  }
// compiled string node returning strlit301 (depth = 6)
  adddatum2(obj294, strlit301, 1);
  sourceObject = obj294;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj294, *var_v, 2);
  sourceObject = obj294;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call303 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 7)
// compiled member node returning call303 (depth = 6)
  adddatum2(obj294, call303, 3);
objclass294 = obj294->class;
  objclass294->definitionModule = modulename;
  objclass294->definitionLine = 136;
  (*(struct UserObject *)self).data[0] = lowerouter294;
  self = oldself294;
  selfslot = oldselfslot294;
  stackframe = oldstackframe294;
  gc_frame_end(frame);
  return obj294;
}
Object meth_lexer_new293_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject294 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj294 = alloc_userobj2(4,5, objclass294);
  gc_frame_newslot(obj294);
if (objclass294 == NULL) {
  glfree(obj294->class->name);
  obj294->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj294, self, 0);
  addmethodreal(obj294,"outer", &reader_lexer_outer_295);
  Object oldself294 = self;
  struct StackFrameObject *oldstackframe294 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe294);
  gc_frame_newslot((Object)stackframe);
  self = obj294;
  Object *oldselfslot294 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter294 = (*(struct UserObject *)self).data[0], lowerouter294 = thisouter294;
  if (inheritingObject294) {
    struct UserObject *inho294 = (struct UserObject *)inheritingObject294;
    while (inho294->super != GraceDefaultObject) inho294 = (struct UserObject *)inho294->super;
    inho294->super = obj294;
    self = inheritingObject294;
    *selfslot = self;
    lowerouter294 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter294;
  }
if (objclass294 == NULL) {
  Method *reader296 = addmethodrealflags(obj294, "kind",&reader_lexer_kind_296, MFLAG_DEF);
  reader296->definitionModule = modulename;
  reader296->definitionLine = 139;
}
adddatum2(obj294, alloc_Undefined(), 1);
if (objclass294 == NULL) {
  Method *reader297 = addmethodrealflags(obj294, "value",&reader_lexer_value_297, MFLAG_DEF);
  reader297->definitionModule = modulename;
  reader297->definitionLine = 140;
}
adddatum2(obj294, alloc_Undefined(), 2);
if (objclass294 == NULL) {
  Method *reader298 = addmethodrealflags(obj294, "size",&reader_lexer_size_298, MFLAG_DEF);
  reader298->definitionModule = modulename;
  reader298->definitionLine = 141;
}
adddatum2(obj294, alloc_Undefined(), 3);
  sourceObject = obj294;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe299 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call300 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 6)
  struct UserObject *obj294_uo = (struct UserObject *)obj294;
  obj294_uo->super = call300;
  sourceObject = obj294;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit301 == NULL) {
    strlit301 = alloc_String("keyword");
    gc_root(strlit301);
  }
// compiled string node returning strlit301 (depth = 6)
  adddatum2(obj294, strlit301, 1);
  sourceObject = obj294;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj294, *var_v, 2);
  sourceObject = obj294;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call303 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 7)
// compiled member node returning call303 (depth = 6)
  adddatum2(obj294, call303, 3);
objclass294 = obj294->class;
  objclass294->definitionModule = modulename;
  objclass294->definitionLine = 136;
  (*(struct UserObject *)self).data[0] = lowerouter294;
  self = oldself294;
  selfslot = oldselfslot294;
  stackframe = oldstackframe294;
  gc_frame_end(frame);
  return obj294;
}
Object meth_lexer_new307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj308 = alloc_userobj2(4,5, objclass308);
  gc_frame_newslot(obj308);
if (objclass308 == NULL) {
  glfree(obj308->class->name);
  obj308->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj308, self, 0);
  addmethodreal(obj308,"outer", &reader_lexer_outer_309);
  Object oldself308 = self;
  struct StackFrameObject *oldstackframe308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe308);
  gc_frame_newslot((Object)stackframe);
  self = obj308;
  Object *oldselfslot308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter308 = (*(struct UserObject *)self).data[0], lowerouter308 = thisouter308;
  if (inheritingObject308) {
    struct UserObject *inho308 = (struct UserObject *)inheritingObject308;
    while (inho308->super != GraceDefaultObject) inho308 = (struct UserObject *)inho308->super;
    inho308->super = obj308;
    self = inheritingObject308;
    *selfslot = self;
    lowerouter308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter308;
  }
if (objclass308 == NULL) {
  Method *reader310 = addmethodrealflags(obj308, "kind",&reader_lexer_kind_310, MFLAG_DEF);
  reader310->definitionModule = modulename;
  reader310->definitionLine = 145;
}
adddatum2(obj308, alloc_Undefined(), 1);
if (objclass308 == NULL) {
  Method *reader311 = addmethodrealflags(obj308, "value",&reader_lexer_value_311, MFLAG_DEF);
  reader311->definitionModule = modulename;
  reader311->definitionLine = 146;
}
adddatum2(obj308, alloc_Undefined(), 2);
if (objclass308 == NULL) {
  Method *reader312 = addmethodrealflags(obj308, "size",&reader_lexer_size_312, MFLAG_DEF);
  reader312->definitionModule = modulename;
  reader312->definitionLine = 147;
}
adddatum2(obj308, alloc_Undefined(), 3);
  sourceObject = obj308;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe313 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call314 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe313);
// compiled call node returning call314 (depth = 6)
  struct UserObject *obj308_uo = (struct UserObject *)obj308;
  obj308_uo->super = call314;
  sourceObject = obj308;
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit315 == NULL) {
    strlit315 = alloc_String("op");
    gc_root(strlit315);
  }
// compiled string node returning strlit315 (depth = 6)
  adddatum2(obj308, strlit315, 1);
  sourceObject = obj308;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj308, *var_v, 2);
  sourceObject = obj308;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call317 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe316);
// compiled call node returning call317 (depth = 7)
// compiled member node returning call317 (depth = 6)
  adddatum2(obj308, call317, 3);
objclass308 = obj308->class;
  objclass308->definitionModule = modulename;
  objclass308->definitionLine = 142;
  (*(struct UserObject *)self).data[0] = lowerouter308;
  self = oldself308;
  selfslot = oldselfslot308;
  stackframe = oldstackframe308;
  gc_frame_end(frame);
  return obj308;
}
Object meth_lexer_new307_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj308 = alloc_userobj2(4,5, objclass308);
  gc_frame_newslot(obj308);
if (objclass308 == NULL) {
  glfree(obj308->class->name);
  obj308->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj308, self, 0);
  addmethodreal(obj308,"outer", &reader_lexer_outer_309);
  Object oldself308 = self;
  struct StackFrameObject *oldstackframe308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe308);
  gc_frame_newslot((Object)stackframe);
  self = obj308;
  Object *oldselfslot308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter308 = (*(struct UserObject *)self).data[0], lowerouter308 = thisouter308;
  if (inheritingObject308) {
    struct UserObject *inho308 = (struct UserObject *)inheritingObject308;
    while (inho308->super != GraceDefaultObject) inho308 = (struct UserObject *)inho308->super;
    inho308->super = obj308;
    self = inheritingObject308;
    *selfslot = self;
    lowerouter308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter308;
  }
if (objclass308 == NULL) {
  Method *reader310 = addmethodrealflags(obj308, "kind",&reader_lexer_kind_310, MFLAG_DEF);
  reader310->definitionModule = modulename;
  reader310->definitionLine = 145;
}
adddatum2(obj308, alloc_Undefined(), 1);
if (objclass308 == NULL) {
  Method *reader311 = addmethodrealflags(obj308, "value",&reader_lexer_value_311, MFLAG_DEF);
  reader311->definitionModule = modulename;
  reader311->definitionLine = 146;
}
adddatum2(obj308, alloc_Undefined(), 2);
if (objclass308 == NULL) {
  Method *reader312 = addmethodrealflags(obj308, "size",&reader_lexer_size_312, MFLAG_DEF);
  reader312->definitionModule = modulename;
  reader312->definitionLine = 147;
}
adddatum2(obj308, alloc_Undefined(), 3);
  sourceObject = obj308;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe313 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call314 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe313);
// compiled call node returning call314 (depth = 6)
  struct UserObject *obj308_uo = (struct UserObject *)obj308;
  obj308_uo->super = call314;
  sourceObject = obj308;
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit315 == NULL) {
    strlit315 = alloc_String("op");
    gc_root(strlit315);
  }
// compiled string node returning strlit315 (depth = 6)
  adddatum2(obj308, strlit315, 1);
  sourceObject = obj308;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj308, *var_v, 2);
  sourceObject = obj308;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call317 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe316);
// compiled call node returning call317 (depth = 7)
// compiled member node returning call317 (depth = 6)
  adddatum2(obj308, call317, 3);
objclass308 = obj308->class;
  objclass308->definitionModule = modulename;
  objclass308->definitionLine = 142;
  (*(struct UserObject *)self).data[0] = lowerouter308;
  self = oldself308;
  selfslot = oldselfslot308;
  stackframe = oldstackframe308;
  gc_frame_end(frame);
  return obj308;
}
Object meth_lexer_new321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject322 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj322 = alloc_userobj2(4,5, objclass322);
  gc_frame_newslot(obj322);
if (objclass322 == NULL) {
  glfree(obj322->class->name);
  obj322->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj322, self, 0);
  addmethodreal(obj322,"outer", &reader_lexer_outer_323);
  Object oldself322 = self;
  struct StackFrameObject *oldstackframe322 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe322);
  gc_frame_newslot((Object)stackframe);
  self = obj322;
  Object *oldselfslot322 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter322 = (*(struct UserObject *)self).data[0], lowerouter322 = thisouter322;
  if (inheritingObject322) {
    struct UserObject *inho322 = (struct UserObject *)inheritingObject322;
    while (inho322->super != GraceDefaultObject) inho322 = (struct UserObject *)inho322->super;
    inho322->super = obj322;
    self = inheritingObject322;
    *selfslot = self;
    lowerouter322 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter322;
  }
if (objclass322 == NULL) {
  Method *reader324 = addmethodrealflags(obj322, "kind",&reader_lexer_kind_324, MFLAG_DEF);
  reader324->definitionModule = modulename;
  reader324->definitionLine = 151;
}
adddatum2(obj322, alloc_Undefined(), 1);
if (objclass322 == NULL) {
  Method *reader325 = addmethodrealflags(obj322, "value",&reader_lexer_value_325, MFLAG_DEF);
  reader325->definitionModule = modulename;
  reader325->definitionLine = 152;
}
adddatum2(obj322, alloc_Undefined(), 2);
if (objclass322 == NULL) {
  Method *reader326 = addmethodrealflags(obj322, "size",&reader_lexer_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 153;
}
adddatum2(obj322, alloc_Undefined(), 3);
  sourceObject = obj322;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe327 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call328 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe327);
// compiled call node returning call328 (depth = 6)
  struct UserObject *obj322_uo = (struct UserObject *)obj322;
  obj322_uo->super = call328;
  sourceObject = obj322;
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit329 == NULL) {
    strlit329 = alloc_String("arrow");
    gc_root(strlit329);
  }
// compiled string node returning strlit329 (depth = 6)
  adddatum2(obj322, strlit329, 1);
  sourceObject = obj322;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit330 == NULL) {
    strlit330 = alloc_String("->");
    gc_root(strlit330);
  }
// compiled string node returning strlit330 (depth = 6)
  adddatum2(obj322, strlit330, 2);
  sourceObject = obj322;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num331 = alloc_Float64(2);
// compiled num node returning num331 (depth = 6)
  adddatum2(obj322, num331, 3);
objclass322 = obj322->class;
  objclass322->definitionModule = modulename;
  objclass322->definitionLine = 148;
  (*(struct UserObject *)self).data[0] = lowerouter322;
  self = oldself322;
  selfslot = oldselfslot322;
  stackframe = oldstackframe322;
  gc_frame_end(frame);
  return obj322;
}
Object meth_lexer_new321_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject322 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj322 = alloc_userobj2(4,5, objclass322);
  gc_frame_newslot(obj322);
if (objclass322 == NULL) {
  glfree(obj322->class->name);
  obj322->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj322, self, 0);
  addmethodreal(obj322,"outer", &reader_lexer_outer_323);
  Object oldself322 = self;
  struct StackFrameObject *oldstackframe322 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe322);
  gc_frame_newslot((Object)stackframe);
  self = obj322;
  Object *oldselfslot322 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter322 = (*(struct UserObject *)self).data[0], lowerouter322 = thisouter322;
  if (inheritingObject322) {
    struct UserObject *inho322 = (struct UserObject *)inheritingObject322;
    while (inho322->super != GraceDefaultObject) inho322 = (struct UserObject *)inho322->super;
    inho322->super = obj322;
    self = inheritingObject322;
    *selfslot = self;
    lowerouter322 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter322;
  }
if (objclass322 == NULL) {
  Method *reader324 = addmethodrealflags(obj322, "kind",&reader_lexer_kind_324, MFLAG_DEF);
  reader324->definitionModule = modulename;
  reader324->definitionLine = 151;
}
adddatum2(obj322, alloc_Undefined(), 1);
if (objclass322 == NULL) {
  Method *reader325 = addmethodrealflags(obj322, "value",&reader_lexer_value_325, MFLAG_DEF);
  reader325->definitionModule = modulename;
  reader325->definitionLine = 152;
}
adddatum2(obj322, alloc_Undefined(), 2);
if (objclass322 == NULL) {
  Method *reader326 = addmethodrealflags(obj322, "size",&reader_lexer_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 153;
}
adddatum2(obj322, alloc_Undefined(), 3);
  sourceObject = obj322;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe327 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call328 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe327);
// compiled call node returning call328 (depth = 6)
  struct UserObject *obj322_uo = (struct UserObject *)obj322;
  obj322_uo->super = call328;
  sourceObject = obj322;
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit329 == NULL) {
    strlit329 = alloc_String("arrow");
    gc_root(strlit329);
  }
// compiled string node returning strlit329 (depth = 6)
  adddatum2(obj322, strlit329, 1);
  sourceObject = obj322;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit330 == NULL) {
    strlit330 = alloc_String("->");
    gc_root(strlit330);
  }
// compiled string node returning strlit330 (depth = 6)
  adddatum2(obj322, strlit330, 2);
  sourceObject = obj322;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num331 = alloc_Float64(2);
// compiled num node returning num331 (depth = 6)
  adddatum2(obj322, num331, 3);
objclass322 = obj322->class;
  objclass322->definitionModule = modulename;
  objclass322->definitionLine = 148;
  (*(struct UserObject *)self).data[0] = lowerouter322;
  self = oldself322;
  selfslot = oldselfslot322;
  stackframe = oldstackframe322;
  gc_frame_end(frame);
  return obj322;
}
Object meth_lexer_new335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject336 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj336 = alloc_userobj2(4,5, objclass336);
  gc_frame_newslot(obj336);
if (objclass336 == NULL) {
  glfree(obj336->class->name);
  obj336->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj336, self, 0);
  addmethodreal(obj336,"outer", &reader_lexer_outer_337);
  Object oldself336 = self;
  struct StackFrameObject *oldstackframe336 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe336);
  gc_frame_newslot((Object)stackframe);
  self = obj336;
  Object *oldselfslot336 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter336 = (*(struct UserObject *)self).data[0], lowerouter336 = thisouter336;
  if (inheritingObject336) {
    struct UserObject *inho336 = (struct UserObject *)inheritingObject336;
    while (inho336->super != GraceDefaultObject) inho336 = (struct UserObject *)inho336->super;
    inho336->super = obj336;
    self = inheritingObject336;
    *selfslot = self;
    lowerouter336 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter336;
  }
if (objclass336 == NULL) {
  Method *reader338 = addmethodrealflags(obj336, "kind",&reader_lexer_kind_338, MFLAG_DEF);
  reader338->definitionModule = modulename;
  reader338->definitionLine = 157;
}
adddatum2(obj336, alloc_Undefined(), 1);
if (objclass336 == NULL) {
  Method *reader339 = addmethodrealflags(obj336, "value",&reader_lexer_value_339, MFLAG_DEF);
  reader339->definitionModule = modulename;
  reader339->definitionLine = 158;
}
adddatum2(obj336, alloc_Undefined(), 2);
if (objclass336 == NULL) {
  Method *reader340 = addmethodrealflags(obj336, "size",&reader_lexer_size_340, MFLAG_DEF);
  reader340->definitionModule = modulename;
  reader340->definitionLine = 159;
}
adddatum2(obj336, alloc_Undefined(), 3);
  sourceObject = obj336;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call342 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 6)
  struct UserObject *obj336_uo = (struct UserObject *)obj336;
  obj336_uo->super = call342;
  sourceObject = obj336;
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit343 == NULL) {
    strlit343 = alloc_String("bind");
    gc_root(strlit343);
  }
// compiled string node returning strlit343 (depth = 6)
  adddatum2(obj336, strlit343, 1);
  sourceObject = obj336;
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit344 == NULL) {
    strlit344 = alloc_String(":=");
    gc_root(strlit344);
  }
// compiled string node returning strlit344 (depth = 6)
  adddatum2(obj336, strlit344, 2);
  sourceObject = obj336;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num345 = alloc_Float64(2);
// compiled num node returning num345 (depth = 6)
  adddatum2(obj336, num345, 3);
objclass336 = obj336->class;
  objclass336->definitionModule = modulename;
  objclass336->definitionLine = 154;
  (*(struct UserObject *)self).data[0] = lowerouter336;
  self = oldself336;
  selfslot = oldselfslot336;
  stackframe = oldstackframe336;
  gc_frame_end(frame);
  return obj336;
}
Object meth_lexer_new335_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject336 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj336 = alloc_userobj2(4,5, objclass336);
  gc_frame_newslot(obj336);
if (objclass336 == NULL) {
  glfree(obj336->class->name);
  obj336->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj336, self, 0);
  addmethodreal(obj336,"outer", &reader_lexer_outer_337);
  Object oldself336 = self;
  struct StackFrameObject *oldstackframe336 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe336);
  gc_frame_newslot((Object)stackframe);
  self = obj336;
  Object *oldselfslot336 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter336 = (*(struct UserObject *)self).data[0], lowerouter336 = thisouter336;
  if (inheritingObject336) {
    struct UserObject *inho336 = (struct UserObject *)inheritingObject336;
    while (inho336->super != GraceDefaultObject) inho336 = (struct UserObject *)inho336->super;
    inho336->super = obj336;
    self = inheritingObject336;
    *selfslot = self;
    lowerouter336 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter336;
  }
if (objclass336 == NULL) {
  Method *reader338 = addmethodrealflags(obj336, "kind",&reader_lexer_kind_338, MFLAG_DEF);
  reader338->definitionModule = modulename;
  reader338->definitionLine = 157;
}
adddatum2(obj336, alloc_Undefined(), 1);
if (objclass336 == NULL) {
  Method *reader339 = addmethodrealflags(obj336, "value",&reader_lexer_value_339, MFLAG_DEF);
  reader339->definitionModule = modulename;
  reader339->definitionLine = 158;
}
adddatum2(obj336, alloc_Undefined(), 2);
if (objclass336 == NULL) {
  Method *reader340 = addmethodrealflags(obj336, "size",&reader_lexer_size_340, MFLAG_DEF);
  reader340->definitionModule = modulename;
  reader340->definitionLine = 159;
}
adddatum2(obj336, alloc_Undefined(), 3);
  sourceObject = obj336;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe341 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call342 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 6)
  struct UserObject *obj336_uo = (struct UserObject *)obj336;
  obj336_uo->super = call342;
  sourceObject = obj336;
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit343 == NULL) {
    strlit343 = alloc_String("bind");
    gc_root(strlit343);
  }
// compiled string node returning strlit343 (depth = 6)
  adddatum2(obj336, strlit343, 1);
  sourceObject = obj336;
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit344 == NULL) {
    strlit344 = alloc_String(":=");
    gc_root(strlit344);
  }
// compiled string node returning strlit344 (depth = 6)
  adddatum2(obj336, strlit344, 2);
  sourceObject = obj336;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num345 = alloc_Float64(2);
// compiled num node returning num345 (depth = 6)
  adddatum2(obj336, num345, 3);
objclass336 = obj336->class;
  objclass336->definitionModule = modulename;
  objclass336->definitionLine = 154;
  (*(struct UserObject *)self).data[0] = lowerouter336;
  self = oldself336;
  selfslot = oldselfslot336;
  stackframe = oldstackframe336;
  gc_frame_end(frame);
  return obj336;
}
Object meth_lexer_new349(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject350 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj350 = alloc_userobj2(4,5, objclass350);
  gc_frame_newslot(obj350);
if (objclass350 == NULL) {
  glfree(obj350->class->name);
  obj350->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj350, self, 0);
  addmethodreal(obj350,"outer", &reader_lexer_outer_351);
  Object oldself350 = self;
  struct StackFrameObject *oldstackframe350 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe350);
  gc_frame_newslot((Object)stackframe);
  self = obj350;
  Object *oldselfslot350 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter350 = (*(struct UserObject *)self).data[0], lowerouter350 = thisouter350;
  if (inheritingObject350) {
    struct UserObject *inho350 = (struct UserObject *)inheritingObject350;
    while (inho350->super != GraceDefaultObject) inho350 = (struct UserObject *)inho350->super;
    inho350->super = obj350;
    self = inheritingObject350;
    *selfslot = self;
    lowerouter350 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter350;
  }
if (objclass350 == NULL) {
  Method *reader352 = addmethodrealflags(obj350, "kind",&reader_lexer_kind_352, MFLAG_DEF);
  reader352->definitionModule = modulename;
  reader352->definitionLine = 163;
}
adddatum2(obj350, alloc_Undefined(), 1);
if (objclass350 == NULL) {
  Method *reader353 = addmethodrealflags(obj350, "value",&reader_lexer_value_353, MFLAG_DEF);
  reader353->definitionModule = modulename;
  reader353->definitionLine = 164;
}
adddatum2(obj350, alloc_Undefined(), 2);
if (objclass350 == NULL) {
  Method *reader354 = addmethodrealflags(obj350, "size",&reader_lexer_size_354, MFLAG_DEF);
  reader354->definitionModule = modulename;
  reader354->definitionLine = 165;
}
adddatum2(obj350, alloc_Undefined(), 3);
  sourceObject = obj350;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe355 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call356 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe355);
// compiled call node returning call356 (depth = 6)
  struct UserObject *obj350_uo = (struct UserObject *)obj350;
  obj350_uo->super = call356;
  sourceObject = obj350;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit357 == NULL) {
    strlit357 = alloc_String("semicolon");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 6)
  adddatum2(obj350, strlit357, 1);
  sourceObject = obj350;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit358 == NULL) {
    strlit358 = alloc_String(";");
    gc_root(strlit358);
  }
// compiled string node returning strlit358 (depth = 6)
  adddatum2(obj350, strlit358, 2);
  sourceObject = obj350;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num359 = alloc_Float64(1);
// compiled num node returning num359 (depth = 6)
  adddatum2(obj350, num359, 3);
objclass350 = obj350->class;
  objclass350->definitionModule = modulename;
  objclass350->definitionLine = 160;
  (*(struct UserObject *)self).data[0] = lowerouter350;
  self = oldself350;
  selfslot = oldselfslot350;
  stackframe = oldstackframe350;
  gc_frame_end(frame);
  return obj350;
}
Object meth_lexer_new349_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject350 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj350 = alloc_userobj2(4,5, objclass350);
  gc_frame_newslot(obj350);
if (objclass350 == NULL) {
  glfree(obj350->class->name);
  obj350->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj350, self, 0);
  addmethodreal(obj350,"outer", &reader_lexer_outer_351);
  Object oldself350 = self;
  struct StackFrameObject *oldstackframe350 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe350);
  gc_frame_newslot((Object)stackframe);
  self = obj350;
  Object *oldselfslot350 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter350 = (*(struct UserObject *)self).data[0], lowerouter350 = thisouter350;
  if (inheritingObject350) {
    struct UserObject *inho350 = (struct UserObject *)inheritingObject350;
    while (inho350->super != GraceDefaultObject) inho350 = (struct UserObject *)inho350->super;
    inho350->super = obj350;
    self = inheritingObject350;
    *selfslot = self;
    lowerouter350 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter350;
  }
if (objclass350 == NULL) {
  Method *reader352 = addmethodrealflags(obj350, "kind",&reader_lexer_kind_352, MFLAG_DEF);
  reader352->definitionModule = modulename;
  reader352->definitionLine = 163;
}
adddatum2(obj350, alloc_Undefined(), 1);
if (objclass350 == NULL) {
  Method *reader353 = addmethodrealflags(obj350, "value",&reader_lexer_value_353, MFLAG_DEF);
  reader353->definitionModule = modulename;
  reader353->definitionLine = 164;
}
adddatum2(obj350, alloc_Undefined(), 2);
if (objclass350 == NULL) {
  Method *reader354 = addmethodrealflags(obj350, "size",&reader_lexer_size_354, MFLAG_DEF);
  reader354->definitionModule = modulename;
  reader354->definitionLine = 165;
}
adddatum2(obj350, alloc_Undefined(), 3);
  sourceObject = obj350;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe355 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call356 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe355);
// compiled call node returning call356 (depth = 6)
  struct UserObject *obj350_uo = (struct UserObject *)obj350;
  obj350_uo->super = call356;
  sourceObject = obj350;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit357 == NULL) {
    strlit357 = alloc_String("semicolon");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 6)
  adddatum2(obj350, strlit357, 1);
  sourceObject = obj350;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit358 == NULL) {
    strlit358 = alloc_String(";");
    gc_root(strlit358);
  }
// compiled string node returning strlit358 (depth = 6)
  adddatum2(obj350, strlit358, 2);
  sourceObject = obj350;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num359 = alloc_Float64(1);
// compiled num node returning num359 (depth = 6)
  adddatum2(obj350, num359, 3);
objclass350 = obj350->class;
  objclass350->definitionModule = modulename;
  objclass350->definitionLine = 160;
  (*(struct UserObject *)self).data[0] = lowerouter350;
  self = oldself350;
  selfslot = oldselfslot350;
  stackframe = oldstackframe350;
  gc_frame_end(frame);
  return obj350;
}
Object meth_lexer_new363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject364 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj364 = alloc_userobj2(4,5, objclass364);
  gc_frame_newslot(obj364);
if (objclass364 == NULL) {
  glfree(obj364->class->name);
  obj364->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj364, self, 0);
  addmethodreal(obj364,"outer", &reader_lexer_outer_365);
  Object oldself364 = self;
  struct StackFrameObject *oldstackframe364 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe364);
  gc_frame_newslot((Object)stackframe);
  self = obj364;
  Object *oldselfslot364 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter364 = (*(struct UserObject *)self).data[0], lowerouter364 = thisouter364;
  if (inheritingObject364) {
    struct UserObject *inho364 = (struct UserObject *)inheritingObject364;
    while (inho364->super != GraceDefaultObject) inho364 = (struct UserObject *)inho364->super;
    inho364->super = obj364;
    self = inheritingObject364;
    *selfslot = self;
    lowerouter364 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter364;
  }
if (objclass364 == NULL) {
  Method *reader366 = addmethodrealflags(obj364, "kind",&reader_lexer_kind_366, MFLAG_DEF);
  reader366->definitionModule = modulename;
  reader366->definitionLine = 169;
}
adddatum2(obj364, alloc_Undefined(), 1);
if (objclass364 == NULL) {
  Method *reader367 = addmethodrealflags(obj364, "value",&reader_lexer_value_367, MFLAG_DEF);
  reader367->definitionModule = modulename;
  reader367->definitionLine = 170;
}
adddatum2(obj364, alloc_Undefined(), 2);
if (objclass364 == NULL) {
  Method *reader368 = addmethodrealflags(obj364, "size",&reader_lexer_size_368, MFLAG_DEF);
  reader368->definitionModule = modulename;
  reader368->definitionLine = 171;
}
adddatum2(obj364, alloc_Undefined(), 3);
  sourceObject = obj364;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe369 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call370 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 6)
  struct UserObject *obj364_uo = (struct UserObject *)obj364;
  obj364_uo->super = call370;
  sourceObject = obj364;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit371 == NULL) {
    strlit371 = alloc_String("lgeneric");
    gc_root(strlit371);
  }
// compiled string node returning strlit371 (depth = 6)
  adddatum2(obj364, strlit371, 1);
  sourceObject = obj364;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit372 == NULL) {
    strlit372 = alloc_String("<");
    gc_root(strlit372);
  }
// compiled string node returning strlit372 (depth = 6)
  adddatum2(obj364, strlit372, 2);
  sourceObject = obj364;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num373 = alloc_Float64(1);
// compiled num node returning num373 (depth = 6)
  adddatum2(obj364, num373, 3);
objclass364 = obj364->class;
  objclass364->definitionModule = modulename;
  objclass364->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter364;
  self = oldself364;
  selfslot = oldselfslot364;
  stackframe = oldstackframe364;
  gc_frame_end(frame);
  return obj364;
}
Object meth_lexer_new363_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject364 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj364 = alloc_userobj2(4,5, objclass364);
  gc_frame_newslot(obj364);
if (objclass364 == NULL) {
  glfree(obj364->class->name);
  obj364->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj364, self, 0);
  addmethodreal(obj364,"outer", &reader_lexer_outer_365);
  Object oldself364 = self;
  struct StackFrameObject *oldstackframe364 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe364);
  gc_frame_newslot((Object)stackframe);
  self = obj364;
  Object *oldselfslot364 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter364 = (*(struct UserObject *)self).data[0], lowerouter364 = thisouter364;
  if (inheritingObject364) {
    struct UserObject *inho364 = (struct UserObject *)inheritingObject364;
    while (inho364->super != GraceDefaultObject) inho364 = (struct UserObject *)inho364->super;
    inho364->super = obj364;
    self = inheritingObject364;
    *selfslot = self;
    lowerouter364 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter364;
  }
if (objclass364 == NULL) {
  Method *reader366 = addmethodrealflags(obj364, "kind",&reader_lexer_kind_366, MFLAG_DEF);
  reader366->definitionModule = modulename;
  reader366->definitionLine = 169;
}
adddatum2(obj364, alloc_Undefined(), 1);
if (objclass364 == NULL) {
  Method *reader367 = addmethodrealflags(obj364, "value",&reader_lexer_value_367, MFLAG_DEF);
  reader367->definitionModule = modulename;
  reader367->definitionLine = 170;
}
adddatum2(obj364, alloc_Undefined(), 2);
if (objclass364 == NULL) {
  Method *reader368 = addmethodrealflags(obj364, "size",&reader_lexer_size_368, MFLAG_DEF);
  reader368->definitionModule = modulename;
  reader368->definitionLine = 171;
}
adddatum2(obj364, alloc_Undefined(), 3);
  sourceObject = obj364;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe369 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call370 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 6)
  struct UserObject *obj364_uo = (struct UserObject *)obj364;
  obj364_uo->super = call370;
  sourceObject = obj364;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit371 == NULL) {
    strlit371 = alloc_String("lgeneric");
    gc_root(strlit371);
  }
// compiled string node returning strlit371 (depth = 6)
  adddatum2(obj364, strlit371, 1);
  sourceObject = obj364;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit372 == NULL) {
    strlit372 = alloc_String("<");
    gc_root(strlit372);
  }
// compiled string node returning strlit372 (depth = 6)
  adddatum2(obj364, strlit372, 2);
  sourceObject = obj364;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num373 = alloc_Float64(1);
// compiled num node returning num373 (depth = 6)
  adddatum2(obj364, num373, 3);
objclass364 = obj364->class;
  objclass364->definitionModule = modulename;
  objclass364->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter364;
  self = oldself364;
  selfslot = oldselfslot364;
  stackframe = oldstackframe364;
  gc_frame_end(frame);
  return obj364;
}
Object meth_lexer_new377(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject378 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj378 = alloc_userobj2(4,5, objclass378);
  gc_frame_newslot(obj378);
if (objclass378 == NULL) {
  glfree(obj378->class->name);
  obj378->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj378, self, 0);
  addmethodreal(obj378,"outer", &reader_lexer_outer_379);
  Object oldself378 = self;
  struct StackFrameObject *oldstackframe378 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe378);
  gc_frame_newslot((Object)stackframe);
  self = obj378;
  Object *oldselfslot378 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter378 = (*(struct UserObject *)self).data[0], lowerouter378 = thisouter378;
  if (inheritingObject378) {
    struct UserObject *inho378 = (struct UserObject *)inheritingObject378;
    while (inho378->super != GraceDefaultObject) inho378 = (struct UserObject *)inho378->super;
    inho378->super = obj378;
    self = inheritingObject378;
    *selfslot = self;
    lowerouter378 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter378;
  }
if (objclass378 == NULL) {
  Method *reader380 = addmethodrealflags(obj378, "kind",&reader_lexer_kind_380, MFLAG_DEF);
  reader380->definitionModule = modulename;
  reader380->definitionLine = 175;
}
adddatum2(obj378, alloc_Undefined(), 1);
if (objclass378 == NULL) {
  Method *reader381 = addmethodrealflags(obj378, "value",&reader_lexer_value_381, MFLAG_DEF);
  reader381->definitionModule = modulename;
  reader381->definitionLine = 176;
}
adddatum2(obj378, alloc_Undefined(), 2);
if (objclass378 == NULL) {
  Method *reader382 = addmethodrealflags(obj378, "size",&reader_lexer_size_382, MFLAG_DEF);
  reader382->definitionModule = modulename;
  reader382->definitionLine = 177;
}
adddatum2(obj378, alloc_Undefined(), 3);
  sourceObject = obj378;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe383 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call384 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 6)
  struct UserObject *obj378_uo = (struct UserObject *)obj378;
  obj378_uo->super = call384;
  sourceObject = obj378;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit385 == NULL) {
    strlit385 = alloc_String("rgeneric");
    gc_root(strlit385);
  }
// compiled string node returning strlit385 (depth = 6)
  adddatum2(obj378, strlit385, 1);
  sourceObject = obj378;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit386 == NULL) {
    strlit386 = alloc_String(">");
    gc_root(strlit386);
  }
// compiled string node returning strlit386 (depth = 6)
  adddatum2(obj378, strlit386, 2);
  sourceObject = obj378;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num387 = alloc_Float64(1);
// compiled num node returning num387 (depth = 6)
  adddatum2(obj378, num387, 3);
objclass378 = obj378->class;
  objclass378->definitionModule = modulename;
  objclass378->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter378;
  self = oldself378;
  selfslot = oldselfslot378;
  stackframe = oldstackframe378;
  gc_frame_end(frame);
  return obj378;
}
Object meth_lexer_new377_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject378 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj378 = alloc_userobj2(4,5, objclass378);
  gc_frame_newslot(obj378);
if (objclass378 == NULL) {
  glfree(obj378->class->name);
  obj378->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj378, self, 0);
  addmethodreal(obj378,"outer", &reader_lexer_outer_379);
  Object oldself378 = self;
  struct StackFrameObject *oldstackframe378 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe378);
  gc_frame_newslot((Object)stackframe);
  self = obj378;
  Object *oldselfslot378 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter378 = (*(struct UserObject *)self).data[0], lowerouter378 = thisouter378;
  if (inheritingObject378) {
    struct UserObject *inho378 = (struct UserObject *)inheritingObject378;
    while (inho378->super != GraceDefaultObject) inho378 = (struct UserObject *)inho378->super;
    inho378->super = obj378;
    self = inheritingObject378;
    *selfslot = self;
    lowerouter378 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter378;
  }
if (objclass378 == NULL) {
  Method *reader380 = addmethodrealflags(obj378, "kind",&reader_lexer_kind_380, MFLAG_DEF);
  reader380->definitionModule = modulename;
  reader380->definitionLine = 175;
}
adddatum2(obj378, alloc_Undefined(), 1);
if (objclass378 == NULL) {
  Method *reader381 = addmethodrealflags(obj378, "value",&reader_lexer_value_381, MFLAG_DEF);
  reader381->definitionModule = modulename;
  reader381->definitionLine = 176;
}
adddatum2(obj378, alloc_Undefined(), 2);
if (objclass378 == NULL) {
  Method *reader382 = addmethodrealflags(obj378, "size",&reader_lexer_size_382, MFLAG_DEF);
  reader382->definitionModule = modulename;
  reader382->definitionLine = 177;
}
adddatum2(obj378, alloc_Undefined(), 3);
  sourceObject = obj378;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe383 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call384 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 6)
  struct UserObject *obj378_uo = (struct UserObject *)obj378;
  obj378_uo->super = call384;
  sourceObject = obj378;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit385 == NULL) {
    strlit385 = alloc_String("rgeneric");
    gc_root(strlit385);
  }
// compiled string node returning strlit385 (depth = 6)
  adddatum2(obj378, strlit385, 1);
  sourceObject = obj378;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit386 == NULL) {
    strlit386 = alloc_String(">");
    gc_root(strlit386);
  }
// compiled string node returning strlit386 (depth = 6)
  adddatum2(obj378, strlit386, 2);
  sourceObject = obj378;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num387 = alloc_Float64(1);
// compiled num node returning num387 (depth = 6)
  adddatum2(obj378, num387, 3);
objclass378 = obj378->class;
  objclass378->definitionModule = modulename;
  objclass378->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter378;
  self = oldself378;
  selfslot = oldselfslot378;
  stackframe = oldstackframe378;
  gc_frame_end(frame);
  return obj378;
}
Object meth_lexer__apply695(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit697 == NULL) {
    strlit697 = alloc_String("dot");
    gc_root(strlit697);
  }
// compiled string node returning strlit697 (depth = 13)
  int op_slot_right_696 = gc_frame_newslot(strlit697);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe699 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call701 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe700);
// compiled call node returning call701 (depth = 16)
// compiled member node returning call701 (depth = 15)
  partcv[0] = 0;
  Object call702 = callmethod(call701, "kind",
    1, partcv, params);
  gc_frame_end(callframe699);
// compiled call node returning call702 (depth = 14)
// compiled member node returning call702 (depth = 13)
  int op_slot_left_696 = gc_frame_newslot(call702);
  params[0] = strlit697;
  partcv[0] = 1;
  Object opresult703 = callmethod(call702, "==", 1, partcv, params);
// compiled op node returning opresult703 (depth = 12)
  gc_frame_end(frame);
  return opresult703;
}
Object meth_lexer_modechange391(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "modechange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method modechange");
  Object params[5];
  int partcv[3];
  Object *var_IdentifierToken = getfromclosure(closure, 0);
  Object *var_KeywordToken = getfromclosure(closure, 1);
  Object *var_StringToken = getfromclosure(closure, 2);
  Object *var_MultiLineStringToken = getfromclosure(closure, 3);
  Object *var_CommaToken = getfromclosure(closure, 4);
  Object *var_DotToken = getfromclosure(closure, 5);
  Object *var_LBraceToken = getfromclosure(closure, 6);
  Object *var_RBraceToken = getfromclosure(closure, 7);
  Object *var_LParenToken = getfromclosure(closure, 8);
  Object *var_RParenToken = getfromclosure(closure, 9);
  Object *var_LSquareToken = getfromclosure(closure, 10);
  Object *var_RSquareToken = getfromclosure(closure, 11);
  Object *var_LGenericToken = getfromclosure(closure, 12);
  Object *var_RGenericToken = getfromclosure(closure, 13);
  Object *var_SemicolonToken = getfromclosure(closure, 14);
  Object *var_NumToken = getfromclosure(closure, 15);
  Object *var_errormessages = getfromclosure(closure, 16);
  Object *var_linePosition = getfromclosure(closure, 17);
  Object *var_lineNumber = getfromclosure(closure, 18);
  Object *var_OpToken = getfromclosure(closure, 19);
  Object *var_ArrowToken = getfromclosure(closure, 20);
  Object *var_BindToken = getfromclosure(closure, 21);
  Object *var_ColonToken = getfromclosure(closure, 22);
  Object *var_indentLevel = getfromclosure(closure, 23);
  Object *var_CommentToken = getfromclosure(closure, 24);
  Object *var_util = getfromclosure(closure, 25);
  Object *var_startPosition = getfromclosure(closure, 26);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for modechange (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokens = &(stackframe->slots[0]);
  *var_tokens = args[curarg];
  curarg++;
  Object *var_mode = &(stackframe->slots[1]);
  *var_mode = args[curarg];
  curarg++;
  Object *var_accum = &(stackframe->slots[2]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for modechange");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isDone = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "isDone");
  Object *var_tok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tok");
  Object *var_dot = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dot");
  Object *var_decimal = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "decimal");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
  Object *var_suggestion = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "suggestion");
  Object *var_cmt = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "cmt");
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool392 = alloc_Boolean(0);
// compiled identifier node returning bool392 (depth = 4)
  *var_isDone = bool392;
  if (bool392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num393 = alloc_Float64(0);
// compiled num node returning num393 (depth = 4)
  *var_tok = num393;
  if (num393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num397 = alloc_Float64(0);
// compiled num node returning num397 (depth = 6)
  int op_slot_right_396 = gc_frame_newslot(num397);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  partcv[0] = 0;
  Object call400 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call400 (depth = 7)
// compiled member node returning call400 (depth = 6)
  int op_slot_left_396 = gc_frame_newslot(call400);
  params[0] = num397;
  partcv[0] = 1;
  Object opresult401 = callmethod(call400, ">", 1, partcv, params);
// compiled op node returning opresult401 (depth = 5)
  int op_slot_right_395 = gc_frame_newslot(opresult401);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit404 == NULL) {
    strlit404 = alloc_String("n");
    gc_root(strlit404);
  }
// compiled string node returning strlit404 (depth = 6)
  int op_slot_right_403 = gc_frame_newslot(strlit404);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_403 = gc_frame_newslot(*var_mode);
  params[0] = strlit404;
  partcv[0] = 1;
  Object opresult406 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult406 (depth = 5)
  int op_slot_left_395 = gc_frame_newslot(opresult406);
  params[0] = opresult401;
  partcv[0] = 1;
  Object opresult407 = callmethod(opresult406, "||", 1, partcv, params);
// compiled op node returning opresult407 (depth = 4)
  Object if394 = done;
  if (istrue(opresult407)) {
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit410 == NULL) {
    strlit410 = alloc_String("i");
    gc_root(strlit410);
  }
// compiled string node returning strlit410 (depth = 6)
  int op_slot_right_409 = gc_frame_newslot(strlit410);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_409 = gc_frame_newslot(*var_mode);
  params[0] = strlit410;
  partcv[0] = 1;
  Object opresult412 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult412 (depth = 5)
  Object if408 = done;
  if (istrue(opresult412)) {
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe413 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_IdentifierToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call414 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe413);
// compiled call node returning call414 (depth = 6)
  *var_tok = call414;
  if (call414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit419 == NULL) {
    strlit419 = alloc_String("factory");
    gc_root(strlit419);
  }
// compiled string node returning strlit419 (depth = 8)
  int op_slot_right_418 = gc_frame_newslot(strlit419);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  int op_slot_left_418 = gc_frame_newslot(*var_accum);
  params[0] = strlit419;
  partcv[0] = 1;
  Object opresult421 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult421 (depth = 7)
  int op_slot_right_417 = gc_frame_newslot(opresult421);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit425 == NULL) {
    strlit425 = alloc_String("dialect");
    gc_root(strlit425);
  }
// compiled string node returning strlit425 (depth = 9)
  int op_slot_right_424 = gc_frame_newslot(strlit425);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_424 = gc_frame_newslot(*var_accum);
  params[0] = strlit425;
  partcv[0] = 1;
  Object opresult427 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult427 (depth = 8)
  int op_slot_right_423 = gc_frame_newslot(opresult427);
// starting to compile op node (depth = 8)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit431 == NULL) {
    strlit431 = alloc_String("is");
    gc_root(strlit431);
  }
// compiled string node returning strlit431 (depth = 10)
  int op_slot_right_430 = gc_frame_newslot(strlit431);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_430 = gc_frame_newslot(*var_accum);
  params[0] = strlit431;
  partcv[0] = 1;
  Object opresult433 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult433 (depth = 9)
  int op_slot_right_429 = gc_frame_newslot(opresult433);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit437 == NULL) {
    strlit437 = alloc_String("inherits");
    gc_root(strlit437);
  }
// compiled string node returning strlit437 (depth = 11)
  int op_slot_right_436 = gc_frame_newslot(strlit437);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_436 = gc_frame_newslot(*var_accum);
  params[0] = strlit437;
  partcv[0] = 1;
  Object opresult439 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult439 (depth = 10)
  int op_slot_right_435 = gc_frame_newslot(opresult439);
// starting to compile op node (depth = 10)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit443 == NULL) {
    strlit443 = alloc_String("def");
    gc_root(strlit443);
  }
// compiled string node returning strlit443 (depth = 12)
  int op_slot_right_442 = gc_frame_newslot(strlit443);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_442 = gc_frame_newslot(*var_accum);
  params[0] = strlit443;
  partcv[0] = 1;
  Object opresult445 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult445 (depth = 11)
  int op_slot_right_441 = gc_frame_newslot(opresult445);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit449 == NULL) {
    strlit449 = alloc_String("return");
    gc_root(strlit449);
  }
// compiled string node returning strlit449 (depth = 13)
  int op_slot_right_448 = gc_frame_newslot(strlit449);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_448 = gc_frame_newslot(*var_accum);
  params[0] = strlit449;
  partcv[0] = 1;
  Object opresult451 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult451 (depth = 12)
  int op_slot_right_447 = gc_frame_newslot(opresult451);
// starting to compile op node (depth = 12)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit455 == NULL) {
    strlit455 = alloc_String("class");
    gc_root(strlit455);
  }
// compiled string node returning strlit455 (depth = 14)
  int op_slot_right_454 = gc_frame_newslot(strlit455);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_454 = gc_frame_newslot(*var_accum);
  params[0] = strlit455;
  partcv[0] = 1;
  Object opresult457 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult457 (depth = 13)
  int op_slot_right_453 = gc_frame_newslot(opresult457);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit461 == NULL) {
    strlit461 = alloc_String("import");
    gc_root(strlit461);
  }
// compiled string node returning strlit461 (depth = 15)
  int op_slot_right_460 = gc_frame_newslot(strlit461);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_460 = gc_frame_newslot(*var_accum);
  params[0] = strlit461;
  partcv[0] = 1;
  Object opresult463 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult463 (depth = 14)
  int op_slot_right_459 = gc_frame_newslot(opresult463);
// starting to compile op node (depth = 14)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit467 == NULL) {
    strlit467 = alloc_String("type");
    gc_root(strlit467);
  }
// compiled string node returning strlit467 (depth = 16)
  int op_slot_right_466 = gc_frame_newslot(strlit467);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_466 = gc_frame_newslot(*var_accum);
  params[0] = strlit467;
  partcv[0] = 1;
  Object opresult469 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult469 (depth = 15)
  int op_slot_right_465 = gc_frame_newslot(opresult469);
// starting to compile op node (depth = 15)
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit473 == NULL) {
    strlit473 = alloc_String("var");
    gc_root(strlit473);
  }
// compiled string node returning strlit473 (depth = 17)
  int op_slot_right_472 = gc_frame_newslot(strlit473);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_472 = gc_frame_newslot(*var_accum);
  params[0] = strlit473;
  partcv[0] = 1;
  Object opresult475 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult475 (depth = 16)
  int op_slot_right_471 = gc_frame_newslot(opresult475);
// starting to compile op node (depth = 16)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit479 == NULL) {
    strlit479 = alloc_String("method");
    gc_root(strlit479);
  }
// compiled string node returning strlit479 (depth = 18)
  int op_slot_right_478 = gc_frame_newslot(strlit479);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_478 = gc_frame_newslot(*var_accum);
  params[0] = strlit479;
  partcv[0] = 1;
  Object opresult481 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult481 (depth = 17)
  int op_slot_right_477 = gc_frame_newslot(opresult481);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit484 == NULL) {
    strlit484 = alloc_String("object");
    gc_root(strlit484);
  }
// compiled string node returning strlit484 (depth = 18)
  int op_slot_right_483 = gc_frame_newslot(strlit484);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_483 = gc_frame_newslot(*var_accum);
  params[0] = strlit484;
  partcv[0] = 1;
  Object opresult486 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult486 (depth = 17)
  int op_slot_left_477 = gc_frame_newslot(opresult486);
  params[0] = opresult481;
  partcv[0] = 1;
  Object opresult487 = callmethod(opresult486, "||", 1, partcv, params);
// compiled op node returning opresult487 (depth = 16)
  int op_slot_left_471 = gc_frame_newslot(opresult487);
  params[0] = opresult475;
  partcv[0] = 1;
  Object opresult488 = callmethod(opresult487, "||", 1, partcv, params);
// compiled op node returning opresult488 (depth = 15)
  int op_slot_left_465 = gc_frame_newslot(opresult488);
  params[0] = opresult469;
  partcv[0] = 1;
  Object opresult489 = callmethod(opresult488, "||", 1, partcv, params);
// compiled op node returning opresult489 (depth = 14)
  int op_slot_left_459 = gc_frame_newslot(opresult489);
  params[0] = opresult463;
  partcv[0] = 1;
  Object opresult490 = callmethod(opresult489, "||", 1, partcv, params);
// compiled op node returning opresult490 (depth = 13)
  int op_slot_left_453 = gc_frame_newslot(opresult490);
  params[0] = opresult457;
  partcv[0] = 1;
  Object opresult491 = callmethod(opresult490, "||", 1, partcv, params);
// compiled op node returning opresult491 (depth = 12)
  int op_slot_left_447 = gc_frame_newslot(opresult491);
  params[0] = opresult451;
  partcv[0] = 1;
  Object opresult492 = callmethod(opresult491, "||", 1, partcv, params);
// compiled op node returning opresult492 (depth = 11)
  int op_slot_left_441 = gc_frame_newslot(opresult492);
  params[0] = opresult445;
  partcv[0] = 1;
  Object opresult493 = callmethod(opresult492, "||", 1, partcv, params);
// compiled op node returning opresult493 (depth = 10)
  int op_slot_left_435 = gc_frame_newslot(opresult493);
  params[0] = opresult439;
  partcv[0] = 1;
  Object opresult494 = callmethod(opresult493, "||", 1, partcv, params);
// compiled op node returning opresult494 (depth = 9)
  int op_slot_left_429 = gc_frame_newslot(opresult494);
  params[0] = opresult433;
  partcv[0] = 1;
  Object opresult495 = callmethod(opresult494, "||", 1, partcv, params);
// compiled op node returning opresult495 (depth = 8)
  int op_slot_left_423 = gc_frame_newslot(opresult495);
  params[0] = opresult427;
  partcv[0] = 1;
  Object opresult496 = callmethod(opresult495, "||", 1, partcv, params);
// compiled op node returning opresult496 (depth = 7)
  int op_slot_left_417 = gc_frame_newslot(opresult496);
  params[0] = opresult421;
  partcv[0] = 1;
  Object opresult497 = callmethod(opresult496, "||", 1, partcv, params);
// compiled op node returning opresult497 (depth = 6)
  Object if416 = done;
  if (istrue(opresult497)) {
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe498 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_KeywordToken (depth = 8)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call499 = callmethod(*var_KeywordToken, "new",
    1, partcv, params);
  gc_frame_end(callframe498);
// compiled call node returning call499 (depth = 7)
  *var_tok = call499;
  if (call499 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if416 = done;
  } else {
  }
// compiled if node returning if416 (depth = 5)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe501 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call502 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe501);
// compiled call node returning call502 (depth = 5)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool503 = alloc_Boolean(1);
// compiled identifier node returning bool503 (depth = 6)
  *var_isDone = bool503;
  if (bool503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if408 = done;
  } else {
  }
// compiled if node returning if408 (depth = 4)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit507 == NULL) {
    strlit507 = alloc_String("I");
    gc_root(strlit507);
  }
// compiled string node returning strlit507 (depth = 6)
  int op_slot_right_506 = gc_frame_newslot(strlit507);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_506 = gc_frame_newslot(*var_mode);
  params[0] = strlit507;
  partcv[0] = 1;
  Object opresult509 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult509 (depth = 5)
  Object if505 = done;
  if (istrue(opresult509)) {
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe510 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_IdentifierToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call511 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe510);
// compiled call node returning call511 (depth = 6)
  *var_tok = call511;
  if (call511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe513 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call514 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe513);
// compiled call node returning call514 (depth = 5)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool515 = alloc_Boolean(1);
// compiled identifier node returning bool515 (depth = 6)
  *var_isDone = bool515;
  if (bool515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if505 = done;
  } else {
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit519 == NULL) {
    strlit519 = alloc_String("""\x22""");
    gc_root(strlit519);
  }
// compiled string node returning strlit519 (depth = 7)
  int op_slot_right_518 = gc_frame_newslot(strlit519);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_518 = gc_frame_newslot(*var_mode);
  params[0] = strlit519;
  partcv[0] = 1;
  Object opresult521 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult521 (depth = 6)
  Object if517 = done;
  if (istrue(opresult521)) {
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe522 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_StringToken (depth = 8)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call523 = callmethod(*var_StringToken, "new",
    1, partcv, params);
  gc_frame_end(callframe522);
// compiled call node returning call523 (depth = 7)
  *var_tok = call523;
  if (call523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe525 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call526 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe525);
// compiled call node returning call526 (depth = 6)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool527 = alloc_Boolean(1);
// compiled identifier node returning bool527 (depth = 7)
  *var_isDone = bool527;
  if (bool527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if517 = done;
  } else {
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit531 == NULL) {
    strlit531 = alloc_String("q");
    gc_root(strlit531);
  }
// compiled string node returning strlit531 (depth = 8)
  int op_slot_right_530 = gc_frame_newslot(strlit531);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_530 = gc_frame_newslot(*var_mode);
  params[0] = strlit531;
  partcv[0] = 1;
  Object opresult533 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult533 (depth = 7)
  Object if529 = done;
  if (istrue(opresult533)) {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe534 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_MultiLineStringToken (depth = 9)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call535 = callmethod(*var_MultiLineStringToken, "new",
    1, partcv, params);
  gc_frame_end(callframe534);
// compiled call node returning call535 (depth = 8)
  *var_tok = call535;
  if (call535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe537 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call538 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe537);
// compiled call node returning call538 (depth = 7)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool539 = alloc_Boolean(1);
// compiled identifier node returning bool539 (depth = 8)
  *var_isDone = bool539;
  if (bool539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if529 = done;
  } else {
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit543 == NULL) {
    strlit543 = alloc_String("x");
    gc_root(strlit543);
  }
// compiled string node returning strlit543 (depth = 9)
  int op_slot_right_542 = gc_frame_newslot(strlit543);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_542 = gc_frame_newslot(*var_mode);
  params[0] = strlit543;
  partcv[0] = 1;
  Object opresult545 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult545 (depth = 8)
  Object if541 = done;
  if (istrue(opresult545)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe546 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit547 == NULL) {
    strlit547 = alloc_String("obsolete Octet-token mode in lexer""\x0a""");
    gc_root(strlit547);
  }
// compiled string node returning strlit547 (depth = 9)
  gc_frame_newslot(strlit547);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe548 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call549 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe548);
// compiled call node returning call549 (depth = 10)
// compiled member node returning call549 (depth = 9)
  params[0] = strlit547;
  partcv[0] = 1;
  Object call550 = callmethod(call549, "raise",
    1, partcv, params);
  gc_frame_end(callframe546);
// compiled call node returning call550 (depth = 8)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe551 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call552 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe551);
// compiled call node returning call552 (depth = 8)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool553 = alloc_Boolean(1);
// compiled identifier node returning bool553 (depth = 9)
  *var_isDone = bool553;
  if (bool553 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if541 = done;
  } else {
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit557 == NULL) {
    strlit557 = alloc_String(",");
    gc_root(strlit557);
  }
// compiled string node returning strlit557 (depth = 10)
  int op_slot_right_556 = gc_frame_newslot(strlit557);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_556 = gc_frame_newslot(*var_mode);
  params[0] = strlit557;
  partcv[0] = 1;
  Object opresult559 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult559 (depth = 9)
  Object if555 = done;
  if (istrue(opresult559)) {
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe560 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_CommaToken (depth = 12)
  partcv[0] = 0;
  Object call561 = callmethod(*var_CommaToken, "new",
    1, partcv, params);
  gc_frame_end(callframe560);
// compiled call node returning call561 (depth = 11)
// compiled member node returning call561 (depth = 10)
  *var_tok = call561;
  if (call561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe563 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call564 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe563);
// compiled call node returning call564 (depth = 9)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool565 = alloc_Boolean(1);
// compiled identifier node returning bool565 (depth = 10)
  *var_isDone = bool565;
  if (bool565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if555 = done;
  } else {
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit569 == NULL) {
    strlit569 = alloc_String(".");
    gc_root(strlit569);
  }
// compiled string node returning strlit569 (depth = 11)
  int op_slot_right_568 = gc_frame_newslot(strlit569);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_568 = gc_frame_newslot(*var_mode);
  params[0] = strlit569;
  partcv[0] = 1;
  Object opresult571 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult571 (depth = 10)
  Object if567 = done;
  if (istrue(opresult571)) {
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_DotToken (depth = 13)
  partcv[0] = 0;
  Object call573 = callmethod(*var_DotToken, "new",
    1, partcv, params);
  gc_frame_end(callframe572);
// compiled call node returning call573 (depth = 12)
// compiled member node returning call573 (depth = 11)
  *var_tok = call573;
  if (call573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe575 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call576 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe575);
// compiled call node returning call576 (depth = 10)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
  Object bool577 = alloc_Boolean(1);
// compiled identifier node returning bool577 (depth = 11)
  *var_isDone = bool577;
  if (bool577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if567 = done;
  } else {
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit581 == NULL) {
    strlit581 = alloc_String("{");
    gc_root(strlit581);
  }
// compiled string node returning strlit581 (depth = 12)
  int op_slot_right_580 = gc_frame_newslot(strlit581);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_580 = gc_frame_newslot(*var_mode);
  params[0] = strlit581;
  partcv[0] = 1;
  Object opresult583 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult583 (depth = 11)
  Object if579 = done;
  if (istrue(opresult583)) {
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_LBraceToken (depth = 14)
  partcv[0] = 0;
  Object call585 = callmethod(*var_LBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe584);
// compiled call node returning call585 (depth = 13)
// compiled member node returning call585 (depth = 12)
  *var_tok = call585;
  if (call585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe587 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call588 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe587);
// compiled call node returning call588 (depth = 11)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool589 = alloc_Boolean(1);
// compiled identifier node returning bool589 (depth = 12)
  *var_isDone = bool589;
  if (bool589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if579 = done;
  } else {
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit593 == NULL) {
    strlit593 = alloc_String("}");
    gc_root(strlit593);
  }
// compiled string node returning strlit593 (depth = 13)
  int op_slot_right_592 = gc_frame_newslot(strlit593);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_592 = gc_frame_newslot(*var_mode);
  params[0] = strlit593;
  partcv[0] = 1;
  Object opresult595 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult595 (depth = 12)
  Object if591 = done;
  if (istrue(opresult595)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_RBraceToken (depth = 15)
  partcv[0] = 0;
  Object call597 = callmethod(*var_RBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe596);
// compiled call node returning call597 (depth = 14)
// compiled member node returning call597 (depth = 13)
  *var_tok = call597;
  if (call597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe599 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call600 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe599);
// compiled call node returning call600 (depth = 12)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool601 = alloc_Boolean(1);
// compiled identifier node returning bool601 (depth = 13)
  *var_isDone = bool601;
  if (bool601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if591 = done;
  } else {
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit605 == NULL) {
    strlit605 = alloc_String("(");
    gc_root(strlit605);
  }
// compiled string node returning strlit605 (depth = 14)
  int op_slot_right_604 = gc_frame_newslot(strlit605);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_604 = gc_frame_newslot(*var_mode);
  params[0] = strlit605;
  partcv[0] = 1;
  Object opresult607 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult607 (depth = 13)
  Object if603 = done;
  if (istrue(opresult607)) {
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe608 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_LParenToken (depth = 16)
  partcv[0] = 0;
  Object call609 = callmethod(*var_LParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe608);
// compiled call node returning call609 (depth = 15)
// compiled member node returning call609 (depth = 14)
  *var_tok = call609;
  if (call609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe611 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call612 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 13)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
  Object bool613 = alloc_Boolean(1);
// compiled identifier node returning bool613 (depth = 14)
  *var_isDone = bool613;
  if (bool613 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if603 = done;
  } else {
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit617 == NULL) {
    strlit617 = alloc_String(")");
    gc_root(strlit617);
  }
// compiled string node returning strlit617 (depth = 15)
  int op_slot_right_616 = gc_frame_newslot(strlit617);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_mode (depth = 15)
  int op_slot_left_616 = gc_frame_newslot(*var_mode);
  params[0] = strlit617;
  partcv[0] = 1;
  Object opresult619 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult619 (depth = 14)
  Object if615 = done;
  if (istrue(opresult619)) {
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_RParenToken (depth = 17)
  partcv[0] = 0;
  Object call621 = callmethod(*var_RParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe620);
// compiled call node returning call621 (depth = 16)
// compiled member node returning call621 (depth = 15)
  *var_tok = call621;
  if (call621 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe623 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call624 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe623);
// compiled call node returning call624 (depth = 14)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
  Object bool625 = alloc_Boolean(1);
// compiled identifier node returning bool625 (depth = 15)
  *var_isDone = bool625;
  if (bool625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if615 = done;
  } else {
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit629 == NULL) {
    strlit629 = alloc_String("[");
    gc_root(strlit629);
  }
// compiled string node returning strlit629 (depth = 16)
  int op_slot_right_628 = gc_frame_newslot(strlit629);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_mode (depth = 16)
  int op_slot_left_628 = gc_frame_newslot(*var_mode);
  params[0] = strlit629;
  partcv[0] = 1;
  Object opresult631 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult631 (depth = 15)
  Object if627 = done;
  if (istrue(opresult631)) {
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 15)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_LSquareToken (depth = 18)
  partcv[0] = 0;
  Object call633 = callmethod(*var_LSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe632);
// compiled call node returning call633 (depth = 17)
// compiled member node returning call633 (depth = 16)
  *var_tok = call633;
  if (call633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 15)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe635 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tok (depth = 16)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call636 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe635);
// compiled call node returning call636 (depth = 15)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 15)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
  Object bool637 = alloc_Boolean(1);
// compiled identifier node returning bool637 (depth = 16)
  *var_isDone = bool637;
  if (bool637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 15)
    gc_frame_newslot(done);
    if627 = done;
  } else {
  }
// compiled if node returning if627 (depth = 14)
    gc_frame_newslot(if627);
    if615 = if627;
  }
// compiled if node returning if615 (depth = 13)
    gc_frame_newslot(if615);
    if603 = if615;
  }
// compiled if node returning if603 (depth = 12)
    gc_frame_newslot(if603);
    if591 = if603;
  }
// compiled if node returning if591 (depth = 11)
    gc_frame_newslot(if591);
    if579 = if591;
  }
// compiled if node returning if579 (depth = 10)
    gc_frame_newslot(if579);
    if567 = if579;
  }
// compiled if node returning if567 (depth = 9)
    gc_frame_newslot(if567);
    if555 = if567;
  }
// compiled if node returning if555 (depth = 8)
    gc_frame_newslot(if555);
    if541 = if555;
  }
// compiled if node returning if541 (depth = 7)
    gc_frame_newslot(if541);
    if529 = if541;
  }
// compiled if node returning if529 (depth = 6)
    gc_frame_newslot(if529);
    if517 = if529;
  }
// compiled if node returning if517 (depth = 5)
    gc_frame_newslot(if517);
    if505 = if517;
  }
// compiled if node returning if505 (depth = 4)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit641 == NULL) {
    strlit641 = alloc_String("]");
    gc_root(strlit641);
  }
// compiled string node returning strlit641 (depth = 6)
  int op_slot_right_640 = gc_frame_newslot(strlit641);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_640 = gc_frame_newslot(*var_mode);
  params[0] = strlit641;
  partcv[0] = 1;
  Object opresult643 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult643 (depth = 5)
  Object if639 = done;
  if (istrue(opresult643)) {
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_RSquareToken (depth = 8)
  partcv[0] = 0;
  Object call645 = callmethod(*var_RSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe644);
// compiled call node returning call645 (depth = 7)
// compiled member node returning call645 (depth = 6)
  *var_tok = call645;
  if (call645 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe647 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call648 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe647);
// compiled call node returning call648 (depth = 5)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool649 = alloc_Boolean(1);
// compiled identifier node returning bool649 (depth = 6)
  *var_isDone = bool649;
  if (bool649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if639 = done;
  } else {
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit653 == NULL) {
    strlit653 = alloc_String("<");
    gc_root(strlit653);
  }
// compiled string node returning strlit653 (depth = 7)
  int op_slot_right_652 = gc_frame_newslot(strlit653);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_652 = gc_frame_newslot(*var_mode);
  params[0] = strlit653;
  partcv[0] = 1;
  Object opresult655 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult655 (depth = 6)
  Object if651 = done;
  if (istrue(opresult655)) {
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe656 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_LGenericToken (depth = 9)
  partcv[0] = 0;
  Object call657 = callmethod(*var_LGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe656);
// compiled call node returning call657 (depth = 8)
// compiled member node returning call657 (depth = 7)
  *var_tok = call657;
  if (call657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe659 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call660 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe659);
// compiled call node returning call660 (depth = 6)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool661 = alloc_Boolean(1);
// compiled identifier node returning bool661 (depth = 7)
  *var_isDone = bool661;
  if (bool661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if651 = done;
  } else {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit665 == NULL) {
    strlit665 = alloc_String(">");
    gc_root(strlit665);
  }
// compiled string node returning strlit665 (depth = 8)
  int op_slot_right_664 = gc_frame_newslot(strlit665);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_664 = gc_frame_newslot(*var_mode);
  params[0] = strlit665;
  partcv[0] = 1;
  Object opresult667 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult667 (depth = 7)
  Object if663 = done;
  if (istrue(opresult667)) {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_RGenericToken (depth = 10)
  partcv[0] = 0;
  Object call669 = callmethod(*var_RGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe668);
// compiled call node returning call669 (depth = 9)
// compiled member node returning call669 (depth = 8)
  *var_tok = call669;
  if (call669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe671 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call672 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe671);
// compiled call node returning call672 (depth = 7)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool673 = alloc_Boolean(1);
// compiled identifier node returning bool673 (depth = 8)
  *var_isDone = bool673;
  if (bool673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if663 = done;
  } else {
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit677 == NULL) {
    strlit677 = alloc_String(";");
    gc_root(strlit677);
  }
// compiled string node returning strlit677 (depth = 9)
  int op_slot_right_676 = gc_frame_newslot(strlit677);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_676 = gc_frame_newslot(*var_mode);
  params[0] = strlit677;
  partcv[0] = 1;
  Object opresult679 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult679 (depth = 8)
  Object if675 = done;
  if (istrue(opresult679)) {
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_SemicolonToken (depth = 11)
  partcv[0] = 0;
  Object call681 = callmethod(*var_SemicolonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe680);
// compiled call node returning call681 (depth = 10)
// compiled member node returning call681 (depth = 9)
  *var_tok = call681;
  if (call681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe683 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call684 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe683);
// compiled call node returning call684 (depth = 8)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool685 = alloc_Boolean(1);
// compiled identifier node returning bool685 (depth = 9)
  *var_isDone = bool685;
  if (bool685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if675 = done;
  } else {
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit689 == NULL) {
    strlit689 = alloc_String("m");
    gc_root(strlit689);
  }
// compiled string node returning strlit689 (depth = 10)
  int op_slot_right_688 = gc_frame_newslot(strlit689);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_688 = gc_frame_newslot(*var_mode);
  params[0] = strlit689;
  partcv[0] = 1;
  Object opresult691 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult691 (depth = 9)
  Object if687 = done;
  if (istrue(opresult691)) {
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe693 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block694 = alloc_Block(NULL, NULL, "lexer", 275);
  gc_frame_newslot(block694);
// method _apply
  block_savedest(block694);
  Object closure695 = createclosure(2, "_apply");
  setclosureframe(closure695, stackframe);
  addtoclosure(closure695, var_tokens);
  addtoclosure(closure695, selfslot);
  struct UserObject *uo695 = (struct UserObject*)block694;
  uo695->data[0] = (Object)closure695;
  Method *meth_meth_lexer__apply695 = addmethod2pos(block694, "_apply", &meth_lexer__apply695, 0);
  int argcv_meth_lexer__apply695[] = {0};
  meth_meth_lexer__apply695->type = alloc_MethodType(1, argcv_meth_lexer__apply695);
  meth_meth_lexer__apply695->definitionModule = modulename;
  meth_meth_lexer__apply695->definitionLine = 271;
// compiled block node returning block694 (depth = 11)
  gc_frame_newslot(block694);
// call case 6: other member request
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num706 = alloc_Float64(1);
// compiled num node returning num706 (depth = 12)
  int op_slot_right_705 = gc_frame_newslot(num706);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe708 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call709 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe708);
// compiled call node returning call709 (depth = 13)
// compiled member node returning call709 (depth = 12)
  int op_slot_left_705 = gc_frame_newslot(call709);
  params[0] = num706;
  partcv[0] = 1;
  Object opresult710 = callmethod(call709, ">", 1, partcv, params);
// compiled op node returning opresult710 (depth = 11)
  params[0] = block694;
  partcv[0] = 1;
  Object call711 = callmethod(opresult710, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe693);
// compiled call node returning call711 (depth = 10)
  Object if692 = done;
  if (istrue(call711)) {
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call713 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe712);
// compiled call node returning call713 (depth = 12)
// compiled member node returning call713 (depth = 11)
  *var_dot = call713;
  if (call713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit716 == NULL) {
    strlit716 = alloc_String("num");
    gc_root(strlit716);
  }
// compiled string node returning strlit716 (depth = 12)
  int op_slot_right_715 = gc_frame_newslot(strlit716);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe718 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call720 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe719);
// compiled call node returning call720 (depth = 15)
// compiled member node returning call720 (depth = 14)
  partcv[0] = 0;
  Object call721 = callmethod(call720, "kind",
    1, partcv, params);
  gc_frame_end(callframe718);
// compiled call node returning call721 (depth = 13)
// compiled member node returning call721 (depth = 12)
  int op_slot_left_715 = gc_frame_newslot(call721);
  params[0] = strlit716;
  partcv[0] = 1;
  Object opresult722 = callmethod(call721, "==", 1, partcv, params);
// compiled op node returning opresult722 (depth = 11)
  Object if714 = done;
  if (istrue(opresult722)) {
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num725 = alloc_Float64(10);
// compiled num node returning num725 (depth = 13)
  int op_slot_right_724 = gc_frame_newslot(num725);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe727 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call729 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe728);
// compiled call node returning call729 (depth = 16)
// compiled member node returning call729 (depth = 15)
  partcv[0] = 0;
  Object call730 = callmethod(call729, "base",
    1, partcv, params);
  gc_frame_end(callframe727);
// compiled call node returning call730 (depth = 14)
// compiled member node returning call730 (depth = 13)
  int op_slot_left_724 = gc_frame_newslot(call730);
  params[0] = num725;
  partcv[0] = 1;
  Object opresult731 = callmethod(call730, "==", 1, partcv, params);
// compiled op node returning opresult731 (depth = 12)
  Object if723 = done;
  if (istrue(opresult731)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  partcv[0] = 0;
  Object call733 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe732);
// compiled call node returning call733 (depth = 14)
// compiled member node returning call733 (depth = 13)
  *var_tok = call733;
  if (call733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe735 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call736 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 13)
  *var_decimal = call736;
  if (call736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num739 = alloc_Float64(10);
// compiled num node returning num739 (depth = 14)
  int op_slot_right_738 = gc_frame_newslot(num739);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_decimal (depth = 16)
  partcv[0] = 0;
  Object call742 = callmethod(*var_decimal, "base",
    1, partcv, params);
  gc_frame_end(callframe741);
// compiled call node returning call742 (depth = 15)
// compiled member node returning call742 (depth = 14)
  int op_slot_left_738 = gc_frame_newslot(call742);
  params[0] = num739;
  partcv[0] = 1;
  Object opresult743 = callmethod(call742, "==", 1, partcv, params);
// compiled op node returning opresult743 (depth = 13)
  Object if737 = done;
  if (istrue(opresult743)) {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe744 = gc_frame_new();
// starting to compile op node (depth = 15)
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_right_745 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit748 == NULL) {
    strlit748 = alloc_String(".");
    gc_root(strlit748);
  }
// compiled string node returning strlit748 (depth = 17)
  int op_slot_right_747 = gc_frame_newslot(strlit748);
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tok (depth = 19)
  partcv[0] = 0;
  Object call751 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe750);
// compiled call node returning call751 (depth = 18)
// compiled member node returning call751 (depth = 17)
  int op_slot_left_747 = gc_frame_newslot(call751);
  params[0] = strlit748;
  partcv[0] = 1;
  Object opresult752 = callmethod(call751, "++", 1, partcv, params);
// compiled op node returning opresult752 (depth = 16)
  int op_slot_left_745 = gc_frame_newslot(opresult752);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult753 = callmethod(opresult752, "++", 1, partcv, params);
// compiled op node returning opresult753 (depth = 15)
  gc_frame_newslot(opresult753);
// starting to compile num node (depth = 15)
  Object num754 = alloc_Float64(10);
// compiled num node returning num754 (depth = 15)
  gc_frame_newslot(num754);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_NumToken (depth = 15)
  params[0] = opresult753;
  params[1] = num754;
  partcv[0] = 2;
  Object call755 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe744);
// compiled call node returning call755 (depth = 14)
  *var_tok = call755;
  if (call755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if737 = done;
  } else {
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 14)
  Object array757 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array757 (depth = 14)
  *var_suggestions = array757;
  if (array757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 13)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe758 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call760 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe759);
// compiled call node returning call760 (depth = 17)
// compiled member node returning call760 (depth = 16)
  partcv[0] = 0;
  Object call761 = callmethod(call760, "new",
    1, partcv, params);
  gc_frame_end(callframe758);
// compiled call node returning call761 (depth = 15)
// compiled member node returning call761 (depth = 14)
  *var_suggestion = call761;
  if (call761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 13)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe762 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num764 = alloc_Float64(1);
// compiled num node returning num764 (depth = 15)
  int op_slot_right_763 = gc_frame_newslot(num764);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call767 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe766);
// compiled call node returning call767 (depth = 16)
// compiled member node returning call767 (depth = 15)
  int op_slot_left_763 = gc_frame_newslot(call767);
  params[0] = num764;
  partcv[0] = 1;
  Object sum768 = callmethod(call767, "+", 1, partcv, params);
// compiled op node returning sum768 (depth = 14)
  gc_frame_newslot(sum768);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num770 = alloc_Float64(1);
// compiled num node returning num770 (depth = 15)
  int op_slot_right_769 = gc_frame_newslot(num770);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_769 = gc_frame_newslot(*var_linePosition);
  params[0] = num770;
  partcv[0] = 1;
  Object diff772 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff772 (depth = 14)
  gc_frame_newslot(diff772);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe773 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_decimal (depth = 16)
  partcv[0] = 0;
  Object call774 = callmethod(*var_decimal, "value",
    1, partcv, params);
  gc_frame_end(callframe773);
// compiled call node returning call774 (depth = 15)
// compiled member node returning call774 (depth = 14)
  gc_frame_newslot(call774);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = sum768;
  params[1] = diff772;
  params[2] = call774;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call775 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe762);
// compiled call node returning call775 (depth = 13)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe776 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call777 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe776);
// compiled call node returning call777 (depth = 13)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe778 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call780 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe779);
// compiled call node returning call780 (depth = 17)
// compiled member node returning call780 (depth = 16)
  partcv[0] = 0;
  Object call781 = callmethod(call780, "new",
    1, partcv, params);
  gc_frame_end(callframe778);
// compiled call node returning call781 (depth = 15)
// compiled member node returning call781 (depth = 14)
  *var_suggestion = call781;
  if (call781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe783 = gc_frame_new();
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call785 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe784);
// compiled call node returning call785 (depth = 15)
// compiled member node returning call785 (depth = 14)
  gc_frame_newslot(call785);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num787 = alloc_Float64(1);
// compiled num node returning num787 (depth = 15)
  int op_slot_right_786 = gc_frame_newslot(num787);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_786 = gc_frame_newslot(*var_linePosition);
  params[0] = num787;
  partcv[0] = 1;
  Object diff789 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff789 (depth = 14)
  gc_frame_newslot(diff789);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = call785;
  params[1] = diff789;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call790 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe783);
// compiled call node returning call790 (depth = 13)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe791 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call792 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe791);
// compiled call node returning call792 (depth = 13)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe793 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit794 == NULL) {
    strlit794 = alloc_String("The fractional part of a number must be in base 10.");
    gc_root(strlit794);
  }
// compiled string node returning strlit794 (depth = 14)
  gc_frame_newslot(strlit794);
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num796 = alloc_Float64(1);
// compiled num node returning num796 (depth = 15)
  int op_slot_right_795 = gc_frame_newslot(num796);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call799 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe798);
// compiled call node returning call799 (depth = 16)
// compiled member node returning call799 (depth = 15)
  int op_slot_left_795 = gc_frame_newslot(call799);
  params[0] = num796;
  partcv[0] = 1;
  Object sum800 = callmethod(call799, "+", 1, partcv, params);
// compiled op node returning sum800 (depth = 14)
  gc_frame_newslot(sum800);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num802 = alloc_Float64(1);
// compiled num node returning num802 (depth = 15)
  int op_slot_right_801 = gc_frame_newslot(num802);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_801 = gc_frame_newslot(*var_linePosition);
  params[0] = num802;
  partcv[0] = 1;
  Object diff804 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff804 (depth = 14)
  gc_frame_newslot(diff804);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit794;
  params[1] = *var_lineNumber;
  params[2] = sum800;
  params[3] = diff804;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call805 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe793);
// compiled call node returning call805 (depth = 13)
    gc_frame_newslot(call805);
    if737 = call805;
  }
// compiled if node returning if737 (depth = 12)
    gc_frame_newslot(if737);
    if723 = if737;
  } else {
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 13)
  Object array806 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array806 (depth = 13)
  *var_suggestions = array806;
  if (array806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe807 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call809 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe808);
// compiled call node returning call809 (depth = 16)
// compiled member node returning call809 (depth = 15)
  partcv[0] = 0;
  Object call810 = callmethod(call809, "new",
    1, partcv, params);
  gc_frame_end(callframe807);
// compiled call node returning call810 (depth = 14)
// compiled member node returning call810 (depth = 13)
  *var_suggestion = call810;
  if (call810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe811 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe812 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call814 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe813);
// compiled call node returning call814 (depth = 16)
// compiled member node returning call814 (depth = 15)
  partcv[0] = 0;
  Object call815 = callmethod(call814, "linePos",
    1, partcv, params);
  gc_frame_end(callframe812);
// compiled call node returning call815 (depth = 14)
// compiled member node returning call815 (depth = 13)
  gc_frame_newslot(call815);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num817 = alloc_Float64(1);
// compiled num node returning num817 (depth = 14)
  int op_slot_right_816 = gc_frame_newslot(num817);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call820 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe819);
// compiled call node returning call820 (depth = 15)
// compiled member node returning call820 (depth = 14)
  int op_slot_left_816 = gc_frame_newslot(call820);
  params[0] = num817;
  partcv[0] = 1;
  Object diff821 = callmethod(call820, "-", 1, partcv, params);
// compiled op node returning diff821 (depth = 13)
  gc_frame_newslot(diff821);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe822 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call824 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call824 (depth = 16)
// compiled member node returning call824 (depth = 15)
  partcv[0] = 0;
  Object call825 = callmethod(call824, "value",
    1, partcv, params);
  gc_frame_end(callframe822);
// compiled call node returning call825 (depth = 14)
// compiled member node returning call825 (depth = 13)
  gc_frame_newslot(call825);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call815;
  params[1] = diff821;
  params[2] = call825;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call826 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe811);
// compiled call node returning call826 (depth = 12)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe827 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call828 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe827);
// compiled call node returning call828 (depth = 12)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe829 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call831 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe830);
// compiled call node returning call831 (depth = 16)
// compiled member node returning call831 (depth = 15)
  partcv[0] = 0;
  Object call832 = callmethod(call831, "new",
    1, partcv, params);
  gc_frame_end(callframe829);
// compiled call node returning call832 (depth = 14)
// compiled member node returning call832 (depth = 13)
  *var_suggestion = call832;
  if (call832 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe834 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe835 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call836 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe835);
// compiled call node returning call836 (depth = 14)
// compiled member node returning call836 (depth = 13)
  gc_frame_newslot(call836);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call836;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call837 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe834);
// compiled call node returning call837 (depth = 12)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe838 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call839 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe838);
// compiled call node returning call839 (depth = 12)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe840 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit842 == NULL) {
    strlit842 = alloc_String(" cannot have a fractional part.");
    gc_root(strlit842);
  }
// compiled string node returning strlit842 (depth = 14)
  int op_slot_right_841 = gc_frame_newslot(strlit842);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe845 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call847 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe846);
// compiled call node returning call847 (depth = 18)
// compiled member node returning call847 (depth = 17)
  partcv[0] = 0;
  Object call848 = callmethod(call847, "base",
    1, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call848 (depth = 16)
// compiled member node returning call848 (depth = 15)
  int op_slot_right_844 = gc_frame_newslot(call848);
// starting to compile string node (depth = 15)
  if (strlit850 == NULL) {
    strlit850 = alloc_String("A number in base ");
    gc_root(strlit850);
  }
// compiled string node returning strlit850 (depth = 15)
  int op_slot_left_844 = gc_frame_newslot(strlit850);
  params[0] = call848;
  partcv[0] = 1;
  Object opresult851 = callmethod(strlit850, "++", 1, partcv, params);
// compiled op node returning opresult851 (depth = 14)
  int op_slot_left_841 = gc_frame_newslot(opresult851);
  params[0] = strlit842;
  partcv[0] = 1;
  Object opresult852 = callmethod(opresult851, "++", 1, partcv, params);
// compiled op node returning opresult852 (depth = 13)
  gc_frame_newslot(opresult852);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call854 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe853);
// compiled call node returning call854 (depth = 14)
// compiled member node returning call854 (depth = 13)
  gc_frame_newslot(call854);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num856 = alloc_Float64(1);
// compiled num node returning num856 (depth = 14)
  int op_slot_right_855 = gc_frame_newslot(num856);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_linePosition (depth = 14)
  int op_slot_left_855 = gc_frame_newslot(*var_linePosition);
  params[0] = num856;
  partcv[0] = 1;
  Object diff858 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff858 (depth = 13)
  gc_frame_newslot(diff858);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = opresult852;
  params[1] = *var_lineNumber;
  params[2] = call854;
  params[3] = diff858;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call859 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe840);
// compiled call node returning call859 (depth = 12)
    gc_frame_newslot(call859);
    if723 = call859;
  }
// compiled if node returning if723 (depth = 11)
    gc_frame_newslot(if723);
    if714 = if723;
  } else {
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit862 == NULL) {
    strlit862 = alloc_String("string");
    gc_root(strlit862);
  }
// compiled string node returning strlit862 (depth = 13)
  int op_slot_right_861 = gc_frame_newslot(strlit862);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe864 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call866 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe865);
// compiled call node returning call866 (depth = 16)
// compiled member node returning call866 (depth = 15)
  partcv[0] = 0;
  Object call867 = callmethod(call866, "kind",
    1, partcv, params);
  gc_frame_end(callframe864);
// compiled call node returning call867 (depth = 14)
// compiled member node returning call867 (depth = 13)
  int op_slot_left_861 = gc_frame_newslot(call867);
  params[0] = strlit862;
  partcv[0] = 1;
  Object opresult868 = callmethod(call867, "==", 1, partcv, params);
// compiled op node returning opresult868 (depth = 12)
  Object if860 = done;
  if (istrue(opresult868)) {
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe869 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call871 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe870);
// compiled call node returning call871 (depth = 16)
// compiled member node returning call871 (depth = 15)
  partcv[0] = 0;
  Object call872 = callmethod(call871, "new",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call872 (depth = 14)
// compiled member node returning call872 (depth = 13)
  *var_suggestion = call872;
  if (call872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe873 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call875 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe874);
// compiled call node returning call875 (depth = 14)
// compiled member node returning call875 (depth = 13)
  gc_frame_newslot(call875);
// starting to compile string node (depth = 13)
  if (strlit876 == NULL) {
    strlit876 = alloc_String("++");
    gc_root(strlit876);
  }
// compiled string node returning strlit876 (depth = 13)
  gc_frame_newslot(strlit876);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call878 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 14)
// compiled member node returning call878 (depth = 13)
  gc_frame_newslot(call878);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call875;
  params[1] = strlit876;
  params[2] = call878;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call879 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe873);
// compiled call node returning call879 (depth = 12)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe880 = gc_frame_new();
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit882 == NULL) {
    strlit882 = alloc_String("To join a number to a string, use '++'.");
    gc_root(strlit882);
  }
// compiled string node returning strlit882 (depth = 14)
  int op_slot_right_881 = gc_frame_newslot(strlit882);
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit884 == NULL) {
    strlit884 = alloc_String("A number may follow a '.' only if there is a number before the '.'. ");
    gc_root(strlit884);
  }
// compiled string node returning strlit884 (depth = 14)
  int op_slot_left_881 = gc_frame_newslot(strlit884);
  params[0] = strlit882;
  partcv[0] = 1;
  Object opresult885 = callmethod(strlit884, "++", 1, partcv, params);
// compiled op node returning opresult885 (depth = 13)
  gc_frame_newslot(opresult885);
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call887 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe886);
// compiled call node returning call887 (depth = 14)
// compiled member node returning call887 (depth = 13)
  gc_frame_newslot(call887);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call889 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe888);
// compiled call node returning call889 (depth = 14)
// compiled member node returning call889 (depth = 13)
  gc_frame_newslot(call889);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call891 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe890);
// compiled call node returning call891 (depth = 14)
// compiled member node returning call891 (depth = 13)
  gc_frame_newslot(call891);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = opresult885;
  params[1] = call887;
  params[2] = call889;
  params[3] = call891;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call892 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe880);
// compiled call node returning call892 (depth = 12)
    gc_frame_newslot(call892);
    if860 = call892;
  } else {
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit896 == NULL) {
    strlit896 = alloc_String("bind");
    gc_root(strlit896);
  }
// compiled string node returning strlit896 (depth = 15)
  int op_slot_right_895 = gc_frame_newslot(strlit896);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe898 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call900 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe899);
// compiled call node returning call900 (depth = 18)
// compiled member node returning call900 (depth = 17)
  partcv[0] = 0;
  Object call901 = callmethod(call900, "kind",
    1, partcv, params);
  gc_frame_end(callframe898);
// compiled call node returning call901 (depth = 16)
// compiled member node returning call901 (depth = 15)
  int op_slot_left_895 = gc_frame_newslot(call901);
  params[0] = strlit896;
  partcv[0] = 1;
  Object opresult902 = callmethod(call901, "==", 1, partcv, params);
// compiled op node returning opresult902 (depth = 14)
  int op_slot_right_894 = gc_frame_newslot(opresult902);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit905 == NULL) {
    strlit905 = alloc_String("op");
    gc_root(strlit905);
  }
// compiled string node returning strlit905 (depth = 15)
  int op_slot_right_904 = gc_frame_newslot(strlit905);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe907 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call909 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe908);
// compiled call node returning call909 (depth = 18)
// compiled member node returning call909 (depth = 17)
  partcv[0] = 0;
  Object call910 = callmethod(call909, "kind",
    1, partcv, params);
  gc_frame_end(callframe907);
// compiled call node returning call910 (depth = 16)
// compiled member node returning call910 (depth = 15)
  int op_slot_left_904 = gc_frame_newslot(call910);
  params[0] = strlit905;
  partcv[0] = 1;
  Object opresult911 = callmethod(call910, "==", 1, partcv, params);
// compiled op node returning opresult911 (depth = 14)
  int op_slot_left_894 = gc_frame_newslot(opresult911);
  params[0] = opresult902;
  partcv[0] = 1;
  Object opresult912 = callmethod(opresult911, "||", 1, partcv, params);
// compiled op node returning opresult912 (depth = 13)
  Object if893 = done;
  if (istrue(opresult912)) {
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe913 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe914 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call915 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe914);
// compiled call node returning call915 (depth = 17)
// compiled member node returning call915 (depth = 16)
  partcv[0] = 0;
  Object call916 = callmethod(call915, "new",
    1, partcv, params);
  gc_frame_end(callframe913);
// compiled call node returning call916 (depth = 15)
// compiled member node returning call916 (depth = 14)
  *var_suggestion = call916;
  if (call916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe917 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit918 == NULL) {
    strlit918 = alloc_String("0");
    gc_root(strlit918);
  }
// compiled string node returning strlit918 (depth = 14)
  gc_frame_newslot(strlit918);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call920 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe919);
// compiled call node returning call920 (depth = 15)
// compiled member node returning call920 (depth = 14)
  gc_frame_newslot(call920);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call922 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe921);
// compiled call node returning call922 (depth = 15)
// compiled member node returning call922 (depth = 14)
  gc_frame_newslot(call922);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = strlit918;
  params[1] = call920;
  params[2] = call922;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call923 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe917);
// compiled call node returning call923 (depth = 13)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe924 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit925 == NULL) {
    strlit925 = alloc_String("A number must have a digit before the decimal point.");
    gc_root(strlit925);
  }
// compiled string node returning strlit925 (depth = 14)
  gc_frame_newslot(strlit925);
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call927 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe926);
// compiled call node returning call927 (depth = 15)
// compiled member node returning call927 (depth = 14)
  gc_frame_newslot(call927);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call929 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe928);
// compiled call node returning call929 (depth = 15)
// compiled member node returning call929 (depth = 14)
  gc_frame_newslot(call929);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit925;
  params[1] = call927;
  params[2] = call929;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call930 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call930 (depth = 13)
    gc_frame_newslot(call930);
    if893 = call930;
  } else {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit933 == NULL) {
    strlit933 = alloc_String("identifier");
    gc_root(strlit933);
  }
// compiled string node returning strlit933 (depth = 15)
  int op_slot_right_932 = gc_frame_newslot(strlit933);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe935 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call937 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 18)
// compiled member node returning call937 (depth = 17)
  partcv[0] = 0;
  Object call938 = callmethod(call937, "kind",
    1, partcv, params);
  gc_frame_end(callframe935);
// compiled call node returning call938 (depth = 16)
// compiled member node returning call938 (depth = 15)
  int op_slot_left_932 = gc_frame_newslot(call938);
  params[0] = strlit933;
  partcv[0] = 1;
  Object opresult939 = callmethod(call938, "==", 1, partcv, params);
// compiled op node returning opresult939 (depth = 14)
  Object if931 = done;
  if (istrue(opresult939)) {
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 14)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 15)
  Object array940 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array940 (depth = 15)
  *var_suggestions = array940;
  if (array940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 14)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit943 == NULL) {
    strlit943 = alloc_String("o");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 16)
  int op_slot_right_942 = gc_frame_newslot(strlit943);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe945 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call947 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 19)
// compiled member node returning call947 (depth = 18)
  partcv[0] = 0;
  Object call948 = callmethod(call947, "value",
    1, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call948 (depth = 17)
// compiled member node returning call948 (depth = 16)
  int op_slot_left_942 = gc_frame_newslot(call948);
  params[0] = strlit943;
  partcv[0] = 1;
  Object opresult949 = callmethod(call948, "==", 1, partcv, params);
// compiled op node returning opresult949 (depth = 15)
  Object if941 = done;
  if (istrue(opresult949)) {
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 15)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe950 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_errormessages (depth = 20)
  partcv[0] = 0;
  Object call952 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe951);
// compiled call node returning call952 (depth = 19)
// compiled member node returning call952 (depth = 18)
  partcv[0] = 0;
  Object call953 = callmethod(call952, "new",
    1, partcv, params);
  gc_frame_end(callframe950);
// compiled call node returning call953 (depth = 17)
// compiled member node returning call953 (depth = 16)
  *var_suggestion = call953;
  if (call953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 15)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe954 = gc_frame_new();
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe955 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call957 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe956);
// compiled call node returning call957 (depth = 19)
// compiled member node returning call957 (depth = 18)
  partcv[0] = 0;
  Object call958 = callmethod(call957, "linePos",
    1, partcv, params);
  gc_frame_end(callframe955);
// compiled call node returning call958 (depth = 17)
// compiled member node returning call958 (depth = 16)
  gc_frame_newslot(call958);
// starting to compile string node (depth = 16)
  if (strlit959 == NULL) {
    strlit959 = alloc_String("0");
    gc_root(strlit959);
  }
// compiled string node returning strlit959 (depth = 16)
  gc_frame_newslot(strlit959);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe960 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call962 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe961);
// compiled call node returning call962 (depth = 19)
// compiled member node returning call962 (depth = 18)
  partcv[0] = 0;
  Object call963 = callmethod(call962, "line",
    1, partcv, params);
  gc_frame_end(callframe960);
// compiled call node returning call963 (depth = 17)
// compiled member node returning call963 (depth = 16)
  gc_frame_newslot(call963);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestion (depth = 16)
  params[0] = call958;
  params[1] = strlit959;
  params[2] = call963;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call964 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe954);
// compiled call node returning call964 (depth = 15)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe965 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestion (depth = 16)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestions (depth = 16)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call966 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe965);
// compiled call node returning call966 (depth = 15)
    gc_frame_newslot(call966);
    if941 = call966;
  } else {
  }
// compiled if node returning if941 (depth = 14)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 14)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe967 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_errormessages (depth = 19)
  partcv[0] = 0;
  Object call969 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe968);
// compiled call node returning call969 (depth = 18)
// compiled member node returning call969 (depth = 17)
  partcv[0] = 0;
  Object call970 = callmethod(call969, "new",
    1, partcv, params);
  gc_frame_end(callframe967);
// compiled call node returning call970 (depth = 16)
// compiled member node returning call970 (depth = 15)
  *var_suggestion = call970;
  if (call970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 14)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe971 = gc_frame_new();
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call973 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe972);
// compiled call node returning call973 (depth = 16)
// compiled member node returning call973 (depth = 15)
  gc_frame_newslot(call973);
// starting to compile op node (depth = 15)
// starting to compile num node (depth = 16)
  Object num975 = alloc_Float64(1);
// compiled num node returning num975 (depth = 16)
  int op_slot_right_974 = gc_frame_newslot(num975);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  int op_slot_left_974 = gc_frame_newslot(*var_linePosition);
  params[0] = num975;
  partcv[0] = 1;
  Object diff977 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff977 (depth = 15)
  gc_frame_newslot(diff977);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit979 == NULL) {
    strlit979 = alloc_String(")");
    gc_root(strlit979);
  }
// compiled string node returning strlit979 (depth = 16)
  int op_slot_right_978 = gc_frame_newslot(strlit979);
// starting to compile op node (depth = 16)
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_right_981 = gc_frame_newslot(*var_accum);
// starting to compile string node (depth = 17)
  if (strlit983 == NULL) {
    strlit983 = alloc_String("(");
    gc_root(strlit983);
  }
// compiled string node returning strlit983 (depth = 17)
  int op_slot_left_981 = gc_frame_newslot(strlit983);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult984 = callmethod(strlit983, "++", 1, partcv, params);
// compiled op node returning opresult984 (depth = 16)
  int op_slot_left_978 = gc_frame_newslot(opresult984);
  params[0] = strlit979;
  partcv[0] = 1;
  Object opresult985 = callmethod(opresult984, "++", 1, partcv, params);
// compiled op node returning opresult985 (depth = 15)
  gc_frame_newslot(opresult985);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe986 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call988 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe987);
// compiled call node returning call988 (depth = 18)
// compiled member node returning call988 (depth = 17)
  partcv[0] = 0;
  Object call989 = callmethod(call988, "line",
    1, partcv, params);
  gc_frame_end(callframe986);
// compiled call node returning call989 (depth = 16)
// compiled member node returning call989 (depth = 15)
  gc_frame_newslot(call989);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  params[0] = call973;
  params[1] = diff977;
  params[2] = opresult985;
  params[3] = call989;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call990 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe971);
// compiled call node returning call990 (depth = 14)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe991 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestions (depth = 15)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call992 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe991);
// compiled call node returning call992 (depth = 14)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe993 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit994 == NULL) {
    strlit994 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit994);
  }
// compiled string node returning strlit994 (depth = 15)
  gc_frame_newslot(strlit994);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call996 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe995);
// compiled call node returning call996 (depth = 16)
// compiled member node returning call996 (depth = 15)
  gc_frame_newslot(call996);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call998 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe997);
// compiled call node returning call998 (depth = 16)
// compiled member node returning call998 (depth = 15)
  gc_frame_newslot(call998);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1000 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe999);
// compiled call node returning call1000 (depth = 16)
// compiled member node returning call1000 (depth = 15)
  gc_frame_newslot(call1000);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestions (depth = 15)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = strlit994;
  params[1] = call996;
  params[2] = call998;
  params[3] = call1000;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1001 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe993);
// compiled call node returning call1001 (depth = 14)
    gc_frame_newslot(call1001);
    if931 = call1001;
  } else {
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1002 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit1003 == NULL) {
    strlit1003 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit1003);
  }
// compiled string node returning strlit1003 (depth = 15)
  gc_frame_newslot(strlit1003);
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1005 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe1004);
// compiled call node returning call1005 (depth = 16)
// compiled member node returning call1005 (depth = 15)
  gc_frame_newslot(call1005);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1007 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1006);
// compiled call node returning call1007 (depth = 16)
// compiled member node returning call1007 (depth = 15)
  gc_frame_newslot(call1007);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1009 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1008);
// compiled call node returning call1009 (depth = 16)
// compiled member node returning call1009 (depth = 15)
  gc_frame_newslot(call1009);
// call case 6: other member request
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = strlit1003;
  params[1] = call1005;
  params[2] = call1007;
  params[3] = call1009;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1010 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe1002);
// compiled call node returning call1010 (depth = 14)
    gc_frame_newslot(call1010);
    if931 = call1010;
  }
// compiled if node returning if931 (depth = 13)
    gc_frame_newslot(if931);
    if893 = if931;
  }
// compiled if node returning if893 (depth = 12)
    gc_frame_newslot(if893);
    if860 = if893;
  }
// compiled if node returning if860 (depth = 11)
    gc_frame_newslot(if860);
    if714 = if860;
  }
// compiled if node returning if714 (depth = 10)
    gc_frame_newslot(if714);
    if692 = if714;
  } else {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1011 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1012 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1011);
// compiled call node returning call1012 (depth = 11)
  *var_tok = call1012;
  if (call1012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if692 = done;
  }
// compiled if node returning if692 (depth = 9)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1014 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1015 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1014);
// compiled call node returning call1015 (depth = 9)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool1016 = alloc_Boolean(1);
// compiled identifier node returning bool1016 (depth = 10)
  *var_isDone = bool1016;
  if (bool1016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if687 = done;
  } else {
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1020 == NULL) {
    strlit1020 = alloc_String("o");
    gc_root(strlit1020);
  }
// compiled string node returning strlit1020 (depth = 11)
  int op_slot_right_1019 = gc_frame_newslot(strlit1020);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_1019 = gc_frame_newslot(*var_mode);
  params[0] = strlit1020;
  partcv[0] = 1;
  Object opresult1022 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1022 (depth = 10)
  Object if1018 = done;
  if (istrue(opresult1022)) {
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1023 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_OpToken (depth = 12)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1024 = callmethod(*var_OpToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1023);
// compiled call node returning call1024 (depth = 11)
  *var_tok = call1024;
  if (call1024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1028 == NULL) {
    strlit1028 = alloc_String("->");
    gc_root(strlit1028);
  }
// compiled string node returning strlit1028 (depth = 12)
  int op_slot_right_1027 = gc_frame_newslot(strlit1028);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_1027 = gc_frame_newslot(*var_accum);
  params[0] = strlit1028;
  partcv[0] = 1;
  Object opresult1030 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1030 (depth = 11)
  Object if1026 = done;
  if (istrue(opresult1030)) {
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1031 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ArrowToken (depth = 14)
  partcv[0] = 0;
  Object call1032 = callmethod(*var_ArrowToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1031);
// compiled call node returning call1032 (depth = 13)
// compiled member node returning call1032 (depth = 12)
  *var_tok = call1032;
  if (call1032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1026 = done;
  } else {
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1036 == NULL) {
    strlit1036 = alloc_String(":=");
    gc_root(strlit1036);
  }
// compiled string node returning strlit1036 (depth = 13)
  int op_slot_right_1035 = gc_frame_newslot(strlit1036);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_1035 = gc_frame_newslot(*var_accum);
  params[0] = strlit1036;
  partcv[0] = 1;
  Object opresult1038 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1038 (depth = 12)
  Object if1034 = done;
  if (istrue(opresult1038)) {
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_BindToken (depth = 15)
  partcv[0] = 0;
  Object call1040 = callmethod(*var_BindToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1039);
// compiled call node returning call1040 (depth = 14)
// compiled member node returning call1040 (depth = 13)
  *var_tok = call1040;
  if (call1040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1034 = done;
  } else {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1044 == NULL) {
    strlit1044 = alloc_String(":");
    gc_root(strlit1044);
  }
// compiled string node returning strlit1044 (depth = 14)
  int op_slot_right_1043 = gc_frame_newslot(strlit1044);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_1043 = gc_frame_newslot(*var_accum);
  params[0] = strlit1044;
  partcv[0] = 1;
  Object opresult1046 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1046 (depth = 13)
  Object if1042 = done;
  if (istrue(opresult1046)) {
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1047 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_ColonToken (depth = 16)
  partcv[0] = 0;
  Object call1048 = callmethod(*var_ColonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1047);
// compiled call node returning call1048 (depth = 15)
// compiled member node returning call1048 (depth = 14)
  *var_tok = call1048;
  if (call1048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if1042 = done;
  } else {
  }
// compiled if node returning if1042 (depth = 12)
    gc_frame_newslot(if1042);
    if1034 = if1042;
  }
// compiled if node returning if1034 (depth = 11)
    gc_frame_newslot(if1034);
    if1026 = if1034;
  }
// compiled if node returning if1026 (depth = 10)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1050 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1051 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1050);
// compiled call node returning call1051 (depth = 10)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
  Object bool1052 = alloc_Boolean(1);
// compiled identifier node returning bool1052 (depth = 11)
  *var_isDone = bool1052;
  if (bool1052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1018 = done;
  } else {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1056 == NULL) {
    strlit1056 = alloc_String("d");
    gc_root(strlit1056);
  }
// compiled string node returning strlit1056 (depth = 12)
  int op_slot_right_1055 = gc_frame_newslot(strlit1056);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_1055 = gc_frame_newslot(*var_mode);
  params[0] = strlit1056;
  partcv[0] = 1;
  Object opresult1058 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1058 (depth = 11)
  Object if1054 = done;
  if (istrue(opresult1058)) {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num1060 = alloc_Float64(1);
// compiled num node returning num1060 (depth = 13)
  int op_slot_right_1059 = gc_frame_newslot(num1060);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_1059 = gc_frame_newslot(*var_linePosition);
  params[0] = num1060;
  partcv[0] = 1;
  Object diff1062 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1062 (depth = 12)
  *var_indentLevel = diff1062;
  if (diff1062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool1064 = alloc_Boolean(1);
// compiled identifier node returning bool1064 (depth = 12)
  *var_isDone = bool1064;
  if (bool1064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1054 = done;
  } else {
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1068 == NULL) {
    strlit1068 = alloc_String("n");
    gc_root(strlit1068);
  }
// compiled string node returning strlit1068 (depth = 13)
  int op_slot_right_1067 = gc_frame_newslot(strlit1068);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_1067 = gc_frame_newslot(*var_mode);
  params[0] = strlit1068;
  partcv[0] = 1;
  Object opresult1070 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1070 (depth = 12)
  Object if1066 = done;
  if (istrue(opresult1070)) {
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool1071 = alloc_Boolean(1);
// compiled identifier node returning bool1071 (depth = 13)
  *var_isDone = bool1071;
  if (bool1071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1066 = done;
  } else {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1075 == NULL) {
    strlit1075 = alloc_String("c");
    gc_root(strlit1075);
  }
// compiled string node returning strlit1075 (depth = 14)
  int op_slot_right_1074 = gc_frame_newslot(strlit1075);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_1074 = gc_frame_newslot(*var_mode);
  params[0] = strlit1075;
  partcv[0] = 1;
  Object opresult1077 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1077 (depth = 13)
  Object if1073 = done;
  if (istrue(opresult1077)) {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1078 = gc_frame_new();
// starting to compile num node (depth = 15)
  Object num1079 = alloc_Float64(3);
// compiled num node returning num1079 (depth = 15)
  gc_frame_newslot(num1079);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  partcv[0] = 0;
  Object call1081 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1080);
// compiled call node returning call1081 (depth = 16)
// compiled member node returning call1081 (depth = 15)
  gc_frame_newslot(call1081);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  params[0] = num1079;
  params[1] = call1081;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1082 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1078);
// compiled call node returning call1082 (depth = 14)
  *var_cmt = call1082;
  if (call1082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1083 = gc_frame_new();
// starting to compile call node (depth = 14)
  int callframe1084 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_cmt (depth = 15)
  gc_frame_newslot(*var_cmt);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_CommentToken (depth = 15)
  params[0] = *var_cmt;
  partcv[0] = 1;
  Object call1085 = callmethod(*var_CommentToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1084);
// compiled call node returning call1085 (depth = 14)
  gc_frame_newslot(call1085);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  params[0] = call1085;
  partcv[0] = 1;
  Object call1086 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1083);
// compiled call node returning call1086 (depth = 13)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
  Object bool1087 = alloc_Boolean(1);
// compiled identifier node returning bool1087 (depth = 14)
  *var_isDone = bool1087;
  if (bool1087 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if1073 = done;
  } else {
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("p");
    gc_root(strlit1091);
  }
// compiled string node returning strlit1091 (depth = 15)
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_mode (depth = 15)
  int op_slot_left_1090 = gc_frame_newslot(*var_mode);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1093 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1093 (depth = 14)
  Object if1089 = done;
  if (istrue(opresult1093)) {
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1096 == NULL) {
    strlit1096 = alloc_String("#pragma ");
    gc_root(strlit1096);
  }
// compiled string node returning strlit1096 (depth = 16)
  int op_slot_right_1095 = gc_frame_newslot(strlit1096);
// starting to compile call node (depth = 16)
  int callframe1098 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num1099 = alloc_Float64(1);
// compiled num node returning num1099 (depth = 17)
  gc_frame_newslot(num1099);
// starting to compile num node (depth = 17)
  Object num1100 = alloc_Float64(8);
// compiled num node returning num1100 (depth = 17)
  gc_frame_newslot(num1100);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  params[0] = num1099;
  params[1] = num1100;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1101 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1098);
// compiled call node returning call1101 (depth = 16)
  int op_slot_left_1095 = gc_frame_newslot(call1101);
  params[0] = strlit1096;
  partcv[0] = 1;
  Object opresult1102 = callmethod(call1101, "==", 1, partcv, params);
// compiled op node returning opresult1102 (depth = 15)
  Object if1094 = done;
  if (istrue(opresult1102)) {
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe1103 = gc_frame_new();
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 16)
  int callframe1104 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num1105 = alloc_Float64(9);
// compiled num node returning num1105 (depth = 17)
  gc_frame_newslot(num1105);
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe1106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  partcv[0] = 0;
  Object call1107 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1106);
// compiled call node returning call1107 (depth = 18)
// compiled member node returning call1107 (depth = 17)
  gc_frame_newslot(call1107);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  params[0] = num1105;
  params[1] = call1107;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1108 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1104);
// compiled call node returning call1108 (depth = 16)
  gc_frame_newslot(call1108);
// call case 6: other member request
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  params[0] = call1108;
  partcv[0] = 1;
  Object call1109 = callmethod(*var_util, "processExtension",
    1, partcv, params);
  gc_frame_end(callframe1103);
// compiled call node returning call1109 (depth = 15)
    gc_frame_newslot(call1109);
    if1094 = call1109;
  } else {
  }
// compiled if node returning if1094 (depth = 14)
    gc_frame_newslot(if1094);
    if1089 = if1094;
  } else {
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_isDone (depth = 15)
  Object if1110 = done;
  if (istrue(*var_isDone)) {
    gc_frame_newslot(done);
    if1110 = done;
  } else {
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe1111 = gc_frame_new();
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit1113 == NULL) {
    strlit1113 = alloc_String(".");
    gc_root(strlit1113);
  }
// compiled string node returning strlit1113 (depth = 17)
  int op_slot_right_1112 = gc_frame_newslot(strlit1113);
// starting to compile op node (depth = 17)
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_right_1115 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit1118 == NULL) {
    strlit1118 = alloc_String(" with accum ");
    gc_root(strlit1118);
  }
// compiled string node returning strlit1118 (depth = 19)
  int op_slot_right_1117 = gc_frame_newslot(strlit1118);
// starting to compile op node (depth = 19)
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_mode (depth = 20)
  int op_slot_right_1120 = gc_frame_newslot(*var_mode);
// starting to compile string node (depth = 20)
  if (strlit1122 == NULL) {
    strlit1122 = alloc_String("Lexing error: no handler for mode ");
    gc_root(strlit1122);
  }
// compiled string node returning strlit1122 (depth = 20)
  int op_slot_left_1120 = gc_frame_newslot(strlit1122);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult1123 = callmethod(strlit1122, "++", 1, partcv, params);
// compiled op node returning opresult1123 (depth = 19)
  int op_slot_left_1117 = gc_frame_newslot(opresult1123);
  params[0] = strlit1118;
  partcv[0] = 1;
  Object opresult1124 = callmethod(opresult1123, "++", 1, partcv, params);
// compiled op node returning opresult1124 (depth = 18)
  int op_slot_left_1115 = gc_frame_newslot(opresult1124);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult1125 = callmethod(opresult1124, "++", 1, partcv, params);
// compiled op node returning opresult1125 (depth = 17)
  int op_slot_left_1112 = gc_frame_newslot(opresult1125);
  params[0] = strlit1113;
  partcv[0] = 1;
  Object opresult1126 = callmethod(opresult1125, "++", 1, partcv, params);
// compiled op node returning opresult1126 (depth = 16)
  gc_frame_newslot(opresult1126);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lineNumber (depth = 16)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  params[0] = opresult1126;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call1127 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe1111);
// compiled call node returning call1127 (depth = 15)
    gc_frame_newslot(call1127);
    if1110 = call1127;
  }
// compiled if node returning if1110 (depth = 14)
    gc_frame_newslot(if1110);
    if1089 = if1110;
  }
// compiled if node returning if1089 (depth = 13)
    gc_frame_newslot(if1089);
    if1073 = if1089;
  }
// compiled if node returning if1073 (depth = 12)
    gc_frame_newslot(if1073);
    if1066 = if1073;
  }
// compiled if node returning if1066 (depth = 11)
    gc_frame_newslot(if1066);
    if1054 = if1066;
  }
// compiled if node returning if1054 (depth = 10)
    gc_frame_newslot(if1054);
    if1018 = if1054;
  }
// compiled if node returning if1018 (depth = 9)
    gc_frame_newslot(if1018);
    if687 = if1018;
  }
// compiled if node returning if687 (depth = 8)
    gc_frame_newslot(if687);
    if675 = if687;
  }
// compiled if node returning if675 (depth = 7)
    gc_frame_newslot(if675);
    if663 = if675;
  }
// compiled if node returning if663 (depth = 6)
    gc_frame_newslot(if663);
    if651 = if663;
  }
// compiled if node returning if651 (depth = 5)
    gc_frame_newslot(if651);
    if639 = if651;
  }
// compiled if node returning if639 (depth = 4)
    gc_frame_newslot(if639);
    if394 = if639;
  } else {
  }
// compiled if node returning if394 (depth = 3)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_linePosition (depth = 4)
  *var_startPosition = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply1134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_base = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_linePosition = getfromclosure(closure, 4);
  Object *var_lineNumber = getfromclosure(closure, 5);
  Object *var_i = getfromclosure(closure, 6);
  Object *var_unicode = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_inc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "inc");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_validDigits = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "validDigits");
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1135 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  partcv[0] = 0;
  Object call1136 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe1135);
// compiled call node returning call1136 (depth = 7)
// compiled member node returning call1136 (depth = 6)
  *var_n = call1136;
  if (call1136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_1137 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  int op_slot_left_1137 = gc_frame_newslot(*var_val);
  params[0] = *var_base;
  partcv[0] = 1;
  Object prod1139 = callmethod(*var_val, "*", 1, partcv, params);
// compiled op node returning prod1139 (depth = 6)
  *var_val = prod1139;
  if (prod1139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1141 = alloc_Float64(0);
// compiled num node returning num1141 (depth = 6)
  *var_inc = num1141;
  if (num1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1145 = alloc_Float64(57);
// compiled num node returning num1145 (depth = 8)
  int op_slot_right_1144 = gc_frame_newslot(num1145);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1144 = gc_frame_newslot(*var_n);
  params[0] = num1145;
  partcv[0] = 1;
  Object opresult1147 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1147 (depth = 7)
  int op_slot_right_1143 = gc_frame_newslot(opresult1147);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1150 = alloc_Float64(48);
// compiled num node returning num1150 (depth = 8)
  int op_slot_right_1149 = gc_frame_newslot(num1150);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1149 = gc_frame_newslot(*var_n);
  params[0] = num1150;
  partcv[0] = 1;
  Object opresult1152 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1152 (depth = 7)
  int op_slot_left_1143 = gc_frame_newslot(opresult1152);
  params[0] = opresult1147;
  partcv[0] = 1;
  Object opresult1153 = callmethod(opresult1152, "&&", 1, partcv, params);
// compiled op node returning opresult1153 (depth = 6)
  Object if1142 = done;
  if (istrue(opresult1153)) {
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1155 = alloc_Float64(48);
// compiled num node returning num1155 (depth = 8)
  int op_slot_right_1154 = gc_frame_newslot(num1155);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1154 = gc_frame_newslot(*var_n);
  params[0] = num1155;
  partcv[0] = 1;
  Object diff1157 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1157 (depth = 7)
  *var_inc = diff1157;
  if (diff1157 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1142 = done;
  } else {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1162 = alloc_Float64(90);
// compiled num node returning num1162 (depth = 9)
  int op_slot_right_1161 = gc_frame_newslot(num1162);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1161 = gc_frame_newslot(*var_n);
  params[0] = num1162;
  partcv[0] = 1;
  Object opresult1164 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1164 (depth = 8)
  int op_slot_right_1160 = gc_frame_newslot(opresult1164);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1167 = alloc_Float64(65);
// compiled num node returning num1167 (depth = 9)
  int op_slot_right_1166 = gc_frame_newslot(num1167);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1166 = gc_frame_newslot(*var_n);
  params[0] = num1167;
  partcv[0] = 1;
  Object opresult1169 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1169 (depth = 8)
  int op_slot_left_1160 = gc_frame_newslot(opresult1169);
  params[0] = opresult1164;
  partcv[0] = 1;
  Object opresult1170 = callmethod(opresult1169, "&&", 1, partcv, params);
// compiled op node returning opresult1170 (depth = 7)
  Object if1159 = done;
  if (istrue(opresult1170)) {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1172 = alloc_Float64(55);
// compiled num node returning num1172 (depth = 9)
  int op_slot_right_1171 = gc_frame_newslot(num1172);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1171 = gc_frame_newslot(*var_n);
  params[0] = num1172;
  partcv[0] = 1;
  Object diff1174 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1174 (depth = 8)
  *var_inc = diff1174;
  if (diff1174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1159 = done;
  } else {
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1177 = alloc_Float64(87);
// compiled num node returning num1177 (depth = 9)
  int op_slot_right_1176 = gc_frame_newslot(num1177);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1176 = gc_frame_newslot(*var_n);
  params[0] = num1177;
  partcv[0] = 1;
  Object diff1179 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1179 (depth = 8)
  *var_inc = diff1179;
  if (diff1179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1159 = done;
  }
// compiled if node returning if1159 (depth = 6)
    gc_frame_newslot(if1159);
    if1142 = if1159;
  }
// compiled if node returning if1142 (depth = 5)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_1182 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inc (depth = 7)
  int op_slot_left_1182 = gc_frame_newslot(*var_inc);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1184 = callmethod(*var_inc, ">=", 1, partcv, params);
// compiled op node returning opresult1184 (depth = 6)
  Object if1181 = done;
  if (istrue(opresult1184)) {
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1188 = alloc_Float64(16);
// compiled num node returning num1188 (depth = 9)
  int op_slot_right_1187 = gc_frame_newslot(num1188);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_inc (depth = 9)
  int op_slot_left_1187 = gc_frame_newslot(*var_inc);
  params[0] = num1188;
  partcv[0] = 1;
  Object opresult1190 = callmethod(*var_inc, "<", 1, partcv, params);
// compiled op node returning opresult1190 (depth = 8)
  int op_slot_right_1186 = gc_frame_newslot(opresult1190);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1193 == NULL) {
    strlit1193 = alloc_String("0");
    gc_root(strlit1193);
  }
// compiled string node returning strlit1193 (depth = 9)
  int op_slot_right_1192 = gc_frame_newslot(strlit1193);
// starting to compile index node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
// starting to compile num node (depth = 10)
  Object num1195 = alloc_Float64(1);
// compiled num node returning num1195 (depth = 10)
  params[0] = num1195;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1196 = callmethod(*var_str, "[]", 1, partcv, params);
// compiled index node returning idxres1196 (depth = 9)
  int op_slot_left_1192 = gc_frame_newslot(idxres1196);
  params[0] = strlit1193;
  partcv[0] = 1;
  Object opresult1197 = callmethod(idxres1196, "==", 1, partcv, params);
// compiled op node returning opresult1197 (depth = 8)
  int op_slot_left_1186 = gc_frame_newslot(opresult1197);
  params[0] = opresult1190;
  partcv[0] = 1;
  Object opresult1198 = callmethod(opresult1197, "&&", 1, partcv, params);
// compiled op node returning opresult1198 (depth = 7)
  Object if1185 = done;
  if (istrue(opresult1198)) {
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1199 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1201 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1200);
// compiled call node returning call1201 (depth = 11)
// compiled member node returning call1201 (depth = 10)
  partcv[0] = 0;
  Object call1202 = callmethod(call1201, "new",
    1, partcv, params);
  gc_frame_end(callframe1199);
// compiled call node returning call1202 (depth = 9)
// compiled member node returning call1202 (depth = 8)
  *var_suggestion = call1202;
  if (call1202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1203 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1204 == NULL) {
    strlit1204 = alloc_String("x");
    gc_root(strlit1204);
  }
// compiled string node returning strlit1204 (depth = 8)
  gc_frame_newslot(strlit1204);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1206 = alloc_Float64(1);
// compiled num node returning num1206 (depth = 9)
  int op_slot_right_1205 = gc_frame_newslot(num1206);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1209 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1210 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1209);
// compiled call node returning call1210 (depth = 11)
// compiled member node returning call1210 (depth = 10)
  int op_slot_right_1208 = gc_frame_newslot(call1210);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1208 = gc_frame_newslot(*var_linePosition);
  params[0] = call1210;
  partcv[0] = 1;
  Object diff1212 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1212 (depth = 9)
  int op_slot_left_1205 = gc_frame_newslot(diff1212);
  params[0] = num1206;
  partcv[0] = 1;
  Object sum1213 = callmethod(diff1212, "+", 1, partcv, params);
// compiled op node returning sum1213 (depth = 8)
  gc_frame_newslot(sum1213);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1204;
  params[1] = sum1213;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1214 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1203);
// compiled call node returning call1214 (depth = 7)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1215 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1216 == NULL) {
    strlit1216 = alloc_String("A number in base 16 must start with '0x'.");
    gc_root(strlit1216);
  }
// compiled string node returning strlit1216 (depth = 8)
  gc_frame_newslot(strlit1216);
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1218 = alloc_Float64(1);
// compiled num node returning num1218 (depth = 9)
  int op_slot_right_1217 = gc_frame_newslot(num1218);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1222 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1221);
// compiled call node returning call1222 (depth = 11)
// compiled member node returning call1222 (depth = 10)
  int op_slot_right_1220 = gc_frame_newslot(call1222);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1220 = gc_frame_newslot(*var_linePosition);
  params[0] = call1222;
  partcv[0] = 1;
  Object diff1224 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1224 (depth = 9)
  int op_slot_left_1217 = gc_frame_newslot(diff1224);
  params[0] = num1218;
  partcv[0] = 1;
  Object sum1225 = callmethod(diff1224, "+", 1, partcv, params);
// compiled op node returning sum1225 (depth = 8)
  gc_frame_newslot(sum1225);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1216;
  params[1] = *var_lineNumber;
  params[2] = sum1225;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1226 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1215);
// compiled call node returning call1226 (depth = 7)
    gc_frame_newslot(call1226);
    if1185 = call1226;
  } else {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1227 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1229 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1228);
// compiled call node returning call1229 (depth = 11)
// compiled member node returning call1229 (depth = 10)
  partcv[0] = 0;
  Object call1230 = callmethod(call1229, "new",
    1, partcv, params);
  gc_frame_end(callframe1227);
// compiled call node returning call1230 (depth = 9)
// compiled member node returning call1230 (depth = 8)
  *var_suggestion = call1230;
  if (call1230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1233 = alloc_Float64(1);
// compiled num node returning num1233 (depth = 9)
  int op_slot_right_1232 = gc_frame_newslot(num1233);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1236 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1235);
// compiled call node returning call1236 (depth = 10)
// compiled member node returning call1236 (depth = 9)
  int op_slot_left_1232 = gc_frame_newslot(call1236);
  params[0] = num1233;
  partcv[0] = 1;
  Object opresult1237 = callmethod(call1236, "==", 1, partcv, params);
// compiled op node returning opresult1237 (depth = 8)
  Object if1231 = done;
  if (istrue(opresult1237)) {
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1238 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1240 = alloc_Float64(1);
// compiled num node returning num1240 (depth = 10)
  int op_slot_right_1239 = gc_frame_newslot(num1240);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_str (depth = 13)
  partcv[0] = 0;
  Object call1244 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1243);
// compiled call node returning call1244 (depth = 12)
// compiled member node returning call1244 (depth = 11)
  int op_slot_right_1242 = gc_frame_newslot(call1244);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1242 = gc_frame_newslot(*var_linePosition);
  params[0] = call1244;
  partcv[0] = 1;
  Object diff1246 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1246 (depth = 10)
  int op_slot_left_1239 = gc_frame_newslot(diff1246);
  params[0] = num1240;
  partcv[0] = 1;
  Object diff1247 = callmethod(diff1246, "-", 1, partcv, params);
// compiled op node returning diff1247 (depth = 9)
  gc_frame_newslot(diff1247);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1249 = alloc_Float64(1);
// compiled num node returning num1249 (depth = 10)
  int op_slot_right_1248 = gc_frame_newslot(num1249);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1248 = gc_frame_newslot(*var_linePosition);
  params[0] = num1249;
  partcv[0] = 1;
  Object diff1251 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1251 (depth = 9)
  gc_frame_newslot(diff1251);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff1247;
  params[1] = diff1251;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1252 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1238);
// compiled call node returning call1252 (depth = 8)
    gc_frame_newslot(call1252);
    if1231 = call1252;
  } else {
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1253 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_right_1254 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1257 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_str (depth = 13)
  partcv[0] = 0;
  Object call1258 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1257);
// compiled call node returning call1258 (depth = 12)
// compiled member node returning call1258 (depth = 11)
  int op_slot_right_1256 = gc_frame_newslot(call1258);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1256 = gc_frame_newslot(*var_linePosition);
  params[0] = call1258;
  partcv[0] = 1;
  Object diff1260 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1260 (depth = 10)
  int op_slot_left_1254 = gc_frame_newslot(diff1260);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1261 = callmethod(diff1260, "+", 1, partcv, params);
// compiled op node returning sum1261 (depth = 9)
  gc_frame_newslot(sum1261);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum1261;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1262 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe1253);
// compiled call node returning call1262 (depth = 8)
    gc_frame_newslot(call1262);
    if1231 = call1262;
  }
// compiled if node returning if1231 (depth = 7)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile if node (depth = 8)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1265 = alloc_Float64(10);
// compiled num node returning num1265 (depth = 10)
  int op_slot_right_1264 = gc_frame_newslot(num1265);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_base (depth = 10)
  int op_slot_left_1264 = gc_frame_newslot(*var_base);
  params[0] = num1265;
  partcv[0] = 1;
  Object opresult1267 = callmethod(*var_base, "<=", 1, partcv, params);
// compiled op node returning opresult1267 (depth = 9)
  Object if1263 = done;
struct StackFrameObject *iftmpstackframe1263 = stackframe;
  if (istrue(opresult1267)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1263);
gc_frame_newslot((Object)stackframe);
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1269 == NULL) {
    strlit1269 = alloc_String("'");
    gc_root(strlit1269);
  }
// compiled string node returning strlit1269 (depth = 10)
  int op_slot_right_1268 = gc_frame_newslot(strlit1269);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1273 = alloc_Float64(1);
// compiled num node returning num1273 (depth = 12)
  int op_slot_right_1272 = gc_frame_newslot(num1273);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_left_1272 = gc_frame_newslot(*var_base);
  params[0] = num1273;
  partcv[0] = 1;
  Object diff1275 = callmethod(*var_base, "-", 1, partcv, params);
// compiled op node returning diff1275 (depth = 11)
  int op_slot_right_1271 = gc_frame_newslot(diff1275);
// starting to compile string node (depth = 11)
  if (strlit1277 == NULL) {
    strlit1277 = alloc_String("'0' to '");
    gc_root(strlit1277);
  }
// compiled string node returning strlit1277 (depth = 11)
  int op_slot_left_1271 = gc_frame_newslot(strlit1277);
  params[0] = diff1275;
  partcv[0] = 1;
  Object opresult1278 = callmethod(strlit1277, "++", 1, partcv, params);
// compiled op node returning opresult1278 (depth = 10)
  int op_slot_left_1268 = gc_frame_newslot(opresult1278);
  params[0] = strlit1269;
  partcv[0] = 1;
  Object opresult1279 = callmethod(opresult1278, "++", 1, partcv, params);
// compiled op node returning opresult1279 (depth = 9)
    gc_frame_newslot(opresult1279);
    if1263 = opresult1279;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1263);
  gc_frame_newslot((Object)stackframe);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1281 == NULL) {
    strlit1281 = alloc_String("'");
    gc_root(strlit1281);
  }
// compiled string node returning strlit1281 (depth = 10)
  int op_slot_right_1280 = gc_frame_newslot(strlit1281);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1284 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_base (depth = 13)
  int op_slot_right_1285 = gc_frame_newslot(*var_base);
// starting to compile num node (depth = 13)
  Object num1287 = alloc_Float64(87);
// compiled num node returning num1287 (depth = 13)
  int op_slot_left_1285 = gc_frame_newslot(num1287);
  params[0] = *var_base;
  partcv[0] = 1;
  Object sum1288 = callmethod(num1287, "+", 1, partcv, params);
// compiled op node returning sum1288 (depth = 12)
  gc_frame_newslot(sum1288);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unicode (depth = 12)
  params[0] = sum1288;
  partcv[0] = 1;
  Object call1289 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe1284);
// compiled call node returning call1289 (depth = 11)
  int op_slot_right_1283 = gc_frame_newslot(call1289);
// starting to compile string node (depth = 11)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String("'0' to '9', 'a' to '");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 11)
  int op_slot_left_1283 = gc_frame_newslot(strlit1291);
  params[0] = call1289;
  partcv[0] = 1;
  Object opresult1292 = callmethod(strlit1291, "++", 1, partcv, params);
// compiled op node returning opresult1292 (depth = 10)
  int op_slot_left_1280 = gc_frame_newslot(opresult1292);
  params[0] = strlit1281;
  partcv[0] = 1;
  Object opresult1293 = callmethod(opresult1292, "++", 1, partcv, params);
// compiled op node returning opresult1293 (depth = 9)
    gc_frame_newslot(opresult1293);
    if1263 = opresult1293;
  }
stackframe = iftmpstackframe1263;
// compiled if node returning if1263 (depth = 8)
  *var_validDigits = if1263;
  if (if1263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1294 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1296 == NULL) {
    strlit1296 = alloc_String(".");
    gc_root(strlit1296);
  }
// compiled string node returning strlit1296 (depth = 9)
  int op_slot_right_1295 = gc_frame_newslot(strlit1296);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_validDigits (depth = 10)
  int op_slot_right_1298 = gc_frame_newslot(*var_validDigits);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1301 == NULL) {
    strlit1301 = alloc_String(". Valid digits are ");
    gc_root(strlit1301);
  }
// compiled string node returning strlit1301 (depth = 11)
  int op_slot_right_1300 = gc_frame_newslot(strlit1301);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_right_1303 = gc_frame_newslot(*var_base);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1306 == NULL) {
    strlit1306 = alloc_String("' is not a valid digit in base ");
    gc_root(strlit1306);
  }
// compiled string node returning strlit1306 (depth = 13)
  int op_slot_right_1305 = gc_frame_newslot(strlit1306);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_right_1308 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 14)
  if (strlit1310 == NULL) {
    strlit1310 = alloc_String("'");
    gc_root(strlit1310);
  }
// compiled string node returning strlit1310 (depth = 14)
  int op_slot_left_1308 = gc_frame_newslot(strlit1310);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1311 = callmethod(strlit1310, "++", 1, partcv, params);
// compiled op node returning opresult1311 (depth = 13)
  int op_slot_left_1305 = gc_frame_newslot(opresult1311);
  params[0] = strlit1306;
  partcv[0] = 1;
  Object opresult1312 = callmethod(opresult1311, "++", 1, partcv, params);
// compiled op node returning opresult1312 (depth = 12)
  int op_slot_left_1303 = gc_frame_newslot(opresult1312);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1313 = callmethod(opresult1312, "++", 1, partcv, params);
// compiled op node returning opresult1313 (depth = 11)
  int op_slot_left_1300 = gc_frame_newslot(opresult1313);
  params[0] = strlit1301;
  partcv[0] = 1;
  Object opresult1314 = callmethod(opresult1313, "++", 1, partcv, params);
// compiled op node returning opresult1314 (depth = 10)
  int op_slot_left_1298 = gc_frame_newslot(opresult1314);
  params[0] = *var_validDigits;
  partcv[0] = 1;
  Object opresult1315 = callmethod(opresult1314, "++", 1, partcv, params);
// compiled op node returning opresult1315 (depth = 9)
  int op_slot_left_1295 = gc_frame_newslot(opresult1315);
  params[0] = strlit1296;
  partcv[0] = 1;
  Object opresult1316 = callmethod(opresult1315, "++", 1, partcv, params);
// compiled op node returning opresult1316 (depth = 8)
  gc_frame_newslot(opresult1316);
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1317 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1320 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1321 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1320);
// compiled call node returning call1321 (depth = 11)
// compiled member node returning call1321 (depth = 10)
  int op_slot_right_1319 = gc_frame_newslot(call1321);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1319 = gc_frame_newslot(*var_linePosition);
  params[0] = call1321;
  partcv[0] = 1;
  Object diff1323 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1323 (depth = 9)
  int op_slot_left_1317 = gc_frame_newslot(diff1323);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1324 = callmethod(diff1323, "+", 1, partcv, params);
// compiled op node returning sum1324 (depth = 8)
  gc_frame_newslot(sum1324);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1325 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1329 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1328);
// compiled call node returning call1329 (depth = 11)
// compiled member node returning call1329 (depth = 10)
  int op_slot_right_1327 = gc_frame_newslot(call1329);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1327 = gc_frame_newslot(*var_linePosition);
  params[0] = call1329;
  partcv[0] = 1;
  Object diff1331 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1331 (depth = 9)
  int op_slot_left_1325 = gc_frame_newslot(diff1331);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1332 = callmethod(diff1331, "+", 1, partcv, params);
// compiled op node returning sum1332 (depth = 8)
  gc_frame_newslot(sum1332);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult1316;
  params[1] = *var_lineNumber;
  params[2] = sum1324;
  params[3] = sum1332;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1333 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1294);
// compiled call node returning call1333 (depth = 7)
    gc_frame_newslot(call1333);
    if1185 = call1333;
  }
// compiled if node returning if1185 (depth = 6)
    gc_frame_newslot(if1185);
    if1181 = if1185;
  } else {
  }
// compiled if node returning if1181 (depth = 5)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inc (depth = 7)
  int op_slot_right_1334 = gc_frame_newslot(*var_inc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  int op_slot_left_1334 = gc_frame_newslot(*var_val);
  params[0] = *var_inc;
  partcv[0] = 1;
  Object sum1336 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum1336 (depth = 6)
  *var_val = sum1336;
  if (sum1336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num1339 = alloc_Float64(1);
// compiled num node returning num1339 (depth = 7)
  int op_slot_right_1338 = gc_frame_newslot(num1339);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_1338 = gc_frame_newslot(*var_i);
  params[0] = num1339;
  partcv[0] = 1;
  Object sum1341 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1341 (depth = 6)
  *var_i = sum1341;
  if (sum1341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_fromBase1129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromBase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method fromBase");
  Object params[2];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_unicode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromBase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  Object *var_base = &(stackframe->slots[1]);
  *var_base = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for fromBase");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1130 = alloc_Float64(0);
// compiled num node returning num1130 (depth = 4)
  *var_val = num1130;
  if (num1130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1131 = alloc_Float64(0);
// compiled num node returning num1131 (depth = 4)
  *var_i = num1131;
  if (num1131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1132 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_str (depth = 4)
  gc_frame_newslot(*var_str);
// starting to compile block node (depth = 4)
  Object block1133 = alloc_Block(NULL, NULL, "lexer", 376);
  gc_frame_newslot(block1133);
// method _apply
  block_savedest(block1133);
  Object closure1134 = createclosure(9, "_apply");
  setclosureframe(closure1134, stackframe);
  addtoclosure(closure1134, var_base);
  addtoclosure(closure1134, var_val);
  addtoclosure(closure1134, var_str);
  addtoclosure(closure1134, var_errormessages);
  addtoclosure(closure1134, var_linePosition);
  addtoclosure(closure1134, var_lineNumber);
  addtoclosure(closure1134, var_i);
  addtoclosure(closure1134, var_unicode);
  addtoclosure(closure1134, selfslot);
  struct UserObject *uo1134 = (struct UserObject*)block1133;
  uo1134->data[0] = (Object)closure1134;
  Method *meth_meth_lexer__apply1134 = addmethod2pos(block1133, "_apply", &meth_lexer__apply1134, 0);
  int argcv_meth_lexer__apply1134[] = {1};
  meth_meth_lexer__apply1134->type = alloc_MethodType(1, argcv_meth_lexer__apply1134);
  meth_meth_lexer__apply1134->definitionModule = modulename;
  meth_meth_lexer__apply1134->definitionLine = 362;
// compiled block node returning block1133 (depth = 4)
  gc_frame_newslot(block1133);
// call case 5: prelude request
  params[0] = *var_str;
  params[1] = block1133;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1344 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compiled call node returning call1344 (depth = 3)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  gc_frame_end(frame);
  return *var_val;
}
Object meth_lexer_hexdecchar1345(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hexdecchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method hexdecchar");
  Object params[4];
  int partcv[2];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hexdecchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for hexdecchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_AOrd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "AOrd");
  Object *var_aOrd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "aOrd");
  Object *var_zeroOrd = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "zeroOrd");
  Object *var_cOrd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cOrd");
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1346 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit1347 == NULL) {
    strlit1347 = alloc_String("A");
    gc_root(strlit1347);
  }
// compiled string node returning strlit1347 (depth = 6)
  partcv[0] = 0;
  Object call1348 = callmethod(strlit1347, "ord",
    1, partcv, params);
  gc_frame_end(callframe1346);
// compiled call node returning call1348 (depth = 5)
// compiled member node returning call1348 (depth = 4)
  *var_AOrd = call1348;
  if (call1348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1349 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit1350 == NULL) {
    strlit1350 = alloc_String("a");
    gc_root(strlit1350);
  }
// compiled string node returning strlit1350 (depth = 6)
  partcv[0] = 0;
  Object call1351 = callmethod(strlit1350, "ord",
    1, partcv, params);
  gc_frame_end(callframe1349);
// compiled call node returning call1351 (depth = 5)
// compiled member node returning call1351 (depth = 4)
  *var_aOrd = call1351;
  if (call1351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1352 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 6)
  if (strlit1353 == NULL) {
    strlit1353 = alloc_String("0");
    gc_root(strlit1353);
  }
// compiled string node returning strlit1353 (depth = 6)
  partcv[0] = 0;
  Object call1354 = callmethod(strlit1353, "ord",
    1, partcv, params);
  gc_frame_end(callframe1352);
// compiled call node returning call1354 (depth = 5)
// compiled member node returning call1354 (depth = 4)
  *var_zeroOrd = call1354;
  if (call1354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  partcv[0] = 0;
  Object call1356 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe1355);
// compiled call node returning call1356 (depth = 5)
// compiled member node returning call1356 (depth = 4)
  *var_cOrd = call1356;
  if (call1356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1360 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 8)
  if (strlit1361 == NULL) {
    strlit1361 = alloc_String("F");
    gc_root(strlit1361);
  }
// compiled string node returning strlit1361 (depth = 8)
  partcv[0] = 0;
  Object call1362 = callmethod(strlit1361, "ord",
    1, partcv, params);
  gc_frame_end(callframe1360);
// compiled call node returning call1362 (depth = 7)
// compiled member node returning call1362 (depth = 6)
  int op_slot_right_1359 = gc_frame_newslot(call1362);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1359 = gc_frame_newslot(*var_cOrd);
  params[0] = call1362;
  partcv[0] = 1;
  Object opresult1364 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1364 (depth = 5)
  int op_slot_right_1358 = gc_frame_newslot(opresult1364);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_AOrd (depth = 6)
  int op_slot_right_1366 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1366 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object opresult1368 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1368 (depth = 5)
  int op_slot_left_1358 = gc_frame_newslot(opresult1368);
  params[0] = opresult1364;
  partcv[0] = 1;
  Object opresult1369 = callmethod(opresult1368, "&&", 1, partcv, params);
// compiled op node returning opresult1369 (depth = 4)
  Object if1357 = done;
  if (istrue(opresult1369)) {
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1371 = alloc_Float64(10);
// compiled num node returning num1371 (depth = 5)
  int op_slot_right_1370 = gc_frame_newslot(num1371);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_AOrd (depth = 6)
  int op_slot_right_1373 = gc_frame_newslot(*var_AOrd);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cOrd (depth = 6)
  int op_slot_left_1373 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_AOrd;
  partcv[0] = 1;
  Object diff1375 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1375 (depth = 5)
  int op_slot_left_1370 = gc_frame_newslot(diff1375);
  params[0] = num1371;
  partcv[0] = 1;
  Object sum1376 = callmethod(diff1375, "+", 1, partcv, params);
// compiled op node returning sum1376 (depth = 4)
    gc_frame_newslot(sum1376);
    if1357 = sum1376;
  } else {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1380 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 9)
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("f");
    gc_root(strlit1381);
  }
// compiled string node returning strlit1381 (depth = 9)
  partcv[0] = 0;
  Object call1382 = callmethod(strlit1381, "ord",
    1, partcv, params);
  gc_frame_end(callframe1380);
// compiled call node returning call1382 (depth = 8)
// compiled member node returning call1382 (depth = 7)
  int op_slot_right_1379 = gc_frame_newslot(call1382);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1379 = gc_frame_newslot(*var_cOrd);
  params[0] = call1382;
  partcv[0] = 1;
  Object opresult1384 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1384 (depth = 6)
  int op_slot_right_1378 = gc_frame_newslot(opresult1384);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_aOrd (depth = 7)
  int op_slot_right_1386 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1386 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object opresult1388 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1388 (depth = 6)
  int op_slot_left_1378 = gc_frame_newslot(opresult1388);
  params[0] = opresult1384;
  partcv[0] = 1;
  Object opresult1389 = callmethod(opresult1388, "&&", 1, partcv, params);
// compiled op node returning opresult1389 (depth = 5)
  Object if1377 = done;
  if (istrue(opresult1389)) {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1391 = alloc_Float64(10);
// compiled num node returning num1391 (depth = 6)
  int op_slot_right_1390 = gc_frame_newslot(num1391);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_aOrd (depth = 7)
  int op_slot_right_1393 = gc_frame_newslot(*var_aOrd);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1393 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_aOrd;
  partcv[0] = 1;
  Object diff1395 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1395 (depth = 6)
  int op_slot_left_1390 = gc_frame_newslot(diff1395);
  params[0] = num1391;
  partcv[0] = 1;
  Object sum1396 = callmethod(diff1395, "+", 1, partcv, params);
// compiled op node returning sum1396 (depth = 5)
    gc_frame_newslot(sum1396);
    if1377 = sum1396;
  } else {
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1400 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 10)
  if (strlit1401 == NULL) {
    strlit1401 = alloc_String("9");
    gc_root(strlit1401);
  }
// compiled string node returning strlit1401 (depth = 10)
  partcv[0] = 0;
  Object call1402 = callmethod(strlit1401, "ord",
    1, partcv, params);
  gc_frame_end(callframe1400);
// compiled call node returning call1402 (depth = 9)
// compiled member node returning call1402 (depth = 8)
  int op_slot_right_1399 = gc_frame_newslot(call1402);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cOrd (depth = 8)
  int op_slot_left_1399 = gc_frame_newslot(*var_cOrd);
  params[0] = call1402;
  partcv[0] = 1;
  Object opresult1404 = callmethod(*var_cOrd, "<=", 1, partcv, params);
// compiled op node returning opresult1404 (depth = 7)
  int op_slot_right_1398 = gc_frame_newslot(opresult1404);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_zeroOrd (depth = 8)
  int op_slot_right_1406 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_cOrd (depth = 8)
  int op_slot_left_1406 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object opresult1408 = callmethod(*var_cOrd, ">=", 1, partcv, params);
// compiled op node returning opresult1408 (depth = 7)
  int op_slot_left_1398 = gc_frame_newslot(opresult1408);
  params[0] = opresult1404;
  partcv[0] = 1;
  Object opresult1409 = callmethod(opresult1408, "&&", 1, partcv, params);
// compiled op node returning opresult1409 (depth = 6)
  Object if1397 = done;
  if (istrue(opresult1409)) {
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_zeroOrd (depth = 7)
  int op_slot_right_1410 = gc_frame_newslot(*var_zeroOrd);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cOrd (depth = 7)
  int op_slot_left_1410 = gc_frame_newslot(*var_cOrd);
  params[0] = *var_zeroOrd;
  partcv[0] = 1;
  Object diff1412 = callmethod(*var_cOrd, "-", 1, partcv, params);
// compiled op node returning diff1412 (depth = 6)
    gc_frame_newslot(diff1412);
    if1397 = diff1412;
  } else {
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1413 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1415 == NULL) {
    strlit1415 = alloc_String("' must be a hexadecimal digit");
    gc_root(strlit1415);
  }
// compiled string node returning strlit1415 (depth = 8)
  int op_slot_right_1414 = gc_frame_newslot(strlit1415);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_right_1417 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 9)
  if (strlit1419 == NULL) {
    strlit1419 = alloc_String("The character '");
    gc_root(strlit1419);
  }
// compiled string node returning strlit1419 (depth = 9)
  int op_slot_left_1417 = gc_frame_newslot(strlit1419);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1420 = callmethod(strlit1419, "++", 1, partcv, params);
// compiled op node returning opresult1420 (depth = 8)
  int op_slot_left_1414 = gc_frame_newslot(opresult1420);
  params[0] = strlit1415;
  partcv[0] = 1;
  Object opresult1421 = callmethod(opresult1420, "++", 1, partcv, params);
// compiled op node returning opresult1421 (depth = 7)
  gc_frame_newslot(opresult1421);
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult1421;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1422 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe1413);
// compiled call node returning call1422 (depth = 6)
    gc_frame_newslot(call1422);
    if1397 = call1422;
  }
// compiled if node returning if1397 (depth = 5)
    gc_frame_newslot(if1397);
    if1377 = if1397;
  }
// compiled if node returning if1377 (depth = 4)
    gc_frame_newslot(if1377);
    if1357 = if1377;
  }
// compiled if node returning if1357 (depth = 3)
  gc_frame_end(frame);
  return if1357;
}
Object meth_lexer__apply1430(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_baseSet = getfromclosure(closure, 0);
  Object *var_sofar = getfromclosure(closure, 1);
  Object *var_base = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_i = getfromclosure(closure, 4);
  Object *var_accum = getfromclosure(closure, 5);
  Object *var_linePosition = getfromclosure(closure, 6);
  Object *var_lineNumber = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_baseSet (depth = 8)
  partcv[0] = 0;
  Object call1434 = callmethod(*var_baseSet, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1433);
// compiled call node returning call1434 (depth = 7)
  int op_slot_right_1432 = gc_frame_newslot(call1434);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1437 == NULL) {
    strlit1437 = alloc_String("x");
    gc_root(strlit1437);
  }
// compiled string node returning strlit1437 (depth = 8)
  int op_slot_right_1436 = gc_frame_newslot(strlit1437);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1436 = gc_frame_newslot(*var_c);
  params[0] = strlit1437;
  partcv[0] = 1;
  Object opresult1439 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1439 (depth = 7)
  int op_slot_left_1432 = gc_frame_newslot(opresult1439);
  params[0] = call1434;
  partcv[0] = 1;
  Object opresult1440 = callmethod(opresult1439, "&&", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 6)
  Object if1431 = done;
  if (istrue(opresult1440)) {
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1441 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sofar (depth = 9)
  partcv[0] = 0;
  Object call1442 = callmethod(*var_sofar, "asNumber",
    1, partcv, params);
  gc_frame_end(callframe1441);
// compiled call node returning call1442 (depth = 8)
// compiled member node returning call1442 (depth = 7)
  *var_base = call1442;
  if (call1442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1444 = alloc_Boolean(1);
// compiled identifier node returning bool1444 (depth = 7)
  *var_baseSet = bool1444;
  if (bool1444 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1448 = alloc_Float64(0);
// compiled num node returning num1448 (depth = 8)
  int op_slot_right_1447 = gc_frame_newslot(num1448);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_base (depth = 8)
  int op_slot_left_1447 = gc_frame_newslot(*var_base);
  params[0] = num1448;
  partcv[0] = 1;
  Object opresult1450 = callmethod(*var_base, "==", 1, partcv, params);
// compiled op node returning opresult1450 (depth = 7)
  Object if1446 = done;
  if (istrue(opresult1450)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1451 = alloc_Float64(16);
// compiled num node returning num1451 (depth = 8)
  *var_base = num1451;
  if (num1451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1446 = done;
  } else {
  }
// compiled if node returning if1446 (depth = 6)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1456 = alloc_Float64(36);
// compiled num node returning num1456 (depth = 9)
  int op_slot_right_1455 = gc_frame_newslot(num1456);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1455 = gc_frame_newslot(*var_base);
  params[0] = num1456;
  partcv[0] = 1;
  Object opresult1458 = callmethod(*var_base, ">", 1, partcv, params);
// compiled op node returning opresult1458 (depth = 8)
  int op_slot_right_1454 = gc_frame_newslot(opresult1458);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1461 = alloc_Float64(2);
// compiled num node returning num1461 (depth = 9)
  int op_slot_right_1460 = gc_frame_newslot(num1461);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1460 = gc_frame_newslot(*var_base);
  params[0] = num1461;
  partcv[0] = 1;
  Object opresult1463 = callmethod(*var_base, "<", 1, partcv, params);
// compiled op node returning opresult1463 (depth = 8)
  int op_slot_left_1454 = gc_frame_newslot(opresult1463);
  params[0] = opresult1458;
  partcv[0] = 1;
  Object opresult1464 = callmethod(opresult1463, "||", 1, partcv, params);
// compiled op node returning opresult1464 (depth = 7)
  Object if1453 = done;
  if (istrue(opresult1464)) {
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array1465 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1465 (depth = 8)
  *var_suggestions = array1465;
  if (array1465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1466 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1468 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1467);
// compiled call node returning call1468 (depth = 11)
// compiled member node returning call1468 (depth = 10)
  partcv[0] = 0;
  Object call1469 = callmethod(call1468, "new",
    1, partcv, params);
  gc_frame_end(callframe1466);
// compiled call node returning call1469 (depth = 9)
// compiled member node returning call1469 (depth = 8)
  *var_suggestion = call1469;
  if (call1469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1470 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1471 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  partcv[0] = 0;
  Object call1475 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1474);
// compiled call node returning call1475 (depth = 11)
// compiled member node returning call1475 (depth = 10)
  int op_slot_right_1473 = gc_frame_newslot(call1475);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1473 = gc_frame_newslot(*var_linePosition);
  params[0] = call1475;
  partcv[0] = 1;
  Object diff1477 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1477 (depth = 9)
  int op_slot_left_1471 = gc_frame_newslot(diff1477);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1478 = callmethod(diff1477, "+", 1, partcv, params);
// compiled op node returning sum1478 (depth = 8)
  gc_frame_newslot(sum1478);
// starting to compile string node (depth = 8)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("*");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 8)
  gc_frame_newslot(strlit1479);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1478;
  params[1] = strlit1479;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1480 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe1470);
// compiled call node returning call1480 (depth = 7)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1481 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1482 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1481);
// compiled call node returning call1482 (depth = 7)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1483 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1485 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1484);
// compiled call node returning call1485 (depth = 11)
// compiled member node returning call1485 (depth = 10)
  partcv[0] = 0;
  Object call1486 = callmethod(call1485, "new",
    1, partcv, params);
  gc_frame_end(callframe1483);
// compiled call node returning call1486 (depth = 9)
// compiled member node returning call1486 (depth = 8)
  *var_suggestion = call1486;
  if (call1486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1488 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1490 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1491 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1490);
// compiled call node returning call1491 (depth = 10)
// compiled member node returning call1491 (depth = 9)
  int op_slot_right_1489 = gc_frame_newslot(call1491);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1489 = gc_frame_newslot(*var_linePosition);
  params[0] = call1491;
  partcv[0] = 1;
  Object diff1493 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1493 (depth = 8)
  gc_frame_newslot(diff1493);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1494 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  partcv[0] = 0;
  Object call1498 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1497);
// compiled call node returning call1498 (depth = 11)
// compiled member node returning call1498 (depth = 10)
  int op_slot_right_1496 = gc_frame_newslot(call1498);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1496 = gc_frame_newslot(*var_linePosition);
  params[0] = call1498;
  partcv[0] = 1;
  Object diff1500 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1500 (depth = 9)
  int op_slot_left_1494 = gc_frame_newslot(diff1500);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1501 = callmethod(diff1500, "+", 1, partcv, params);
// compiled op node returning sum1501 (depth = 8)
  gc_frame_newslot(sum1501);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = diff1493;
  params[1] = sum1501;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1502 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1488);
// compiled call node returning call1502 (depth = 7)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1503 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1504 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1503);
// compiled call node returning call1504 (depth = 7)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1505 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1507 == NULL) {
    strlit1507 = alloc_String(" is not a valid numerical base.");
    gc_root(strlit1507);
  }
// compiled string node returning strlit1507 (depth = 9)
  int op_slot_right_1506 = gc_frame_newslot(strlit1507);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_base (depth = 10)
  int op_slot_right_1509 = gc_frame_newslot(*var_base);
// starting to compile string node (depth = 10)
  if (strlit1511 == NULL) {
    strlit1511 = alloc_String("Base ");
    gc_root(strlit1511);
  }
// compiled string node returning strlit1511 (depth = 10)
  int op_slot_left_1509 = gc_frame_newslot(strlit1511);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1512 = callmethod(strlit1511, "++", 1, partcv, params);
// compiled op node returning opresult1512 (depth = 9)
  int op_slot_left_1506 = gc_frame_newslot(opresult1512);
  params[0] = strlit1507;
  partcv[0] = 1;
  Object opresult1513 = callmethod(opresult1512, "++", 1, partcv, params);
// compiled op node returning opresult1513 (depth = 8)
  gc_frame_newslot(opresult1513);
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1516 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1515);
// compiled call node returning call1516 (depth = 10)
// compiled member node returning call1516 (depth = 9)
  int op_slot_right_1514 = gc_frame_newslot(call1516);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1514 = gc_frame_newslot(*var_linePosition);
  params[0] = call1516;
  partcv[0] = 1;
  Object diff1518 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1518 (depth = 8)
  gc_frame_newslot(diff1518);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1520 = alloc_Float64(1);
// compiled num node returning num1520 (depth = 9)
  int op_slot_right_1519 = gc_frame_newslot(num1520);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_right_1522 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  partcv[0] = 0;
  Object call1526 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1525);
// compiled call node returning call1526 (depth = 12)
// compiled member node returning call1526 (depth = 11)
  int op_slot_right_1524 = gc_frame_newslot(call1526);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1524 = gc_frame_newslot(*var_linePosition);
  params[0] = call1526;
  partcv[0] = 1;
  Object diff1528 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1528 (depth = 10)
  int op_slot_left_1522 = gc_frame_newslot(diff1528);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1529 = callmethod(diff1528, "+", 1, partcv, params);
// compiled op node returning sum1529 (depth = 9)
  int op_slot_left_1519 = gc_frame_newslot(sum1529);
  params[0] = num1520;
  partcv[0] = 1;
  Object diff1530 = callmethod(sum1529, "-", 1, partcv, params);
// compiled op node returning diff1530 (depth = 8)
  gc_frame_newslot(diff1530);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult1513;
  params[1] = *var_lineNumber;
  params[2] = diff1518;
  params[3] = diff1530;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1531 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1505);
// compiled call node returning call1531 (depth = 7)
    gc_frame_newslot(call1531);
    if1453 = call1531;
  } else {
  }
// compiled if node returning if1453 (depth = 6)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1532 == NULL) {
    strlit1532 = alloc_String("");
    gc_root(strlit1532);
  }
// compiled string node returning strlit1532 (depth = 7)
  *var_sofar = strlit1532;
  if (strlit1532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1431 = done;
  } else {
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_1534 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sofar (depth = 8)
  int op_slot_left_1534 = gc_frame_newslot(*var_sofar);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1536 = callmethod(*var_sofar, "++", 1, partcv, params);
// compiled op node returning opresult1536 (depth = 7)
  *var_sofar = opresult1536;
  if (opresult1536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1431 = done;
  }
// compiled if node returning if1431 (depth = 5)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num1539 = alloc_Float64(1);
// compiled num node returning num1539 (depth = 7)
  int op_slot_right_1538 = gc_frame_newslot(num1539);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_1538 = gc_frame_newslot(*var_i);
  params[0] = num1539;
  partcv[0] = 1;
  Object sum1541 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1541 (depth = 6)
  *var_i = sum1541;
  if (sum1541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_makeNumToken1423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "makeNumToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method makeNumToken");
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_NumToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for makeNumToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_accum = &(stackframe->slots[0]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for makeNumToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_base = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "base");
  Object *var_baseSet = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "baseSet");
  Object *var_sofar = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sofar");
  Object *var_i = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "i");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1424 = alloc_Float64(10);
// compiled num node returning num1424 (depth = 4)
  *var_base = num1424;
  if (num1424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1425 = alloc_Boolean(0);
// compiled identifier node returning bool1425 (depth = 4)
  *var_baseSet = bool1425;
  if (bool1425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1426 == NULL) {
    strlit1426 = alloc_String("");
    gc_root(strlit1426);
  }
// compiled string node returning strlit1426 (depth = 4)
  *var_sofar = strlit1426;
  if (strlit1426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1427 = alloc_Float64(0);
// compiled num node returning num1427 (depth = 4)
  *var_i = num1427;
  if (num1427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1428 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_accum (depth = 4)
  gc_frame_newslot(*var_accum);
// starting to compile block node (depth = 4)
  Object block1429 = alloc_Block(NULL, NULL, "lexer", 438);
  gc_frame_newslot(block1429);
// method _apply
  block_savedest(block1429);
  Object closure1430 = createclosure(9, "_apply");
  setclosureframe(closure1430, stackframe);
  addtoclosure(closure1430, var_baseSet);
  addtoclosure(closure1430, var_sofar);
  addtoclosure(closure1430, var_base);
  addtoclosure(closure1430, var_errormessages);
  addtoclosure(closure1430, var_i);
  addtoclosure(closure1430, var_accum);
  addtoclosure(closure1430, var_linePosition);
  addtoclosure(closure1430, var_lineNumber);
  addtoclosure(closure1430, selfslot);
  struct UserObject *uo1430 = (struct UserObject*)block1429;
  uo1430->data[0] = (Object)closure1430;
  Method *meth_meth_lexer__apply1430 = addmethod2pos(block1429, "_apply", &meth_lexer__apply1430, 0);
  int argcv_meth_lexer__apply1430[] = {1};
  meth_meth_lexer__apply1430->type = alloc_MethodType(1, argcv_meth_lexer__apply1430);
  meth_meth_lexer__apply1430->definitionModule = modulename;
  meth_meth_lexer__apply1430->definitionLine = 425;
// compiled block node returning block1429 (depth = 4)
  gc_frame_newslot(block1429);
// call case 5: prelude request
  params[0] = *var_accum;
  params[1] = block1429;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1544 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1428);
// compiled call node returning call1544 (depth = 3)
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1547 == NULL) {
    strlit1547 = alloc_String("");
    gc_root(strlit1547);
  }
// compiled string node returning strlit1547 (depth = 5)
  int op_slot_right_1546 = gc_frame_newslot(strlit1547);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sofar (depth = 5)
  int op_slot_left_1546 = gc_frame_newslot(*var_sofar);
  params[0] = strlit1547;
  partcv[0] = 1;
  Object opresult1549 = callmethod(*var_sofar, "==", 1, partcv, params);
// compiled op node returning opresult1549 (depth = 4)
  Object if1545 = done;
  if (istrue(opresult1549)) {
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array1550 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1550 (depth = 5)
  *var_suggestions = array1550;
  if (array1550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1551 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1553 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1552);
// compiled call node returning call1553 (depth = 8)
// compiled member node returning call1553 (depth = 7)
  partcv[0] = 0;
  Object call1554 = callmethod(call1553, "new",
    1, partcv, params);
  gc_frame_end(callframe1551);
// compiled call node returning call1554 (depth = 6)
// compiled member node returning call1554 (depth = 5)
  *var_suggestion = call1554;
  if (call1554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1555 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1557 = alloc_Float64(1);
// compiled num node returning num1557 (depth = 6)
  int op_slot_right_1556 = gc_frame_newslot(num1557);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_right_1559 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  partcv[0] = 0;
  Object call1563 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1562);
// compiled call node returning call1563 (depth = 9)
// compiled member node returning call1563 (depth = 8)
  int op_slot_right_1561 = gc_frame_newslot(call1563);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_1561 = gc_frame_newslot(*var_linePosition);
  params[0] = call1563;
  partcv[0] = 1;
  Object diff1565 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1565 (depth = 7)
  int op_slot_left_1559 = gc_frame_newslot(diff1565);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1566 = callmethod(diff1565, "+", 1, partcv, params);
// compiled op node returning sum1566 (depth = 6)
  int op_slot_left_1556 = gc_frame_newslot(sum1566);
  params[0] = num1557;
  partcv[0] = 1;
  Object diff1567 = callmethod(sum1566, "-", 1, partcv, params);
// compiled op node returning diff1567 (depth = 5)
  gc_frame_newslot(diff1567);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1569 = alloc_Float64(1);
// compiled num node returning num1569 (depth = 6)
  int op_slot_right_1568 = gc_frame_newslot(num1569);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  int op_slot_left_1568 = gc_frame_newslot(*var_linePosition);
  params[0] = num1569;
  partcv[0] = 1;
  Object diff1571 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1571 (depth = 5)
  gc_frame_newslot(diff1571);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = diff1567;
  params[1] = diff1571;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1572 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1555);
// compiled call node returning call1572 (depth = 4)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1573 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1574 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1573);
// compiled call node returning call1574 (depth = 4)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1575 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1577 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1576);
// compiled call node returning call1577 (depth = 8)
// compiled member node returning call1577 (depth = 7)
  partcv[0] = 0;
  Object call1578 = callmethod(call1577, "new",
    1, partcv, params);
  gc_frame_end(callframe1575);
// compiled call node returning call1578 (depth = 6)
// compiled member node returning call1578 (depth = 5)
  *var_suggestion = call1578;
  if (call1578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1580 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1581 == NULL) {
    strlit1581 = alloc_String("0");
    gc_root(strlit1581);
  }
// compiled string node returning strlit1581 (depth = 5)
  gc_frame_newslot(strlit1581);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1581;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1582 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1580);
// compiled call node returning call1582 (depth = 4)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1583 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1584 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1583);
// compiled call node returning call1584 (depth = 4)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1585 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1586 == NULL) {
    strlit1586 = alloc_String("At least one digit must follow the 'x' in a number.");
    gc_root(strlit1586);
  }
// compiled string node returning strlit1586 (depth = 5)
  gc_frame_newslot(strlit1586);
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_right_1587 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  partcv[0] = 0;
  Object call1591 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1590);
// compiled call node returning call1591 (depth = 8)
// compiled member node returning call1591 (depth = 7)
  int op_slot_right_1589 = gc_frame_newslot(call1591);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_1589 = gc_frame_newslot(*var_linePosition);
  params[0] = call1591;
  partcv[0] = 1;
  Object diff1593 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1593 (depth = 6)
  int op_slot_left_1587 = gc_frame_newslot(diff1593);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1594 = callmethod(diff1593, "+", 1, partcv, params);
// compiled op node returning sum1594 (depth = 5)
  gc_frame_newslot(sum1594);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1586;
  params[1] = *var_lineNumber;
  params[2] = sum1594;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1595 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1585);
// compiled call node returning call1595 (depth = 4)
    gc_frame_newslot(call1595);
    if1545 = call1595;
  } else {
  }
// compiled if node returning if1545 (depth = 3)
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1596 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1597 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1598 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sofar (depth = 7)
  gc_frame_newslot(*var_sofar);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  gc_frame_newslot(*var_base);
// call case 4: self request
  params[0] = *var_sofar;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1599 = callmethodflags(self, "fromBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1598);
// compiled call node returning call1599 (depth = 6)
  partcv[0] = 0;
  Object call1600 = callmethod(call1599, "asString",
    1, partcv, params);
  gc_frame_end(callframe1597);
// compiled call node returning call1600 (depth = 5)
// compiled member node returning call1600 (depth = 4)
  gc_frame_newslot(call1600);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  gc_frame_newslot(*var_base);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NumToken (depth = 4)
  params[0] = call1600;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1601 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1596);
// compiled call node returning call1601 (depth = 3)
  gc_frame_end(frame);
  return call1601;
}
Object meth_lexer_isidentifierchar1602(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isidentifierchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method isidentifierchar");
  Object params[1];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isidentifierchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ov = &(stackframe->slots[0]);
  *var_ov = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for isidentifierchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1604 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1605 = callmethod(*var_unicode, "isLetter",
    1, partcv, params);
  gc_frame_end(callframe1604);
// compiled call node returning call1605 (depth = 4)
  Object if1603 = done;
  if (istrue(call1605)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1606 = alloc_Boolean(1);
// compiled identifier node returning bool1606 (depth = 5)
  return bool1606;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1603 = undefined;
  } else {
  }
// compiled if node returning if1603 (depth = 3)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1608 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1609 = callmethod(*var_unicode, "isNumber",
    1, partcv, params);
  gc_frame_end(callframe1608);
// compiled call node returning call1609 (depth = 4)
  Object if1607 = done;
  if (istrue(call1609)) {
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1610 = alloc_Boolean(1);
// compiled identifier node returning bool1610 (depth = 5)
  return bool1610;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1607 = undefined;
  } else {
  }
// compiled if node returning if1607 (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1614 = alloc_Float64(39);
// compiled num node returning num1614 (depth = 6)
  int op_slot_right_1613 = gc_frame_newslot(num1614);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ov (depth = 6)
  int op_slot_left_1613 = gc_frame_newslot(*var_ov);
  params[0] = num1614;
  partcv[0] = 1;
  Object opresult1616 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1616 (depth = 5)
  int op_slot_right_1612 = gc_frame_newslot(opresult1616);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1619 = alloc_Float64(95);
// compiled num node returning num1619 (depth = 6)
  int op_slot_right_1618 = gc_frame_newslot(num1619);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ov (depth = 6)
  int op_slot_left_1618 = gc_frame_newslot(*var_ov);
  params[0] = num1619;
  partcv[0] = 1;
  Object opresult1621 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1621 (depth = 5)
  int op_slot_left_1612 = gc_frame_newslot(opresult1621);
  params[0] = opresult1616;
  partcv[0] = 1;
  Object opresult1622 = callmethod(opresult1621, "||", 1, partcv, params);
// compiled op node returning opresult1622 (depth = 4)
  Object if1611 = done;
  if (istrue(opresult1622)) {
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1623 = alloc_Boolean(1);
// compiled identifier node returning bool1623 (depth = 4)
    gc_frame_newslot(bool1623);
    if1611 = bool1623;
  } else {
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1624 = alloc_Boolean(0);
// compiled identifier node returning bool1624 (depth = 4)
    gc_frame_newslot(bool1624);
    if1611 = bool1624;
  }
// compiled if node returning if1611 (depth = 3)
  gc_frame_end(frame);
  return if1611;
}
Object meth_lexer_isoperatorchar1625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isoperatorchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method isoperatorchar");
  Object params[2];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isoperatorchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *var_ordval = &(stackframe->slots[1]);
  *var_ordval = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for isoperatorchar");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1629 == NULL) {
    strlit1629 = alloc_String("!");
    gc_root(strlit1629);
  }
// compiled string node returning strlit1629 (depth = 6)
  int op_slot_right_1628 = gc_frame_newslot(strlit1629);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_1628 = gc_frame_newslot(*var_c);
  params[0] = strlit1629;
  partcv[0] = 1;
  Object opresult1631 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1631 (depth = 5)
  int op_slot_right_1627 = gc_frame_newslot(opresult1631);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1635 == NULL) {
    strlit1635 = alloc_String("+");
    gc_root(strlit1635);
  }
// compiled string node returning strlit1635 (depth = 7)
  int op_slot_right_1634 = gc_frame_newslot(strlit1635);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1634 = gc_frame_newslot(*var_c);
  params[0] = strlit1635;
  partcv[0] = 1;
  Object opresult1637 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1637 (depth = 6)
  int op_slot_right_1633 = gc_frame_newslot(opresult1637);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1641 == NULL) {
    strlit1641 = alloc_String("/");
    gc_root(strlit1641);
  }
// compiled string node returning strlit1641 (depth = 8)
  int op_slot_right_1640 = gc_frame_newslot(strlit1641);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1640 = gc_frame_newslot(*var_c);
  params[0] = strlit1641;
  partcv[0] = 1;
  Object opresult1643 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1643 (depth = 7)
  int op_slot_right_1639 = gc_frame_newslot(opresult1643);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1647 == NULL) {
    strlit1647 = alloc_String("*");
    gc_root(strlit1647);
  }
// compiled string node returning strlit1647 (depth = 9)
  int op_slot_right_1646 = gc_frame_newslot(strlit1647);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1646 = gc_frame_newslot(*var_c);
  params[0] = strlit1647;
  partcv[0] = 1;
  Object opresult1649 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1649 (depth = 8)
  int op_slot_right_1645 = gc_frame_newslot(opresult1649);
// starting to compile op node (depth = 8)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1653 == NULL) {
    strlit1653 = alloc_String("?");
    gc_root(strlit1653);
  }
// compiled string node returning strlit1653 (depth = 10)
  int op_slot_right_1652 = gc_frame_newslot(strlit1653);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1652 = gc_frame_newslot(*var_c);
  params[0] = strlit1653;
  partcv[0] = 1;
  Object opresult1655 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1655 (depth = 9)
  int op_slot_right_1651 = gc_frame_newslot(opresult1655);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1659 == NULL) {
    strlit1659 = alloc_String("@");
    gc_root(strlit1659);
  }
// compiled string node returning strlit1659 (depth = 11)
  int op_slot_right_1658 = gc_frame_newslot(strlit1659);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_1658 = gc_frame_newslot(*var_c);
  params[0] = strlit1659;
  partcv[0] = 1;
  Object opresult1661 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1661 (depth = 10)
  int op_slot_right_1657 = gc_frame_newslot(opresult1661);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1665 == NULL) {
    strlit1665 = alloc_String("^");
    gc_root(strlit1665);
  }
// compiled string node returning strlit1665 (depth = 12)
  int op_slot_right_1664 = gc_frame_newslot(strlit1665);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_1664 = gc_frame_newslot(*var_c);
  params[0] = strlit1665;
  partcv[0] = 1;
  Object opresult1667 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1667 (depth = 11)
  int op_slot_right_1663 = gc_frame_newslot(opresult1667);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1671 == NULL) {
    strlit1671 = alloc_String("%");
    gc_root(strlit1671);
  }
// compiled string node returning strlit1671 (depth = 13)
  int op_slot_right_1670 = gc_frame_newslot(strlit1671);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_1670 = gc_frame_newslot(*var_c);
  params[0] = strlit1671;
  partcv[0] = 1;
  Object opresult1673 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1673 (depth = 12)
  int op_slot_right_1669 = gc_frame_newslot(opresult1673);
// starting to compile op node (depth = 12)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1677 == NULL) {
    strlit1677 = alloc_String(":");
    gc_root(strlit1677);
  }
// compiled string node returning strlit1677 (depth = 14)
  int op_slot_right_1676 = gc_frame_newslot(strlit1677);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_1676 = gc_frame_newslot(*var_c);
  params[0] = strlit1677;
  partcv[0] = 1;
  Object opresult1679 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1679 (depth = 13)
  int op_slot_right_1675 = gc_frame_newslot(opresult1679);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1683 == NULL) {
    strlit1683 = alloc_String("|");
    gc_root(strlit1683);
  }
// compiled string node returning strlit1683 (depth = 15)
  int op_slot_right_1682 = gc_frame_newslot(strlit1683);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_1682 = gc_frame_newslot(*var_c);
  params[0] = strlit1683;
  partcv[0] = 1;
  Object opresult1685 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1685 (depth = 14)
  int op_slot_right_1681 = gc_frame_newslot(opresult1685);
// starting to compile op node (depth = 14)
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1689 == NULL) {
    strlit1689 = alloc_String("&");
    gc_root(strlit1689);
  }
// compiled string node returning strlit1689 (depth = 16)
  int op_slot_right_1688 = gc_frame_newslot(strlit1689);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_1688 = gc_frame_newslot(*var_c);
  params[0] = strlit1689;
  partcv[0] = 1;
  Object opresult1691 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1691 (depth = 15)
  int op_slot_right_1687 = gc_frame_newslot(opresult1691);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1694 == NULL) {
    strlit1694 = alloc_String("-");
    gc_root(strlit1694);
  }
// compiled string node returning strlit1694 (depth = 16)
  int op_slot_right_1693 = gc_frame_newslot(strlit1694);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_1693 = gc_frame_newslot(*var_c);
  params[0] = strlit1694;
  partcv[0] = 1;
  Object opresult1696 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1696 (depth = 15)
  int op_slot_left_1687 = gc_frame_newslot(opresult1696);
  params[0] = opresult1691;
  partcv[0] = 1;
  Object opresult1697 = callmethod(opresult1696, "||", 1, partcv, params);
// compiled op node returning opresult1697 (depth = 14)
  int op_slot_left_1681 = gc_frame_newslot(opresult1697);
  params[0] = opresult1685;
  partcv[0] = 1;
  Object opresult1698 = callmethod(opresult1697, "||", 1, partcv, params);
// compiled op node returning opresult1698 (depth = 13)
  int op_slot_left_1675 = gc_frame_newslot(opresult1698);
  params[0] = opresult1679;
  partcv[0] = 1;
  Object opresult1699 = callmethod(opresult1698, "||", 1, partcv, params);
// compiled op node returning opresult1699 (depth = 12)
  int op_slot_left_1669 = gc_frame_newslot(opresult1699);
  params[0] = opresult1673;
  partcv[0] = 1;
  Object opresult1700 = callmethod(opresult1699, "||", 1, partcv, params);
// compiled op node returning opresult1700 (depth = 11)
  int op_slot_left_1663 = gc_frame_newslot(opresult1700);
  params[0] = opresult1667;
  partcv[0] = 1;
  Object opresult1701 = callmethod(opresult1700, "||", 1, partcv, params);
// compiled op node returning opresult1701 (depth = 10)
  int op_slot_left_1657 = gc_frame_newslot(opresult1701);
  params[0] = opresult1661;
  partcv[0] = 1;
  Object opresult1702 = callmethod(opresult1701, "||", 1, partcv, params);
// compiled op node returning opresult1702 (depth = 9)
  int op_slot_left_1651 = gc_frame_newslot(opresult1702);
  params[0] = opresult1655;
  partcv[0] = 1;
  Object opresult1703 = callmethod(opresult1702, "||", 1, partcv, params);
// compiled op node returning opresult1703 (depth = 8)
  int op_slot_left_1645 = gc_frame_newslot(opresult1703);
  params[0] = opresult1649;
  partcv[0] = 1;
  Object opresult1704 = callmethod(opresult1703, "||", 1, partcv, params);
// compiled op node returning opresult1704 (depth = 7)
  int op_slot_left_1639 = gc_frame_newslot(opresult1704);
  params[0] = opresult1643;
  partcv[0] = 1;
  Object opresult1705 = callmethod(opresult1704, "||", 1, partcv, params);
// compiled op node returning opresult1705 (depth = 6)
  int op_slot_left_1633 = gc_frame_newslot(opresult1705);
  params[0] = opresult1637;
  partcv[0] = 1;
  Object opresult1706 = callmethod(opresult1705, "||", 1, partcv, params);
// compiled op node returning opresult1706 (depth = 5)
  int op_slot_left_1627 = gc_frame_newslot(opresult1706);
  params[0] = opresult1631;
  partcv[0] = 1;
  Object opresult1707 = callmethod(opresult1706, "||", 1, partcv, params);
// compiled op node returning opresult1707 (depth = 4)
  Object if1626 = done;
  if (istrue(opresult1707)) {
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1708 = alloc_Boolean(1);
// compiled identifier node returning bool1708 (depth = 5)
  return bool1708;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1626 = undefined;
  } else {
  }
// compiled if node returning if1626 (depth = 3)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1710 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ordval (depth = 5)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call1711 = callmethod(*var_unicode, "isSymbolMathematical",
    1, partcv, params);
  gc_frame_end(callframe1710);
// compiled call node returning call1711 (depth = 4)
  Object if1709 = done;
  if (istrue(call1711)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1712 = alloc_Boolean(1);
// compiled identifier node returning bool1712 (depth = 5)
  return bool1712;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1709 = undefined;
  } else {
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1714 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// starting to compile string node (depth = 6)
  if (strlit1715 == NULL) {
    strlit1715 = alloc_String("So");
    gc_root(strlit1715);
  }
// compiled string node returning strlit1715 (depth = 6)
  gc_frame_newslot(strlit1715);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unicode (depth = 6)
  params[0] = *var_c;
  params[1] = strlit1715;
  partcv[0] = 2;
  Object call1716 = callmethod(*var_unicode, "iscategory",
    1, partcv, params);
  gc_frame_end(callframe1714);
// compiled call node returning call1716 (depth = 5)
  Object if1713 = done;
  if (istrue(call1716)) {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1717 = alloc_Boolean(1);
// compiled identifier node returning bool1717 (depth = 6)
  return bool1717;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1713 = undefined;
  } else {
  }
// compiled if node returning if1713 (depth = 4)
    gc_frame_newslot(if1713);
    if1709 = if1713;
  }
// compiled if node returning if1709 (depth = 3)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1718 = alloc_Boolean(0);
// compiled identifier node returning bool1718 (depth = 4)
  return bool1718;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer__apply1732(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_lines = getfromclosure(closure, 1);
  Object *var_cLine = getfromclosure(closure, 2);
  Object *var_cLines = getfromclosure(closure, 3);
  Object *var_source = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1736 == NULL) {
    strlit1736 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit1736);
  }
// compiled string node returning strlit1736 (depth = 8)
  int op_slot_right_1735 = gc_frame_newslot(strlit1736);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1735 = gc_frame_newslot(*var_c);
  params[0] = strlit1736;
  partcv[0] = 1;
  Object opresult1738 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1738 (depth = 7)
  int op_slot_right_1734 = gc_frame_newslot(opresult1738);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1741 == NULL) {
    strlit1741 = alloc_String("""\x0a""");
    gc_root(strlit1741);
  }
// compiled string node returning strlit1741 (depth = 8)
  int op_slot_right_1740 = gc_frame_newslot(strlit1741);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1740 = gc_frame_newslot(*var_c);
  params[0] = strlit1741;
  partcv[0] = 1;
  Object opresult1743 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1743 (depth = 7)
  int op_slot_left_1734 = gc_frame_newslot(opresult1743);
  params[0] = opresult1738;
  partcv[0] = 1;
  Object opresult1744 = callmethod(opresult1743, "||", 1, partcv, params);
// compiled op node returning opresult1744 (depth = 6)
  Object if1733 = done;
  if (istrue(opresult1744)) {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1745 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lines (depth = 7)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1746 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1745);
// compiled call node returning call1746 (depth = 6)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1747 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cLine (depth = 7)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cLines (depth = 7)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1748 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1747);
// compiled call node returning call1748 (depth = 6)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1749 == NULL) {
    strlit1749 = alloc_String("");
    gc_root(strlit1749);
  }
// compiled string node returning strlit1749 (depth = 7)
  *var_line = strlit1749;
  if (strlit1749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1751 == NULL) {
    strlit1751 = alloc_String("");
    gc_root(strlit1751);
  }
// compiled string node returning strlit1751 (depth = 7)
  *var_cLine = strlit1751;
  if (strlit1751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1733 = done;
  } else {
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String("""\x0d""");
    gc_root(strlit1755);
  }
// compiled string node returning strlit1755 (depth = 8)
  int op_slot_right_1754 = gc_frame_newslot(strlit1755);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1754 = gc_frame_newslot(*var_c);
  params[0] = strlit1755;
  partcv[0] = 1;
  Object opresult1757 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1757 (depth = 7)
  Object if1753 = done;
  if (istrue(opresult1757)) {
    gc_frame_newslot(done);
    if1753 = done;
  } else {
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1760 == NULL) {
    strlit1760 = alloc_String("\\");
    gc_root(strlit1760);
  }
// compiled string node returning strlit1760 (depth = 9)
  int op_slot_right_1759 = gc_frame_newslot(strlit1760);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1759 = gc_frame_newslot(*var_c);
  params[0] = strlit1760;
  partcv[0] = 1;
  Object opresult1762 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1762 (depth = 8)
  Object if1758 = done;
  if (istrue(opresult1762)) {
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1764 == NULL) {
    strlit1764 = alloc_String("\\");
    gc_root(strlit1764);
  }
// compiled string node returning strlit1764 (depth = 10)
  int op_slot_right_1763 = gc_frame_newslot(strlit1764);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_1763 = gc_frame_newslot(*var_line);
  params[0] = strlit1764;
  partcv[0] = 1;
  Object opresult1766 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1766 (depth = 9)
  *var_line = opresult1766;
  if (opresult1766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1769 == NULL) {
    strlit1769 = alloc_String("\\\\");
    gc_root(strlit1769);
  }
// compiled string node returning strlit1769 (depth = 10)
  int op_slot_right_1768 = gc_frame_newslot(strlit1769);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_cLine (depth = 10)
  int op_slot_left_1768 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1769;
  partcv[0] = 1;
  Object opresult1771 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1771 (depth = 9)
  *var_cLine = opresult1771;
  if (opresult1771 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1758 = done;
  } else {
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1775 == NULL) {
    strlit1775 = alloc_String("""\x22""");
    gc_root(strlit1775);
  }
// compiled string node returning strlit1775 (depth = 10)
  int op_slot_right_1774 = gc_frame_newslot(strlit1775);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1774 = gc_frame_newslot(*var_c);
  params[0] = strlit1775;
  partcv[0] = 1;
  Object opresult1777 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1777 (depth = 9)
  Object if1773 = done;
  if (istrue(opresult1777)) {
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit1779 == NULL) {
    strlit1779 = alloc_String("""\x22""");
    gc_root(strlit1779);
  }
// compiled string node returning strlit1779 (depth = 11)
  int op_slot_right_1778 = gc_frame_newslot(strlit1779);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1778 = gc_frame_newslot(*var_line);
  params[0] = strlit1779;
  partcv[0] = 1;
  Object opresult1781 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1781 (depth = 10)
  *var_line = opresult1781;
  if (opresult1781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit1784 == NULL) {
    strlit1784 = alloc_String("\\""\x22""");
    gc_root(strlit1784);
  }
// compiled string node returning strlit1784 (depth = 11)
  int op_slot_right_1783 = gc_frame_newslot(strlit1784);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1783 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1784;
  partcv[0] = 1;
  Object opresult1786 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1786 (depth = 10)
  *var_cLine = opresult1786;
  if (opresult1786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1773 = done;
  } else {
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1788 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1788 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1790 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1790 (depth = 10)
  *var_line = opresult1790;
  if (opresult1790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1792 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1792 = gc_frame_newslot(*var_cLine);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1794 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1794 (depth = 10)
  *var_cLine = opresult1794;
  if (opresult1794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1773 = done;
  }
// compiled if node returning if1773 (depth = 8)
    gc_frame_newslot(if1773);
    if1758 = if1773;
  }
// compiled if node returning if1758 (depth = 7)
    gc_frame_newslot(if1758);
    if1753 = if1758;
  }
// compiled if node returning if1753 (depth = 6)
    gc_frame_newslot(if1753);
    if1733 = if1753;
  }
// compiled if node returning if1733 (depth = 5)
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_right_1796 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_source (depth = 7)
  int op_slot_left_1796 = gc_frame_newslot(*var_source);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1798 = callmethod(*var_source, "++", 1, partcv, params);
// compiled op node returning opresult1798 (depth = 6)
  *var_source = opresult1798;
  if (opresult1798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_lexfile1719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexfile");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexfile");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexfile (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_file = &(stackframe->slots[0]);
  *var_file = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexfile");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lines = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lines");
  Object *var_cLines = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "cLines");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_cLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cLine");
  Object *var_source = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "source");
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1720 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1721 == NULL) {
    strlit1721 = alloc_String("reading source.");
    gc_root(strlit1721);
  }
// compiled string node returning strlit1721 (depth = 4)
  gc_frame_newslot(strlit1721);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = strlit1721;
  partcv[0] = 1;
  Object call1722 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe1720);
// compiled call node returning call1722 (depth = 3)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1723 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1723 (depth = 4)
  *var_lines = array1723;
  if (array1723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1724 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1724 (depth = 4)
  *var_cLines = array1724;
  if (array1724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1725 == NULL) {
    strlit1725 = alloc_String("");
    gc_root(strlit1725);
  }
// compiled string node returning strlit1725 (depth = 4)
  *var_line = strlit1725;
  if (strlit1725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1726 == NULL) {
    strlit1726 = alloc_String("");
    gc_root(strlit1726);
  }
// compiled string node returning strlit1726 (depth = 4)
  *var_cLine = strlit1726;
  if (strlit1726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1727 == NULL) {
    strlit1727 = alloc_String("");
    gc_root(strlit1727);
  }
// compiled string node returning strlit1727 (depth = 4)
  *var_source = strlit1727;
  if (strlit1727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1728 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1729 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_file (depth = 6)
  partcv[0] = 0;
  Object call1730 = callmethod(*var_file, "read",
    1, partcv, params);
  gc_frame_end(callframe1729);
// compiled call node returning call1730 (depth = 5)
// compiled member node returning call1730 (depth = 4)
  gc_frame_newslot(call1730);
// starting to compile block node (depth = 4)
  Object block1731 = alloc_Block(NULL, NULL, "lexer", 518);
  gc_frame_newslot(block1731);
// method _apply
  block_savedest(block1731);
  Object closure1732 = createclosure(6, "_apply");
  setclosureframe(closure1732, stackframe);
  addtoclosure(closure1732, var_line);
  addtoclosure(closure1732, var_lines);
  addtoclosure(closure1732, var_cLine);
  addtoclosure(closure1732, var_cLines);
  addtoclosure(closure1732, var_source);
  addtoclosure(closure1732, selfslot);
  struct UserObject *uo1732 = (struct UserObject*)block1731;
  uo1732->data[0] = (Object)closure1732;
  Method *meth_meth_lexer__apply1732 = addmethod2pos(block1731, "_apply", &meth_lexer__apply1732, 0);
  int argcv_meth_lexer__apply1732[] = {1};
  meth_meth_lexer__apply1732->type = alloc_MethodType(1, argcv_meth_lexer__apply1732);
  meth_meth_lexer__apply1732->definitionModule = modulename;
  meth_meth_lexer__apply1732->definitionLine = 518;
// compiled block node returning block1731 (depth = 4)
  gc_frame_newslot(block1731);
// call case 5: prelude request
  params[0] = call1730;
  params[1] = block1731;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1801 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1728);
// compiled call node returning call1801 (depth = 3)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1804 == NULL) {
    strlit1804 = alloc_String("");
    gc_root(strlit1804);
  }
// compiled string node returning strlit1804 (depth = 5)
  int op_slot_right_1803 = gc_frame_newslot(strlit1804);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  int op_slot_left_1803 = gc_frame_newslot(*var_line);
  params[0] = strlit1804;
  partcv[0] = 1;
  Object opresult1806 = callmethod(*var_line, "!=", 1, partcv, params);
// compiled op node returning opresult1806 (depth = 4)
  Object if1802 = done;
  if (istrue(opresult1806)) {
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1807 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lines (depth = 5)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1808 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1807);
// compiled call node returning call1808 (depth = 4)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1809 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLine (depth = 5)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLines (depth = 5)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1810 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1809);
// compiled call node returning call1810 (depth = 4)
    gc_frame_newslot(call1810);
    if1802 = call1810;
  } else {
  }
// compiled if node returning if1802 (depth = 3)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1811 = gc_frame_new();
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lines (depth = 5)
  gc_frame_newslot(*var_lines);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_lines;
  partcv[0] = 1;
  Object call1812 = callmethod(*var_util, "lines:=",
    1, partcv, params);
  gc_frame_end(callframe1811);
// compiled call node returning call1812 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1813 = gc_frame_new();
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLines (depth = 5)
  gc_frame_newslot(*var_cLines);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_cLines;
  partcv[0] = 1;
  Object call1814 = callmethod(*var_util, "cLines:=",
    1, partcv, params);
  gc_frame_end(callframe1813);
// compiled call node returning call1814 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1815 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  gc_frame_newslot(*var_source);
// call case 4: self request
  params[0] = *var_source;
  partcv[0] = 1;
  Object call1816 = callmethodflags(self, "lexinput", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1815);
// compiled call node returning call1816 (depth = 3)
  gc_frame_end(frame);
  return call1816;
}
Object meth_lexer_push1823(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method push");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1826 = alloc_Boolean(0);
// compiled identifier node returning bool1826 (depth = 7)
  int op_slot_right_1825 = gc_frame_newslot(bool1826);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1829 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1828);
// compiled call node returning call1829 (depth = 8)
// compiled member node returning call1829 (depth = 7)
  int op_slot_left_1825 = gc_frame_newslot(call1829);
  params[0] = bool1826;
  partcv[0] = 1;
  Object opresult1830 = callmethod(call1829, "==", 1, partcv, params);
// compiled op node returning opresult1830 (depth = 6)
  Object if1824 = done;
  if (istrue(opresult1830)) {
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1831 = gc_frame_new();
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1832 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1831);
// compiled call node returning call1832 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1833 = gc_frame_new();
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1834 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1833);
// compiled call node returning call1834 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1824 = done;
  } else {
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1835 = gc_frame_new();
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1836 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1837 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1836);
// compiled call node returning call1837 (depth = 9)
// compiled member node returning call1837 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1838 = callmethod(call1837, "next:=",
    1, partcv, params);
  gc_frame_end(callframe1835);
// compiled call node returning call1838 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1839 = gc_frame_new();
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1841 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1840);
// compiled call node returning call1841 (depth = 9)
// compiled member node returning call1841 (depth = 8)
  gc_frame_newslot(call1841);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = call1841;
  partcv[0] = 1;
  Object call1842 = callmethod(*var_t, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe1839);
// compiled call node returning call1842 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1843 = gc_frame_new();
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1844 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1844 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1824 = done;
  }
// compiled if node returning if1824 (depth = 5)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1845 = gc_frame_new();
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1847 = alloc_Float64(1);
// compiled num node returning num1847 (depth = 8)
  int op_slot_right_1846 = gc_frame_newslot(num1847);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1849 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1850 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1849);
// compiled call node returning call1850 (depth = 9)
// compiled member node returning call1850 (depth = 8)
  int op_slot_left_1846 = gc_frame_newslot(call1850);
  params[0] = num1847;
  partcv[0] = 1;
  Object sum1851 = callmethod(call1850, "+", 1, partcv, params);
// compiled op node returning sum1851 (depth = 7)
  gc_frame_newslot(sum1851);
// call case 4: self request
  params[0] = sum1851;
  partcv[0] = 1;
  Object call1852 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1845);
// compiled call node returning call1852 (depth = 6)
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_pop1853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_popped = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "popped");
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1856 = alloc_Boolean(0);
// compiled identifier node returning bool1856 (depth = 7)
  int op_slot_right_1855 = gc_frame_newslot(bool1856);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1859 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1858);
// compiled call node returning call1859 (depth = 8)
// compiled member node returning call1859 (depth = 7)
  int op_slot_left_1855 = gc_frame_newslot(call1859);
  params[0] = bool1856;
  partcv[0] = 1;
  Object opresult1860 = callmethod(call1859, "!=", 1, partcv, params);
// compiled op node returning opresult1860 (depth = 6)
  Object if1854 = done;
  if (istrue(opresult1860)) {
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1862 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1861);
// compiled call node returning call1862 (depth = 8)
// compiled member node returning call1862 (depth = 7)
  *var_popped = call1862;
  if (call1862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1863 = gc_frame_new();
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1864 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1866 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1865);
// compiled call node returning call1866 (depth = 11)
// compiled member node returning call1866 (depth = 10)
  partcv[0] = 0;
  Object call1867 = callmethod(call1866, "prev",
    1, partcv, params);
  gc_frame_end(callframe1864);
// compiled call node returning call1867 (depth = 9)
// compiled member node returning call1867 (depth = 8)
  gc_frame_newslot(call1867);
// call case 4: self request
  params[0] = call1867;
  partcv[0] = 1;
  Object call1868 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1863);
// compiled call node returning call1868 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1871 = alloc_Boolean(0);
// compiled identifier node returning bool1871 (depth = 8)
  int op_slot_right_1870 = gc_frame_newslot(bool1871);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1873 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1874 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1873);
// compiled call node returning call1874 (depth = 9)
// compiled member node returning call1874 (depth = 8)
  int op_slot_left_1870 = gc_frame_newslot(call1874);
  params[0] = bool1871;
  partcv[0] = 1;
  Object opresult1875 = callmethod(call1874, "==", 1, partcv, params);
// compiled op node returning opresult1875 (depth = 7)
  Object if1869 = done;
  if (istrue(opresult1875)) {
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1876 = gc_frame_new();
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1877 = alloc_Boolean(0);
// compiled identifier node returning bool1877 (depth = 9)
  gc_frame_newslot(bool1877);
// call case 4: self request
  params[0] = bool1877;
  partcv[0] = 1;
  Object call1878 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1876);
// compiled call node returning call1878 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1869 = done;
  } else {
  }
// compiled if node returning if1869 (depth = 6)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1879 = gc_frame_new();
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1881 = alloc_Float64(1);
// compiled num node returning num1881 (depth = 9)
  int op_slot_right_1880 = gc_frame_newslot(num1881);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1883 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1884 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1883);
// compiled call node returning call1884 (depth = 10)
// compiled member node returning call1884 (depth = 9)
  int op_slot_left_1880 = gc_frame_newslot(call1884);
  params[0] = num1881;
  partcv[0] = 1;
  Object diff1885 = callmethod(call1884, "-", 1, partcv, params);
// compiled op node returning diff1885 (depth = 8)
  gc_frame_newslot(diff1885);
// call case 4: self request
  params[0] = diff1885;
  partcv[0] = 1;
  Object call1886 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1879);
// compiled call node returning call1886 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_popped (depth = 6)
    gc_frame_newslot(*var_popped);
    if1854 = *var_popped;
  } else {
  }
// compiled if node returning if1854 (depth = 5)
  gc_frame_end(frame);
  return if1854;
}
Object meth_lexer_poll1887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "poll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for poll (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for poll");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_polled = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "polled");
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1890 = alloc_Boolean(0);
// compiled identifier node returning bool1890 (depth = 7)
  int op_slot_right_1889 = gc_frame_newslot(bool1890);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1892 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1893 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1892);
// compiled call node returning call1893 (depth = 8)
// compiled member node returning call1893 (depth = 7)
  int op_slot_left_1889 = gc_frame_newslot(call1893);
  params[0] = bool1890;
  partcv[0] = 1;
  Object opresult1894 = callmethod(call1893, "!=", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 6)
  Object if1888 = done;
  if (istrue(opresult1894)) {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1895 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1896 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1895);
// compiled call node returning call1896 (depth = 8)
// compiled member node returning call1896 (depth = 7)
  *var_polled = call1896;
  if (call1896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1897 = gc_frame_new();
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1898 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1900 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1899);
// compiled call node returning call1900 (depth = 11)
// compiled member node returning call1900 (depth = 10)
  partcv[0] = 0;
  Object call1901 = callmethod(call1900, "next",
    1, partcv, params);
  gc_frame_end(callframe1898);
// compiled call node returning call1901 (depth = 9)
// compiled member node returning call1901 (depth = 8)
  gc_frame_newslot(call1901);
// call case 4: self request
  params[0] = call1901;
  partcv[0] = 1;
  Object call1902 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1897);
// compiled call node returning call1902 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1905 = alloc_Boolean(0);
// compiled identifier node returning bool1905 (depth = 8)
  int op_slot_right_1904 = gc_frame_newslot(bool1905);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1908 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1907);
// compiled call node returning call1908 (depth = 9)
// compiled member node returning call1908 (depth = 8)
  int op_slot_left_1904 = gc_frame_newslot(call1908);
  params[0] = bool1905;
  partcv[0] = 1;
  Object opresult1909 = callmethod(call1908, "==", 1, partcv, params);
// compiled op node returning opresult1909 (depth = 7)
  Object if1903 = done;
  if (istrue(opresult1909)) {
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1910 = gc_frame_new();
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1911 = alloc_Boolean(0);
// compiled identifier node returning bool1911 (depth = 9)
  gc_frame_newslot(bool1911);
// call case 4: self request
  params[0] = bool1911;
  partcv[0] = 1;
  Object call1912 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compiled call node returning call1912 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1903 = done;
  } else {
  }
// compiled if node returning if1903 (depth = 6)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1913 = gc_frame_new();
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1915 = alloc_Float64(1);
// compiled num node returning num1915 (depth = 9)
  int op_slot_right_1914 = gc_frame_newslot(num1915);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1917 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1918 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1917);
// compiled call node returning call1918 (depth = 10)
// compiled member node returning call1918 (depth = 9)
  int op_slot_left_1914 = gc_frame_newslot(call1918);
  params[0] = num1915;
  partcv[0] = 1;
  Object diff1919 = callmethod(call1918, "-", 1, partcv, params);
// compiled op node returning diff1919 (depth = 8)
  gc_frame_newslot(diff1919);
// call case 4: self request
  params[0] = diff1919;
  partcv[0] = 1;
  Object call1920 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1913);
// compiled call node returning call1920 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_polled (depth = 6)
    gc_frame_newslot(*var_polled);
    if1888 = *var_polled;
  } else {
  }
// compiled if node returning if1888 (depth = 5)
  gc_frame_end(frame);
  return if1888;
}
Object meth_lexer_size1921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1923 = alloc_Float64(0);
// compiled num node returning num1923 (depth = 6)
  int op_slot_right_1922 = gc_frame_newslot(num1923);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1926 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1925);
// compiled call node returning call1926 (depth = 7)
// compiled member node returning call1926 (depth = 6)
  int op_slot_left_1922 = gc_frame_newslot(call1926);
  params[0] = num1923;
  partcv[0] = 1;
  Object sum1927 = callmethod(call1926, "+", 1, partcv, params);
// compiled op node returning sum1927 (depth = 5)
  gc_frame_end(frame);
  return sum1927;
}
Object meth_lexer_havemore1932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "havemore");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for havemore (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for havemore");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1934 = alloc_Boolean(0);
// compiled identifier node returning bool1934 (depth = 6)
  int op_slot_right_1933 = gc_frame_newslot(bool1934);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1937 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1936);
// compiled call node returning call1937 (depth = 7)
// compiled member node returning call1937 (depth = 6)
  int op_slot_left_1933 = gc_frame_newslot(call1937);
  params[0] = bool1934;
  partcv[0] = 1;
  Object opresult1938 = callmethod(call1937, "!=", 1, partcv, params);
// compiled op node returning opresult1938 (depth = 5)
  gc_frame_end(frame);
  return opresult1938;
}
Object meth_lexer_hasNext1939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1941 = alloc_Boolean(0);
// compiled identifier node returning bool1941 (depth = 6)
  int op_slot_right_1940 = gc_frame_newslot(bool1941);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1943 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1944 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1943);
// compiled call node returning call1944 (depth = 7)
// compiled member node returning call1944 (depth = 6)
  int op_slot_left_1940 = gc_frame_newslot(call1944);
  params[0] = bool1941;
  partcv[0] = 1;
  Object opresult1945 = callmethod(call1944, "!=", 1, partcv, params);
// compiled op node returning opresult1945 (depth = 5)
  gc_frame_end(frame);
  return opresult1945;
}
Object meth_lexer_next1946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1947 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1948 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1947);
// compiled call node returning call1948 (depth = 7)
// compiled member node returning call1948 (depth = 6)
  *var_ret = call1948;
  if (call1948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1949 = gc_frame_new();
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1950 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1951 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1952 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1951);
// compiled call node returning call1952 (depth = 10)
// compiled member node returning call1952 (depth = 9)
  partcv[0] = 0;
  Object call1953 = callmethod(call1952, "next",
    1, partcv, params);
  gc_frame_end(callframe1950);
// compiled call node returning call1953 (depth = 8)
// compiled member node returning call1953 (depth = 7)
  gc_frame_newslot(call1953);
// call case 4: self request
  params[0] = call1953;
  partcv[0] = 1;
  Object call1954 = callmethodflags(self, "n:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1949);
// compiled call node returning call1954 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ret (depth = 5)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_lexer_iter1928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1929 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1929 = alloc_userobj2(5,5, objclass1929);
  gc_frame_newslot(obj1929);
if (objclass1929 == NULL) {
  glfree(obj1929->class->name);
  obj1929->class->name = "obj1818.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1929, self, 0);
  addmethodreal(obj1929,"outer", &reader_lexer_outer_1930);
  Object oldself1929 = self;
  struct StackFrameObject *oldstackframe1929 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1929);
  gc_frame_newslot((Object)stackframe);
  self = obj1929;
  Object *oldselfslot1929 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1929 = (*(struct UserObject *)self).data[0], lowerouter1929 = thisouter1929;
  if (inheritingObject1929) {
    struct UserObject *inho1929 = (struct UserObject *)inheritingObject1929;
    while (inho1929->super != GraceDefaultObject) inho1929 = (struct UserObject *)inho1929->super;
    inho1929->super = obj1929;
    self = inheritingObject1929;
    *selfslot = self;
    lowerouter1929 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1929;
  }
if (objclass1929 == NULL) {
  Method *reader1931 = addmethodrealflags(obj1929, "n",&reader_lexer_n_1931, 0);
  Method *writer1931 = addmethodrealflags(obj1929, "n:=",&writer_lexer_n_1931, 0);
  reader1931->definitionModule = modulename;
  writer1931->definitionModule = modulename;
  reader1931->definitionLine = 596;
  writer1931->definitionLine = 596;
}
obj1929->flags |= OFLAG_MUTABLE;
adddatum2(obj1929, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo1932 = (struct UserObject*)obj1929;
  uo1932->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore1932 = addmethod2pos(obj1929, "havemore", &meth_lexer_havemore1932, 2);
  int argcv_meth_lexer_havemore1932[] = {0};
  meth_meth_lexer_havemore1932->type = alloc_MethodType(1, argcv_meth_lexer_havemore1932);
  meth_meth_lexer_havemore1932->definitionModule = modulename;
  meth_meth_lexer_havemore1932->definitionLine = 596;
// method hasNext
  struct UserObject *uo1939 = (struct UserObject*)obj1929;
  uo1939->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext1939 = addmethod2pos(obj1929, "hasNext", &meth_lexer_hasNext1939, 3);
  int argcv_meth_lexer_hasNext1939[] = {0};
  meth_meth_lexer_hasNext1939->type = alloc_MethodType(1, argcv_meth_lexer_hasNext1939);
  meth_meth_lexer_hasNext1939->definitionModule = modulename;
  meth_meth_lexer_hasNext1939->definitionLine = 599;
// method next
  struct UserObject *uo1946 = (struct UserObject*)obj1929;
  uo1946->data[4] = emptyclosure;
  Method *meth_meth_lexer_next1946 = addmethod2pos(obj1929, "next", &meth_lexer_next1946, 4);
  int argcv_meth_lexer_next1946[] = {0};
  meth_meth_lexer_next1946->type = alloc_MethodType(1, argcv_meth_lexer_next1946);
  meth_meth_lexer_next1946->definitionModule = modulename;
  meth_meth_lexer_next1946->definitionLine = 602;
  sourceObject = obj1929;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1955 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1956 = gc_frame_new();
// call case 3: self.outer request
  Object call1957 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1956);
// compiled call node returning call1957 (depth = 8)
// compiled member node returning call1957 (depth = 7)
  partcv[0] = 0;
  Object call1958 = callmethodflags(call1957, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1955);
// compiled call node returning call1958 (depth = 6)
// compiled member node returning call1958 (depth = 5)
  adddatum2(obj1929, call1958, 1);
  sourceObject = obj1929;
  sourceObject = obj1929;
  sourceObject = obj1929;
objclass1929 = obj1929->class;
  objclass1929->definitionModule = modulename;
  objclass1929->definitionLine = 594;
  (*(struct UserObject *)self).data[0] = lowerouter1929;
  self = oldself1929;
  selfslot = oldselfslot1929;
  stackframe = oldstackframe1929;
  gc_frame_end(frame);
  return obj1929;
}
Object meth_lexer_iter1928_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1929 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1929 = alloc_userobj2(5,5, objclass1929);
  gc_frame_newslot(obj1929);
if (objclass1929 == NULL) {
  glfree(obj1929->class->name);
  obj1929->class->name = "obj1818.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1929, self, 0);
  addmethodreal(obj1929,"outer", &reader_lexer_outer_1930);
  Object oldself1929 = self;
  struct StackFrameObject *oldstackframe1929 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1929);
  gc_frame_newslot((Object)stackframe);
  self = obj1929;
  Object *oldselfslot1929 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1929 = (*(struct UserObject *)self).data[0], lowerouter1929 = thisouter1929;
  if (inheritingObject1929) {
    struct UserObject *inho1929 = (struct UserObject *)inheritingObject1929;
    while (inho1929->super != GraceDefaultObject) inho1929 = (struct UserObject *)inho1929->super;
    inho1929->super = obj1929;
    self = inheritingObject1929;
    *selfslot = self;
    lowerouter1929 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1929;
  }
if (objclass1929 == NULL) {
  Method *reader1931 = addmethodrealflags(obj1929, "n",&reader_lexer_n_1931, 0);
  Method *writer1931 = addmethodrealflags(obj1929, "n:=",&writer_lexer_n_1931, 0);
  reader1931->definitionModule = modulename;
  writer1931->definitionModule = modulename;
  reader1931->definitionLine = 596;
  writer1931->definitionLine = 596;
}
obj1929->flags |= OFLAG_MUTABLE;
adddatum2(obj1929, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo1932 = (struct UserObject*)obj1929;
  uo1932->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore1932 = addmethod2pos(obj1929, "havemore", &meth_lexer_havemore1932, 2);
  int argcv_meth_lexer_havemore1932[] = {0};
  meth_meth_lexer_havemore1932->type = alloc_MethodType(1, argcv_meth_lexer_havemore1932);
  meth_meth_lexer_havemore1932->definitionModule = modulename;
  meth_meth_lexer_havemore1932->definitionLine = 596;
// method hasNext
  struct UserObject *uo1939 = (struct UserObject*)obj1929;
  uo1939->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext1939 = addmethod2pos(obj1929, "hasNext", &meth_lexer_hasNext1939, 3);
  int argcv_meth_lexer_hasNext1939[] = {0};
  meth_meth_lexer_hasNext1939->type = alloc_MethodType(1, argcv_meth_lexer_hasNext1939);
  meth_meth_lexer_hasNext1939->definitionModule = modulename;
  meth_meth_lexer_hasNext1939->definitionLine = 599;
// method next
  struct UserObject *uo1946 = (struct UserObject*)obj1929;
  uo1946->data[4] = emptyclosure;
  Method *meth_meth_lexer_next1946 = addmethod2pos(obj1929, "next", &meth_lexer_next1946, 4);
  int argcv_meth_lexer_next1946[] = {0};
  meth_meth_lexer_next1946->type = alloc_MethodType(1, argcv_meth_lexer_next1946);
  meth_meth_lexer_next1946->definitionModule = modulename;
  meth_meth_lexer_next1946->definitionLine = 602;
  sourceObject = obj1929;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1955 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1956 = gc_frame_new();
// call case 3: self.outer request
  Object call1957 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1956);
// compiled call node returning call1957 (depth = 8)
// compiled member node returning call1957 (depth = 7)
  partcv[0] = 0;
  Object call1958 = callmethodflags(call1957, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1955);
// compiled call node returning call1958 (depth = 6)
// compiled member node returning call1958 (depth = 5)
  adddatum2(obj1929, call1958, 1);
  sourceObject = obj1929;
  sourceObject = obj1929;
  sourceObject = obj1929;
objclass1929 = obj1929->class;
  objclass1929->definitionModule = modulename;
  objclass1929->definitionLine = 594;
  (*(struct UserObject *)self).data[0] = lowerouter1929;
  self = oldself1929;
  selfslot = oldselfslot1929;
  stackframe = oldstackframe1929;
  gc_frame_end(frame);
  return obj1929;
}
Object meth_lexer_iterator1960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1961 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1962 = callmethodflags(self, "iter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1961);
// compiled call node returning call1962 (depth = 6)
// compiled member node returning call1962 (depth = 5)
  gc_frame_end(frame);
  return call1962;
}
Object meth_lexer__apply2141(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_mode = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("q");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 9)
  int op_slot_right_2142 = gc_frame_newslot(strlit2143);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2142 = gc_frame_newslot(*var_mode);
  params[0] = strlit2143;
  partcv[0] = 1;
  Object opresult2145 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2145 (depth = 8)
  gc_frame_end(frame);
  return opresult2145;
}
Object meth_lexer__apply2343(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_mode = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2345 == NULL) {
    strlit2345 = alloc_String("q");
    gc_root(strlit2345);
  }
// compiled string node returning strlit2345 (depth = 10)
  int op_slot_right_2344 = gc_frame_newslot(strlit2345);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2344 = gc_frame_newslot(*var_mode);
  params[0] = strlit2345;
  partcv[0] = 1;
  Object opresult2347 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2347 (depth = 9)
  gc_frame_end(frame);
  return opresult2347;
}
Object meth_lexer__apply2949(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_i = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2951 == NULL) {
    strlit2951 = alloc_String("{");
    gc_root(strlit2951);
  }
// compiled string node returning strlit2951 (depth = 12)
  int op_slot_right_2950 = gc_frame_newslot(strlit2951);
// starting to compile index node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2953 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_line (depth = 14)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  partcv[0] = 0;
  Object call2955 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2954);
// compiled call node returning call2955 (depth = 15)
// compiled member node returning call2955 (depth = 14)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2956 = callmethod(call2955, "at",
    1, partcv, params);
  gc_frame_end(callframe2953);
// compiled call node returning call2956 (depth = 13)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2957 = callmethod(call2956, "[]", 1, partcv, params);
// compiled index node returning idxres2957 (depth = 12)
  int op_slot_left_2950 = gc_frame_newslot(idxres2957);
  params[0] = strlit2951;
  partcv[0] = 1;
  Object opresult2958 = callmethod(idxres2957, "!=", 1, partcv, params);
// compiled op node returning opresult2958 (depth = 11)
  gc_frame_end(frame);
  return opresult2958;
}
Object meth_lexer__apply2961(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_line = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num2963 = alloc_Float64(1);
// compiled num node returning num2963 (depth = 13)
  int op_slot_right_2962 = gc_frame_newslot(num2963);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_2962 = gc_frame_newslot(*var_i);
  params[0] = num2963;
  partcv[0] = 1;
  Object diff2965 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff2965 (depth = 12)
  *var_i = diff2965;
  if (diff2965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2969 = alloc_Float64(0);
// compiled num node returning num2969 (depth = 13)
  int op_slot_right_2968 = gc_frame_newslot(num2969);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_2968 = gc_frame_newslot(*var_i);
  params[0] = num2969;
  partcv[0] = 1;
  Object opresult2971 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult2971 (depth = 12)
  Object if2967 = done;
  if (istrue(opresult2971)) {
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 14)
  Object num2973 = alloc_Float64(1);
// compiled num node returning num2973 (depth = 14)
  int op_slot_right_2972 = gc_frame_newslot(num2973);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_line (depth = 14)
  int op_slot_left_2972 = gc_frame_newslot(*var_line);
  params[0] = num2973;
  partcv[0] = 1;
  Object diff2975 = callmethod(*var_line, "-", 1, partcv, params);
// compiled op node returning diff2975 (depth = 13)
  *var_lineNumber = diff2975;
  if (diff2975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2977 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 15)
  int callframe2978 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_line (depth = 16)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_util (depth = 18)
  partcv[0] = 0;
  Object call2980 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2979);
// compiled call node returning call2980 (depth = 17)
// compiled member node returning call2980 (depth = 16)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2981 = callmethod(call2980, "at",
    1, partcv, params);
  gc_frame_end(callframe2978);
// compiled call node returning call2981 (depth = 15)
  partcv[0] = 0;
  Object call2982 = callmethod(call2981, "size",
    1, partcv, params);
  gc_frame_end(callframe2977);
// compiled call node returning call2982 (depth = 14)
// compiled member node returning call2982 (depth = 13)
  *var_i = call2982;
  if (call2982 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if2967 = done;
  } else {
  }
// compiled if node returning if2967 (depth = 11)
  gc_frame_end(frame);
  return if2967;
}
Object meth_lexer__apply3073(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextLine (depth = 14)
  partcv[0] = 0;
  Object call3076 = callmethod(*var_nextLine, "size",
    1, partcv, params);
  gc_frame_end(callframe3075);
// compiled call node returning call3076 (depth = 13)
// compiled member node returning call3076 (depth = 12)
  int op_slot_right_3074 = gc_frame_newslot(call3076);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_3074 = gc_frame_newslot(*var_i);
  params[0] = call3076;
  partcv[0] = 1;
  Object opresult3078 = callmethod(*var_i, "<=", 1, partcv, params);
// compiled op node returning opresult3078 (depth = 11)
  gc_frame_end(frame);
  return opresult3078;
}
Object meth_lexer__apply3081(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object *var_count = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3084 == NULL) {
    strlit3084 = alloc_String("""\x22""");
    gc_root(strlit3084);
  }
// compiled string node returning strlit3084 (depth = 13)
  int op_slot_right_3083 = gc_frame_newslot(strlit3084);
// starting to compile index node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextLine (depth = 14)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3086 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3086 (depth = 13)
  int op_slot_left_3083 = gc_frame_newslot(idxres3086);
  params[0] = strlit3084;
  partcv[0] = 1;
  Object opresult3087 = callmethod(idxres3086, "==", 1, partcv, params);
// compiled op node returning opresult3087 (depth = 12)
  Object if3082 = done;
  if (istrue(opresult3087)) {
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num3089 = alloc_Float64(1);
// compiled num node returning num3089 (depth = 14)
  int op_slot_right_3088 = gc_frame_newslot(num3089);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_count (depth = 14)
  int op_slot_left_3088 = gc_frame_newslot(*var_count);
  params[0] = num3089;
  partcv[0] = 1;
  Object sum3091 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum3091 (depth = 13)
  *var_count = sum3091;
  if (sum3091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3082 = done;
  } else {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3095 == NULL) {
    strlit3095 = alloc_String("\\");
    gc_root(strlit3095);
  }
// compiled string node returning strlit3095 (depth = 14)
  int op_slot_right_3094 = gc_frame_newslot(strlit3095);
// starting to compile index node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextLine (depth = 15)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_i (depth = 15)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3097 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3097 (depth = 14)
  int op_slot_left_3094 = gc_frame_newslot(idxres3097);
  params[0] = strlit3095;
  partcv[0] = 1;
  Object opresult3098 = callmethod(idxres3097, "==", 1, partcv, params);
// compiled op node returning opresult3098 (depth = 13)
  Object if3093 = done;
  if (istrue(opresult3098)) {
// starting to compile bind node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num3100 = alloc_Float64(1);
// compiled num node returning num3100 (depth = 15)
  int op_slot_right_3099 = gc_frame_newslot(num3100);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_i (depth = 15)
  int op_slot_left_3099 = gc_frame_newslot(*var_i);
  params[0] = num3100;
  partcv[0] = 1;
  Object sum3102 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3102 (depth = 14)
  *var_i = sum3102;
  if (sum3102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if3093 = done;
  } else {
  }
// compiled if node returning if3093 (depth = 12)
    gc_frame_newslot(if3093);
    if3082 = if3093;
  }
// compiled if node returning if3082 (depth = 11)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num3105 = alloc_Float64(1);
// compiled num node returning num3105 (depth = 13)
  int op_slot_right_3104 = gc_frame_newslot(num3105);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_3104 = gc_frame_newslot(*var_i);
  params[0] = num3105;
  partcv[0] = 1;
  Object sum3107 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3107 (depth = 12)
  *var_i = sum3107;
  if (sum3107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply2134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(20, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_mode = getfromclosure(closure, 0);
  Object *var_badSeparator = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_linePosition = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object *var_inStr = getfromclosure(closure, 5);
  Object *var_unicode = getfromclosure(closure, 6);
  Object *var_badControl = getfromclosure(closure, 7);
  Object *var_atStart = getfromclosure(closure, 8);
  Object *var_newmode = getfromclosure(closure, 9);
  Object *var_stringStart = getfromclosure(closure, 10);
  Object *var_startLine = getfromclosure(closure, 11);
  Object *var_identifierChar = getfromclosure(closure, 12);
  Object *var_digit = getfromclosure(closure, 13);
  Object *var_iGTLT = getfromclosure(closure, 14);
  Object *var_tokens = getfromclosure(closure, 15);
  Object *var_accum = getfromclosure(closure, 16);
  Object *var_operatorChar = getfromclosure(closure, 17);
  Object *var_selfModes = getfromclosure(closure, 18);
  Object *var_util = getfromclosure(closure, 19);
  Object *var_escaped = getfromclosure(closure, 20);
  Object *var_interpString = getfromclosure(closure, 21);
  Object *var_interpdepth = getfromclosure(closure, 22);
  Object *var_brackets = getfromclosure(closure, 23);
  Object *var_unichars = getfromclosure(closure, 24);
  Object *var_codepoint = getfromclosure(closure, 25);
  Object *var_newlineFound = getfromclosure(closure, 26);
  Object *var_startPosition = getfromclosure(closure, 27);
  Object self = *(getfromclosure(closure, 28));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ct = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ct");
  Object *var_ordval = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ordval");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_i = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "i");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_errorLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "errorLine");
  Object *var_nextLine = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "nextLine");
  Object *var_count = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "count");
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2135 == NULL) {
    strlit2135 = alloc_String("");
    gc_root(strlit2135);
  }
// compiled string node returning strlit2135 (depth = 6)
  *var_ct = strlit2135;
  if (strlit2135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  partcv[0] = 0;
  Object call2137 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe2136);
// compiled call node returning call2137 (depth = 7)
// compiled member node returning call2137 (depth = 6)
  *var_ordval = call2137;
  if (call2137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2139 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2140 = alloc_Block(NULL, NULL, "lexer", 650);
  gc_frame_newslot(block2140);
// method _apply
  block_savedest(block2140);
  Object closure2141 = createclosure(2, "_apply");
  setclosureframe(closure2141, stackframe);
  addtoclosure(closure2141, var_mode);
  addtoclosure(closure2141, selfslot);
  struct UserObject *uo2141 = (struct UserObject*)block2140;
  uo2141->data[0] = (Object)closure2141;
  Method *meth_meth_lexer__apply2141 = addmethod2pos(block2140, "_apply", &meth_lexer__apply2141, 0);
  int argcv_meth_lexer__apply2141[] = {0};
  meth_meth_lexer__apply2141->type = alloc_MethodType(1, argcv_meth_lexer__apply2141);
  meth_meth_lexer__apply2141->definitionModule = modulename;
  meth_meth_lexer__apply2141->definitionLine = 649;
// compiled block node returning block2140 (depth = 7)
  gc_frame_newslot(block2140);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe2147 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_badSeparator (depth = 8)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2148 = callmethod(*var_badSeparator, "match",
    1, partcv, params);
  gc_frame_end(callframe2147);
// compiled call node returning call2148 (depth = 7)
  params[0] = block2140;
  partcv[0] = 1;
  Object call2149 = callmethod(call2148, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2139);
// compiled call node returning call2149 (depth = 6)
  Object if2138 = done;
  if (istrue(call2149)) {
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2150 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2152 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2151);
// compiled call node returning call2152 (depth = 10)
// compiled member node returning call2152 (depth = 9)
  partcv[0] = 0;
  Object call2153 = callmethod(call2152, "new",
    1, partcv, params);
  gc_frame_end(callframe2150);
// compiled call node returning call2153 (depth = 8)
// compiled member node returning call2153 (depth = 7)
  *var_suggestion = call2153;
  if (call2153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2154 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 7)
  if (strlit2155 == NULL) {
    strlit2155 = alloc_String(" ");
    gc_root(strlit2155);
  }
// compiled string node returning strlit2155 (depth = 7)
  gc_frame_newslot(strlit2155);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_linePosition;
  params[1] = strlit2155;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2156 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2154);
// compiled call node returning call2156 (depth = 6)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2159 = alloc_Float64(9);
// compiled num node returning num2159 (depth = 8)
  int op_slot_right_2158 = gc_frame_newslot(num2159);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  int op_slot_left_2158 = gc_frame_newslot(*var_ordval);
  params[0] = num2159;
  partcv[0] = 1;
  Object opresult2161 = callmethod(*var_ordval, "==", 1, partcv, params);
// compiled op node returning opresult2161 (depth = 7)
  Object if2157 = done;
  if (istrue(opresult2161)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inStr (depth = 8)
  Object if2162 = done;
  if (istrue(*var_inStr)) {
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2163 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2165 == NULL) {
    strlit2165 = alloc_String("");
    gc_root(strlit2165);
  }
// compiled string node returning strlit2165 (depth = 10)
  int op_slot_right_2164 = gc_frame_newslot(strlit2165);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2168 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2169 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2170 = alloc_Float64(16);
// compiled num node returning num2170 (depth = 13)
  gc_frame_newslot(num2170);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2170;
  partcv[0] = 1;
  Object call2171 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2169);
// compiled call node returning call2171 (depth = 12)
  gc_frame_newslot(call2171);
// starting to compile num node (depth = 12)
  Object num2172 = alloc_Float64(4);
// compiled num node returning num2172 (depth = 12)
  gc_frame_newslot(num2172);
// starting to compile string node (depth = 12)
  if (strlit2173 == NULL) {
    strlit2173 = alloc_String("0");
    gc_root(strlit2173);
  }
// compiled string node returning strlit2173 (depth = 12)
  gc_frame_newslot(strlit2173);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2174 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2175 = gc_frame_new();
// call case 3: self.outer request
  Object call2176 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2175);
// compiled call node returning call2176 (depth = 15)
// compiled member node returning call2176 (depth = 14)
  partcv[0] = 0;
  Object call2177 = callmethodflags(call2176, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2174);
// compiled call node returning call2177 (depth = 13)
// compiled member node returning call2177 (depth = 12)
  params[0] = call2171;
  params[1] = num2172;
  params[2] = strlit2173;
  partcv[0] = 3;
  Object call2178 = callmethodflags(call2177, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled call node returning call2178 (depth = 11)
  int op_slot_right_2167 = gc_frame_newslot(call2178);
// starting to compile string node (depth = 11)
  if (strlit2180 == NULL) {
    strlit2180 = alloc_String("\\u");
    gc_root(strlit2180);
  }
// compiled string node returning strlit2180 (depth = 11)
  int op_slot_left_2167 = gc_frame_newslot(strlit2180);
  params[0] = call2178;
  partcv[0] = 1;
  Object opresult2181 = callmethod(strlit2180, "++", 1, partcv, params);
// compiled op node returning opresult2181 (depth = 10)
  int op_slot_left_2164 = gc_frame_newslot(opresult2181);
  params[0] = strlit2165;
  partcv[0] = 1;
  Object opresult2182 = callmethod(opresult2181, "++", 1, partcv, params);
// compiled op node returning opresult2182 (depth = 9)
  gc_frame_newslot(opresult2182);
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2182;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2183 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2163);
// compiled call node returning call2183 (depth = 8)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2184 = gc_frame_new();
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2186 == NULL) {
    strlit2186 = alloc_String(" instead");
    gc_root(strlit2186);
  }
// compiled string node returning strlit2186 (depth = 10)
  int op_slot_right_2185 = gc_frame_newslot(strlit2186);
// starting to compile op node (depth = 10)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2189 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2190 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2191 = alloc_Float64(16);
// compiled num node returning num2191 (depth = 13)
  gc_frame_newslot(num2191);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2191;
  partcv[0] = 1;
  Object call2192 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2190);
// compiled call node returning call2192 (depth = 12)
  gc_frame_newslot(call2192);
// starting to compile num node (depth = 12)
  Object num2193 = alloc_Float64(4);
// compiled num node returning num2193 (depth = 12)
  gc_frame_newslot(num2193);
// starting to compile string node (depth = 12)
  if (strlit2194 == NULL) {
    strlit2194 = alloc_String("0");
    gc_root(strlit2194);
  }
// compiled string node returning strlit2194 (depth = 12)
  gc_frame_newslot(strlit2194);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2195 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2196 = gc_frame_new();
// call case 3: self.outer request
  Object call2197 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2196);
// compiled call node returning call2197 (depth = 15)
// compiled member node returning call2197 (depth = 14)
  partcv[0] = 0;
  Object call2198 = callmethodflags(call2197, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2195);
// compiled call node returning call2198 (depth = 13)
// compiled member node returning call2198 (depth = 12)
  params[0] = call2192;
  params[1] = num2193;
  params[2] = strlit2194;
  partcv[0] = 3;
  Object call2199 = callmethodflags(call2198, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2189);
// compiled call node returning call2199 (depth = 11)
  int op_slot_right_2188 = gc_frame_newslot(call2199);
// starting to compile op node (depth = 11)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2202 == NULL) {
    strlit2202 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2202);
  }
// compiled string node returning strlit2202 (depth = 12)
  int op_slot_right_2201 = gc_frame_newslot(strlit2202);
// starting to compile op node (depth = 12)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2205 == NULL) {
    strlit2205 = alloc_String("written in the source code; ");
    gc_root(strlit2205);
  }
// compiled string node returning strlit2205 (depth = 13)
  int op_slot_right_2204 = gc_frame_newslot(strlit2205);
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2207 == NULL) {
    strlit2207 = alloc_String("tabs cannot be ");
    gc_root(strlit2207);
  }
// compiled string node returning strlit2207 (depth = 13)
  int op_slot_left_2204 = gc_frame_newslot(strlit2207);
  params[0] = strlit2205;
  partcv[0] = 1;
  Object opresult2208 = callmethod(strlit2207, "++", 1, partcv, params);
// compiled op node returning opresult2208 (depth = 12)
  int op_slot_left_2201 = gc_frame_newslot(opresult2208);
  params[0] = strlit2202;
  partcv[0] = 1;
  Object opresult2209 = callmethod(opresult2208, "++", 1, partcv, params);
// compiled op node returning opresult2209 (depth = 11)
  int op_slot_left_2188 = gc_frame_newslot(opresult2209);
  params[0] = call2199;
  partcv[0] = 1;
  Object opresult2210 = callmethod(opresult2209, "++", 1, partcv, params);
// compiled op node returning opresult2210 (depth = 10)
  int op_slot_left_2185 = gc_frame_newslot(opresult2210);
  params[0] = strlit2186;
  partcv[0] = 1;
  Object opresult2211 = callmethod(opresult2210, "++", 1, partcv, params);
// compiled op node returning opresult2211 (depth = 9)
  gc_frame_newslot(opresult2211);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2211;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2212 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2184);
// compiled call node returning call2212 (depth = 8)
    gc_frame_newslot(call2212);
    if2162 = call2212;
  } else {
  }
// compiled if node returning if2162 (depth = 7)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2213 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2214 == NULL) {
    strlit2214 = alloc_String("Tabs are not allowed; use spaces instead.");
    gc_root(strlit2214);
  }
// compiled string node returning strlit2214 (depth = 8)
  gc_frame_newslot(strlit2214);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2214;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2215 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2213);
// compiled call node returning call2215 (depth = 7)
    gc_frame_newslot(call2215);
    if2157 = call2215;
  } else {
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2218 == NULL) {
    strlit2218 = alloc_String("""\x22""");
    gc_root(strlit2218);
  }
// compiled string node returning strlit2218 (depth = 9)
  int op_slot_right_2217 = gc_frame_newslot(strlit2218);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2217 = gc_frame_newslot(*var_mode);
  params[0] = strlit2218;
  partcv[0] = 1;
  Object opresult2220 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2220 (depth = 8)
  Object if2216 = done;
  if (istrue(opresult2220)) {
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2221 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String("");
    gc_root(strlit2223);
  }
// compiled string node returning strlit2223 (depth = 10)
  int op_slot_right_2222 = gc_frame_newslot(strlit2223);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2226 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2227 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2228 = alloc_Float64(16);
// compiled num node returning num2228 (depth = 13)
  gc_frame_newslot(num2228);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2228;
  partcv[0] = 1;
  Object call2229 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2227);
// compiled call node returning call2229 (depth = 12)
  gc_frame_newslot(call2229);
// starting to compile num node (depth = 12)
  Object num2230 = alloc_Float64(4);
// compiled num node returning num2230 (depth = 12)
  gc_frame_newslot(num2230);
// starting to compile string node (depth = 12)
  if (strlit2231 == NULL) {
    strlit2231 = alloc_String("0");
    gc_root(strlit2231);
  }
// compiled string node returning strlit2231 (depth = 12)
  gc_frame_newslot(strlit2231);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2232 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2233 = gc_frame_new();
// call case 3: self.outer request
  Object call2234 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2233);
// compiled call node returning call2234 (depth = 15)
// compiled member node returning call2234 (depth = 14)
  partcv[0] = 0;
  Object call2235 = callmethodflags(call2234, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2232);
// compiled call node returning call2235 (depth = 13)
// compiled member node returning call2235 (depth = 12)
  params[0] = call2229;
  params[1] = num2230;
  params[2] = strlit2231;
  partcv[0] = 3;
  Object call2236 = callmethodflags(call2235, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2226);
// compiled call node returning call2236 (depth = 11)
  int op_slot_right_2225 = gc_frame_newslot(call2236);
// starting to compile string node (depth = 11)
  if (strlit2238 == NULL) {
    strlit2238 = alloc_String("\\u");
    gc_root(strlit2238);
  }
// compiled string node returning strlit2238 (depth = 11)
  int op_slot_left_2225 = gc_frame_newslot(strlit2238);
  params[0] = call2236;
  partcv[0] = 1;
  Object opresult2239 = callmethod(strlit2238, "++", 1, partcv, params);
// compiled op node returning opresult2239 (depth = 10)
  int op_slot_left_2222 = gc_frame_newslot(opresult2239);
  params[0] = strlit2223;
  partcv[0] = 1;
  Object opresult2240 = callmethod(opresult2239, "++", 1, partcv, params);
// compiled op node returning opresult2240 (depth = 9)
  gc_frame_newslot(opresult2240);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2240;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2241 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2221);
// compiled call node returning call2241 (depth = 8)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2242 = gc_frame_new();
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2244 == NULL) {
    strlit2244 = alloc_String(" instead");
    gc_root(strlit2244);
  }
// compiled string node returning strlit2244 (depth = 10)
  int op_slot_right_2243 = gc_frame_newslot(strlit2244);
// starting to compile op node (depth = 10)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2247 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2248 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2249 = alloc_Float64(16);
// compiled num node returning num2249 (depth = 13)
  gc_frame_newslot(num2249);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2249;
  partcv[0] = 1;
  Object call2250 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2248);
// compiled call node returning call2250 (depth = 12)
  gc_frame_newslot(call2250);
// starting to compile num node (depth = 12)
  Object num2251 = alloc_Float64(4);
// compiled num node returning num2251 (depth = 12)
  gc_frame_newslot(num2251);
// starting to compile string node (depth = 12)
  if (strlit2252 == NULL) {
    strlit2252 = alloc_String("0");
    gc_root(strlit2252);
  }
// compiled string node returning strlit2252 (depth = 12)
  gc_frame_newslot(strlit2252);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2253 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2254 = gc_frame_new();
// call case 3: self.outer request
  Object call2255 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2254);
// compiled call node returning call2255 (depth = 15)
// compiled member node returning call2255 (depth = 14)
  partcv[0] = 0;
  Object call2256 = callmethodflags(call2255, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2253);
// compiled call node returning call2256 (depth = 13)
// compiled member node returning call2256 (depth = 12)
  params[0] = call2250;
  params[1] = num2251;
  params[2] = strlit2252;
  partcv[0] = 3;
  Object call2257 = callmethodflags(call2256, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2247);
// compiled call node returning call2257 (depth = 11)
  int op_slot_right_2246 = gc_frame_newslot(call2257);
// starting to compile op node (depth = 11)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2260 == NULL) {
    strlit2260 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2260);
  }
// compiled string node returning strlit2260 (depth = 12)
  int op_slot_right_2259 = gc_frame_newslot(strlit2260);
// starting to compile op node (depth = 12)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2263 == NULL) {
    strlit2263 = alloc_String("written in the source code; ");
    gc_root(strlit2263);
  }
// compiled string node returning strlit2263 (depth = 13)
  int op_slot_right_2262 = gc_frame_newslot(strlit2263);
// starting to compile op node (depth = 13)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit2266 == NULL) {
    strlit2266 = alloc_String(" and cannot be ");
    gc_root(strlit2266);
  }
// compiled string node returning strlit2266 (depth = 14)
  int op_slot_right_2265 = gc_frame_newslot(strlit2266);
// starting to compile op node (depth = 14)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 15)
  if (strlit2269 == NULL) {
    strlit2269 = alloc_String("is not a valid whitespace character");
    gc_root(strlit2269);
  }
// compiled string node returning strlit2269 (depth = 15)
  int op_slot_right_2268 = gc_frame_newslot(strlit2269);
// starting to compile op node (depth = 15)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 16)
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String(") ");
    gc_root(strlit2272);
  }
// compiled string node returning strlit2272 (depth = 16)
  int op_slot_right_2271 = gc_frame_newslot(strlit2272);
// starting to compile op node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2275 = gc_frame_new();
// starting to compile call node (depth = 18)
  int callframe2276 = gc_frame_new();
// starting to compile num node (depth = 19)
  Object num2277 = alloc_Float64(16);
// compiled num node returning num2277 (depth = 19)
  gc_frame_newslot(num2277);
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_ordval (depth = 19)
  params[0] = num2277;
  partcv[0] = 1;
  Object call2278 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2276);
// compiled call node returning call2278 (depth = 18)
  gc_frame_newslot(call2278);
// starting to compile num node (depth = 18)
  Object num2279 = alloc_Float64(4);
// compiled num node returning num2279 (depth = 18)
  gc_frame_newslot(num2279);
// starting to compile string node (depth = 18)
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("0");
    gc_root(strlit2280);
  }
// compiled string node returning strlit2280 (depth = 18)
  gc_frame_newslot(strlit2280);
// call case 2: outer request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2281 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2282 = gc_frame_new();
// call case 3: self.outer request
  Object call2283 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2282);
// compiled call node returning call2283 (depth = 21)
// compiled member node returning call2283 (depth = 20)
  partcv[0] = 0;
  Object call2284 = callmethodflags(call2283, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2281);
// compiled call node returning call2284 (depth = 19)
// compiled member node returning call2284 (depth = 18)
  params[0] = call2278;
  params[1] = num2279;
  params[2] = strlit2280;
  partcv[0] = 3;
  Object call2285 = callmethodflags(call2284, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2275);
// compiled call node returning call2285 (depth = 17)
  int op_slot_right_2274 = gc_frame_newslot(call2285);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit2288 == NULL) {
    strlit2288 = alloc_String(" (U+");
    gc_root(strlit2288);
  }
// compiled string node returning strlit2288 (depth = 18)
  int op_slot_right_2287 = gc_frame_newslot(strlit2288);
// starting to compile op node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2291 = gc_frame_new();
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_c (depth = 20)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_unicode (depth = 20)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2292 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2291);
// compiled call node returning call2292 (depth = 19)
  int op_slot_right_2290 = gc_frame_newslot(call2292);
// starting to compile string node (depth = 19)
  if (strlit2294 == NULL) {
    strlit2294 = alloc_String("");
    gc_root(strlit2294);
  }
// compiled string node returning strlit2294 (depth = 19)
  int op_slot_left_2290 = gc_frame_newslot(strlit2294);
  params[0] = call2292;
  partcv[0] = 1;
  Object opresult2295 = callmethod(strlit2294, "++", 1, partcv, params);
// compiled op node returning opresult2295 (depth = 18)
  int op_slot_left_2287 = gc_frame_newslot(opresult2295);
  params[0] = strlit2288;
  partcv[0] = 1;
  Object opresult2296 = callmethod(opresult2295, "++", 1, partcv, params);
// compiled op node returning opresult2296 (depth = 17)
  int op_slot_left_2274 = gc_frame_newslot(opresult2296);
  params[0] = call2285;
  partcv[0] = 1;
  Object opresult2297 = callmethod(opresult2296, "++", 1, partcv, params);
// compiled op node returning opresult2297 (depth = 16)
  int op_slot_left_2271 = gc_frame_newslot(opresult2297);
  params[0] = strlit2272;
  partcv[0] = 1;
  Object opresult2298 = callmethod(opresult2297, "++", 1, partcv, params);
// compiled op node returning opresult2298 (depth = 15)
  int op_slot_left_2268 = gc_frame_newslot(opresult2298);
  params[0] = strlit2269;
  partcv[0] = 1;
  Object opresult2299 = callmethod(opresult2298, "++", 1, partcv, params);
// compiled op node returning opresult2299 (depth = 14)
  int op_slot_left_2265 = gc_frame_newslot(opresult2299);
  params[0] = strlit2266;
  partcv[0] = 1;
  Object opresult2300 = callmethod(opresult2299, "++", 1, partcv, params);
// compiled op node returning opresult2300 (depth = 13)
  int op_slot_left_2262 = gc_frame_newslot(opresult2300);
  params[0] = strlit2263;
  partcv[0] = 1;
  Object opresult2301 = callmethod(opresult2300, "++", 1, partcv, params);
// compiled op node returning opresult2301 (depth = 12)
  int op_slot_left_2259 = gc_frame_newslot(opresult2301);
  params[0] = strlit2260;
  partcv[0] = 1;
  Object opresult2302 = callmethod(opresult2301, "++", 1, partcv, params);
// compiled op node returning opresult2302 (depth = 11)
  int op_slot_left_2246 = gc_frame_newslot(opresult2302);
  params[0] = call2257;
  partcv[0] = 1;
  Object opresult2303 = callmethod(opresult2302, "++", 1, partcv, params);
// compiled op node returning opresult2303 (depth = 10)
  int op_slot_left_2243 = gc_frame_newslot(opresult2303);
  params[0] = strlit2244;
  partcv[0] = 1;
  Object opresult2304 = callmethod(opresult2303, "++", 1, partcv, params);
// compiled op node returning opresult2304 (depth = 9)
  gc_frame_newslot(opresult2304);
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2304;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2305 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2242);
// compiled call node returning call2305 (depth = 8)
    gc_frame_newslot(call2305);
    if2216 = call2305;
  } else {
  }
// compiled if node returning if2216 (depth = 7)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2306 = gc_frame_new();
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2308 == NULL) {
    strlit2308 = alloc_String("is not a valid whitespace character; use spaces instead.");
    gc_root(strlit2308);
  }
// compiled string node returning strlit2308 (depth = 9)
  int op_slot_right_2307 = gc_frame_newslot(strlit2308);
// starting to compile op node (depth = 9)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2311 == NULL) {
    strlit2311 = alloc_String(") ");
    gc_root(strlit2311);
  }
// compiled string node returning strlit2311 (depth = 10)
  int op_slot_right_2310 = gc_frame_newslot(strlit2311);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2314 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2315 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2316 = alloc_Float64(16);
// compiled num node returning num2316 (depth = 13)
  gc_frame_newslot(num2316);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2316;
  partcv[0] = 1;
  Object call2317 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2315);
// compiled call node returning call2317 (depth = 12)
  gc_frame_newslot(call2317);
// starting to compile num node (depth = 12)
  Object num2318 = alloc_Float64(4);
// compiled num node returning num2318 (depth = 12)
  gc_frame_newslot(num2318);
// starting to compile string node (depth = 12)
  if (strlit2319 == NULL) {
    strlit2319 = alloc_String("0");
    gc_root(strlit2319);
  }
// compiled string node returning strlit2319 (depth = 12)
  gc_frame_newslot(strlit2319);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2320 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2321 = gc_frame_new();
// call case 3: self.outer request
  Object call2322 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2321);
// compiled call node returning call2322 (depth = 15)
// compiled member node returning call2322 (depth = 14)
  partcv[0] = 0;
  Object call2323 = callmethodflags(call2322, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2320);
// compiled call node returning call2323 (depth = 13)
// compiled member node returning call2323 (depth = 12)
  params[0] = call2317;
  params[1] = num2318;
  params[2] = strlit2319;
  partcv[0] = 3;
  Object call2324 = callmethodflags(call2323, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2314);
// compiled call node returning call2324 (depth = 11)
  int op_slot_right_2313 = gc_frame_newslot(call2324);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2327 == NULL) {
    strlit2327 = alloc_String(" (U+");
    gc_root(strlit2327);
  }
// compiled string node returning strlit2327 (depth = 12)
  int op_slot_right_2326 = gc_frame_newslot(strlit2327);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2330 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2331 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2330);
// compiled call node returning call2331 (depth = 13)
  int op_slot_right_2329 = gc_frame_newslot(call2331);
// starting to compile string node (depth = 13)
  if (strlit2333 == NULL) {
    strlit2333 = alloc_String("");
    gc_root(strlit2333);
  }
// compiled string node returning strlit2333 (depth = 13)
  int op_slot_left_2329 = gc_frame_newslot(strlit2333);
  params[0] = call2331;
  partcv[0] = 1;
  Object opresult2334 = callmethod(strlit2333, "++", 1, partcv, params);
// compiled op node returning opresult2334 (depth = 12)
  int op_slot_left_2326 = gc_frame_newslot(opresult2334);
  params[0] = strlit2327;
  partcv[0] = 1;
  Object opresult2335 = callmethod(opresult2334, "++", 1, partcv, params);
// compiled op node returning opresult2335 (depth = 11)
  int op_slot_left_2313 = gc_frame_newslot(opresult2335);
  params[0] = call2324;
  partcv[0] = 1;
  Object opresult2336 = callmethod(opresult2335, "++", 1, partcv, params);
// compiled op node returning opresult2336 (depth = 10)
  int op_slot_left_2310 = gc_frame_newslot(opresult2336);
  params[0] = strlit2311;
  partcv[0] = 1;
  Object opresult2337 = callmethod(opresult2336, "++", 1, partcv, params);
// compiled op node returning opresult2337 (depth = 9)
  int op_slot_left_2307 = gc_frame_newslot(opresult2337);
  params[0] = strlit2308;
  partcv[0] = 1;
  Object opresult2338 = callmethod(opresult2337, "++", 1, partcv, params);
// compiled op node returning opresult2338 (depth = 8)
  gc_frame_newslot(opresult2338);
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2338;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2339 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2306);
// compiled call node returning call2339 (depth = 7)
    gc_frame_newslot(call2339);
    if2157 = call2339;
  }
// compiled if node returning if2157 (depth = 6)
    gc_frame_newslot(if2157);
    if2138 = if2157;
  } else {
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2341 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block2342 = alloc_Block(NULL, NULL, "lexer", 689);
  gc_frame_newslot(block2342);
// method _apply
  block_savedest(block2342);
  Object closure2343 = createclosure(2, "_apply");
  setclosureframe(closure2343, stackframe);
  addtoclosure(closure2343, var_mode);
  addtoclosure(closure2343, selfslot);
  struct UserObject *uo2343 = (struct UserObject*)block2342;
  uo2343->data[0] = (Object)closure2343;
  Method *meth_meth_lexer__apply2343 = addmethod2pos(block2342, "_apply", &meth_lexer__apply2343, 0);
  int argcv_meth_lexer__apply2343[] = {0};
  meth_meth_lexer__apply2343->type = alloc_MethodType(1, argcv_meth_lexer__apply2343);
  meth_meth_lexer__apply2343->definitionModule = modulename;
  meth_meth_lexer__apply2343->definitionLine = 685;
// compiled block node returning block2342 (depth = 8)
  gc_frame_newslot(block2342);
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2349 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_badControl (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2350 = callmethod(*var_badControl, "match",
    1, partcv, params);
  gc_frame_end(callframe2349);
// compiled call node returning call2350 (depth = 8)
  params[0] = block2342;
  partcv[0] = 1;
  Object call2351 = callmethod(call2350, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe2341);
// compiled call node returning call2351 (depth = 7)
  Object if2340 = done;
  if (istrue(call2351)) {
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2352 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2353 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2354 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2353);
// compiled call node returning call2354 (depth = 11)
// compiled member node returning call2354 (depth = 10)
  partcv[0] = 0;
  Object call2355 = callmethod(call2354, "new",
    1, partcv, params);
  gc_frame_end(callframe2352);
// compiled call node returning call2355 (depth = 9)
// compiled member node returning call2355 (depth = 8)
  *var_suggestion = call2355;
  if (call2355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inStr (depth = 8)
  Object if2356 = done;
  if (istrue(*var_inStr)) {
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2357 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2359 == NULL) {
    strlit2359 = alloc_String("");
    gc_root(strlit2359);
  }
// compiled string node returning strlit2359 (depth = 10)
  int op_slot_right_2358 = gc_frame_newslot(strlit2359);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2362 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2363 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2364 = alloc_Float64(16);
// compiled num node returning num2364 (depth = 13)
  gc_frame_newslot(num2364);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2364;
  partcv[0] = 1;
  Object call2365 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2363);
// compiled call node returning call2365 (depth = 12)
  gc_frame_newslot(call2365);
// starting to compile num node (depth = 12)
  Object num2366 = alloc_Float64(4);
// compiled num node returning num2366 (depth = 12)
  gc_frame_newslot(num2366);
// starting to compile string node (depth = 12)
  if (strlit2367 == NULL) {
    strlit2367 = alloc_String("0");
    gc_root(strlit2367);
  }
// compiled string node returning strlit2367 (depth = 12)
  gc_frame_newslot(strlit2367);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2368 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2369 = gc_frame_new();
// call case 3: self.outer request
  Object call2370 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2369);
// compiled call node returning call2370 (depth = 15)
// compiled member node returning call2370 (depth = 14)
  partcv[0] = 0;
  Object call2371 = callmethodflags(call2370, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2368);
// compiled call node returning call2371 (depth = 13)
// compiled member node returning call2371 (depth = 12)
  params[0] = call2365;
  params[1] = num2366;
  params[2] = strlit2367;
  partcv[0] = 3;
  Object call2372 = callmethodflags(call2371, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2362);
// compiled call node returning call2372 (depth = 11)
  int op_slot_right_2361 = gc_frame_newslot(call2372);
// starting to compile string node (depth = 11)
  if (strlit2374 == NULL) {
    strlit2374 = alloc_String("\\u");
    gc_root(strlit2374);
  }
// compiled string node returning strlit2374 (depth = 11)
  int op_slot_left_2361 = gc_frame_newslot(strlit2374);
  params[0] = call2372;
  partcv[0] = 1;
  Object opresult2375 = callmethod(strlit2374, "++", 1, partcv, params);
// compiled op node returning opresult2375 (depth = 10)
  int op_slot_left_2358 = gc_frame_newslot(opresult2375);
  params[0] = strlit2359;
  partcv[0] = 1;
  Object opresult2376 = callmethod(opresult2375, "++", 1, partcv, params);
// compiled op node returning opresult2376 (depth = 9)
  gc_frame_newslot(opresult2376);
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2376;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2377 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2357);
// compiled call node returning call2377 (depth = 8)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2378 = gc_frame_new();
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2380 == NULL) {
    strlit2380 = alloc_String(" instead");
    gc_root(strlit2380);
  }
// compiled string node returning strlit2380 (depth = 10)
  int op_slot_right_2379 = gc_frame_newslot(strlit2380);
// starting to compile op node (depth = 10)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2383 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2384 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2385 = alloc_Float64(16);
// compiled num node returning num2385 (depth = 13)
  gc_frame_newslot(num2385);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2385;
  partcv[0] = 1;
  Object call2386 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2384);
// compiled call node returning call2386 (depth = 12)
  gc_frame_newslot(call2386);
// starting to compile num node (depth = 12)
  Object num2387 = alloc_Float64(4);
// compiled num node returning num2387 (depth = 12)
  gc_frame_newslot(num2387);
// starting to compile string node (depth = 12)
  if (strlit2388 == NULL) {
    strlit2388 = alloc_String("0");
    gc_root(strlit2388);
  }
// compiled string node returning strlit2388 (depth = 12)
  gc_frame_newslot(strlit2388);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2389 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2390 = gc_frame_new();
// call case 3: self.outer request
  Object call2391 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2390);
// compiled call node returning call2391 (depth = 15)
// compiled member node returning call2391 (depth = 14)
  partcv[0] = 0;
  Object call2392 = callmethodflags(call2391, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2389);
// compiled call node returning call2392 (depth = 13)
// compiled member node returning call2392 (depth = 12)
  params[0] = call2386;
  params[1] = num2387;
  params[2] = strlit2388;
  partcv[0] = 3;
  Object call2393 = callmethodflags(call2392, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2383);
// compiled call node returning call2393 (depth = 11)
  int op_slot_right_2382 = gc_frame_newslot(call2393);
// starting to compile op node (depth = 11)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2396 == NULL) {
    strlit2396 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2396);
  }
// compiled string node returning strlit2396 (depth = 12)
  int op_slot_right_2395 = gc_frame_newslot(strlit2396);
// starting to compile op node (depth = 12)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2399 == NULL) {
    strlit2399 = alloc_String("written in the source code; ");
    gc_root(strlit2399);
  }
// compiled string node returning strlit2399 (depth = 13)
  int op_slot_right_2398 = gc_frame_newslot(strlit2399);
// starting to compile op node (depth = 13)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit2402 == NULL) {
    strlit2402 = alloc_String("is a control character and cannot be ");
    gc_root(strlit2402);
  }
// compiled string node returning strlit2402 (depth = 14)
  int op_slot_right_2401 = gc_frame_newslot(strlit2402);
// starting to compile op node (depth = 14)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 15)
  if (strlit2405 == NULL) {
    strlit2405 = alloc_String(") ");
    gc_root(strlit2405);
  }
// compiled string node returning strlit2405 (depth = 15)
  int op_slot_right_2404 = gc_frame_newslot(strlit2405);
// starting to compile op node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2408 = gc_frame_new();
// starting to compile call node (depth = 17)
  int callframe2409 = gc_frame_new();
// starting to compile num node (depth = 18)
  Object num2410 = alloc_Float64(16);
// compiled num node returning num2410 (depth = 18)
  gc_frame_newslot(num2410);
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_ordval (depth = 18)
  params[0] = num2410;
  partcv[0] = 1;
  Object call2411 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2409);
// compiled call node returning call2411 (depth = 17)
  gc_frame_newslot(call2411);
// starting to compile num node (depth = 17)
  Object num2412 = alloc_Float64(4);
// compiled num node returning num2412 (depth = 17)
  gc_frame_newslot(num2412);
// starting to compile string node (depth = 17)
  if (strlit2413 == NULL) {
    strlit2413 = alloc_String("0");
    gc_root(strlit2413);
  }
// compiled string node returning strlit2413 (depth = 17)
  gc_frame_newslot(strlit2413);
// call case 2: outer request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe2414 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 19)
// starting to compile call node (depth = 20)
  int callframe2415 = gc_frame_new();
// call case 3: self.outer request
  Object call2416 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2415);
// compiled call node returning call2416 (depth = 20)
// compiled member node returning call2416 (depth = 19)
  partcv[0] = 0;
  Object call2417 = callmethodflags(call2416, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2414);
// compiled call node returning call2417 (depth = 18)
// compiled member node returning call2417 (depth = 17)
  params[0] = call2411;
  params[1] = num2412;
  params[2] = strlit2413;
  partcv[0] = 3;
  Object call2418 = callmethodflags(call2417, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2408);
// compiled call node returning call2418 (depth = 16)
  int op_slot_right_2407 = gc_frame_newslot(call2418);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2421 == NULL) {
    strlit2421 = alloc_String(" (U+");
    gc_root(strlit2421);
  }
// compiled string node returning strlit2421 (depth = 17)
  int op_slot_right_2420 = gc_frame_newslot(strlit2421);
// starting to compile op node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe2424 = gc_frame_new();
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_unicode (depth = 19)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2425 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2424);
// compiled call node returning call2425 (depth = 18)
  int op_slot_right_2423 = gc_frame_newslot(call2425);
// starting to compile string node (depth = 18)
  if (strlit2427 == NULL) {
    strlit2427 = alloc_String("");
    gc_root(strlit2427);
  }
// compiled string node returning strlit2427 (depth = 18)
  int op_slot_left_2423 = gc_frame_newslot(strlit2427);
  params[0] = call2425;
  partcv[0] = 1;
  Object opresult2428 = callmethod(strlit2427, "++", 1, partcv, params);
// compiled op node returning opresult2428 (depth = 17)
  int op_slot_left_2420 = gc_frame_newslot(opresult2428);
  params[0] = strlit2421;
  partcv[0] = 1;
  Object opresult2429 = callmethod(opresult2428, "++", 1, partcv, params);
// compiled op node returning opresult2429 (depth = 16)
  int op_slot_left_2407 = gc_frame_newslot(opresult2429);
  params[0] = call2418;
  partcv[0] = 1;
  Object opresult2430 = callmethod(opresult2429, "++", 1, partcv, params);
// compiled op node returning opresult2430 (depth = 15)
  int op_slot_left_2404 = gc_frame_newslot(opresult2430);
  params[0] = strlit2405;
  partcv[0] = 1;
  Object opresult2431 = callmethod(opresult2430, "++", 1, partcv, params);
// compiled op node returning opresult2431 (depth = 14)
  int op_slot_left_2401 = gc_frame_newslot(opresult2431);
  params[0] = strlit2402;
  partcv[0] = 1;
  Object opresult2432 = callmethod(opresult2431, "++", 1, partcv, params);
// compiled op node returning opresult2432 (depth = 13)
  int op_slot_left_2398 = gc_frame_newslot(opresult2432);
  params[0] = strlit2399;
  partcv[0] = 1;
  Object opresult2433 = callmethod(opresult2432, "++", 1, partcv, params);
// compiled op node returning opresult2433 (depth = 12)
  int op_slot_left_2395 = gc_frame_newslot(opresult2433);
  params[0] = strlit2396;
  partcv[0] = 1;
  Object opresult2434 = callmethod(opresult2433, "++", 1, partcv, params);
// compiled op node returning opresult2434 (depth = 11)
  int op_slot_left_2382 = gc_frame_newslot(opresult2434);
  params[0] = call2393;
  partcv[0] = 1;
  Object opresult2435 = callmethod(opresult2434, "++", 1, partcv, params);
// compiled op node returning opresult2435 (depth = 10)
  int op_slot_left_2379 = gc_frame_newslot(opresult2435);
  params[0] = strlit2380;
  partcv[0] = 1;
  Object opresult2436 = callmethod(opresult2435, "++", 1, partcv, params);
// compiled op node returning opresult2436 (depth = 9)
  gc_frame_newslot(opresult2436);
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2436;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2437 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2378);
// compiled call node returning call2437 (depth = 8)
    gc_frame_newslot(call2437);
    if2356 = call2437;
  } else {
  }
// compiled if node returning if2356 (depth = 7)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2438 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_linePosition;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2439 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe2438);
// compiled call node returning call2439 (depth = 7)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2440 = gc_frame_new();
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2442 == NULL) {
    strlit2442 = alloc_String("is a control character and cannot be written in the source code; consider using spaces instead.");
    gc_root(strlit2442);
  }
// compiled string node returning strlit2442 (depth = 9)
  int op_slot_right_2441 = gc_frame_newslot(strlit2442);
// starting to compile op node (depth = 9)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2445 == NULL) {
    strlit2445 = alloc_String(") ");
    gc_root(strlit2445);
  }
// compiled string node returning strlit2445 (depth = 10)
  int op_slot_right_2444 = gc_frame_newslot(strlit2445);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2448 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2449 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2450 = alloc_Float64(16);
// compiled num node returning num2450 (depth = 13)
  gc_frame_newslot(num2450);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2450;
  partcv[0] = 1;
  Object call2451 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compiled call node returning call2451 (depth = 12)
  gc_frame_newslot(call2451);
// starting to compile num node (depth = 12)
  Object num2452 = alloc_Float64(4);
// compiled num node returning num2452 (depth = 12)
  gc_frame_newslot(num2452);
// starting to compile string node (depth = 12)
  if (strlit2453 == NULL) {
    strlit2453 = alloc_String("0");
    gc_root(strlit2453);
  }
// compiled string node returning strlit2453 (depth = 12)
  gc_frame_newslot(strlit2453);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2454 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2455 = gc_frame_new();
// call case 3: self.outer request
  Object call2456 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2455);
// compiled call node returning call2456 (depth = 15)
// compiled member node returning call2456 (depth = 14)
  partcv[0] = 0;
  Object call2457 = callmethodflags(call2456, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2454);
// compiled call node returning call2457 (depth = 13)
// compiled member node returning call2457 (depth = 12)
  params[0] = call2451;
  params[1] = num2452;
  params[2] = strlit2453;
  partcv[0] = 3;
  Object call2458 = callmethodflags(call2457, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2448);
// compiled call node returning call2458 (depth = 11)
  int op_slot_right_2447 = gc_frame_newslot(call2458);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String(" (U+");
    gc_root(strlit2461);
  }
// compiled string node returning strlit2461 (depth = 12)
  int op_slot_right_2460 = gc_frame_newslot(strlit2461);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2464 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2465 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2464);
// compiled call node returning call2465 (depth = 13)
  int op_slot_right_2463 = gc_frame_newslot(call2465);
// starting to compile string node (depth = 13)
  if (strlit2467 == NULL) {
    strlit2467 = alloc_String("");
    gc_root(strlit2467);
  }
// compiled string node returning strlit2467 (depth = 13)
  int op_slot_left_2463 = gc_frame_newslot(strlit2467);
  params[0] = call2465;
  partcv[0] = 1;
  Object opresult2468 = callmethod(strlit2467, "++", 1, partcv, params);
// compiled op node returning opresult2468 (depth = 12)
  int op_slot_left_2460 = gc_frame_newslot(opresult2468);
  params[0] = strlit2461;
  partcv[0] = 1;
  Object opresult2469 = callmethod(opresult2468, "++", 1, partcv, params);
// compiled op node returning opresult2469 (depth = 11)
  int op_slot_left_2447 = gc_frame_newslot(opresult2469);
  params[0] = call2458;
  partcv[0] = 1;
  Object opresult2470 = callmethod(opresult2469, "++", 1, partcv, params);
// compiled op node returning opresult2470 (depth = 10)
  int op_slot_left_2444 = gc_frame_newslot(opresult2470);
  params[0] = strlit2445;
  partcv[0] = 1;
  Object opresult2471 = callmethod(opresult2470, "++", 1, partcv, params);
// compiled op node returning opresult2471 (depth = 9)
  int op_slot_left_2441 = gc_frame_newslot(opresult2471);
  params[0] = strlit2442;
  partcv[0] = 1;
  Object opresult2472 = callmethod(opresult2471, "++", 1, partcv, params);
// compiled op node returning opresult2472 (depth = 8)
  gc_frame_newslot(opresult2472);
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2472;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2473 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2440);
// compiled call node returning call2473 (depth = 7)
    gc_frame_newslot(call2473);
    if2340 = call2473;
  } else {
  }
// compiled if node returning if2340 (depth = 6)
    gc_frame_newslot(if2340);
    if2138 = if2340;
  }
// compiled if node returning if2138 (depth = 5)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_atStart (depth = 6)
  Object if2474 = done;
  if (istrue(*var_atStart)) {
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2477 = alloc_Float64(1);
// compiled num node returning num2477 (depth = 8)
  int op_slot_right_2476 = gc_frame_newslot(num2477);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_2476 = gc_frame_newslot(*var_linePosition);
  params[0] = num2477;
  partcv[0] = 1;
  Object opresult2479 = callmethod(*var_linePosition, "==", 1, partcv, params);
// compiled op node returning opresult2479 (depth = 7)
  Object if2475 = done;
  if (istrue(opresult2479)) {
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2482 == NULL) {
    strlit2482 = alloc_String("#");
    gc_root(strlit2482);
  }
// compiled string node returning strlit2482 (depth = 9)
  int op_slot_right_2481 = gc_frame_newslot(strlit2482);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2481 = gc_frame_newslot(*var_c);
  params[0] = strlit2482;
  partcv[0] = 1;
  Object opresult2484 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2484 (depth = 8)
  Object if2480 = done;
  if (istrue(opresult2484)) {
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2485 == NULL) {
    strlit2485 = alloc_String("p");
    gc_root(strlit2485);
  }
// compiled string node returning strlit2485 (depth = 9)
  *var_mode = strlit2485;
  if (strlit2485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2480 = done;
  } else {
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2488 = alloc_Boolean(0);
// compiled identifier node returning bool2488 (depth = 9)
  *var_atStart = bool2488;
  if (bool2488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2480 = done;
  }
// compiled if node returning if2480 (depth = 7)
    gc_frame_newslot(if2480);
    if2475 = if2480;
  } else {
  }
// compiled if node returning if2475 (depth = 6)
    gc_frame_newslot(if2475);
    if2474 = if2475;
  } else {
  }
// compiled if node returning if2474 (depth = 5)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inStr (depth = 6)
  Object if2490 = done;
  if (istrue(*var_inStr)) {
    gc_frame_newslot(done);
    if2490 = done;
  } else {
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2494 == NULL) {
    strlit2494 = alloc_String("p");
    gc_root(strlit2494);
  }
// compiled string node returning strlit2494 (depth = 9)
  int op_slot_right_2493 = gc_frame_newslot(strlit2494);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2493 = gc_frame_newslot(*var_mode);
  params[0] = strlit2494;
  partcv[0] = 1;
  Object opresult2496 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2496 (depth = 8)
  int op_slot_right_2492 = gc_frame_newslot(opresult2496);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2499 == NULL) {
    strlit2499 = alloc_String("c");
    gc_root(strlit2499);
  }
// compiled string node returning strlit2499 (depth = 9)
  int op_slot_right_2498 = gc_frame_newslot(strlit2499);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2498 = gc_frame_newslot(*var_mode);
  params[0] = strlit2499;
  partcv[0] = 1;
  Object opresult2501 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2501 (depth = 8)
  int op_slot_left_2492 = gc_frame_newslot(opresult2501);
  params[0] = opresult2496;
  partcv[0] = 1;
  Object opresult2502 = callmethod(opresult2501, "&&", 1, partcv, params);
// compiled op node returning opresult2502 (depth = 7)
  Object if2491 = done;
  if (istrue(opresult2502)) {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2506 == NULL) {
    strlit2506 = alloc_String("d");
    gc_root(strlit2506);
  }
// compiled string node returning strlit2506 (depth = 10)
  int op_slot_right_2505 = gc_frame_newslot(strlit2506);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2505 = gc_frame_newslot(*var_mode);
  params[0] = strlit2506;
  partcv[0] = 1;
  Object opresult2508 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 9)
  int op_slot_right_2504 = gc_frame_newslot(opresult2508);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2511 == NULL) {
    strlit2511 = alloc_String(" ");
    gc_root(strlit2511);
  }
// compiled string node returning strlit2511 (depth = 10)
  int op_slot_right_2510 = gc_frame_newslot(strlit2511);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2510 = gc_frame_newslot(*var_c);
  params[0] = strlit2511;
  partcv[0] = 1;
  Object opresult2513 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2513 (depth = 9)
  int op_slot_left_2504 = gc_frame_newslot(opresult2513);
  params[0] = opresult2508;
  partcv[0] = 1;
  Object opresult2514 = callmethod(opresult2513, "&&", 1, partcv, params);
// compiled op node returning opresult2514 (depth = 8)
  Object if2503 = done;
  if (istrue(opresult2514)) {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2515 == NULL) {
    strlit2515 = alloc_String("n");
    gc_root(strlit2515);
  }
// compiled string node returning strlit2515 (depth = 9)
  *var_newmode = strlit2515;
  if (strlit2515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2503 = done;
  } else {
  }
// compiled if node returning if2503 (depth = 7)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2519 == NULL) {
    strlit2519 = alloc_String("""\x22""");
    gc_root(strlit2519);
  }
// compiled string node returning strlit2519 (depth = 9)
  int op_slot_right_2518 = gc_frame_newslot(strlit2519);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2518 = gc_frame_newslot(*var_c);
  params[0] = strlit2519;
  partcv[0] = 1;
  Object opresult2521 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2521 (depth = 8)
  Object if2517 = done;
  if (istrue(opresult2521)) {
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2522 == NULL) {
    strlit2522 = alloc_String("""\x22""");
    gc_root(strlit2522);
  }
// compiled string node returning strlit2522 (depth = 9)
  *var_newmode = strlit2522;
  if (strlit2522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2524 = alloc_Boolean(1);
// compiled identifier node returning bool2524 (depth = 9)
  *var_inStr = bool2524;
  if (bool2524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  *var_stringStart = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2517 = done;
  } else {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2529 == NULL) {
    strlit2529 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit2529);
  }
// compiled string node returning strlit2529 (depth = 10)
  int op_slot_right_2528 = gc_frame_newslot(strlit2529);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2528 = gc_frame_newslot(*var_c);
  params[0] = strlit2529;
  partcv[0] = 1;
  Object opresult2531 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2531 (depth = 9)
  Object if2527 = done;
  if (istrue(opresult2531)) {
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2532 == NULL) {
    strlit2532 = alloc_String("q");
    gc_root(strlit2532);
  }
// compiled string node returning strlit2532 (depth = 10)
  *var_newmode = strlit2532;
  if (strlit2532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool2534 = alloc_Boolean(1);
// compiled identifier node returning bool2534 (depth = 10)
  *var_inStr = bool2534;
  if (bool2534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  *var_startLine = *var_lineNumber;
  if (*var_lineNumber == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  *var_stringStart = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2527 = done;
  } else {
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2539 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_identifierChar (depth = 11)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2540 = callmethod(*var_identifierChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2539);
// compiled call node returning call2540 (depth = 10)
  Object if2538 = done;
  if (istrue(call2540)) {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2541 == NULL) {
    strlit2541 = alloc_String("i");
    gc_root(strlit2541);
  }
// compiled string node returning strlit2541 (depth = 11)
  *var_newmode = strlit2541;
  if (strlit2541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2538 = done;
  } else {
  }
// compiled if node returning if2538 (depth = 9)
    gc_frame_newslot(if2538);
    if2527 = if2538;
  }
// compiled if node returning if2527 (depth = 8)
    gc_frame_newslot(if2527);
    if2517 = if2527;
  }
// compiled if node returning if2517 (depth = 7)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2544 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_digit (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2545 = callmethod(*var_digit, "match",
    1, partcv, params);
  gc_frame_end(callframe2544);
// compiled call node returning call2545 (depth = 8)
  Object if2543 = done;
  if (istrue(call2545)) {
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2548 == NULL) {
    strlit2548 = alloc_String("i");
    gc_root(strlit2548);
  }
// compiled string node returning strlit2548 (depth = 10)
  int op_slot_right_2547 = gc_frame_newslot(strlit2548);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2547 = gc_frame_newslot(*var_mode);
  params[0] = strlit2548;
  partcv[0] = 1;
  Object opresult2550 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2550 (depth = 9)
  Object if2546 = done;
  if (istrue(opresult2550)) {
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2551 == NULL) {
    strlit2551 = alloc_String("m");
    gc_root(strlit2551);
  }
// compiled string node returning strlit2551 (depth = 10)
  *var_newmode = strlit2551;
  if (strlit2551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2546 = done;
  } else {
  }
// compiled if node returning if2546 (depth = 8)
    gc_frame_newslot(if2546);
    if2543 = if2546;
  } else {
  }
// compiled if node returning if2543 (depth = 7)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2555 == NULL) {
    strlit2555 = alloc_String("m");
    gc_root(strlit2555);
  }
// compiled string node returning strlit2555 (depth = 9)
  int op_slot_right_2554 = gc_frame_newslot(strlit2555);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2554 = gc_frame_newslot(*var_mode);
  params[0] = strlit2555;
  partcv[0] = 1;
  Object opresult2557 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2557 (depth = 8)
  Object if2553 = done;
  if (istrue(opresult2557)) {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2561 = alloc_Float64(122);
// compiled num node returning num2561 (depth = 11)
  int op_slot_right_2560 = gc_frame_newslot(num2561);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2560 = gc_frame_newslot(*var_ordval);
  params[0] = num2561;
  partcv[0] = 1;
  Object opresult2563 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2563 (depth = 10)
  int op_slot_right_2559 = gc_frame_newslot(opresult2563);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2566 = alloc_Float64(97);
// compiled num node returning num2566 (depth = 11)
  int op_slot_right_2565 = gc_frame_newslot(num2566);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2565 = gc_frame_newslot(*var_ordval);
  params[0] = num2566;
  partcv[0] = 1;
  Object opresult2568 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2568 (depth = 10)
  int op_slot_left_2559 = gc_frame_newslot(opresult2568);
  params[0] = opresult2563;
  partcv[0] = 1;
  Object opresult2569 = callmethod(opresult2568, "&&", 1, partcv, params);
// compiled op node returning opresult2569 (depth = 9)
  Object if2558 = done;
  if (istrue(opresult2569)) {
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2570 == NULL) {
    strlit2570 = alloc_String("m");
    gc_root(strlit2570);
  }
// compiled string node returning strlit2570 (depth = 10)
  *var_newmode = strlit2570;
  if (strlit2570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2558 = done;
  } else {
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2575 = alloc_Float64(90);
// compiled num node returning num2575 (depth = 12)
  int op_slot_right_2574 = gc_frame_newslot(num2575);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  int op_slot_left_2574 = gc_frame_newslot(*var_ordval);
  params[0] = num2575;
  partcv[0] = 1;
  Object opresult2577 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2577 (depth = 11)
  int op_slot_right_2573 = gc_frame_newslot(opresult2577);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2580 = alloc_Float64(65);
// compiled num node returning num2580 (depth = 12)
  int op_slot_right_2579 = gc_frame_newslot(num2580);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  int op_slot_left_2579 = gc_frame_newslot(*var_ordval);
  params[0] = num2580;
  partcv[0] = 1;
  Object opresult2582 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 11)
  int op_slot_left_2573 = gc_frame_newslot(opresult2582);
  params[0] = opresult2577;
  partcv[0] = 1;
  Object opresult2583 = callmethod(opresult2582, "&&", 1, partcv, params);
// compiled op node returning opresult2583 (depth = 10)
  Object if2572 = done;
  if (istrue(opresult2583)) {
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2584 == NULL) {
    strlit2584 = alloc_String("m");
    gc_root(strlit2584);
  }
// compiled string node returning strlit2584 (depth = 11)
  *var_newmode = strlit2584;
  if (strlit2584 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2572 = done;
  } else {
  }
// compiled if node returning if2572 (depth = 9)
    gc_frame_newslot(if2572);
    if2558 = if2572;
  }
// compiled if node returning if2558 (depth = 8)
    gc_frame_newslot(if2558);
    if2553 = if2558;
  } else {
  }
// compiled if node returning if2553 (depth = 7)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2589 == NULL) {
    strlit2589 = alloc_String("<");
    gc_root(strlit2589);
  }
// compiled string node returning strlit2589 (depth = 10)
  int op_slot_right_2588 = gc_frame_newslot(strlit2589);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2588 = gc_frame_newslot(*var_c);
  params[0] = strlit2589;
  partcv[0] = 1;
  Object opresult2591 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2591 (depth = 9)
  int op_slot_right_2587 = gc_frame_newslot(opresult2591);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2594 == NULL) {
    strlit2594 = alloc_String("i");
    gc_root(strlit2594);
  }
// compiled string node returning strlit2594 (depth = 10)
  int op_slot_right_2593 = gc_frame_newslot(strlit2594);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2593 = gc_frame_newslot(*var_mode);
  params[0] = strlit2594;
  partcv[0] = 1;
  Object opresult2596 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2596 (depth = 9)
  int op_slot_left_2587 = gc_frame_newslot(opresult2596);
  params[0] = opresult2591;
  partcv[0] = 1;
  Object opresult2597 = callmethod(opresult2596, "&&", 1, partcv, params);
// compiled op node returning opresult2597 (depth = 8)
  Object if2586 = done;
  if (istrue(opresult2597)) {
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2598 == NULL) {
    strlit2598 = alloc_String("<");
    gc_root(strlit2598);
  }
// compiled string node returning strlit2598 (depth = 9)
  *var_newmode = strlit2598;
  if (strlit2598 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2586 = done;
  } else {
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2603 == NULL) {
    strlit2603 = alloc_String(">");
    gc_root(strlit2603);
  }
// compiled string node returning strlit2603 (depth = 11)
  int op_slot_right_2602 = gc_frame_newslot(strlit2603);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_2602 = gc_frame_newslot(*var_c);
  params[0] = strlit2603;
  partcv[0] = 1;
  Object opresult2605 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2605 (depth = 10)
  int op_slot_right_2601 = gc_frame_newslot(opresult2605);
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2607 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_iGTLT (depth = 11)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2608 = callmethod(*var_iGTLT, "match",
    1, partcv, params);
  gc_frame_end(callframe2607);
// compiled call node returning call2608 (depth = 10)
  int op_slot_left_2601 = gc_frame_newslot(call2608);
  params[0] = opresult2605;
  partcv[0] = 1;
  Object opresult2609 = callmethod(call2608, "&&", 1, partcv, params);
// compiled op node returning opresult2609 (depth = 9)
  Object if2600 = done;
  if (istrue(opresult2609)) {
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2612 == NULL) {
    strlit2612 = alloc_String(">");
    gc_root(strlit2612);
  }
// compiled string node returning strlit2612 (depth = 11)
  int op_slot_right_2611 = gc_frame_newslot(strlit2612);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_2611 = gc_frame_newslot(*var_mode);
  params[0] = strlit2612;
  partcv[0] = 1;
  Object opresult2614 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2614 (depth = 10)
  Object if2610 = done;
  if (istrue(opresult2614)) {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2615 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2616 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2615);
// compiled call node returning call2616 (depth = 10)
    gc_frame_newslot(call2616);
    if2610 = call2616;
  } else {
  }
// compiled if node returning if2610 (depth = 9)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2617 == NULL) {
    strlit2617 = alloc_String(">");
    gc_root(strlit2617);
  }
// compiled string node returning strlit2617 (depth = 10)
  *var_newmode = strlit2617;
  if (strlit2617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2600 = done;
  } else {
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2620 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_operatorChar (depth = 11)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2621 = callmethod(*var_operatorChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2620);
// compiled call node returning call2621 (depth = 10)
  Object if2619 = done;
  if (istrue(call2621)) {
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2622 == NULL) {
    strlit2622 = alloc_String("o");
    gc_root(strlit2622);
  }
// compiled string node returning strlit2622 (depth = 11)
  *var_newmode = strlit2622;
  if (strlit2622 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2619 = done;
  } else {
  }
// compiled if node returning if2619 (depth = 9)
    gc_frame_newslot(if2619);
    if2600 = if2619;
  }
// compiled if node returning if2600 (depth = 8)
    gc_frame_newslot(if2600);
    if2586 = if2600;
  }
// compiled if node returning if2586 (depth = 7)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2625 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfModes (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2626 = callmethod(*var_selfModes, "match",
    1, partcv, params);
  gc_frame_end(callframe2625);
// compiled call node returning call2626 (depth = 8)
  Object if2624 = done;
  if (istrue(call2626)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  *var_newmode = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2624 = done;
  } else {
  }
// compiled if node returning if2624 (depth = 7)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2630 == NULL) {
    strlit2630 = alloc_String("#");
    gc_root(strlit2630);
  }
// compiled string node returning strlit2630 (depth = 9)
  int op_slot_right_2629 = gc_frame_newslot(strlit2630);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2629 = gc_frame_newslot(*var_c);
  params[0] = strlit2630;
  partcv[0] = 1;
  Object opresult2632 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2632 (depth = 8)
  Object if2628 = done;
  if (istrue(opresult2632)) {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2635 == NULL) {
    strlit2635 = alloc_String("p");
    gc_root(strlit2635);
  }
// compiled string node returning strlit2635 (depth = 10)
  int op_slot_right_2634 = gc_frame_newslot(strlit2635);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2634 = gc_frame_newslot(*var_mode);
  params[0] = strlit2635;
  partcv[0] = 1;
  Object opresult2637 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2637 (depth = 9)
  Object if2633 = done;
  if (istrue(opresult2637)) {
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2640 == NULL) {
    strlit2640 = alloc_String("#pragma");
    gc_root(strlit2640);
  }
// compiled string node returning strlit2640 (depth = 11)
  int op_slot_right_2639 = gc_frame_newslot(strlit2640);
// starting to compile call node (depth = 11)
  int callframe2642 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2643 = alloc_Float64(1);
// compiled num node returning num2643 (depth = 12)
  gc_frame_newslot(num2643);
// starting to compile num node (depth = 12)
  Object num2644 = alloc_Float64(7);
// compiled num node returning num2644 (depth = 12)
  gc_frame_newslot(num2644);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2645 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2647 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2646);
// compiled call node returning call2647 (depth = 14)
// compiled member node returning call2647 (depth = 13)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2648 = callmethod(call2647, "at",
    1, partcv, params);
  gc_frame_end(callframe2645);
// compiled call node returning call2648 (depth = 12)
  params[0] = num2643;
  params[1] = num2644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2649 = callmethod(call2648, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2642);
// compiled call node returning call2649 (depth = 11)
  int op_slot_left_2639 = gc_frame_newslot(call2649);
  params[0] = strlit2640;
  partcv[0] = 1;
  Object opresult2650 = callmethod(call2649, "==", 1, partcv, params);
// compiled op node returning opresult2650 (depth = 10)
  Object if2638 = done;
  if (istrue(opresult2650)) {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2653 = alloc_Float64(0);
// compiled num node returning num2653 (depth = 12)
  int op_slot_right_2652 = gc_frame_newslot(num2653);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call2656 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe2655);
// compiled call node returning call2656 (depth = 13)
// compiled member node returning call2656 (depth = 12)
  int op_slot_left_2652 = gc_frame_newslot(call2656);
  params[0] = num2653;
  partcv[0] = 1;
  Object opresult2657 = callmethod(call2656, "==", 1, partcv, params);
// compiled op node returning opresult2657 (depth = 11)
  Object if2651 = done;
  if (istrue(opresult2657)) {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 11)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2658 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  partcv[0] = 0;
  Object call2660 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2659);
// compiled call node returning call2660 (depth = 15)
// compiled member node returning call2660 (depth = 14)
  partcv[0] = 0;
  Object call2661 = callmethod(call2660, "new",
    1, partcv, params);
  gc_frame_end(callframe2658);
// compiled call node returning call2661 (depth = 13)
// compiled member node returning call2661 (depth = 12)
  *var_suggestion = call2661;
  if (call2661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 11)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2662 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2663 = alloc_Float64(1);
// compiled num node returning num2663 (depth = 12)
  gc_frame_newslot(num2663);
// starting to compile call node (depth = 12)
  int callframe2664 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2666 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2665);
// compiled call node returning call2666 (depth = 14)
// compiled member node returning call2666 (depth = 13)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2667 = callmethod(call2666, "at",
    1, partcv, params);
  gc_frame_end(callframe2664);
// compiled call node returning call2667 (depth = 12)
  gc_frame_newslot(call2667);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = num2663;
  params[1] = call2667;
  partcv[0] = 2;
  Object call2668 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2662);
// compiled call node returning call2668 (depth = 11)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2669 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 12)
  if (strlit2670 == NULL) {
    strlit2670 = alloc_String("");
    gc_root(strlit2670);
  }
// compiled string node returning strlit2670 (depth = 12)
  gc_frame_newslot(strlit2670);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = *var_lineNumber;
  params[1] = strlit2670;
  partcv[0] = 2;
  Object call2671 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2669);
// compiled call node returning call2671 (depth = 11)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2672 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2673 == NULL) {
    strlit2673 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2673);
  }
// compiled string node returning strlit2673 (depth = 12)
  gc_frame_newslot(strlit2673);
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = strlit2673;
  params[1] = *var_lineNumber;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2674 = callmethod(*var_errormessages, "syntaxError()atLine()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2672);
// compiled call node returning call2674 (depth = 11)
    gc_frame_newslot(call2674);
    if2651 = call2674;
  } else {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2675 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2676 == NULL) {
    strlit2676 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2676);
  }
// compiled string node returning strlit2676 (depth = 12)
  gc_frame_newslot(strlit2676);
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = strlit2676;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2677 = callmethod(*var_errormessages, "syntaxError()atLine",
    2, partcv, params);
  gc_frame_end(callframe2675);
// compiled call node returning call2677 (depth = 11)
    gc_frame_newslot(call2677);
    if2651 = call2677;
  }
// compiled if node returning if2651 (depth = 10)
    gc_frame_newslot(if2651);
    if2638 = if2651;
  } else {
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2678 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call2680 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2679);
// compiled call node returning call2680 (depth = 14)
// compiled member node returning call2680 (depth = 13)
  partcv[0] = 0;
  Object call2681 = callmethod(call2680, "new",
    1, partcv, params);
  gc_frame_end(callframe2678);
// compiled call node returning call2681 (depth = 12)
// compiled member node returning call2681 (depth = 11)
  *var_suggestion = call2681;
  if (call2681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2682 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 11)
  if (strlit2683 == NULL) {
    strlit2683 = alloc_String("//");
    gc_root(strlit2683);
  }
// compiled string node returning strlit2683 (depth = 11)
  gc_frame_newslot(strlit2683);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_linePosition;
  params[1] = strlit2683;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2684 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2682);
// compiled call node returning call2684 (depth = 10)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2685 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2686 == NULL) {
    strlit2686 = alloc_String("'#' is not allowed here. For a comment use '//'.");
    gc_root(strlit2686);
  }
// compiled string node returning strlit2686 (depth = 11)
  gc_frame_newslot(strlit2686);
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2686;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2687 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2685);
// compiled call node returning call2687 (depth = 10)
    gc_frame_newslot(call2687);
    if2638 = call2687;
  }
// compiled if node returning if2638 (depth = 9)
    gc_frame_newslot(if2638);
    if2633 = if2638;
  } else {
  }
// compiled if node returning if2633 (depth = 8)
    gc_frame_newslot(if2633);
    if2628 = if2633;
  } else {
  }
// compiled if node returning if2628 (depth = 7)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2690 == NULL) {
    strlit2690 = alloc_String(".");
    gc_root(strlit2690);
  }
// compiled string node returning strlit2690 (depth = 9)
  int op_slot_right_2689 = gc_frame_newslot(strlit2690);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2689 = gc_frame_newslot(*var_c);
  params[0] = strlit2690;
  partcv[0] = 1;
  Object opresult2692 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2692 (depth = 8)
  Object if2688 = done;
  if (istrue(opresult2692)) {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2695 == NULL) {
    strlit2695 = alloc_String(".");
    gc_root(strlit2695);
  }
// compiled string node returning strlit2695 (depth = 10)
  int op_slot_right_2694 = gc_frame_newslot(strlit2695);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2694 = gc_frame_newslot(*var_accum);
  params[0] = strlit2695;
  partcv[0] = 1;
  Object opresult2697 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2697 (depth = 9)
  Object if2693 = done;
  if (istrue(opresult2697)) {
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2698 == NULL) {
    strlit2698 = alloc_String("o");
    gc_root(strlit2698);
  }
// compiled string node returning strlit2698 (depth = 10)
  *var_mode = strlit2698;
  if (strlit2698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2693 = done;
  } else {
  }
// compiled if node returning if2693 (depth = 8)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2703 == NULL) {
    strlit2703 = alloc_String("..");
    gc_root(strlit2703);
  }
// compiled string node returning strlit2703 (depth = 10)
  int op_slot_right_2702 = gc_frame_newslot(strlit2703);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2702 = gc_frame_newslot(*var_accum);
  params[0] = strlit2703;
  partcv[0] = 1;
  Object opresult2705 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2705 (depth = 9)
  Object if2701 = done;
  if (istrue(opresult2705)) {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2706 == NULL) {
    strlit2706 = alloc_String("n");
    gc_root(strlit2706);
  }
// compiled string node returning strlit2706 (depth = 10)
  *var_mode = strlit2706;
  if (strlit2706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2709 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 10)
  if (strlit2710 == NULL) {
    strlit2710 = alloc_String("i");
    gc_root(strlit2710);
  }
// compiled string node returning strlit2710 (depth = 10)
  gc_frame_newslot(strlit2710);
// starting to compile string node (depth = 10)
  if (strlit2711 == NULL) {
    strlit2711 = alloc_String("...");
    gc_root(strlit2711);
  }
// compiled string node returning strlit2711 (depth = 10)
  gc_frame_newslot(strlit2711);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2710;
  params[2] = strlit2711;
  partcv[0] = 3;
  Object call2712 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2709);
// compiled call node returning call2712 (depth = 9)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2713 == NULL) {
    strlit2713 = alloc_String("");
    gc_root(strlit2713);
  }
// compiled string node returning strlit2713 (depth = 10)
  *var_accum = strlit2713;
  if (strlit2713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2701 = done;
  } else {
  }
// compiled if node returning if2701 (depth = 8)
    gc_frame_newslot(if2701);
    if2688 = if2701;
  } else {
  }
// compiled if node returning if2688 (depth = 7)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2717 == NULL) {
    strlit2717 = alloc_String("/");
    gc_root(strlit2717);
  }
// compiled string node returning strlit2717 (depth = 9)
  int op_slot_right_2716 = gc_frame_newslot(strlit2717);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2716 = gc_frame_newslot(*var_c);
  params[0] = strlit2717;
  partcv[0] = 1;
  Object opresult2719 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2719 (depth = 8)
  Object if2715 = done;
  if (istrue(opresult2719)) {
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2722 == NULL) {
    strlit2722 = alloc_String("/");
    gc_root(strlit2722);
  }
// compiled string node returning strlit2722 (depth = 10)
  int op_slot_right_2721 = gc_frame_newslot(strlit2722);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2721 = gc_frame_newslot(*var_accum);
  params[0] = strlit2722;
  partcv[0] = 1;
  Object opresult2724 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2724 (depth = 9)
  Object if2720 = done;
  if (istrue(opresult2724)) {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2725 == NULL) {
    strlit2725 = alloc_String("c");
    gc_root(strlit2725);
  }
// compiled string node returning strlit2725 (depth = 10)
  *var_mode = strlit2725;
  if (strlit2725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2720 = done;
  } else {
  }
// compiled if node returning if2720 (depth = 8)
    gc_frame_newslot(if2720);
    if2715 = if2720;
  } else {
  }
// compiled if node returning if2715 (depth = 7)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("n");
    gc_root(strlit2730);
  }
// compiled string node returning strlit2730 (depth = 9)
  int op_slot_right_2729 = gc_frame_newslot(strlit2730);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2729 = gc_frame_newslot(*var_mode);
  params[0] = strlit2730;
  partcv[0] = 1;
  Object opresult2732 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2732 (depth = 8)
  Object if2728 = done;
  if (istrue(opresult2732)) {
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_newmode (depth = 10)
  int op_slot_right_2734 = gc_frame_newslot(*var_newmode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2734 = gc_frame_newslot(*var_mode);
  params[0] = *var_newmode;
  partcv[0] = 1;
  Object opresult2736 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2736 (depth = 9)
  Object if2733 = done;
  if (istrue(opresult2736)) {
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2738 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2739 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2740 = callmethod(*var_unicode, "isSeparator",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compiled call node returning call2740 (depth = 12)
  partcv[0] = 0;
  Object call2741 = callmethod(call2740, "not",
    1, partcv, params);
  gc_frame_end(callframe2738);
// compiled call node returning call2741 (depth = 11)
// compiled member node returning call2741 (depth = 10)
  Object if2737 = done;
  if (istrue(call2741)) {
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2743 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 13)
  int callframe2744 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2745 = callmethod(*var_unicode, "isControl",
    1, partcv, params);
  gc_frame_end(callframe2744);
// compiled call node returning call2745 (depth = 13)
  partcv[0] = 0;
  Object call2746 = callmethod(call2745, "not",
    1, partcv, params);
  gc_frame_end(callframe2743);
// compiled call node returning call2746 (depth = 12)
// compiled member node returning call2746 (depth = 11)
  Object if2742 = done;
  if (istrue(call2746)) {
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2749 = alloc_Float64(10);
// compiled num node returning num2749 (depth = 13)
  int op_slot_right_2748 = gc_frame_newslot(num2749);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  int op_slot_left_2748 = gc_frame_newslot(*var_ordval);
  params[0] = num2749;
  partcv[0] = 1;
  Object opresult2751 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2751 (depth = 12)
  Object if2747 = done;
  if (istrue(opresult2751)) {
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num2754 = alloc_Float64(13);
// compiled num node returning num2754 (depth = 14)
  int op_slot_right_2753 = gc_frame_newslot(num2754);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  int op_slot_left_2753 = gc_frame_newslot(*var_ordval);
  params[0] = num2754;
  partcv[0] = 1;
  Object opresult2756 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2756 (depth = 13)
  Object if2752 = done;
  if (istrue(opresult2756)) {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num2759 = alloc_Float64(32);
// compiled num node returning num2759 (depth = 15)
  int op_slot_right_2758 = gc_frame_newslot(num2759);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_ordval (depth = 15)
  int op_slot_left_2758 = gc_frame_newslot(*var_ordval);
  params[0] = num2759;
  partcv[0] = 1;
  Object opresult2761 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2761 (depth = 14)
  Object if2757 = done;
  if (istrue(opresult2761)) {
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit2764 == NULL) {
    strlit2764 = alloc_String(".");
    gc_root(strlit2764);
  }
// compiled string node returning strlit2764 (depth = 16)
  int op_slot_right_2763 = gc_frame_newslot(strlit2764);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_2763 = gc_frame_newslot(*var_c);
  params[0] = strlit2764;
  partcv[0] = 1;
  Object opresult2766 = callmethod(*var_c, "!=", 1, partcv, params);
// compiled op node returning opresult2766 (depth = 15)
  Object if2762 = done;
  if (istrue(opresult2766)) {
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe2767 = gc_frame_new();
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2769 == NULL) {
    strlit2769 = alloc_String("is not a valid character; use spaces instead.");
    gc_root(strlit2769);
  }
// compiled string node returning strlit2769 (depth = 17)
  int op_slot_right_2768 = gc_frame_newslot(strlit2769);
// starting to compile op node (depth = 17)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String(") ");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 18)
  int op_slot_right_2771 = gc_frame_newslot(strlit2772);
// starting to compile op node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2775 = gc_frame_new();
// starting to compile call node (depth = 20)
  int callframe2776 = gc_frame_new();
// starting to compile num node (depth = 21)
  Object num2777 = alloc_Float64(16);
// compiled num node returning num2777 (depth = 21)
  gc_frame_newslot(num2777);
// call case 6: other member request
// starting to compile identifier node (depth = 21)
// compiled identifier node returning *var_ordval (depth = 21)
  params[0] = num2777;
  partcv[0] = 1;
  Object call2778 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2776);
// compiled call node returning call2778 (depth = 20)
  gc_frame_newslot(call2778);
// starting to compile num node (depth = 20)
  Object num2779 = alloc_Float64(4);
// compiled num node returning num2779 (depth = 20)
  gc_frame_newslot(num2779);
// starting to compile string node (depth = 20)
  if (strlit2780 == NULL) {
    strlit2780 = alloc_String("0");
    gc_root(strlit2780);
  }
// compiled string node returning strlit2780 (depth = 20)
  gc_frame_newslot(strlit2780);
// call case 2: outer request
// starting to compile member node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2781 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 22)
// starting to compile call node (depth = 23)
  int callframe2782 = gc_frame_new();
// call case 3: self.outer request
  Object call2783 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2782);
// compiled call node returning call2783 (depth = 23)
// compiled member node returning call2783 (depth = 22)
  partcv[0] = 0;
  Object call2784 = callmethodflags(call2783, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2781);
// compiled call node returning call2784 (depth = 21)
// compiled member node returning call2784 (depth = 20)
  params[0] = call2778;
  params[1] = num2779;
  params[2] = strlit2780;
  partcv[0] = 3;
  Object call2785 = callmethodflags(call2784, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2775);
// compiled call node returning call2785 (depth = 19)
  int op_slot_right_2774 = gc_frame_newslot(call2785);
// starting to compile op node (depth = 19)
// starting to compile string node (depth = 20)
  if (strlit2788 == NULL) {
    strlit2788 = alloc_String(" (U+");
    gc_root(strlit2788);
  }
// compiled string node returning strlit2788 (depth = 20)
  int op_slot_right_2787 = gc_frame_newslot(strlit2788);
// starting to compile op node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2791 = gc_frame_new();
// starting to compile identifier node (depth = 22)
// compiled identifier node returning *var_c (depth = 22)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 22)
// compiled identifier node returning *var_unicode (depth = 22)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2792 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2791);
// compiled call node returning call2792 (depth = 21)
  int op_slot_right_2790 = gc_frame_newslot(call2792);
// starting to compile string node (depth = 21)
  if (strlit2794 == NULL) {
    strlit2794 = alloc_String("");
    gc_root(strlit2794);
  }
// compiled string node returning strlit2794 (depth = 21)
  int op_slot_left_2790 = gc_frame_newslot(strlit2794);
  params[0] = call2792;
  partcv[0] = 1;
  Object opresult2795 = callmethod(strlit2794, "++", 1, partcv, params);
// compiled op node returning opresult2795 (depth = 20)
  int op_slot_left_2787 = gc_frame_newslot(opresult2795);
  params[0] = strlit2788;
  partcv[0] = 1;
  Object opresult2796 = callmethod(opresult2795, "++", 1, partcv, params);
// compiled op node returning opresult2796 (depth = 19)
  int op_slot_left_2774 = gc_frame_newslot(opresult2796);
  params[0] = call2785;
  partcv[0] = 1;
  Object opresult2797 = callmethod(opresult2796, "++", 1, partcv, params);
// compiled op node returning opresult2797 (depth = 18)
  int op_slot_left_2771 = gc_frame_newslot(opresult2797);
  params[0] = strlit2772;
  partcv[0] = 1;
  Object opresult2798 = callmethod(opresult2797, "++", 1, partcv, params);
// compiled op node returning opresult2798 (depth = 17)
  int op_slot_left_2768 = gc_frame_newslot(opresult2798);
  params[0] = strlit2769;
  partcv[0] = 1;
  Object opresult2799 = callmethod(opresult2798, "++", 1, partcv, params);
// compiled op node returning opresult2799 (depth = 16)
  gc_frame_newslot(opresult2799);
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lineNumber (depth = 16)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  params[0] = opresult2799;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2800 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe2767);
// compiled call node returning call2800 (depth = 15)
    gc_frame_newslot(call2800);
    if2762 = call2800;
  } else {
  }
// compiled if node returning if2762 (depth = 14)
    gc_frame_newslot(if2762);
    if2757 = if2762;
  } else {
  }
// compiled if node returning if2757 (depth = 13)
    gc_frame_newslot(if2757);
    if2752 = if2757;
  } else {
  }
// compiled if node returning if2752 (depth = 12)
    gc_frame_newslot(if2752);
    if2747 = if2752;
  } else {
  }
// compiled if node returning if2747 (depth = 11)
    gc_frame_newslot(if2747);
    if2742 = if2747;
  } else {
  }
// compiled if node returning if2742 (depth = 10)
    gc_frame_newslot(if2742);
    if2737 = if2742;
  } else {
  }
// compiled if node returning if2737 (depth = 9)
    gc_frame_newslot(if2737);
    if2733 = if2737;
  } else {
  }
// compiled if node returning if2733 (depth = 8)
    gc_frame_newslot(if2733);
    if2728 = if2733;
  } else {
  }
// compiled if node returning if2728 (depth = 7)
    gc_frame_newslot(if2728);
    if2491 = if2728;
  } else {
  }
// compiled if node returning if2491 (depth = 6)
    gc_frame_newslot(if2491);
    if2490 = if2491;
  }
// compiled if node returning if2490 (depth = 5)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2803 == NULL) {
    strlit2803 = alloc_String("""\x22""");
    gc_root(strlit2803);
  }
// compiled string node returning strlit2803 (depth = 7)
  int op_slot_right_2802 = gc_frame_newslot(strlit2803);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_2802 = gc_frame_newslot(*var_mode);
  params[0] = strlit2803;
  partcv[0] = 1;
  Object opresult2805 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2805 (depth = 6)
  Object if2801 = done;
  if (istrue(opresult2805)) {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2808 == NULL) {
    strlit2808 = alloc_String("""\x22""");
    gc_root(strlit2808);
  }
// compiled string node returning strlit2808 (depth = 8)
  int op_slot_right_2807 = gc_frame_newslot(strlit2808);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2807 = gc_frame_newslot(*var_c);
  params[0] = strlit2808;
  partcv[0] = 1;
  Object opresult2810 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2810 (depth = 7)
  Object if2806 = done;
  if (istrue(opresult2810)) {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_escaped (depth = 10)
  partcv[0] = 0;
  Object call2813 = callmethod(*var_escaped, "not",
    1, partcv, params);
  gc_frame_end(callframe2812);
// compiled call node returning call2813 (depth = 9)
// compiled member node returning call2813 (depth = 8)
  Object if2811 = done;
  if (istrue(call2813)) {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2814 == NULL) {
    strlit2814 = alloc_String("n");
    gc_root(strlit2814);
  }
// compiled string node returning strlit2814 (depth = 9)
  *var_newmode = strlit2814;
  if (strlit2814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2816 = alloc_Boolean(0);
// compiled identifier node returning bool2816 (depth = 9)
  *var_inStr = bool2816;
  if (bool2816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_interpString (depth = 9)
  Object if2818 = done;
  if (istrue(*var_interpString)) {
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2819 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2820 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2819);
// compiled call node returning call2820 (depth = 9)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2821 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 10)
  if (strlit2822 == NULL) {
    strlit2822 = alloc_String(")");
    gc_root(strlit2822);
  }
// compiled string node returning strlit2822 (depth = 10)
  gc_frame_newslot(strlit2822);
// starting to compile string node (depth = 10)
  if (strlit2823 == NULL) {
    strlit2823 = alloc_String(")");
    gc_root(strlit2823);
  }
// compiled string node returning strlit2823 (depth = 10)
  gc_frame_newslot(strlit2823);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2822;
  params[2] = strlit2823;
  partcv[0] = 3;
  Object call2824 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2821);
// compiled call node returning call2824 (depth = 9)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_newmode (depth = 10)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool2826 = alloc_Boolean(0);
// compiled identifier node returning bool2826 (depth = 10)
  *var_interpString = bool2826;
  if (bool2826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2818 = done;
  } else {
  }
// compiled if node returning if2818 (depth = 8)
    gc_frame_newslot(if2818);
    if2811 = if2818;
  } else {
  }
// compiled if node returning if2811 (depth = 7)
    gc_frame_newslot(if2811);
    if2806 = if2811;
  } else {
  }
// compiled if node returning if2806 (depth = 6)
    gc_frame_newslot(if2806);
    if2801 = if2806;
  } else {
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2830 == NULL) {
    strlit2830 = alloc_String("q");
    gc_root(strlit2830);
  }
// compiled string node returning strlit2830 (depth = 8)
  int op_slot_right_2829 = gc_frame_newslot(strlit2830);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2829 = gc_frame_newslot(*var_mode);
  params[0] = strlit2830;
  partcv[0] = 1;
  Object opresult2832 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2832 (depth = 7)
  Object if2828 = done;
  if (istrue(opresult2832)) {
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2835 == NULL) {
    strlit2835 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit2835);
  }
// compiled string node returning strlit2835 (depth = 9)
  int op_slot_right_2834 = gc_frame_newslot(strlit2835);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2834 = gc_frame_newslot(*var_c);
  params[0] = strlit2835;
  partcv[0] = 1;
  Object opresult2837 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2837 (depth = 8)
  Object if2833 = done;
  if (istrue(opresult2837)) {
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2838 == NULL) {
    strlit2838 = alloc_String("n");
    gc_root(strlit2838);
  }
// compiled string node returning strlit2838 (depth = 9)
  *var_newmode = strlit2838;
  if (strlit2838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2840 = alloc_Boolean(0);
// compiled identifier node returning bool2840 (depth = 9)
  *var_inStr = bool2840;
  if (bool2840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2833 = done;
  } else {
  }
// compiled if node returning if2833 (depth = 7)
    gc_frame_newslot(if2833);
    if2828 = if2833;
  } else {
  }
// compiled if node returning if2828 (depth = 6)
    gc_frame_newslot(if2828);
    if2801 = if2828;
  }
// compiled if node returning if2801 (depth = 5)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_right_2843 = gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newmode (depth = 7)
  int op_slot_left_2843 = gc_frame_newslot(*var_newmode);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult2845 = callmethod(*var_newmode, "!=", 1, partcv, params);
// compiled op node returning opresult2845 (depth = 6)
  Object if2842 = done;
  if (istrue(opresult2845)) {
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2846 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2847 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2846);
// compiled call node returning call2847 (depth = 6)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2850 = alloc_Float64(0);
// compiled num node returning num2850 (depth = 8)
  int op_slot_right_2849 = gc_frame_newslot(num2850);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_interpdepth (depth = 8)
  int op_slot_left_2849 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2850;
  partcv[0] = 1;
  Object opresult2852 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult2852 (depth = 7)
  Object if2848 = done;
  if (istrue(opresult2852)) {
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2855 == NULL) {
    strlit2855 = alloc_String("}");
    gc_root(strlit2855);
  }
// compiled string node returning strlit2855 (depth = 9)
  int op_slot_right_2854 = gc_frame_newslot(strlit2855);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newmode (depth = 9)
  int op_slot_left_2854 = gc_frame_newslot(*var_newmode);
  params[0] = strlit2855;
  partcv[0] = 1;
  Object opresult2857 = callmethod(*var_newmode, "==", 1, partcv, params);
// compiled op node returning opresult2857 (depth = 8)
  Object if2853 = done;
  if (istrue(opresult2857)) {
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2860 == NULL) {
    strlit2860 = alloc_String("{");
    gc_root(strlit2860);
  }
// compiled string node returning strlit2860 (depth = 10)
  int op_slot_right_2859 = gc_frame_newslot(strlit2860);
// starting to compile index node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2862 = gc_frame_new();
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2863 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call2865 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2864);
// compiled call node returning call2865 (depth = 15)
// compiled member node returning call2865 (depth = 14)
  partcv[0] = 0;
  Object call2866 = callmethod(call2865, "line",
    1, partcv, params);
  gc_frame_end(callframe2863);
// compiled call node returning call2866 (depth = 13)
// compiled member node returning call2866 (depth = 12)
  gc_frame_newslot(call2866);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2867 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call2868 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2867);
// compiled call node returning call2868 (depth = 13)
// compiled member node returning call2868 (depth = 12)
  params[0] = call2866;
  partcv[0] = 1;
  Object call2869 = callmethod(call2868, "at",
    1, partcv, params);
  gc_frame_end(callframe2862);
// compiled call node returning call2869 (depth = 11)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2870 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  partcv[0] = 0;
  Object call2872 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2871);
// compiled call node returning call2872 (depth = 14)
// compiled member node returning call2872 (depth = 13)
  partcv[0] = 0;
  Object call2873 = callmethod(call2872, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2870);
// compiled call node returning call2873 (depth = 12)
// compiled member node returning call2873 (depth = 11)
  params[0] = call2873;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2874 = callmethod(call2869, "[]", 1, partcv, params);
// compiled index node returning idxres2874 (depth = 10)
  int op_slot_left_2859 = gc_frame_newslot(idxres2874);
  params[0] = strlit2860;
  partcv[0] = 1;
  Object opresult2875 = callmethod(idxres2874, "==", 1, partcv, params);
// compiled op node returning opresult2875 (depth = 9)
  Object if2858 = done;
  if (istrue(opresult2875)) {
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2876 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2877 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2878 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2877);
// compiled call node returning call2878 (depth = 13)
// compiled member node returning call2878 (depth = 12)
  partcv[0] = 0;
  Object call2879 = callmethod(call2878, "new",
    1, partcv, params);
  gc_frame_end(callframe2876);
// compiled call node returning call2879 (depth = 11)
// compiled member node returning call2879 (depth = 10)
  *var_suggestion = call2879;
  if (call2879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2880 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2882 = alloc_Float64(1);
// compiled num node returning num2882 (depth = 11)
  int op_slot_right_2881 = gc_frame_newslot(num2882);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_2881 = gc_frame_newslot(*var_linePosition);
  params[0] = num2882;
  partcv[0] = 1;
  Object diff2884 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2884 (depth = 10)
  gc_frame_newslot(diff2884);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = diff2884;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2885 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe2880);
// compiled call node returning call2885 (depth = 9)
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2886 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2887 == NULL) {
    strlit2887 = alloc_String("A string interpolation cannot be empty.");
    gc_root(strlit2887);
  }
// compiled string node returning strlit2887 (depth = 10)
  gc_frame_newslot(strlit2887);
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2888 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2889 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call2890 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2889);
// compiled call node returning call2890 (depth = 13)
// compiled member node returning call2890 (depth = 12)
  partcv[0] = 0;
  Object call2891 = callmethod(call2890, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2888);
// compiled call node returning call2891 (depth = 11)
// compiled member node returning call2891 (depth = 10)
  gc_frame_newslot(call2891);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2887;
  params[1] = *var_lineNumber;
  params[2] = call2891;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2892 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2886);
// compiled call node returning call2892 (depth = 9)
    gc_frame_newslot(call2892);
    if2858 = call2892;
  } else {
  }
// compiled if node returning if2858 (depth = 8)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2893 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2894 == NULL) {
    strlit2894 = alloc_String(")");
    gc_root(strlit2894);
  }
// compiled string node returning strlit2894 (depth = 9)
  gc_frame_newslot(strlit2894);
// starting to compile string node (depth = 9)
  if (strlit2895 == NULL) {
    strlit2895 = alloc_String(")");
    gc_root(strlit2895);
  }
// compiled string node returning strlit2895 (depth = 9)
  gc_frame_newslot(strlit2895);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2894;
  params[2] = strlit2895;
  partcv[0] = 3;
  Object call2896 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2893);
// compiled call node returning call2896 (depth = 8)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2897 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2898 == NULL) {
    strlit2898 = alloc_String("o");
    gc_root(strlit2898);
  }
// compiled string node returning strlit2898 (depth = 9)
  gc_frame_newslot(strlit2898);
// starting to compile string node (depth = 9)
  if (strlit2899 == NULL) {
    strlit2899 = alloc_String("++");
    gc_root(strlit2899);
  }
// compiled string node returning strlit2899 (depth = 9)
  gc_frame_newslot(strlit2899);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2898;
  params[2] = strlit2899;
  partcv[0] = 3;
  Object call2900 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2897);
// compiled call node returning call2900 (depth = 8)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2901 == NULL) {
    strlit2901 = alloc_String("""\x22""");
    gc_root(strlit2901);
  }
// compiled string node returning strlit2901 (depth = 9)
  *var_newmode = strlit2901;
  if (strlit2901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2903 = alloc_Boolean(1);
// compiled identifier node returning bool2903 (depth = 9)
  *var_inStr = bool2903;
  if (bool2903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num2906 = alloc_Float64(1);
// compiled num node returning num2906 (depth = 10)
  int op_slot_right_2905 = gc_frame_newslot(num2906);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_interpdepth (depth = 10)
  int op_slot_left_2905 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2906;
  partcv[0] = 1;
  Object diff2908 = callmethod(*var_interpdepth, "-", 1, partcv, params);
// compiled op node returning diff2908 (depth = 9)
  *var_interpdepth = diff2908;
  if (diff2908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2853 = done;
  } else {
  }
// compiled if node returning if2853 (depth = 7)
    gc_frame_newslot(if2853);
    if2848 = if2853;
  } else {
  }
// compiled if node returning if2848 (depth = 6)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newmode (depth = 7)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inStr (depth = 7)
  Object if2911 = done;
  if (istrue(*var_inStr)) {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2912 == NULL) {
    strlit2912 = alloc_String("");
    gc_root(strlit2912);
  }
// compiled string node returning strlit2912 (depth = 8)
  *var_accum = strlit2912;
  if (strlit2912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2911 = done;
  } else {
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  *var_accum = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2911 = done;
  }
// compiled if node returning if2911 (depth = 6)
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2916 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_brackets (depth = 8)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2917 = callmethod(*var_brackets, "match",
    1, partcv, params);
  gc_frame_end(callframe2916);
// compiled call node returning call2917 (depth = 7)
  Object if2915 = done;
  if (istrue(call2917)) {
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2918 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2919 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2918);
// compiled call node returning call2919 (depth = 7)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2920 == NULL) {
    strlit2920 = alloc_String("n");
    gc_root(strlit2920);
  }
// compiled string node returning strlit2920 (depth = 8)
  *var_mode = strlit2920;
  if (strlit2920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2922 == NULL) {
    strlit2922 = alloc_String("n");
    gc_root(strlit2922);
  }
// compiled string node returning strlit2922 (depth = 8)
  *var_newmode = strlit2922;
  if (strlit2922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2924 == NULL) {
    strlit2924 = alloc_String("");
    gc_root(strlit2924);
  }
// compiled string node returning strlit2924 (depth = 8)
  *var_accum = strlit2924;
  if (strlit2924 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2915 = done;
  } else {
  }
// compiled if node returning if2915 (depth = 6)
    gc_frame_newslot(if2915);
    if2842 = if2915;
  } else {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2928 == NULL) {
    strlit2928 = alloc_String("""\x22""");
    gc_root(strlit2928);
  }
// compiled string node returning strlit2928 (depth = 8)
  int op_slot_right_2927 = gc_frame_newslot(strlit2928);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_2927 = gc_frame_newslot(*var_mode);
  params[0] = strlit2928;
  partcv[0] = 1;
  Object opresult2930 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2930 (depth = 7)
  Object if2926 = done;
  if (istrue(opresult2930)) {
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2933 == NULL) {
    strlit2933 = alloc_String("""\x0a""");
    gc_root(strlit2933);
  }
// compiled string node returning strlit2933 (depth = 9)
  int op_slot_right_2932 = gc_frame_newslot(strlit2933);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2932 = gc_frame_newslot(*var_c);
  params[0] = strlit2933;
  partcv[0] = 1;
  Object opresult2935 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2935 (depth = 8)
  Object if2931 = done;
  if (istrue(opresult2935)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2938 = alloc_Float64(0);
// compiled num node returning num2938 (depth = 10)
  int op_slot_right_2937 = gc_frame_newslot(num2938);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_interpdepth (depth = 10)
  int op_slot_left_2937 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2938;
  partcv[0] = 1;
  Object opresult2940 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult2940 (depth = 9)
  Object if2936 = done;
  if (istrue(opresult2940)) {
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  *var_line = *var_lineNumber;
  if (*var_lineNumber == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2941 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2942 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_line (depth = 13)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2944 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2943);
// compiled call node returning call2944 (depth = 14)
// compiled member node returning call2944 (depth = 13)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2945 = callmethod(call2944, "at",
    1, partcv, params);
  gc_frame_end(callframe2942);
// compiled call node returning call2945 (depth = 12)
  partcv[0] = 0;
  Object call2946 = callmethod(call2945, "size",
    1, partcv, params);
  gc_frame_end(callframe2941);
// compiled call node returning call2946 (depth = 11)
// compiled member node returning call2946 (depth = 10)
  *var_i = call2946;
  if (call2946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2947 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2948 = alloc_Block(NULL, NULL, "lexer", 897);
  gc_frame_newslot(block2948);
// method _apply
  block_savedest(block2948);
  Object closure2949 = createclosure(4, "_apply");
  setclosureframe(closure2949, stackframe);
  addtoclosure(closure2949, var_line);
  addtoclosure(closure2949, var_util);
  addtoclosure(closure2949, var_i);
  addtoclosure(closure2949, selfslot);
  struct UserObject *uo2949 = (struct UserObject*)block2948;
  uo2949->data[0] = (Object)closure2949;
  Method *meth_meth_lexer__apply2949 = addmethod2pos(block2948, "_apply", &meth_lexer__apply2949, 0);
  int argcv_meth_lexer__apply2949[] = {0};
  meth_meth_lexer__apply2949->type = alloc_MethodType(1, argcv_meth_lexer__apply2949);
  meth_meth_lexer__apply2949->definitionModule = modulename;
  meth_meth_lexer__apply2949->definitionLine = 896;
// compiled block node returning block2948 (depth = 10)
  gc_frame_newslot(block2948);
// starting to compile block node (depth = 10)
  Object block2960 = alloc_Block(NULL, NULL, "lexer", 897);
  gc_frame_newslot(block2960);
// method _apply
  block_savedest(block2960);
  Object closure2961 = createclosure(5, "_apply");
  setclosureframe(closure2961, stackframe);
  addtoclosure(closure2961, var_i);
  addtoclosure(closure2961, var_line);
  addtoclosure(closure2961, var_lineNumber);
  addtoclosure(closure2961, var_util);
  addtoclosure(closure2961, selfslot);
  struct UserObject *uo2961 = (struct UserObject*)block2960;
  uo2961->data[0] = (Object)closure2961;
  Method *meth_meth_lexer__apply2961 = addmethod2pos(block2960, "_apply", &meth_lexer__apply2961, 0);
  int argcv_meth_lexer__apply2961[] = {0};
  meth_meth_lexer__apply2961->type = alloc_MethodType(1, argcv_meth_lexer__apply2961);
  meth_meth_lexer__apply2961->definitionModule = modulename;
  meth_meth_lexer__apply2961->definitionLine = 897;
// compiled block node returning block2960 (depth = 10)
  gc_frame_newslot(block2960);
// call case 5: prelude request
  params[0] = block2948;
  params[1] = block2960;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2985 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2947);
// compiled call node returning call2985 (depth = 9)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 10)
  Object array2986 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2986 (depth = 10)
  *var_suggestions = array2986;
  if (array2986 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2987 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2989 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2988);
// compiled call node returning call2989 (depth = 13)
// compiled member node returning call2989 (depth = 12)
  partcv[0] = 0;
  Object call2990 = callmethod(call2989, "new",
    1, partcv, params);
  gc_frame_end(callframe2987);
// compiled call node returning call2990 (depth = 11)
// compiled member node returning call2990 (depth = 10)
  *var_suggestion = call2990;
  if (call2990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2991 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2992 == NULL) {
    strlit2992 = alloc_String("\\");
    gc_root(strlit2992);
  }
// compiled string node returning strlit2992 (depth = 10)
  gc_frame_newslot(strlit2992);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2992;
  params[1] = *var_i;
  params[2] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2993 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe2991);
// compiled call node returning call2993 (depth = 9)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2994 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call2995 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe2994);
// compiled call node returning call2995 (depth = 9)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3000 = alloc_Float64(2);
// compiled num node returning num3000 (depth = 13)
  int op_slot_right_2999 = gc_frame_newslot(num3000);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_2999 = gc_frame_newslot(*var_linePosition);
  params[0] = num3000;
  partcv[0] = 1;
  Object diff3002 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3002 (depth = 12)
  int op_slot_right_2998 = gc_frame_newslot(diff3002);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_2998 = gc_frame_newslot(*var_i);
  params[0] = diff3002;
  partcv[0] = 1;
  Object opresult3004 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult3004 (depth = 11)
  int op_slot_right_2997 = gc_frame_newslot(opresult3004);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_right_3006 = gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_3006 = gc_frame_newslot(*var_line);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult3008 = callmethod(*var_line, "==", 1, partcv, params);
// compiled op node returning opresult3008 (depth = 11)
  int op_slot_left_2997 = gc_frame_newslot(opresult3008);
  params[0] = opresult3004;
  partcv[0] = 1;
  Object opresult3009 = callmethod(opresult3008, "&&", 1, partcv, params);
// compiled op node returning opresult3009 (depth = 10)
  Object if2996 = done;
  if (istrue(opresult3009)) {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3010 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3011 == NULL) {
    strlit3011 = alloc_String("For a '{' character in a string use '\\{'.");
    gc_root(strlit3011);
  }
// compiled string node returning strlit3011 (depth = 11)
  gc_frame_newslot(strlit3011);
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit3011;
  params[1] = *var_line;
  params[2] = *var_i;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3012 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3010);
// compiled call node returning call3012 (depth = 10)
    gc_frame_newslot(call3012);
    if2996 = call3012;
  } else {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3013 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3015 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3014);
// compiled call node returning call3015 (depth = 14)
// compiled member node returning call3015 (depth = 13)
  partcv[0] = 0;
  Object call3016 = callmethod(call3015, "new",
    1, partcv, params);
  gc_frame_end(callframe3013);
// compiled call node returning call3016 (depth = 12)
// compiled member node returning call3016 (depth = 11)
  *var_suggestion = call3016;
  if (call3016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3018 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3019 == NULL) {
    strlit3019 = alloc_String("}");
    gc_root(strlit3019);
  }
// compiled string node returning strlit3019 (depth = 11)
  gc_frame_newslot(strlit3019);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3021 = alloc_Float64(1);
// compiled num node returning num3021 (depth = 12)
  int op_slot_right_3020 = gc_frame_newslot(num3021);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  partcv[0] = 0;
  Object call3025 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe3024);
// compiled call node returning call3025 (depth = 14)
// compiled member node returning call3025 (depth = 13)
  int op_slot_right_3023 = gc_frame_newslot(call3025);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_3023 = gc_frame_newslot(*var_linePosition);
  params[0] = call3025;
  partcv[0] = 1;
  Object diff3027 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3027 (depth = 12)
  int op_slot_left_3020 = gc_frame_newslot(diff3027);
  params[0] = num3021;
  partcv[0] = 1;
  Object diff3028 = callmethod(diff3027, "-", 1, partcv, params);
// compiled op node returning diff3028 (depth = 11)
  gc_frame_newslot(diff3028);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit3019;
  params[1] = diff3028;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3029 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe3018);
// compiled call node returning call3029 (depth = 10)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3030 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3031 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3030);
// compiled call node returning call3031 (depth = 10)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3032 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3033 == NULL) {
    strlit3033 = alloc_String("A string interpolation must end with a '}'. For a '{' character in a string use '\\{'.");
    gc_root(strlit3033);
  }
// compiled string node returning strlit3033 (depth = 11)
  gc_frame_newslot(strlit3033);
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3035 = alloc_Float64(1);
// compiled num node returning num3035 (depth = 12)
  int op_slot_right_3034 = gc_frame_newslot(num3035);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  partcv[0] = 0;
  Object call3039 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe3038);
// compiled call node returning call3039 (depth = 14)
// compiled member node returning call3039 (depth = 13)
  int op_slot_right_3037 = gc_frame_newslot(call3039);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_3037 = gc_frame_newslot(*var_linePosition);
  params[0] = call3039;
  partcv[0] = 1;
  Object diff3041 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff3041 (depth = 12)
  int op_slot_left_3034 = gc_frame_newslot(diff3041);
  params[0] = num3035;
  partcv[0] = 1;
  Object diff3042 = callmethod(diff3041, "-", 1, partcv, params);
// compiled op node returning diff3042 (depth = 11)
  gc_frame_newslot(diff3042);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit3033;
  params[1] = *var_lineNumber;
  params[2] = diff3042;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3043 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3032);
// compiled call node returning call3043 (depth = 10)
    gc_frame_newslot(call3043);
    if2996 = call3043;
  }
// compiled if node returning if2996 (depth = 9)
    gc_frame_newslot(if2996);
    if2936 = if2996;
  } else {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3044 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_util (depth = 13)
  partcv[0] = 0;
  Object call3046 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3045);
// compiled call node returning call3046 (depth = 12)
// compiled member node returning call3046 (depth = 11)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call3047 = callmethod(call3046, "at",
    1, partcv, params);
  gc_frame_end(callframe3044);
// compiled call node returning call3047 (depth = 10)
  *var_errorLine = call3047;
  if (call3047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile if node (depth = 10)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3051 = alloc_Float64(1);
// compiled num node returning num3051 (depth = 13)
  int op_slot_right_3050 = gc_frame_newslot(num3051);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  int op_slot_left_3050 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3051;
  partcv[0] = 1;
  Object sum3053 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3053 (depth = 12)
  int op_slot_right_3049 = gc_frame_newslot(sum3053);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3055 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe3056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  partcv[0] = 0;
  Object call3057 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 15)
// compiled member node returning call3057 (depth = 14)
  partcv[0] = 0;
  Object call3058 = callmethod(call3057, "size",
    1, partcv, params);
  gc_frame_end(callframe3055);
// compiled call node returning call3058 (depth = 13)
// compiled member node returning call3058 (depth = 12)
  int op_slot_left_3049 = gc_frame_newslot(call3058);
  params[0] = sum3053;
  partcv[0] = 1;
  Object opresult3059 = callmethod(call3058, ">=", 1, partcv, params);
// compiled op node returning opresult3059 (depth = 11)
  Object if3048 = done;
struct StackFrameObject *iftmpstackframe3048 = stackframe;
  if (istrue(opresult3059)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3048);
gc_frame_newslot((Object)stackframe);
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3060 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3062 = alloc_Float64(1);
// compiled num node returning num3062 (depth = 13)
  int op_slot_right_3061 = gc_frame_newslot(num3062);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  int op_slot_left_3061 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3062;
  partcv[0] = 1;
  Object sum3064 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3064 (depth = 12)
  gc_frame_newslot(sum3064);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call3066 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3065);
// compiled call node returning call3066 (depth = 13)
// compiled member node returning call3066 (depth = 12)
  params[0] = sum3064;
  partcv[0] = 1;
  Object call3067 = callmethod(call3066, "at",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3067 (depth = 11)
    gc_frame_newslot(call3067);
    if3048 = call3067;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe3048);
  gc_frame_newslot((Object)stackframe);
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3068 == NULL) {
    strlit3068 = alloc_String("");
    gc_root(strlit3068);
  }
// compiled string node returning strlit3068 (depth = 11)
    gc_frame_newslot(strlit3068);
    if3048 = strlit3068;
  }
stackframe = iftmpstackframe3048;
// compiled if node returning if3048 (depth = 10)
  *var_nextLine = if3048;
  if (if3048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num3069 = alloc_Float64(1);
// compiled num node returning num3069 (depth = 10)
  *var_i = num3069;
  if (num3069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num3070 = alloc_Float64(0);
// compiled num node returning num3070 (depth = 10)
  *var_count = num3070;
  if (num3070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3071 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3072 = alloc_Block(NULL, NULL, "lexer", 928);
  gc_frame_newslot(block3072);
// method _apply
  block_savedest(block3072);
  Object closure3073 = createclosure(3, "_apply");
  setclosureframe(closure3073, stackframe);
  addtoclosure(closure3073, var_nextLine);
  addtoclosure(closure3073, var_i);
  addtoclosure(closure3073, selfslot);
  struct UserObject *uo3073 = (struct UserObject*)block3072;
  uo3073->data[0] = (Object)closure3073;
  Method *meth_meth_lexer__apply3073 = addmethod2pos(block3072, "_apply", &meth_lexer__apply3073, 0);
  int argcv_meth_lexer__apply3073[] = {0};
  meth_meth_lexer__apply3073->type = alloc_MethodType(1, argcv_meth_lexer__apply3073);
  meth_meth_lexer__apply3073->definitionModule = modulename;
  meth_meth_lexer__apply3073->definitionLine = 921;
// compiled block node returning block3072 (depth = 10)
  gc_frame_newslot(block3072);
// starting to compile block node (depth = 10)
  Object block3080 = alloc_Block(NULL, NULL, "lexer", 928);
  gc_frame_newslot(block3080);
// method _apply
  block_savedest(block3080);
  Object closure3081 = createclosure(4, "_apply");
  setclosureframe(closure3081, stackframe);
  addtoclosure(closure3081, var_nextLine);
  addtoclosure(closure3081, var_i);
  addtoclosure(closure3081, var_count);
  addtoclosure(closure3081, selfslot);
  struct UserObject *uo3081 = (struct UserObject*)block3080;
  uo3081->data[0] = (Object)closure3081;
  Method *meth_meth_lexer__apply3081 = addmethod2pos(block3080, "_apply", &meth_lexer__apply3081, 0);
  int argcv_meth_lexer__apply3081[] = {0};
  meth_meth_lexer__apply3081->type = alloc_MethodType(1, argcv_meth_lexer__apply3081);
  meth_meth_lexer__apply3081->definitionModule = modulename;
  meth_meth_lexer__apply3081->definitionLine = 928;
// compiled block node returning block3080 (depth = 10)
  gc_frame_newslot(block3080);
// call case 5: prelude request
  params[0] = block3072;
  params[1] = block3080;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3110 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3071);
// compiled call node returning call3110 (depth = 9)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3113 = alloc_Float64(1);
// compiled num node returning num3113 (depth = 11)
  int op_slot_right_3112 = gc_frame_newslot(num3113);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3116 = alloc_Float64(2);
// compiled num node returning num3116 (depth = 12)
  int op_slot_right_3115 = gc_frame_newslot(num3116);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_count (depth = 12)
  int op_slot_left_3115 = gc_frame_newslot(*var_count);
  params[0] = num3116;
  partcv[0] = 1;
  Object modulus3118 = callmethod(*var_count, "%", 1, partcv, params);
// compiled op node returning modulus3118 (depth = 11)
  int op_slot_left_3112 = gc_frame_newslot(modulus3118);
  params[0] = num3113;
  partcv[0] = 1;
  Object opresult3119 = callmethod(modulus3118, "==", 1, partcv, params);
// compiled op node returning opresult3119 (depth = 10)
  Object if3111 = done;
  if (istrue(opresult3119)) {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 11)
  Object array3120 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3120 (depth = 11)
  *var_suggestions = array3120;
  if (array3120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 10)
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3121 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3123 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3122);
// compiled call node returning call3123 (depth = 14)
// compiled member node returning call3123 (depth = 13)
  partcv[0] = 0;
  Object call3124 = callmethod(call3123, "new",
    1, partcv, params);
  gc_frame_end(callframe3121);
// compiled call node returning call3124 (depth = 12)
// compiled member node returning call3124 (depth = 11)
  *var_suggestion = call3124;
  if (call3124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 10)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3125 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3126 = gc_frame_newslot(*var_nextLine);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3126 = gc_frame_newslot(*var_errorLine);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3128 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3128 (depth = 11)
  gc_frame_newslot(opresult3128);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3128;
  partcv[0] = 2;
  Object call3129 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3125);
// compiled call node returning call3129 (depth = 10)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3130 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3132 = alloc_Float64(1);
// compiled num node returning num3132 (depth = 12)
  int op_slot_right_3131 = gc_frame_newslot(num3132);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3131 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3132;
  partcv[0] = 1;
  Object sum3134 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3134 (depth = 11)
  gc_frame_newslot(sum3134);
// starting to compile string node (depth = 11)
  if (strlit3135 == NULL) {
    strlit3135 = alloc_String("");
    gc_root(strlit3135);
  }
// compiled string node returning strlit3135 (depth = 11)
  gc_frame_newslot(strlit3135);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3134;
  params[1] = strlit3135;
  partcv[0] = 2;
  Object call3136 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3130);
// compiled call node returning call3136 (depth = 10)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3137 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3138 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3137);
// compiled call node returning call3138 (depth = 10)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3139 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3141 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3140);
// compiled call node returning call3141 (depth = 14)
// compiled member node returning call3141 (depth = 13)
  partcv[0] = 0;
  Object call3142 = callmethod(call3141, "new",
    1, partcv, params);
  gc_frame_end(callframe3139);
// compiled call node returning call3142 (depth = 12)
// compiled member node returning call3142 (depth = 11)
  *var_suggestion = call3142;
  if (call3142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3144 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3146 == NULL) {
    strlit3146 = alloc_String("""\x22""");
    gc_root(strlit3146);
  }
// compiled string node returning strlit3146 (depth = 12)
  int op_slot_right_3145 = gc_frame_newslot(strlit3146);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3145 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3146;
  partcv[0] = 1;
  Object opresult3148 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3148 (depth = 11)
  gc_frame_newslot(opresult3148);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3148;
  partcv[0] = 2;
  Object call3149 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3144);
// compiled call node returning call3149 (depth = 10)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3150 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3152 = alloc_Float64(1);
// compiled num node returning num3152 (depth = 12)
  int op_slot_right_3151 = gc_frame_newslot(num3152);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3151 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3152;
  partcv[0] = 1;
  Object sum3154 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3154 (depth = 11)
  gc_frame_newslot(sum3154);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3155 = gc_frame_newslot(*var_nextLine);
// starting to compile string node (depth = 12)
  if (strlit3157 == NULL) {
    strlit3157 = alloc_String("    ++ ""\x22""");
    gc_root(strlit3157);
  }
// compiled string node returning strlit3157 (depth = 12)
  int op_slot_left_3155 = gc_frame_newslot(strlit3157);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3158 = callmethod(strlit3157, "++", 1, partcv, params);
// compiled op node returning opresult3158 (depth = 11)
  gc_frame_newslot(opresult3158);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3154;
  params[1] = opresult3158;
  partcv[0] = 2;
  Object call3159 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3150);
// compiled call node returning call3159 (depth = 10)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3160 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3161 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 10)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3162 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3163 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3164 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3163);
// compiled call node returning call3164 (depth = 14)
// compiled member node returning call3164 (depth = 13)
  partcv[0] = 0;
  Object call3165 = callmethod(call3164, "new",
    1, partcv, params);
  gc_frame_end(callframe3162);
// compiled call node returning call3165 (depth = 12)
// compiled member node returning call3165 (depth = 11)
  *var_suggestion = call3165;
  if (call3165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3167 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3168 = gc_frame_newslot(*var_nextLine);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3171 == NULL) {
    strlit3171 = alloc_String("\\n");
    gc_root(strlit3171);
  }
// compiled string node returning strlit3171 (depth = 13)
  int op_slot_right_3170 = gc_frame_newslot(strlit3171);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errorLine (depth = 13)
  int op_slot_left_3170 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3171;
  partcv[0] = 1;
  Object opresult3173 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3173 (depth = 12)
  int op_slot_left_3168 = gc_frame_newslot(opresult3173);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3174 = callmethod(opresult3173, "++", 1, partcv, params);
// compiled op node returning opresult3174 (depth = 11)
  gc_frame_newslot(opresult3174);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3174;
  partcv[0] = 2;
  Object call3175 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3167);
// compiled call node returning call3175 (depth = 10)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3176 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3178 = alloc_Float64(1);
// compiled num node returning num3178 (depth = 12)
  int op_slot_right_3177 = gc_frame_newslot(num3178);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3177 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3178;
  partcv[0] = 1;
  Object sum3180 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3180 (depth = 11)
  gc_frame_newslot(sum3180);
// starting to compile string node (depth = 11)
  if (strlit3181 == NULL) {
    strlit3181 = alloc_String("");
    gc_root(strlit3181);
  }
// compiled string node returning strlit3181 (depth = 11)
  gc_frame_newslot(strlit3181);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3180;
  params[1] = strlit3181;
  partcv[0] = 2;
  Object call3182 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3176);
// compiled call node returning call3182 (depth = 10)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3183 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3184 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3183);
// compiled call node returning call3184 (depth = 10)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3185 = gc_frame_new();
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3187 == NULL) {
    strlit3187 = alloc_String("To split a string over multiple lines use '++' to join strings together.");
    gc_root(strlit3187);
  }
// compiled string node returning strlit3187 (depth = 12)
  int op_slot_right_3186 = gc_frame_newslot(strlit3187);
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3189 == NULL) {
    strlit3189 = alloc_String("A string must end with a '""\x22""'. To insert a newline in a string use '\\n'. ");
    gc_root(strlit3189);
  }
// compiled string node returning strlit3189 (depth = 12)
  int op_slot_left_3186 = gc_frame_newslot(strlit3189);
  params[0] = strlit3187;
  partcv[0] = 1;
  Object opresult3190 = callmethod(strlit3189, "++", 1, partcv, params);
// compiled op node returning opresult3190 (depth = 11)
  gc_frame_newslot(opresult3190);
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = opresult3190;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3191 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3185);
// compiled call node returning call3191 (depth = 10)
    gc_frame_newslot(call3191);
    if3111 = call3191;
  } else {
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3192 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3193 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3194 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3193);
// compiled call node returning call3194 (depth = 14)
// compiled member node returning call3194 (depth = 13)
  partcv[0] = 0;
  Object call3195 = callmethod(call3194, "new",
    1, partcv, params);
  gc_frame_end(callframe3192);
// compiled call node returning call3195 (depth = 12)
// compiled member node returning call3195 (depth = 11)
  *var_suggestion = call3195;
  if (call3195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3196 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3198 == NULL) {
    strlit3198 = alloc_String("""\x22""");
    gc_root(strlit3198);
  }
// compiled string node returning strlit3198 (depth = 12)
  int op_slot_right_3197 = gc_frame_newslot(strlit3198);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3197 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3198;
  partcv[0] = 1;
  Object opresult3200 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3200 (depth = 11)
  gc_frame_newslot(opresult3200);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3200;
  partcv[0] = 2;
  Object call3201 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3196);
// compiled call node returning call3201 (depth = 10)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3202 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3203 == NULL) {
    strlit3203 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3203);
  }
// compiled string node returning strlit3203 (depth = 11)
  gc_frame_newslot(strlit3203);
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit3203;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3204 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3202);
// compiled call node returning call3204 (depth = 10)
    gc_frame_newslot(call3204);
    if3111 = call3204;
  }
// compiled if node returning if3111 (depth = 9)
    gc_frame_newslot(if3111);
    if2936 = if3111;
  }
// compiled if node returning if2936 (depth = 8)
    gc_frame_newslot(if2936);
    if2931 = if2936;
  } else {
  }
// compiled if node returning if2931 (depth = 7)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_escaped (depth = 8)
  Object if3205 = done;
  if (istrue(*var_escaped)) {
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3208 == NULL) {
    strlit3208 = alloc_String("n");
    gc_root(strlit3208);
  }
// compiled string node returning strlit3208 (depth = 10)
  int op_slot_right_3207 = gc_frame_newslot(strlit3208);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3207 = gc_frame_newslot(*var_c);
  params[0] = strlit3208;
  partcv[0] = 1;
  Object opresult3210 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3210 (depth = 9)
  Object if3206 = done;
  if (istrue(opresult3210)) {
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3212 == NULL) {
    strlit3212 = alloc_String("""\x0a""");
    gc_root(strlit3212);
  }
// compiled string node returning strlit3212 (depth = 11)
  int op_slot_right_3211 = gc_frame_newslot(strlit3212);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_3211 = gc_frame_newslot(*var_accum);
  params[0] = strlit3212;
  partcv[0] = 1;
  Object opresult3214 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 10)
  *var_accum = opresult3214;
  if (opresult3214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3206 = done;
  } else {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3218 == NULL) {
    strlit3218 = alloc_String("u");
    gc_root(strlit3218);
  }
// compiled string node returning strlit3218 (depth = 11)
  int op_slot_right_3217 = gc_frame_newslot(strlit3218);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3217 = gc_frame_newslot(*var_c);
  params[0] = strlit3218;
  partcv[0] = 1;
  Object opresult3220 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3220 (depth = 10)
  Object if3216 = done;
  if (istrue(opresult3220)) {
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 11)
  Object num3221 = alloc_Float64(4);
// compiled num node returning num3221 (depth = 11)
  *var_unichars = num3221;
  if (num3221 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 11)
  Object num3223 = alloc_Float64(0);
// compiled num node returning num3223 (depth = 11)
  *var_codepoint = num3223;
  if (num3223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3216 = done;
  } else {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3227 == NULL) {
    strlit3227 = alloc_String("U");
    gc_root(strlit3227);
  }
// compiled string node returning strlit3227 (depth = 12)
  int op_slot_right_3226 = gc_frame_newslot(strlit3227);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3226 = gc_frame_newslot(*var_c);
  params[0] = strlit3227;
  partcv[0] = 1;
  Object opresult3229 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3229 (depth = 11)
  Object if3225 = done;
  if (istrue(opresult3229)) {
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3230 = alloc_Float64(6);
// compiled num node returning num3230 (depth = 12)
  *var_unichars = num3230;
  if (num3230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3232 = alloc_Float64(0);
// compiled num node returning num3232 (depth = 12)
  *var_codepoint = num3232;
  if (num3232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3225 = done;
  } else {
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3236 == NULL) {
    strlit3236 = alloc_String("t");
    gc_root(strlit3236);
  }
// compiled string node returning strlit3236 (depth = 13)
  int op_slot_right_3235 = gc_frame_newslot(strlit3236);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_3235 = gc_frame_newslot(*var_c);
  params[0] = strlit3236;
  partcv[0] = 1;
  Object opresult3238 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3238 (depth = 12)
  Object if3234 = done;
  if (istrue(opresult3238)) {
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit3240 == NULL) {
    strlit3240 = alloc_String("""\x09""");
    gc_root(strlit3240);
  }
// compiled string node returning strlit3240 (depth = 14)
  int op_slot_right_3239 = gc_frame_newslot(strlit3240);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_3239 = gc_frame_newslot(*var_accum);
  params[0] = strlit3240;
  partcv[0] = 1;
  Object opresult3242 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3242 (depth = 13)
  *var_accum = opresult3242;
  if (opresult3242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3234 = done;
  } else {
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3246 == NULL) {
    strlit3246 = alloc_String("r");
    gc_root(strlit3246);
  }
// compiled string node returning strlit3246 (depth = 14)
  int op_slot_right_3245 = gc_frame_newslot(strlit3246);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_3245 = gc_frame_newslot(*var_c);
  params[0] = strlit3246;
  partcv[0] = 1;
  Object opresult3248 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3248 (depth = 13)
  Object if3244 = done;
  if (istrue(opresult3248)) {
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile op node (depth = 14)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 15)
  if (strlit3250 == NULL) {
    strlit3250 = alloc_String("""\x0d""");
    gc_root(strlit3250);
  }
// compiled string node returning strlit3250 (depth = 15)
  int op_slot_right_3249 = gc_frame_newslot(strlit3250);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_3249 = gc_frame_newslot(*var_accum);
  params[0] = strlit3250;
  partcv[0] = 1;
  Object opresult3252 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3252 (depth = 14)
  *var_accum = opresult3252;
  if (opresult3252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if3244 = done;
  } else {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit3256 == NULL) {
    strlit3256 = alloc_String("b");
    gc_root(strlit3256);
  }
// compiled string node returning strlit3256 (depth = 15)
  int op_slot_right_3255 = gc_frame_newslot(strlit3256);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_3255 = gc_frame_newslot(*var_c);
  params[0] = strlit3256;
  partcv[0] = 1;
  Object opresult3258 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 14)
  Object if3254 = done;
  if (istrue(opresult3258)) {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// starting to compile op node (depth = 15)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 16)
  if (strlit3260 == NULL) {
    strlit3260 = alloc_String("""\x08""");
    gc_root(strlit3260);
  }
// compiled string node returning strlit3260 (depth = 16)
  int op_slot_right_3259 = gc_frame_newslot(strlit3260);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_3259 = gc_frame_newslot(*var_accum);
  params[0] = strlit3260;
  partcv[0] = 1;
  Object opresult3262 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3262 (depth = 15)
  *var_accum = opresult3262;
  if (opresult3262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if3254 = done;
  } else {
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit3266 == NULL) {
    strlit3266 = alloc_String("l");
    gc_root(strlit3266);
  }
// compiled string node returning strlit3266 (depth = 16)
  int op_slot_right_3265 = gc_frame_newslot(strlit3266);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_3265 = gc_frame_newslot(*var_c);
  params[0] = strlit3266;
  partcv[0] = 1;
  Object opresult3268 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3268 (depth = 15)
  Object if3264 = done;
  if (istrue(opresult3268)) {
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 15)
// starting to compile op node (depth = 16)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 17)
  if (strlit3270 == NULL) {
    strlit3270 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit3270);
  }
// compiled string node returning strlit3270 (depth = 17)
  int op_slot_right_3269 = gc_frame_newslot(strlit3270);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_3269 = gc_frame_newslot(*var_accum);
  params[0] = strlit3270;
  partcv[0] = 1;
  Object opresult3272 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3272 (depth = 16)
  *var_accum = opresult3272;
  if (opresult3272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 15)
    gc_frame_newslot(done);
    if3264 = done;
  } else {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 15)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit3276 == NULL) {
    strlit3276 = alloc_String("f");
    gc_root(strlit3276);
  }
// compiled string node returning strlit3276 (depth = 17)
  int op_slot_right_3275 = gc_frame_newslot(strlit3276);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_c (depth = 17)
  int op_slot_left_3275 = gc_frame_newslot(*var_c);
  params[0] = strlit3276;
  partcv[0] = 1;
  Object opresult3278 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3278 (depth = 16)
  Object if3274 = done;
  if (istrue(opresult3278)) {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 16)
// starting to compile op node (depth = 17)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit3280 == NULL) {
    strlit3280 = alloc_String("""\x0c""");
    gc_root(strlit3280);
  }
// compiled string node returning strlit3280 (depth = 18)
  int op_slot_right_3279 = gc_frame_newslot(strlit3280);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_3279 = gc_frame_newslot(*var_accum);
  params[0] = strlit3280;
  partcv[0] = 1;
  Object opresult3282 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3282 (depth = 17)
  *var_accum = opresult3282;
  if (opresult3282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 16)
    gc_frame_newslot(done);
    if3274 = done;
  } else {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 16)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit3286 == NULL) {
    strlit3286 = alloc_String("e");
    gc_root(strlit3286);
  }
// compiled string node returning strlit3286 (depth = 18)
  int op_slot_right_3285 = gc_frame_newslot(strlit3286);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  int op_slot_left_3285 = gc_frame_newslot(*var_c);
  params[0] = strlit3286;
  partcv[0] = 1;
  Object opresult3288 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3288 (depth = 17)
  Object if3284 = done;
  if (istrue(opresult3288)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 17)
// starting to compile op node (depth = 18)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 19)
  if (strlit3290 == NULL) {
    strlit3290 = alloc_String("""\x1b""");
    gc_root(strlit3290);
  }
// compiled string node returning strlit3290 (depth = 19)
  int op_slot_right_3289 = gc_frame_newslot(strlit3290);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  int op_slot_left_3289 = gc_frame_newslot(*var_accum);
  params[0] = strlit3290;
  partcv[0] = 1;
  Object opresult3292 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3292 (depth = 18)
  *var_accum = opresult3292;
  if (opresult3292 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 17)
    gc_frame_newslot(done);
    if3284 = done;
  } else {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 17)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit3296 == NULL) {
    strlit3296 = alloc_String("_");
    gc_root(strlit3296);
  }
// compiled string node returning strlit3296 (depth = 19)
  int op_slot_right_3295 = gc_frame_newslot(strlit3296);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  int op_slot_left_3295 = gc_frame_newslot(*var_c);
  params[0] = strlit3296;
  partcv[0] = 1;
  Object opresult3298 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3298 (depth = 18)
  Object if3294 = done;
  if (istrue(opresult3298)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 18)
// starting to compile op node (depth = 19)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 20)
  if (strlit3300 == NULL) {
    strlit3300 = alloc_String("""\xc2""""\xa0""");
    gc_root(strlit3300);
  }
// compiled string node returning strlit3300 (depth = 20)
  int op_slot_right_3299 = gc_frame_newslot(strlit3300);
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_accum (depth = 20)
  int op_slot_left_3299 = gc_frame_newslot(*var_accum);
  params[0] = strlit3300;
  partcv[0] = 1;
  Object opresult3302 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3302 (depth = 19)
  *var_accum = opresult3302;
  if (opresult3302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 18)
    gc_frame_newslot(done);
    if3294 = done;
  } else {
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 18)
// starting to compile op node (depth = 19)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_c (depth = 20)
  int op_slot_right_3304 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_accum (depth = 20)
  int op_slot_left_3304 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3306 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3306 (depth = 19)
  *var_accum = opresult3306;
  if (opresult3306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 18)
    gc_frame_newslot(done);
    if3294 = done;
  }
// compiled if node returning if3294 (depth = 17)
    gc_frame_newslot(if3294);
    if3284 = if3294;
  }
// compiled if node returning if3284 (depth = 16)
    gc_frame_newslot(if3284);
    if3274 = if3284;
  }
// compiled if node returning if3274 (depth = 15)
    gc_frame_newslot(if3274);
    if3264 = if3274;
  }
// compiled if node returning if3264 (depth = 14)
    gc_frame_newslot(if3264);
    if3254 = if3264;
  }
// compiled if node returning if3254 (depth = 13)
    gc_frame_newslot(if3254);
    if3244 = if3254;
  }
// compiled if node returning if3244 (depth = 12)
    gc_frame_newslot(if3244);
    if3234 = if3244;
  }
// compiled if node returning if3234 (depth = 11)
    gc_frame_newslot(if3234);
    if3225 = if3234;
  }
// compiled if node returning if3225 (depth = 10)
    gc_frame_newslot(if3225);
    if3216 = if3225;
  }
// compiled if node returning if3216 (depth = 9)
    gc_frame_newslot(if3216);
    if3206 = if3216;
  }
// compiled if node returning if3206 (depth = 8)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool3308 = alloc_Boolean(0);
// compiled identifier node returning bool3308 (depth = 9)
  *var_escaped = bool3308;
  if (bool3308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3205 = done;
  } else {
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3312 == NULL) {
    strlit3312 = alloc_String("\\");
    gc_root(strlit3312);
  }
// compiled string node returning strlit3312 (depth = 10)
  int op_slot_right_3311 = gc_frame_newslot(strlit3312);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3311 = gc_frame_newslot(*var_c);
  params[0] = strlit3312;
  partcv[0] = 1;
  Object opresult3314 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3314 (depth = 9)
  Object if3310 = done;
  if (istrue(opresult3314)) {
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool3315 = alloc_Boolean(1);
// compiled identifier node returning bool3315 (depth = 10)
  *var_escaped = bool3315;
  if (bool3315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3310 = done;
  } else {
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3319 = alloc_Float64(0);
// compiled num node returning num3319 (depth = 11)
  int op_slot_right_3318 = gc_frame_newslot(num3319);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unichars (depth = 11)
  int op_slot_left_3318 = gc_frame_newslot(*var_unichars);
  params[0] = num3319;
  partcv[0] = 1;
  Object opresult3321 = callmethod(*var_unichars, ">", 1, partcv, params);
// compiled op node returning opresult3321 (depth = 10)
  Object if3317 = done;
  if (istrue(opresult3321)) {
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3323 = alloc_Float64(1);
// compiled num node returning num3323 (depth = 12)
  int op_slot_right_3322 = gc_frame_newslot(num3323);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unichars (depth = 12)
  int op_slot_left_3322 = gc_frame_newslot(*var_unichars);
  params[0] = num3323;
  partcv[0] = 1;
  Object diff3325 = callmethod(*var_unichars, "-", 1, partcv, params);
// compiled op node returning diff3325 (depth = 11)
  *var_unichars = diff3325;
  if (diff3325 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3328 = alloc_Float64(16);
// compiled num node returning num3328 (depth = 12)
  int op_slot_right_3327 = gc_frame_newslot(num3328);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_codepoint (depth = 12)
  int op_slot_left_3327 = gc_frame_newslot(*var_codepoint);
  params[0] = num3328;
  partcv[0] = 1;
  Object prod3330 = callmethod(*var_codepoint, "*", 1, partcv, params);
// compiled op node returning prod3330 (depth = 11)
  *var_codepoint = prod3330;
  if (prod3330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3333 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3334 = callmethodflags(self, "hexdecchar", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3333);
// compiled call node returning call3334 (depth = 12)
  int op_slot_right_3332 = gc_frame_newslot(call3334);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_codepoint (depth = 12)
  int op_slot_left_3332 = gc_frame_newslot(*var_codepoint);
  params[0] = call3334;
  partcv[0] = 1;
  Object sum3336 = callmethod(*var_codepoint, "+", 1, partcv, params);
// compiled op node returning sum3336 (depth = 11)
  *var_codepoint = sum3336;
  if (sum3336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3340 = alloc_Float64(0);
// compiled num node returning num3340 (depth = 12)
  int op_slot_right_3339 = gc_frame_newslot(num3340);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unichars (depth = 12)
  int op_slot_left_3339 = gc_frame_newslot(*var_unichars);
  params[0] = num3340;
  partcv[0] = 1;
  Object opresult3342 = callmethod(*var_unichars, "==", 1, partcv, params);
// compiled op node returning opresult3342 (depth = 11)
  Object if3338 = done;
  if (istrue(opresult3342)) {
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3344 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_codepoint (depth = 14)
  gc_frame_newslot(*var_codepoint);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_codepoint;
  partcv[0] = 1;
  Object call3345 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe3344);
// compiled call node returning call3345 (depth = 13)
  int op_slot_right_3343 = gc_frame_newslot(call3345);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_3343 = gc_frame_newslot(*var_accum);
  params[0] = call3345;
  partcv[0] = 1;
  Object opresult3347 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3347 (depth = 12)
  *var_accum = opresult3347;
  if (opresult3347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3338 = done;
  } else {
  }
// compiled if node returning if3338 (depth = 10)
    gc_frame_newslot(if3338);
    if3317 = if3338;
  } else {
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3351 == NULL) {
    strlit3351 = alloc_String("{");
    gc_root(strlit3351);
  }
// compiled string node returning strlit3351 (depth = 12)
  int op_slot_right_3350 = gc_frame_newslot(strlit3351);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3350 = gc_frame_newslot(*var_c);
  params[0] = strlit3351;
  partcv[0] = 1;
  Object opresult3353 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3353 (depth = 11)
  Object if3349 = done;
  if (istrue(opresult3353)) {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_interpString (depth = 14)
  partcv[0] = 0;
  Object call3356 = callmethod(*var_interpString, "not",
    1, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 13)
// compiled member node returning call3356 (depth = 12)
  Object if3354 = done;
  if (istrue(call3356)) {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe3357 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 13)
  if (strlit3358 == NULL) {
    strlit3358 = alloc_String("(");
    gc_root(strlit3358);
  }
// compiled string node returning strlit3358 (depth = 13)
  gc_frame_newslot(strlit3358);
// starting to compile string node (depth = 13)
  if (strlit3359 == NULL) {
    strlit3359 = alloc_String("(");
    gc_root(strlit3359);
  }
// compiled string node returning strlit3359 (depth = 13)
  gc_frame_newslot(strlit3359);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3358;
  params[2] = strlit3359;
  partcv[0] = 3;
  Object call3360 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3357);
// compiled call node returning call3360 (depth = 12)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool3361 = alloc_Boolean(1);
// compiled identifier node returning bool3361 (depth = 13)
  *var_interpString = bool3361;
  if (bool3361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3354 = done;
  } else {
  }
// compiled if node returning if3354 (depth = 11)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3363 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3364 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3363);
// compiled call node returning call3364 (depth = 11)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3365 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 12)
  if (strlit3366 == NULL) {
    strlit3366 = alloc_String("o");
    gc_root(strlit3366);
  }
// compiled string node returning strlit3366 (depth = 12)
  gc_frame_newslot(strlit3366);
// starting to compile string node (depth = 12)
  if (strlit3367 == NULL) {
    strlit3367 = alloc_String("++");
    gc_root(strlit3367);
  }
// compiled string node returning strlit3367 (depth = 12)
  gc_frame_newslot(strlit3367);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3366;
  params[2] = strlit3367;
  partcv[0] = 3;
  Object call3368 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3365);
// compiled call node returning call3368 (depth = 11)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3369 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 12)
  if (strlit3370 == NULL) {
    strlit3370 = alloc_String("(");
    gc_root(strlit3370);
  }
// compiled string node returning strlit3370 (depth = 12)
  gc_frame_newslot(strlit3370);
// starting to compile string node (depth = 12)
  if (strlit3371 == NULL) {
    strlit3371 = alloc_String("(");
    gc_root(strlit3371);
  }
// compiled string node returning strlit3371 (depth = 12)
  gc_frame_newslot(strlit3371);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3370;
  params[2] = strlit3371;
  partcv[0] = 3;
  Object call3372 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3369);
// compiled call node returning call3372 (depth = 11)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3373 == NULL) {
    strlit3373 = alloc_String("n");
    gc_root(strlit3373);
  }
// compiled string node returning strlit3373 (depth = 12)
  *var_mode = strlit3373;
  if (strlit3373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3375 == NULL) {
    strlit3375 = alloc_String("n");
    gc_root(strlit3375);
  }
// compiled string node returning strlit3375 (depth = 12)
  *var_newmode = strlit3375;
  if (strlit3375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3377 == NULL) {
    strlit3377 = alloc_String("");
    gc_root(strlit3377);
  }
// compiled string node returning strlit3377 (depth = 12)
  *var_accum = strlit3377;
  if (strlit3377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool3379 = alloc_Boolean(0);
// compiled identifier node returning bool3379 (depth = 12)
  *var_inStr = bool3379;
  if (bool3379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num3382 = alloc_Float64(1);
// compiled num node returning num3382 (depth = 13)
  int op_slot_right_3381 = gc_frame_newslot(num3382);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_interpdepth (depth = 13)
  int op_slot_left_3381 = gc_frame_newslot(*var_interpdepth);
  params[0] = num3382;
  partcv[0] = 1;
  Object sum3384 = callmethod(*var_interpdepth, "+", 1, partcv, params);
// compiled op node returning sum3384 (depth = 12)
  *var_interpdepth = sum3384;
  if (sum3384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3349 = done;
  } else {
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_right_3386 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_3386 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3388 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3388 (depth = 12)
  *var_accum = opresult3388;
  if (opresult3388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3349 = done;
  }
// compiled if node returning if3349 (depth = 10)
    gc_frame_newslot(if3349);
    if3317 = if3349;
  }
// compiled if node returning if3317 (depth = 9)
    gc_frame_newslot(if3317);
    if3310 = if3317;
  }
// compiled if node returning if3310 (depth = 8)
    gc_frame_newslot(if3310);
    if3205 = if3310;
  }
// compiled if node returning if3205 (depth = 7)
    gc_frame_newslot(if3205);
    if2926 = if3205;
  } else {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3393 == NULL) {
    strlit3393 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit3393);
  }
// compiled string node returning strlit3393 (depth = 10)
  int op_slot_right_3392 = gc_frame_newslot(strlit3393);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3392 = gc_frame_newslot(*var_c);
  params[0] = strlit3393;
  partcv[0] = 1;
  Object opresult3395 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3395 (depth = 9)
  int op_slot_right_3391 = gc_frame_newslot(opresult3395);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3399 == NULL) {
    strlit3399 = alloc_String("""\x0d""");
    gc_root(strlit3399);
  }
// compiled string node returning strlit3399 (depth = 11)
  int op_slot_right_3398 = gc_frame_newslot(strlit3399);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3398 = gc_frame_newslot(*var_c);
  params[0] = strlit3399;
  partcv[0] = 1;
  Object opresult3401 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3401 (depth = 10)
  int op_slot_right_3397 = gc_frame_newslot(opresult3401);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3404 == NULL) {
    strlit3404 = alloc_String("""\x0a""");
    gc_root(strlit3404);
  }
// compiled string node returning strlit3404 (depth = 11)
  int op_slot_right_3403 = gc_frame_newslot(strlit3404);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3403 = gc_frame_newslot(*var_c);
  params[0] = strlit3404;
  partcv[0] = 1;
  Object opresult3406 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3406 (depth = 10)
  int op_slot_left_3397 = gc_frame_newslot(opresult3406);
  params[0] = opresult3401;
  partcv[0] = 1;
  Object opresult3407 = callmethod(opresult3406, "||", 1, partcv, params);
// compiled op node returning opresult3407 (depth = 9)
  int op_slot_left_3391 = gc_frame_newslot(opresult3407);
  params[0] = opresult3395;
  partcv[0] = 1;
  Object opresult3408 = callmethod(opresult3407, "||", 1, partcv, params);
// compiled op node returning opresult3408 (depth = 8)
  Object if3390 = done;
  if (istrue(opresult3408)) {
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool3409 = alloc_Boolean(1);
// compiled identifier node returning bool3409 (depth = 9)
  *var_newlineFound = bool3409;
  if (bool3409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3413 == NULL) {
    strlit3413 = alloc_String("q");
    gc_root(strlit3413);
  }
// compiled string node returning strlit3413 (depth = 10)
  int op_slot_right_3412 = gc_frame_newslot(strlit3413);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_3412 = gc_frame_newslot(*var_mode);
  params[0] = strlit3413;
  partcv[0] = 1;
  Object opresult3415 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3415 (depth = 9)
  Object if3411 = done;
  if (istrue(opresult3415)) {
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_3416 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_3416 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3418 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3418 (depth = 10)
  *var_accum = opresult3418;
  if (opresult3418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3411 = done;
  } else {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool3420 = alloc_Boolean(1);
// compiled identifier node returning bool3420 (depth = 10)
  *var_newlineFound = bool3420;
  if (bool3420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3422 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3423 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3422);
// compiled call node returning call3423 (depth = 9)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit3424 == NULL) {
    strlit3424 = alloc_String("d");
    gc_root(strlit3424);
  }
// compiled string node returning strlit3424 (depth = 10)
  *var_mode = strlit3424;
  if (strlit3424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit3426 == NULL) {
    strlit3426 = alloc_String("d");
    gc_root(strlit3426);
  }
// compiled string node returning strlit3426 (depth = 10)
  *var_newmode = strlit3426;
  if (strlit3426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit3428 == NULL) {
    strlit3428 = alloc_String("");
    gc_root(strlit3428);
  }
// compiled string node returning strlit3428 (depth = 10)
  *var_accum = strlit3428;
  if (strlit3428 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3411 = done;
  }
// compiled if node returning if3411 (depth = 8)
    gc_frame_newslot(if3411);
    if3390 = if3411;
  } else {
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_right_3430 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_3430 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3432 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3432 (depth = 9)
  *var_accum = opresult3432;
  if (opresult3432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3390 = done;
  }
// compiled if node returning if3390 (depth = 7)
    gc_frame_newslot(if3390);
    if2926 = if3390;
  }
// compiled if node returning if2926 (depth = 6)
    gc_frame_newslot(if2926);
    if2842 = if2926;
  }
// compiled if node returning if2842 (depth = 5)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3436 == NULL) {
    strlit3436 = alloc_String("...");
    gc_root(strlit3436);
  }
// compiled string node returning strlit3436 (depth = 7)
  int op_slot_right_3435 = gc_frame_newslot(strlit3436);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  int op_slot_left_3435 = gc_frame_newslot(*var_accum);
  params[0] = strlit3436;
  partcv[0] = 1;
  Object opresult3438 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult3438 (depth = 6)
  Object if3434 = done;
  if (istrue(opresult3438)) {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3441 == NULL) {
    strlit3441 = alloc_String("o");
    gc_root(strlit3441);
  }
// compiled string node returning strlit3441 (depth = 8)
  int op_slot_right_3440 = gc_frame_newslot(strlit3441);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_3440 = gc_frame_newslot(*var_mode);
  params[0] = strlit3441;
  partcv[0] = 1;
  Object opresult3443 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3443 (depth = 7)
  Object if3439 = done;
  if (istrue(opresult3443)) {
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3444 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 8)
  if (strlit3445 == NULL) {
    strlit3445 = alloc_String("i");
    gc_root(strlit3445);
  }
// compiled string node returning strlit3445 (depth = 8)
  gc_frame_newslot(strlit3445);
// starting to compile string node (depth = 8)
  if (strlit3446 == NULL) {
    strlit3446 = alloc_String("...");
    gc_root(strlit3446);
  }
// compiled string node returning strlit3446 (depth = 8)
  gc_frame_newslot(strlit3446);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3445;
  params[2] = strlit3446;
  partcv[0] = 3;
  Object call3447 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3444);
// compiled call node returning call3447 (depth = 7)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3448 == NULL) {
    strlit3448 = alloc_String("n");
    gc_root(strlit3448);
  }
// compiled string node returning strlit3448 (depth = 8)
  *var_newmode = strlit3448;
  if (strlit3448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newmode (depth = 8)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3451 == NULL) {
    strlit3451 = alloc_String("");
    gc_root(strlit3451);
  }
// compiled string node returning strlit3451 (depth = 8)
  *var_accum = strlit3451;
  if (strlit3451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3439 = done;
  } else {
  }
// compiled if node returning if3439 (depth = 6)
    gc_frame_newslot(if3439);
    if3434 = if3439;
  } else {
  }
// compiled if node returning if3434 (depth = 5)
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newlineFound (depth = 6)
  Object if3453 = done;
  if (istrue(*var_newlineFound)) {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool3454 = alloc_Boolean(0);
// compiled identifier node returning bool3454 (depth = 7)
  *var_newlineFound = bool3454;
  if (bool3454 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num3457 = alloc_Float64(1);
// compiled num node returning num3457 (depth = 8)
  int op_slot_right_3456 = gc_frame_newslot(num3457);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  int op_slot_left_3456 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3457;
  partcv[0] = 1;
  Object sum3459 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3459 (depth = 7)
  *var_lineNumber = sum3459;
  if (sum3459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3461 = alloc_Float64(0);
// compiled num node returning num3461 (depth = 7)
  *var_linePosition = num3461;
  if (num3461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3463 = alloc_Float64(1);
// compiled num node returning num3463 (depth = 7)
  *var_startPosition = num3463;
  if (num3463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3453 = done;
  } else {
  }
// compiled if node returning if3453 (depth = 5)
  gc_frame_end(frame);
  return if3453;
}
Object meth_lexer__apply3468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_mode = getfromclosure(closure, 1);
  Object *var_mainBlock = getfromclosure(closure, 2);
  Object *var_prev = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3470 = alloc_Float64(1);
// compiled num node returning num3470 (depth = 7)
  int op_slot_right_3469 = gc_frame_newslot(num3470);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_3469 = gc_frame_newslot(*var_linePosition);
  params[0] = num3470;
  partcv[0] = 1;
  Object sum3472 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3472 (depth = 6)
  *var_linePosition = sum3472;
  if (sum3472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3476 == NULL) {
    strlit3476 = alloc_String(" ");
    gc_root(strlit3476);
  }
// compiled string node returning strlit3476 (depth = 7)
  int op_slot_right_3475 = gc_frame_newslot(strlit3476);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_3475 = gc_frame_newslot(*var_c);
  params[0] = strlit3476;
  partcv[0] = 1;
  Object opresult3478 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3478 (depth = 6)
  Object if3474 = done;
  if (istrue(opresult3478)) {
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3481 == NULL) {
    strlit3481 = alloc_String("d");
    gc_root(strlit3481);
  }
// compiled string node returning strlit3481 (depth = 8)
  int op_slot_right_3480 = gc_frame_newslot(strlit3481);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_3480 = gc_frame_newslot(*var_mode);
  params[0] = strlit3481;
  partcv[0] = 1;
  Object opresult3483 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3483 (depth = 7)
  Object if3479 = done;
  if (istrue(opresult3483)) {
    gc_frame_newslot(done);
    if3479 = done;
  } else {
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3486 == NULL) {
    strlit3486 = alloc_String("n");
    gc_root(strlit3486);
  }
// compiled string node returning strlit3486 (depth = 9)
  int op_slot_right_3485 = gc_frame_newslot(strlit3486);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_3485 = gc_frame_newslot(*var_mode);
  params[0] = strlit3486;
  partcv[0] = 1;
  Object opresult3488 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult3488 (depth = 8)
  Object if3484 = done;
  if (istrue(opresult3488)) {
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3489 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mainBlock (depth = 9)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3490 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3489);
// compiled call node returning call3490 (depth = 8)
    gc_frame_newslot(call3490);
    if3484 = call3490;
  } else {
  }
// compiled if node returning if3484 (depth = 7)
    gc_frame_newslot(if3484);
    if3479 = if3484;
  }
// compiled if node returning if3479 (depth = 6)
    gc_frame_newslot(if3479);
    if3474 = if3479;
  } else {
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3491 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mainBlock (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3492 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3491);
// compiled call node returning call3492 (depth = 6)
    gc_frame_newslot(call3492);
    if3474 = call3492;
  }
// compiled if node returning if3474 (depth = 5)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  *var_prev = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_lexinput1817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexinput");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexinput");
  Object params[14];
  int partcv[3];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object *var_stringStart = getfromclosure(closure, 5);
  Object *var_startLine = getfromclosure(closure, 6);
  Object *var_startPosition = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexinput (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_input = &(stackframe->slots[0]);
  *var_input = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexinput");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tokens");
  Object *var_mode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "mode");
  Object *var_newmode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newmode");
  Object *var_inStr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "inStr");
  Object *var_inBackticks = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inBackticks");
  Object *var_backtickIdent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "backtickIdent");
  Object *var_accum = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "accum");
  Object *var_escaped = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "escaped");
  Object *var_prev = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prev");
  Object *var_unichars = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "unichars");
  Object *var_codepoint = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "codepoint");
  Object *var_interpdepth = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "interpdepth");
  Object *var_interpString = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "interpString");
  Object *var_atStart = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "atStart");
  Object *var_newlineFound = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "newlineFound");
  Object *var_badSeparator = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "badSeparator");
  Object *var_badControl = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "badControl");
  Object *var_selfModes = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "selfModes");
  Object *var_brackets = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "brackets");
  Object *var_identifierChar = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "identifierChar");
  Object *var_digit = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "digit");
  Object *var_operatorChar = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "operatorChar");
  Object *var_iGTLT = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "iGTLT");
  Object *var_mainBlock = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "mainBlock");
  Object *var_suggestion = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "suggestion");
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject1818 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1818 = alloc_userobj2(13,11, objclass1818);
  gc_frame_newslot(obj1818);
// OBJECT OUTER DEC outer
  adddatum2(obj1818, self, 0);
  addmethodreal(obj1818,"outer", &reader_lexer_outer_1819);
  Object oldself1818 = self;
  struct StackFrameObject *oldstackframe1818 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1818);
  gc_frame_newslot((Object)stackframe);
  self = obj1818;
  Object *oldselfslot1818 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1818 = (*(struct UserObject *)self).data[0], lowerouter1818 = thisouter1818;
  if (inheritingObject1818) {
    struct UserObject *inho1818 = (struct UserObject *)inheritingObject1818;
    while (inho1818->super != GraceDefaultObject) inho1818 = (struct UserObject *)inho1818->super;
    inho1818->super = obj1818;
    self = inheritingObject1818;
    *selfslot = self;
    lowerouter1818 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1818;
  }
if (objclass1818 == NULL) {
  Method *reader1820 = addmethodrealflags(obj1818, "first",&reader_lexer_first_1820, 0);
  Method *writer1820 = addmethodrealflags(obj1818, "first:=",&writer_lexer_first_1820, 0);
  reader1820->definitionModule = modulename;
  writer1820->definitionModule = modulename;
  reader1820->definitionLine = 550;
  writer1820->definitionLine = 550;
}
obj1818->flags |= OFLAG_MUTABLE;
adddatum2(obj1818, alloc_Undefined(), 1);
if (objclass1818 == NULL) {
  Method *reader1821 = addmethodrealflags(obj1818, "last",&reader_lexer_last_1821, 0);
  Method *writer1821 = addmethodrealflags(obj1818, "last:=",&writer_lexer_last_1821, 0);
  reader1821->definitionModule = modulename;
  writer1821->definitionModule = modulename;
  reader1821->definitionLine = 551;
  writer1821->definitionLine = 551;
}
obj1818->flags |= OFLAG_MUTABLE;
adddatum2(obj1818, alloc_Undefined(), 2);
if (objclass1818 == NULL) {
  Method *reader1822 = addmethodrealflags(obj1818, "size'",&reader_lexer_size_39__1822, 0);
  Method *writer1822 = addmethodrealflags(obj1818, "size':=",&writer_lexer_size_39__1822, 0);
  reader1822->definitionModule = modulename;
  writer1822->definitionModule = modulename;
  reader1822->definitionLine = 553;
  writer1822->definitionLine = 553;
}
obj1818->flags |= OFLAG_MUTABLE;
adddatum2(obj1818, alloc_Undefined(), 3);
// method push
  struct UserObject *uo1823 = (struct UserObject*)obj1818;
  uo1823->data[4] = emptyclosure;
  Method *meth_meth_lexer_push1823 = addmethod2pos(obj1818, "push", &meth_lexer_push1823, 4);
  int argcv_meth_lexer_push1823[] = {1};
  meth_meth_lexer_push1823->type = alloc_MethodType(1, argcv_meth_lexer_push1823);
  meth_meth_lexer_push1823->definitionModule = modulename;
  meth_meth_lexer_push1823->definitionLine = 553;
// method pop
  struct UserObject *uo1853 = (struct UserObject*)obj1818;
  uo1853->data[5] = emptyclosure;
  Method *meth_meth_lexer_pop1853 = addmethod2pos(obj1818, "pop", &meth_lexer_pop1853, 5);
  int argcv_meth_lexer_pop1853[] = {0};
  meth_meth_lexer_pop1853->type = alloc_MethodType(1, argcv_meth_lexer_pop1853);
  meth_meth_lexer_pop1853->definitionModule = modulename;
  meth_meth_lexer_pop1853->definitionLine = 565;
// method poll
  struct UserObject *uo1887 = (struct UserObject*)obj1818;
  uo1887->data[6] = emptyclosure;
  Method *meth_meth_lexer_poll1887 = addmethod2pos(obj1818, "poll", &meth_lexer_poll1887, 6);
  int argcv_meth_lexer_poll1887[] = {0};
  meth_meth_lexer_poll1887->type = alloc_MethodType(1, argcv_meth_lexer_poll1887);
  meth_meth_lexer_poll1887->definitionModule = modulename;
  meth_meth_lexer_poll1887->definitionLine = 577;
// method size
  struct UserObject *uo1921 = (struct UserObject*)obj1818;
  uo1921->data[7] = emptyclosure;
  Method *meth_meth_lexer_size1921 = addmethod2pos(obj1818, "size", &meth_lexer_size1921, 7);
  int argcv_meth_lexer_size1921[] = {0};
  meth_meth_lexer_size1921->type = alloc_MethodType(1, argcv_meth_lexer_size1921);
  meth_meth_lexer_size1921->definitionModule = modulename;
  meth_meth_lexer_size1921->definitionLine = 589;
// method iter
  struct UserObject *uo1928 = (struct UserObject*)obj1818;
  uo1928->data[8] = emptyclosure;
  Method *meth_meth_lexer_iter1928 = addmethod2pos(obj1818, "iter", &meth_lexer_iter1928, 8);
  int argcv_meth_lexer_iter1928[] = {0};
  meth_meth_lexer_iter1928->type = alloc_MethodType(1, argcv_meth_lexer_iter1928);
  meth_meth_lexer_iter1928->definitionModule = modulename;
  meth_meth_lexer_iter1928->definitionLine = 593;
  Method *meth_meth_lexer_iter1928_object = addmethod2pos(obj1818, "iter()object", &meth_lexer_iter1928_object, 8);
  int argcv_meth_lexer_iter1928_object[] = {0};
  meth_meth_lexer_iter1928_object->type = alloc_MethodType(1, argcv_meth_lexer_iter1928_object);
  meth_meth_lexer_iter1928_object->definitionModule = modulename;
  meth_meth_lexer_iter1928_object->definitionLine = 593;
// method iterator
  struct UserObject *uo1960 = (struct UserObject*)obj1818;
  uo1960->data[9] = emptyclosure;
  Method *meth_meth_lexer_iterator1960 = addmethod2pos(obj1818, "iterator", &meth_lexer_iterator1960, 9);
  int argcv_meth_lexer_iterator1960[] = {0};
  meth_meth_lexer_iterator1960->type = alloc_MethodType(1, argcv_meth_lexer_iterator1960);
  meth_meth_lexer_iterator1960->definitionModule = modulename;
  meth_meth_lexer_iterator1960->definitionLine = 610;
  sourceObject = obj1818;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1963 = alloc_Boolean(0);
// compiled identifier node returning bool1963 (depth = 5)
  adddatum2(obj1818, bool1963, 1);
  sourceObject = obj1818;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1964 = alloc_Boolean(0);
// compiled identifier node returning bool1964 (depth = 5)
  adddatum2(obj1818, bool1964, 2);
  sourceObject = obj1818;
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1965 = alloc_Float64(0);
// compiled num node returning num1965 (depth = 5)
  adddatum2(obj1818, num1965, 3);
  sourceObject = obj1818;
  sourceObject = obj1818;
  sourceObject = obj1818;
  sourceObject = obj1818;
  sourceObject = obj1818;
  sourceObject = obj1818;
objclass1818 = obj1818->class;
  objclass1818->definitionModule = modulename;
  objclass1818->definitionLine = 548;
  (*(struct UserObject *)self).data[0] = lowerouter1818;
  self = oldself1818;
  selfslot = oldselfslot1818;
  stackframe = oldstackframe1818;
// compiled object node returning obj1818 (depth = 4)
  *var_tokens = obj1818;
  if (obj1818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1966 == NULL) {
    strlit1966 = alloc_String("d");
    gc_root(strlit1966);
  }
// compiled string node returning strlit1966 (depth = 4)
  *var_mode = strlit1966;
  if (strlit1966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mode (depth = 4)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1967 = alloc_Boolean(0);
// compiled identifier node returning bool1967 (depth = 4)
  *var_inStr = bool1967;
  if (bool1967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1968 = alloc_Boolean(0);
// compiled identifier node returning bool1968 (depth = 4)
  *var_inBackticks = bool1968;
  if (bool1968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1969 = alloc_Boolean(0);
// compiled identifier node returning bool1969 (depth = 4)
  *var_backtickIdent = bool1969;
  if (bool1969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1970 == NULL) {
    strlit1970 = alloc_String("");
    gc_root(strlit1970);
  }
// compiled string node returning strlit1970 (depth = 4)
  *var_accum = strlit1970;
  if (strlit1970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1971 = alloc_Boolean(0);
// compiled identifier node returning bool1971 (depth = 4)
  *var_escaped = bool1971;
  if (bool1971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1972 == NULL) {
    strlit1972 = alloc_String("");
    gc_root(strlit1972);
  }
// compiled string node returning strlit1972 (depth = 4)
  *var_prev = strlit1972;
  if (strlit1972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1973 = alloc_Float64(0);
// compiled num node returning num1973 (depth = 4)
  *var_unichars = num1973;
  if (num1973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1974 = alloc_Float64(0);
// compiled num node returning num1974 (depth = 4)
  *var_codepoint = num1974;
  if (num1974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1975 = alloc_Float64(0);
// compiled num node returning num1975 (depth = 4)
  *var_interpdepth = num1975;
  if (num1975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1976 = alloc_Boolean(0);
// compiled identifier node returning bool1976 (depth = 4)
  *var_interpString = bool1976;
  if (bool1976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1977 = alloc_Boolean(1);
// compiled identifier node returning bool1977 (depth = 4)
  *var_atStart = bool1977;
  if (bool1977 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1978 = alloc_Boolean(0);
// compiled identifier node returning bool1978 (depth = 4)
  *var_newlineFound = bool1978;
  if (bool1978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1979 = alloc_Float64(0);
// compiled num node returning num1979 (depth = 4)
  *var_linePosition = num1979;
  if (num1979 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1981 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1982 == NULL) {
    strlit1982 = alloc_String("lexing.");
    gc_root(strlit1982);
  }
// compiled string node returning strlit1982 (depth = 4)
  gc_frame_newslot(strlit1982);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = strlit1982;
  partcv[0] = 1;
  Object call1983 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe1981);
// compiled call node returning call1983 (depth = 3)
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1984 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1985 == NULL) {
    strlit1985 = alloc_String("Z");
    gc_root(strlit1985);
  }
// compiled string node returning strlit1985 (depth = 5)
  gc_frame_newslot(strlit1985);
// starting to compile num node (depth = 5)
  Object num1986 = alloc_Float64(9);
// compiled num node returning num1986 (depth = 5)
  gc_frame_newslot(num1986);
// starting to compile num node (depth = 5)
  Object num1987 = alloc_Float64(32);
// compiled num node returning num1987 (depth = 5)
  gc_frame_newslot(num1987);
// starting to compile num node (depth = 5)
  Object num1988 = alloc_Float64(160);
// compiled num node returning num1988 (depth = 5)
  gc_frame_newslot(num1988);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit1985;
  params[1] = num1986;
  params[2] = num1987;
  params[3] = num1988;
  partcv[0] = 2;
  partcv[1] = 2;
  Object call1989 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe1984);
// compiled call node returning call1989 (depth = 4)
  *var_badSeparator = call1989;
  if (call1989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1990 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1991 == NULL) {
    strlit1991 = alloc_String("C");
    gc_root(strlit1991);
  }
// compiled string node returning strlit1991 (depth = 5)
  gc_frame_newslot(strlit1991);
// starting to compile num node (depth = 5)
  Object num1992 = alloc_Float64(10);
// compiled num node returning num1992 (depth = 5)
  gc_frame_newslot(num1992);
// starting to compile num node (depth = 5)
  Object num1993 = alloc_Float64(13);
// compiled num node returning num1993 (depth = 5)
  gc_frame_newslot(num1993);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit1991;
  params[1] = num1992;
  params[2] = num1993;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call1994 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe1990);
// compiled call node returning call1994 (depth = 4)
  *var_badControl = call1994;
  if (call1994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1995 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1996 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1997 == NULL) {
    strlit1997 = alloc_String("(");
    gc_root(strlit1997);
  }
// compiled string node returning strlit1997 (depth = 7)
  partcv[0] = 0;
  Object call1998 = callmethod(strlit1997, "ord",
    1, partcv, params);
  gc_frame_end(callframe1996);
// compiled call node returning call1998 (depth = 6)
// compiled member node returning call1998 (depth = 5)
  gc_frame_newslot(call1998);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1999 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2000 == NULL) {
    strlit2000 = alloc_String(")");
    gc_root(strlit2000);
  }
// compiled string node returning strlit2000 (depth = 7)
  partcv[0] = 0;
  Object call2001 = callmethod(strlit2000, "ord",
    1, partcv, params);
  gc_frame_end(callframe1999);
// compiled call node returning call2001 (depth = 6)
// compiled member node returning call2001 (depth = 5)
  gc_frame_newslot(call2001);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2002 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2003 == NULL) {
    strlit2003 = alloc_String(",");
    gc_root(strlit2003);
  }
// compiled string node returning strlit2003 (depth = 7)
  partcv[0] = 0;
  Object call2004 = callmethod(strlit2003, "ord",
    1, partcv, params);
  gc_frame_end(callframe2002);
// compiled call node returning call2004 (depth = 6)
// compiled member node returning call2004 (depth = 5)
  gc_frame_newslot(call2004);
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2005 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2006 == NULL) {
    strlit2006 = alloc_String(".");
    gc_root(strlit2006);
  }
// compiled string node returning strlit2006 (depth = 7)
  partcv[0] = 0;
  Object call2007 = callmethod(strlit2006, "ord",
    1, partcv, params);
  gc_frame_end(callframe2005);
// compiled call node returning call2007 (depth = 6)
// compiled member node returning call2007 (depth = 5)
  gc_frame_newslot(call2007);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2008 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2009 == NULL) {
    strlit2009 = alloc_String("{");
    gc_root(strlit2009);
  }
// compiled string node returning strlit2009 (depth = 7)
  partcv[0] = 0;
  Object call2010 = callmethod(strlit2009, "ord",
    1, partcv, params);
  gc_frame_end(callframe2008);
// compiled call node returning call2010 (depth = 6)
// compiled member node returning call2010 (depth = 5)
  gc_frame_newslot(call2010);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2011 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2012 == NULL) {
    strlit2012 = alloc_String("}");
    gc_root(strlit2012);
  }
// compiled string node returning strlit2012 (depth = 7)
  partcv[0] = 0;
  Object call2013 = callmethod(strlit2012, "ord",
    1, partcv, params);
  gc_frame_end(callframe2011);
// compiled call node returning call2013 (depth = 6)
// compiled member node returning call2013 (depth = 5)
  gc_frame_newslot(call2013);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2014 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2015 == NULL) {
    strlit2015 = alloc_String("[");
    gc_root(strlit2015);
  }
// compiled string node returning strlit2015 (depth = 7)
  partcv[0] = 0;
  Object call2016 = callmethod(strlit2015, "ord",
    1, partcv, params);
  gc_frame_end(callframe2014);
// compiled call node returning call2016 (depth = 6)
// compiled member node returning call2016 (depth = 5)
  gc_frame_newslot(call2016);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2017 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2018 == NULL) {
    strlit2018 = alloc_String("]");
    gc_root(strlit2018);
  }
// compiled string node returning strlit2018 (depth = 7)
  partcv[0] = 0;
  Object call2019 = callmethod(strlit2018, "ord",
    1, partcv, params);
  gc_frame_end(callframe2017);
// compiled call node returning call2019 (depth = 6)
// compiled member node returning call2019 (depth = 5)
  gc_frame_newslot(call2019);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2020 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2021 == NULL) {
    strlit2021 = alloc_String(";");
    gc_root(strlit2021);
  }
// compiled string node returning strlit2021 (depth = 7)
  partcv[0] = 0;
  Object call2022 = callmethod(strlit2021, "ord",
    1, partcv, params);
  gc_frame_end(callframe2020);
// compiled call node returning call2022 (depth = 6)
// compiled member node returning call2022 (depth = 5)
  gc_frame_newslot(call2022);
// call case 6: other member request
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call1998;
  params[1] = call2001;
  params[2] = call2004;
  params[3] = call2007;
  params[4] = call2010;
  params[5] = call2013;
  params[6] = call2016;
  params[7] = call2019;
  params[8] = call2022;
  partcv[0] = 9;
  Object call2023 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe1995);
// compiled call node returning call2023 (depth = 4)
  *var_selfModes = call2023;
  if (call2023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2024 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2025 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2026 == NULL) {
    strlit2026 = alloc_String("(");
    gc_root(strlit2026);
  }
// compiled string node returning strlit2026 (depth = 7)
  partcv[0] = 0;
  Object call2027 = callmethod(strlit2026, "ord",
    1, partcv, params);
  gc_frame_end(callframe2025);
// compiled call node returning call2027 (depth = 6)
// compiled member node returning call2027 (depth = 5)
  gc_frame_newslot(call2027);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2028 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2029 == NULL) {
    strlit2029 = alloc_String(")");
    gc_root(strlit2029);
  }
// compiled string node returning strlit2029 (depth = 7)
  partcv[0] = 0;
  Object call2030 = callmethod(strlit2029, "ord",
    1, partcv, params);
  gc_frame_end(callframe2028);
// compiled call node returning call2030 (depth = 6)
// compiled member node returning call2030 (depth = 5)
  gc_frame_newslot(call2030);
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2031 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2032 == NULL) {
    strlit2032 = alloc_String("{");
    gc_root(strlit2032);
  }
// compiled string node returning strlit2032 (depth = 7)
  partcv[0] = 0;
  Object call2033 = callmethod(strlit2032, "ord",
    1, partcv, params);
  gc_frame_end(callframe2031);
// compiled call node returning call2033 (depth = 6)
// compiled member node returning call2033 (depth = 5)
  gc_frame_newslot(call2033);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2034 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2035 == NULL) {
    strlit2035 = alloc_String("}");
    gc_root(strlit2035);
  }
// compiled string node returning strlit2035 (depth = 7)
  partcv[0] = 0;
  Object call2036 = callmethod(strlit2035, "ord",
    1, partcv, params);
  gc_frame_end(callframe2034);
// compiled call node returning call2036 (depth = 6)
// compiled member node returning call2036 (depth = 5)
  gc_frame_newslot(call2036);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2037 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2038 == NULL) {
    strlit2038 = alloc_String("[");
    gc_root(strlit2038);
  }
// compiled string node returning strlit2038 (depth = 7)
  partcv[0] = 0;
  Object call2039 = callmethod(strlit2038, "ord",
    1, partcv, params);
  gc_frame_end(callframe2037);
// compiled call node returning call2039 (depth = 6)
// compiled member node returning call2039 (depth = 5)
  gc_frame_newslot(call2039);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2040 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2041 == NULL) {
    strlit2041 = alloc_String("]");
    gc_root(strlit2041);
  }
// compiled string node returning strlit2041 (depth = 7)
  partcv[0] = 0;
  Object call2042 = callmethod(strlit2041, "ord",
    1, partcv, params);
  gc_frame_end(callframe2040);
// compiled call node returning call2042 (depth = 6)
// compiled member node returning call2042 (depth = 5)
  gc_frame_newslot(call2042);
// call case 6: other member request
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2027;
  params[1] = call2030;
  params[2] = call2033;
  params[3] = call2036;
  params[4] = call2039;
  params[5] = call2042;
  partcv[0] = 6;
  Object call2043 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2024);
// compiled call node returning call2043 (depth = 4)
  *var_brackets = call2043;
  if (call2043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2044 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2045 == NULL) {
    strlit2045 = alloc_String("L");
    gc_root(strlit2045);
  }
// compiled string node returning strlit2045 (depth = 5)
  gc_frame_newslot(strlit2045);
// starting to compile string node (depth = 5)
  if (strlit2046 == NULL) {
    strlit2046 = alloc_String("N");
    gc_root(strlit2046);
  }
// compiled string node returning strlit2046 (depth = 5)
  gc_frame_newslot(strlit2046);
// starting to compile num node (depth = 5)
  Object num2047 = alloc_Float64(95);
// compiled num node returning num2047 (depth = 5)
  gc_frame_newslot(num2047);
// starting to compile num node (depth = 5)
  Object num2048 = alloc_Float64(39);
// compiled num node returning num2048 (depth = 5)
  gc_frame_newslot(num2048);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit2045;
  params[1] = strlit2046;
  params[2] = num2047;
  params[3] = num2048;
  partcv[0] = 4;
  Object call2049 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2044);
// compiled call node returning call2049 (depth = 4)
  *var_identifierChar = call2049;
  if (call2049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2050 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2051 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2052 == NULL) {
    strlit2052 = alloc_String("0");
    gc_root(strlit2052);
  }
// compiled string node returning strlit2052 (depth = 7)
  partcv[0] = 0;
  Object call2053 = callmethod(strlit2052, "ord",
    1, partcv, params);
  gc_frame_end(callframe2051);
// compiled call node returning call2053 (depth = 6)
// compiled member node returning call2053 (depth = 5)
  gc_frame_newslot(call2053);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2054 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2055 == NULL) {
    strlit2055 = alloc_String("1");
    gc_root(strlit2055);
  }
// compiled string node returning strlit2055 (depth = 7)
  partcv[0] = 0;
  Object call2056 = callmethod(strlit2055, "ord",
    1, partcv, params);
  gc_frame_end(callframe2054);
// compiled call node returning call2056 (depth = 6)
// compiled member node returning call2056 (depth = 5)
  gc_frame_newslot(call2056);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2057 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2058 == NULL) {
    strlit2058 = alloc_String("2");
    gc_root(strlit2058);
  }
// compiled string node returning strlit2058 (depth = 7)
  partcv[0] = 0;
  Object call2059 = callmethod(strlit2058, "ord",
    1, partcv, params);
  gc_frame_end(callframe2057);
// compiled call node returning call2059 (depth = 6)
// compiled member node returning call2059 (depth = 5)
  gc_frame_newslot(call2059);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2060 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2061 == NULL) {
    strlit2061 = alloc_String("3");
    gc_root(strlit2061);
  }
// compiled string node returning strlit2061 (depth = 7)
  partcv[0] = 0;
  Object call2062 = callmethod(strlit2061, "ord",
    1, partcv, params);
  gc_frame_end(callframe2060);
// compiled call node returning call2062 (depth = 6)
// compiled member node returning call2062 (depth = 5)
  gc_frame_newslot(call2062);
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2063 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2064 == NULL) {
    strlit2064 = alloc_String("4");
    gc_root(strlit2064);
  }
// compiled string node returning strlit2064 (depth = 7)
  partcv[0] = 0;
  Object call2065 = callmethod(strlit2064, "ord",
    1, partcv, params);
  gc_frame_end(callframe2063);
// compiled call node returning call2065 (depth = 6)
// compiled member node returning call2065 (depth = 5)
  gc_frame_newslot(call2065);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2066 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2067 == NULL) {
    strlit2067 = alloc_String("5");
    gc_root(strlit2067);
  }
// compiled string node returning strlit2067 (depth = 7)
  partcv[0] = 0;
  Object call2068 = callmethod(strlit2067, "ord",
    1, partcv, params);
  gc_frame_end(callframe2066);
// compiled call node returning call2068 (depth = 6)
// compiled member node returning call2068 (depth = 5)
  gc_frame_newslot(call2068);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2069 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2070 == NULL) {
    strlit2070 = alloc_String("6");
    gc_root(strlit2070);
  }
// compiled string node returning strlit2070 (depth = 7)
  partcv[0] = 0;
  Object call2071 = callmethod(strlit2070, "ord",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2071 (depth = 6)
// compiled member node returning call2071 (depth = 5)
  gc_frame_newslot(call2071);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2072 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2073 == NULL) {
    strlit2073 = alloc_String("7");
    gc_root(strlit2073);
  }
// compiled string node returning strlit2073 (depth = 7)
  partcv[0] = 0;
  Object call2074 = callmethod(strlit2073, "ord",
    1, partcv, params);
  gc_frame_end(callframe2072);
// compiled call node returning call2074 (depth = 6)
// compiled member node returning call2074 (depth = 5)
  gc_frame_newslot(call2074);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2075 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2076 == NULL) {
    strlit2076 = alloc_String("8");
    gc_root(strlit2076);
  }
// compiled string node returning strlit2076 (depth = 7)
  partcv[0] = 0;
  Object call2077 = callmethod(strlit2076, "ord",
    1, partcv, params);
  gc_frame_end(callframe2075);
// compiled call node returning call2077 (depth = 6)
// compiled member node returning call2077 (depth = 5)
  gc_frame_newslot(call2077);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2078 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2079 == NULL) {
    strlit2079 = alloc_String("9");
    gc_root(strlit2079);
  }
// compiled string node returning strlit2079 (depth = 7)
  partcv[0] = 0;
  Object call2080 = callmethod(strlit2079, "ord",
    1, partcv, params);
  gc_frame_end(callframe2078);
// compiled call node returning call2080 (depth = 6)
// compiled member node returning call2080 (depth = 5)
  gc_frame_newslot(call2080);
// call case 6: other member request
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2053;
  params[1] = call2056;
  params[2] = call2059;
  params[3] = call2062;
  params[4] = call2065;
  params[5] = call2068;
  params[6] = call2071;
  params[7] = call2074;
  params[8] = call2077;
  params[9] = call2080;
  partcv[0] = 10;
  Object call2081 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2050);
// compiled call node returning call2081 (depth = 4)
  *var_digit = call2081;
  if (call2081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2082 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2083 == NULL) {
    strlit2083 = alloc_String("Sm");
    gc_root(strlit2083);
  }
// compiled string node returning strlit2083 (depth = 5)
  gc_frame_newslot(strlit2083);
// starting to compile string node (depth = 5)
  if (strlit2084 == NULL) {
    strlit2084 = alloc_String("So");
    gc_root(strlit2084);
  }
// compiled string node returning strlit2084 (depth = 5)
  gc_frame_newslot(strlit2084);
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2085 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2086 == NULL) {
    strlit2086 = alloc_String("-");
    gc_root(strlit2086);
  }
// compiled string node returning strlit2086 (depth = 7)
  partcv[0] = 0;
  Object call2087 = callmethod(strlit2086, "ord",
    1, partcv, params);
  gc_frame_end(callframe2085);
// compiled call node returning call2087 (depth = 6)
// compiled member node returning call2087 (depth = 5)
  gc_frame_newslot(call2087);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2088 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2089 == NULL) {
    strlit2089 = alloc_String("&");
    gc_root(strlit2089);
  }
// compiled string node returning strlit2089 (depth = 7)
  partcv[0] = 0;
  Object call2090 = callmethod(strlit2089, "ord",
    1, partcv, params);
  gc_frame_end(callframe2088);
// compiled call node returning call2090 (depth = 6)
// compiled member node returning call2090 (depth = 5)
  gc_frame_newslot(call2090);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2091 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2092 == NULL) {
    strlit2092 = alloc_String("|");
    gc_root(strlit2092);
  }
// compiled string node returning strlit2092 (depth = 7)
  partcv[0] = 0;
  Object call2093 = callmethod(strlit2092, "ord",
    1, partcv, params);
  gc_frame_end(callframe2091);
// compiled call node returning call2093 (depth = 6)
// compiled member node returning call2093 (depth = 5)
  gc_frame_newslot(call2093);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2094 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2095 == NULL) {
    strlit2095 = alloc_String(":");
    gc_root(strlit2095);
  }
// compiled string node returning strlit2095 (depth = 7)
  partcv[0] = 0;
  Object call2096 = callmethod(strlit2095, "ord",
    1, partcv, params);
  gc_frame_end(callframe2094);
// compiled call node returning call2096 (depth = 6)
// compiled member node returning call2096 (depth = 5)
  gc_frame_newslot(call2096);
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2097 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2098 == NULL) {
    strlit2098 = alloc_String("%");
    gc_root(strlit2098);
  }
// compiled string node returning strlit2098 (depth = 7)
  partcv[0] = 0;
  Object call2099 = callmethod(strlit2098, "ord",
    1, partcv, params);
  gc_frame_end(callframe2097);
// compiled call node returning call2099 (depth = 6)
// compiled member node returning call2099 (depth = 5)
  gc_frame_newslot(call2099);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2100 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2101 == NULL) {
    strlit2101 = alloc_String("^");
    gc_root(strlit2101);
  }
// compiled string node returning strlit2101 (depth = 7)
  partcv[0] = 0;
  Object call2102 = callmethod(strlit2101, "ord",
    1, partcv, params);
  gc_frame_end(callframe2100);
// compiled call node returning call2102 (depth = 6)
// compiled member node returning call2102 (depth = 5)
  gc_frame_newslot(call2102);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2103 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2104 == NULL) {
    strlit2104 = alloc_String("@");
    gc_root(strlit2104);
  }
// compiled string node returning strlit2104 (depth = 7)
  partcv[0] = 0;
  Object call2105 = callmethod(strlit2104, "ord",
    1, partcv, params);
  gc_frame_end(callframe2103);
// compiled call node returning call2105 (depth = 6)
// compiled member node returning call2105 (depth = 5)
  gc_frame_newslot(call2105);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2106 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2107 == NULL) {
    strlit2107 = alloc_String("?");
    gc_root(strlit2107);
  }
// compiled string node returning strlit2107 (depth = 7)
  partcv[0] = 0;
  Object call2108 = callmethod(strlit2107, "ord",
    1, partcv, params);
  gc_frame_end(callframe2106);
// compiled call node returning call2108 (depth = 6)
// compiled member node returning call2108 (depth = 5)
  gc_frame_newslot(call2108);
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2109 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2110 == NULL) {
    strlit2110 = alloc_String("*");
    gc_root(strlit2110);
  }
// compiled string node returning strlit2110 (depth = 7)
  partcv[0] = 0;
  Object call2111 = callmethod(strlit2110, "ord",
    1, partcv, params);
  gc_frame_end(callframe2109);
// compiled call node returning call2111 (depth = 6)
// compiled member node returning call2111 (depth = 5)
  gc_frame_newslot(call2111);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2112 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2113 == NULL) {
    strlit2113 = alloc_String("/");
    gc_root(strlit2113);
  }
// compiled string node returning strlit2113 (depth = 7)
  partcv[0] = 0;
  Object call2114 = callmethod(strlit2113, "ord",
    1, partcv, params);
  gc_frame_end(callframe2112);
// compiled call node returning call2114 (depth = 6)
// compiled member node returning call2114 (depth = 5)
  gc_frame_newslot(call2114);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2115 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2116 == NULL) {
    strlit2116 = alloc_String("+");
    gc_root(strlit2116);
  }
// compiled string node returning strlit2116 (depth = 7)
  partcv[0] = 0;
  Object call2117 = callmethod(strlit2116, "ord",
    1, partcv, params);
  gc_frame_end(callframe2115);
// compiled call node returning call2117 (depth = 6)
// compiled member node returning call2117 (depth = 5)
  gc_frame_newslot(call2117);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2118 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2119 == NULL) {
    strlit2119 = alloc_String("!");
    gc_root(strlit2119);
  }
// compiled string node returning strlit2119 (depth = 7)
  partcv[0] = 0;
  Object call2120 = callmethod(strlit2119, "ord",
    1, partcv, params);
  gc_frame_end(callframe2118);
// compiled call node returning call2120 (depth = 6)
// compiled member node returning call2120 (depth = 5)
  gc_frame_newslot(call2120);
// call case 6: other member request
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit2083;
  params[1] = strlit2084;
  params[2] = call2087;
  params[3] = call2090;
  params[4] = call2093;
  params[5] = call2096;
  params[6] = call2099;
  params[7] = call2102;
  params[8] = call2105;
  params[9] = call2108;
  params[10] = call2111;
  params[11] = call2114;
  params[12] = call2117;
  params[13] = call2120;
  partcv[0] = 14;
  Object call2121 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2082);
// compiled call node returning call2121 (depth = 4)
  *var_operatorChar = call2121;
  if (call2121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2122 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2123 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2124 == NULL) {
    strlit2124 = alloc_String("i");
    gc_root(strlit2124);
  }
// compiled string node returning strlit2124 (depth = 7)
  partcv[0] = 0;
  Object call2125 = callmethod(strlit2124, "ord",
    1, partcv, params);
  gc_frame_end(callframe2123);
// compiled call node returning call2125 (depth = 6)
// compiled member node returning call2125 (depth = 5)
  gc_frame_newslot(call2125);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2126 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2127 == NULL) {
    strlit2127 = alloc_String("<");
    gc_root(strlit2127);
  }
// compiled string node returning strlit2127 (depth = 7)
  partcv[0] = 0;
  Object call2128 = callmethod(strlit2127, "ord",
    1, partcv, params);
  gc_frame_end(callframe2126);
// compiled call node returning call2128 (depth = 6)
// compiled member node returning call2128 (depth = 5)
  gc_frame_newslot(call2128);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2129 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2130 == NULL) {
    strlit2130 = alloc_String(">");
    gc_root(strlit2130);
  }
// compiled string node returning strlit2130 (depth = 7)
  partcv[0] = 0;
  Object call2131 = callmethod(strlit2130, "ord",
    1, partcv, params);
  gc_frame_end(callframe2129);
// compiled call node returning call2131 (depth = 6)
// compiled member node returning call2131 (depth = 5)
  gc_frame_newslot(call2131);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2125;
  params[1] = call2128;
  params[2] = call2131;
  partcv[0] = 3;
  Object call2132 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2122);
// compiled call node returning call2132 (depth = 4)
  *var_iGTLT = call2132;
  if (call2132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile block node (depth = 4)
  Object block2133 = alloc_Block(NULL, NULL, "lexer", 647);
  gc_frame_newslot(block2133);
// method _apply
  block_savedest(block2133);
  Object closure2134 = createclosure(29, "_apply");
  setclosureframe(closure2134, stackframe);
  addtoclosure(closure2134, var_mode);
  addtoclosure(closure2134, var_badSeparator);
  addtoclosure(closure2134, var_errormessages);
  addtoclosure(closure2134, var_linePosition);
  addtoclosure(closure2134, var_lineNumber);
  addtoclosure(closure2134, var_inStr);
  addtoclosure(closure2134, var_unicode);
  addtoclosure(closure2134, var_badControl);
  addtoclosure(closure2134, var_atStart);
  addtoclosure(closure2134, var_newmode);
  addtoclosure(closure2134, var_stringStart);
  addtoclosure(closure2134, var_startLine);
  addtoclosure(closure2134, var_identifierChar);
  addtoclosure(closure2134, var_digit);
  addtoclosure(closure2134, var_iGTLT);
  addtoclosure(closure2134, var_tokens);
  addtoclosure(closure2134, var_accum);
  addtoclosure(closure2134, var_operatorChar);
  addtoclosure(closure2134, var_selfModes);
  addtoclosure(closure2134, var_util);
  addtoclosure(closure2134, var_escaped);
  addtoclosure(closure2134, var_interpString);
  addtoclosure(closure2134, var_interpdepth);
  addtoclosure(closure2134, var_brackets);
  addtoclosure(closure2134, var_unichars);
  addtoclosure(closure2134, var_codepoint);
  addtoclosure(closure2134, var_newlineFound);
  addtoclosure(closure2134, var_startPosition);
  addtoclosure(closure2134, selfslot);
  struct UserObject *uo2134 = (struct UserObject*)block2133;
  uo2134->data[0] = (Object)closure2134;
  Method *meth_meth_lexer__apply2134 = addmethod2pos(block2133, "_apply", &meth_lexer__apply2134, 0);
  int argcv_meth_lexer__apply2134[] = {1};
  meth_meth_lexer__apply2134->type = alloc_MethodType(1, argcv_meth_lexer__apply2134);
  meth_meth_lexer__apply2134->definitionModule = modulename;
  meth_meth_lexer__apply2134->definitionLine = 646;
// compiled block node returning block2133 (depth = 4)
  *var_mainBlock = block2133;
  if (block2133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3466 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_input (depth = 4)
  gc_frame_newslot(*var_input);
// starting to compile block node (depth = 4)
  Object block3467 = alloc_Block(NULL, NULL, "lexer", 1065);
  gc_frame_newslot(block3467);
// method _apply
  block_savedest(block3467);
  Object closure3468 = createclosure(5, "_apply");
  setclosureframe(closure3468, stackframe);
  addtoclosure(closure3468, var_linePosition);
  addtoclosure(closure3468, var_mode);
  addtoclosure(closure3468, var_mainBlock);
  addtoclosure(closure3468, var_prev);
  addtoclosure(closure3468, selfslot);
  struct UserObject *uo3468 = (struct UserObject*)block3467;
  uo3468->data[0] = (Object)closure3468;
  Method *meth_meth_lexer__apply3468 = addmethod2pos(block3467, "_apply", &meth_lexer__apply3468, 0);
  int argcv_meth_lexer__apply3468[] = {1};
  meth_meth_lexer__apply3468->type = alloc_MethodType(1, argcv_meth_lexer__apply3468);
  meth_meth_lexer__apply3468->definitionModule = modulename;
  meth_meth_lexer__apply3468->definitionLine = 1016;
// compiled block node returning block3467 (depth = 4)
  gc_frame_newslot(block3467);
// call case 5: prelude request
  params[0] = *var_input;
  params[1] = block3467;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3495 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3466);
// compiled call node returning call3495 (depth = 3)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num3497 = alloc_Float64(1);
// compiled num node returning num3497 (depth = 5)
  int op_slot_right_3496 = gc_frame_newslot(num3497);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  int op_slot_left_3496 = gc_frame_newslot(*var_linePosition);
  params[0] = num3497;
  partcv[0] = 1;
  Object sum3499 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3499 (depth = 4)
  *var_linePosition = sum3499;
  if (sum3499 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inStr (depth = 4)
  Object if3501 = done;
  if (istrue(*var_inStr)) {
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3504 == NULL) {
    strlit3504 = alloc_String("""\x22""");
    gc_root(strlit3504);
  }
// compiled string node returning strlit3504 (depth = 6)
  int op_slot_right_3503 = gc_frame_newslot(strlit3504);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_3503 = gc_frame_newslot(*var_mode);
  params[0] = strlit3504;
  partcv[0] = 1;
  Object opresult3506 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3506 (depth = 5)
  Object if3502 = done;
  if (istrue(opresult3506)) {
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3507 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3509 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3508);
// compiled call node returning call3509 (depth = 9)
// compiled member node returning call3509 (depth = 8)
  partcv[0] = 0;
  Object call3510 = callmethod(call3509, "new",
    1, partcv, params);
  gc_frame_end(callframe3507);
// compiled call node returning call3510 (depth = 7)
// compiled member node returning call3510 (depth = 6)
  *var_suggestion = call3510;
  if (call3510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3511 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3513 == NULL) {
    strlit3513 = alloc_String("""\x22""");
    gc_root(strlit3513);
  }
// compiled string node returning strlit3513 (depth = 7)
  int op_slot_right_3512 = gc_frame_newslot(strlit3513);
// starting to compile call node (depth = 7)
  int callframe3515 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call3517 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3516);
// compiled call node returning call3517 (depth = 9)
// compiled member node returning call3517 (depth = 8)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call3518 = callmethod(call3517, "at",
    1, partcv, params);
  gc_frame_end(callframe3515);
// compiled call node returning call3518 (depth = 7)
  int op_slot_left_3512 = gc_frame_newslot(call3518);
  params[0] = strlit3513;
  partcv[0] = 1;
  Object opresult3519 = callmethod(call3518, "++", 1, partcv, params);
// compiled op node returning opresult3519 (depth = 6)
  gc_frame_newslot(opresult3519);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lineNumber;
  params[1] = opresult3519;
  partcv[0] = 2;
  Object call3520 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3511);
// compiled call node returning call3520 (depth = 5)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3521 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3522 == NULL) {
    strlit3522 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3522);
  }
// compiled string node returning strlit3522 (depth = 6)
  gc_frame_newslot(strlit3522);
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3522;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3523 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3521);
// compiled call node returning call3523 (depth = 5)
    gc_frame_newslot(call3523);
    if3502 = call3523;
  } else {
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3526 == NULL) {
    strlit3526 = alloc_String("q");
    gc_root(strlit3526);
  }
// compiled string node returning strlit3526 (depth = 7)
  int op_slot_right_3525 = gc_frame_newslot(strlit3526);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_3525 = gc_frame_newslot(*var_mode);
  params[0] = strlit3526;
  partcv[0] = 1;
  Object opresult3528 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3528 (depth = 6)
  Object if3524 = done;
  if (istrue(opresult3528)) {
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3529 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3531 == NULL) {
    strlit3531 = alloc_String(" and unclosed at end of input.");
    gc_root(strlit3531);
  }
// compiled string node returning strlit3531 (depth = 8)
  int op_slot_right_3530 = gc_frame_newslot(strlit3531);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_startLine (depth = 9)
  int op_slot_right_3533 = gc_frame_newslot(*var_startLine);
// starting to compile string node (depth = 9)
  if (strlit3535 == NULL) {
    strlit3535 = alloc_String("A multi-line string must end with a '""\xe2""""\x80""""\xba""'.""\x0a""String opened on line ");
    gc_root(strlit3535);
  }
// compiled string node returning strlit3535 (depth = 9)
  int op_slot_left_3533 = gc_frame_newslot(strlit3535);
  params[0] = *var_startLine;
  partcv[0] = 1;
  Object opresult3536 = callmethod(strlit3535, "++", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 8)
  int op_slot_left_3530 = gc_frame_newslot(opresult3536);
  params[0] = strlit3531;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "++", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 7)
  gc_frame_newslot(opresult3537);
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startLine (depth = 7)
  gc_frame_newslot(*var_startLine);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_stringStart (depth = 7)
  gc_frame_newslot(*var_stringStart);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3538 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3539 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_startLine (depth = 10)
  gc_frame_newslot(*var_startLine);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call3541 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3540);
// compiled call node returning call3541 (depth = 11)
// compiled member node returning call3541 (depth = 10)
  params[0] = *var_startLine;
  partcv[0] = 1;
  Object call3542 = callmethod(call3541, "at",
    1, partcv, params);
  gc_frame_end(callframe3539);
// compiled call node returning call3542 (depth = 9)
  partcv[0] = 0;
  Object call3543 = callmethod(call3542, "size",
    1, partcv, params);
  gc_frame_end(callframe3538);
// compiled call node returning call3543 (depth = 8)
// compiled member node returning call3543 (depth = 7)
  gc_frame_newslot(call3543);
// call case 6: other member request
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult3537;
  params[1] = *var_startLine;
  params[2] = *var_stringStart;
  params[3] = call3543;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call3544 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe3529);
// compiled call node returning call3544 (depth = 6)
    gc_frame_newslot(call3544);
    if3524 = call3544;
  } else {
  }
// compiled if node returning if3524 (depth = 5)
    gc_frame_newslot(if3524);
    if3502 = if3524;
  }
// compiled if node returning if3502 (depth = 4)
    gc_frame_newslot(if3502);
    if3501 = if3502;
  } else {
  }
// compiled if node returning if3501 (depth = 3)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3545 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mode (depth = 4)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_accum (depth = 4)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3546 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3545);
// compiled call node returning call3546 (depth = 3)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_lexer_new29(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_startLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "startLine");
  Object *var_stringStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "stringStart");
  Object *var_Token = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "StringToken");
  Object *var_MultiLineStringToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "MultiLineStringToken");
  Object *var_CommentToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "CommentToken");
  Object *var_LBraceToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "DotToken");
  Object *var_NumToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "RGenericToken");
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num30 = alloc_Float64(1);
// compiled num node returning num30 (depth = 4)
  *var_lineNumber = num30;
  if (num30 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num31 = alloc_Float64(0);
// compiled num node returning num31 (depth = 4)
  *var_linePosition = num31;
  if (num31 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num32 = alloc_Float64(1);
// compiled num node returning num32 (depth = 4)
  *var_startPosition = num32;
  if (num32 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num33 = alloc_Float64(0);
// compiled num node returning num33 (depth = 4)
  *var_indentLevel = num33;
  if (num33 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num34 = alloc_Float64(1);
// compiled num node returning num34 (depth = 4)
  *var_startLine = num34;
  if (num34 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_stringStart = undefined;
// compiled vardec node returning done (depth = 3)
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject35 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj35 = alloc_userobj2(2,4, objclass35);
  gc_frame_newslot(obj35);
// OBJECT OUTER DEC outer
  adddatum2(obj35, self, 0);
  addmethodreal(obj35,"outer", &reader_lexer_outer_36);
  Object oldself35 = self;
  struct StackFrameObject *oldstackframe35 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe35);
  gc_frame_newslot((Object)stackframe);
  self = obj35;
  Object *oldselfslot35 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter35 = (*(struct UserObject *)self).data[0], lowerouter35 = thisouter35;
  if (inheritingObject35) {
    struct UserObject *inho35 = (struct UserObject *)inheritingObject35;
    while (inho35->super != GraceDefaultObject) inho35 = (struct UserObject *)inho35->super;
    inho35->super = obj35;
    self = inheritingObject35;
    *selfslot = self;
    lowerouter35 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter35;
  }
// method new
  block_savedest(obj35);
  Object closure37 = createclosure(3, "new");
  setclosureframe(closure37, stackframe);
  addtoclosure(closure37, var_lineNumber);
  addtoclosure(closure37, var_indentLevel);
  addtoclosure(closure37, var_startPosition);
  struct UserObject *uo37 = (struct UserObject*)obj35;
  uo37->data[1] = (Object)closure37;
  Method *meth_meth_lexer_new37 = addmethod2pos(obj35, "new", &meth_lexer_new37, 1);
  int argcv_meth_lexer_new37[] = {0};
  meth_meth_lexer_new37->type = alloc_MethodType(1, argcv_meth_lexer_new37);
  meth_meth_lexer_new37->definitionModule = modulename;
  meth_meth_lexer_new37->definitionLine = 30;
  block_savedest(obj35);
  Object closure71 = createclosure(3, "new()object");
  setclosureframe(closure71, stackframe);
  addtoclosure(closure71, var_lineNumber);
  addtoclosure(closure71, var_indentLevel);
  addtoclosure(closure71, var_startPosition);
  Method *meth_meth_lexer_new37_object = addmethod2pos(obj35, "new()object", &meth_lexer_new37_object, 1);
  meth_meth_lexer_new37_object->definitionModule = modulename;
  meth_meth_lexer_new37_object->definitionLine = 30;
  sourceObject = obj35;
objclass35 = obj35->class;
  objclass35->definitionModule = modulename;
  objclass35->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter35;
  self = oldself35;
  selfslot = oldselfslot35;
  stackframe = oldstackframe35;
// compiled object node returning obj35 (depth = 5)
  *var_Token = obj35;
  if (obj35 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject72 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj72 = alloc_userobj2(2,4, objclass72);
  gc_frame_newslot(obj72);
// OBJECT OUTER DEC outer
  adddatum2(obj72, self, 0);
  addmethodreal(obj72,"outer", &reader_lexer_outer_73);
  Object oldself72 = self;
  struct StackFrameObject *oldstackframe72 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe72);
  gc_frame_newslot((Object)stackframe);
  self = obj72;
  Object *oldselfslot72 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter72 = (*(struct UserObject *)self).data[0], lowerouter72 = thisouter72;
  if (inheritingObject72) {
    struct UserObject *inho72 = (struct UserObject *)inheritingObject72;
    while (inho72->super != GraceDefaultObject) inho72 = (struct UserObject *)inho72->super;
    inho72->super = obj72;
    self = inheritingObject72;
    *selfslot = self;
    lowerouter72 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter72;
  }
// method new
  block_savedest(obj72);
  Object closure74 = createclosure(1, "new");
  setclosureframe(closure74, stackframe);
  addtoclosure(closure74, var_Token);
  struct UserObject *uo74 = (struct UserObject*)obj72;
  uo74->data[1] = (Object)closure74;
  Method *meth_meth_lexer_new74 = addmethod2pos(obj72, "new", &meth_lexer_new74, 1);
  int argcv_meth_lexer_new74[] = {1};
  meth_meth_lexer_new74->type = alloc_MethodType(1, argcv_meth_lexer_new74);
  meth_meth_lexer_new74->definitionModule = modulename;
  meth_meth_lexer_new74->definitionLine = 47;
  block_savedest(obj72);
  Object closure85 = createclosure(1, "new()object");
  setclosureframe(closure85, stackframe);
  addtoclosure(closure85, var_Token);
  Method *meth_meth_lexer_new74_object = addmethod2pos(obj72, "new()object", &meth_lexer_new74_object, 1);
  meth_meth_lexer_new74_object->definitionModule = modulename;
  meth_meth_lexer_new74_object->definitionLine = 47;
  sourceObject = obj72;
objclass72 = obj72->class;
  objclass72->definitionModule = modulename;
  objclass72->definitionLine = 47;
  (*(struct UserObject *)self).data[0] = lowerouter72;
  self = oldself72;
  selfslot = oldselfslot72;
  stackframe = oldstackframe72;
// compiled object node returning obj72 (depth = 5)
  *var_IdentifierToken = obj72;
  if (obj72 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject86 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj86 = alloc_userobj2(2,4, objclass86);
  gc_frame_newslot(obj86);
// OBJECT OUTER DEC outer
  adddatum2(obj86, self, 0);
  addmethodreal(obj86,"outer", &reader_lexer_outer_87);
  Object oldself86 = self;
  struct StackFrameObject *oldstackframe86 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe86);
  gc_frame_newslot((Object)stackframe);
  self = obj86;
  Object *oldselfslot86 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter86 = (*(struct UserObject *)self).data[0], lowerouter86 = thisouter86;
  if (inheritingObject86) {
    struct UserObject *inho86 = (struct UserObject *)inheritingObject86;
    while (inho86->super != GraceDefaultObject) inho86 = (struct UserObject *)inho86->super;
    inho86->super = obj86;
    self = inheritingObject86;
    *selfslot = self;
    lowerouter86 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter86;
  }
// method new
  block_savedest(obj86);
  Object closure88 = createclosure(3, "new");
  setclosureframe(closure88, stackframe);
  addtoclosure(closure88, var_Token);
  addtoclosure(closure88, var_stringStart);
  addtoclosure(closure88, var_linePosition);
  struct UserObject *uo88 = (struct UserObject*)obj86;
  uo88->data[1] = (Object)closure88;
  Method *meth_meth_lexer_new88 = addmethod2pos(obj86, "new", &meth_lexer_new88, 1);
  int argcv_meth_lexer_new88[] = {1};
  meth_meth_lexer_new88->type = alloc_MethodType(1, argcv_meth_lexer_new88);
  meth_meth_lexer_new88->definitionModule = modulename;
  meth_meth_lexer_new88->definitionLine = 53;
  block_savedest(obj86);
  Object closure104 = createclosure(3, "new()object");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_Token);
  addtoclosure(closure104, var_stringStart);
  addtoclosure(closure104, var_linePosition);
  Method *meth_meth_lexer_new88_object = addmethod2pos(obj86, "new()object", &meth_lexer_new88_object, 1);
  meth_meth_lexer_new88_object->definitionModule = modulename;
  meth_meth_lexer_new88_object->definitionLine = 53;
  sourceObject = obj86;
objclass86 = obj86->class;
  objclass86->definitionModule = modulename;
  objclass86->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter86;
  self = oldself86;
  selfslot = oldselfslot86;
  stackframe = oldstackframe86;
// compiled object node returning obj86 (depth = 5)
  *var_StringToken = obj86;
  if (obj86 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject105 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj105 = alloc_userobj2(2,4, objclass105);
  gc_frame_newslot(obj105);
// OBJECT OUTER DEC outer
  adddatum2(obj105, self, 0);
  addmethodreal(obj105,"outer", &reader_lexer_outer_106);
  Object oldself105 = self;
  struct StackFrameObject *oldstackframe105 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe105);
  gc_frame_newslot((Object)stackframe);
  self = obj105;
  Object *oldselfslot105 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter105 = (*(struct UserObject *)self).data[0], lowerouter105 = thisouter105;
  if (inheritingObject105) {
    struct UserObject *inho105 = (struct UserObject *)inheritingObject105;
    while (inho105->super != GraceDefaultObject) inho105 = (struct UserObject *)inho105->super;
    inho105->super = obj105;
    self = inheritingObject105;
    *selfslot = self;
    lowerouter105 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter105;
  }
// method new
  block_savedest(obj105);
  Object closure107 = createclosure(3, "new");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_Token);
  addtoclosure(closure107, var_startLine);
  addtoclosure(closure107, var_stringStart);
  struct UserObject *uo107 = (struct UserObject*)obj105;
  uo107->data[1] = (Object)closure107;
  Method *meth_meth_lexer_new107 = addmethod2pos(obj105, "new", &meth_lexer_new107, 1);
  int argcv_meth_lexer_new107[] = {1};
  meth_meth_lexer_new107->type = alloc_MethodType(1, argcv_meth_lexer_new107);
  meth_meth_lexer_new107->definitionModule = modulename;
  meth_meth_lexer_new107->definitionLine = 59;
  block_savedest(obj105);
  Object closure130 = createclosure(3, "new()object");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_Token);
  addtoclosure(closure130, var_startLine);
  addtoclosure(closure130, var_stringStart);
  Method *meth_meth_lexer_new107_object = addmethod2pos(obj105, "new()object", &meth_lexer_new107_object, 1);
  meth_meth_lexer_new107_object->definitionModule = modulename;
  meth_meth_lexer_new107_object->definitionLine = 59;
  sourceObject = obj105;
objclass105 = obj105->class;
  objclass105->definitionModule = modulename;
  objclass105->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter105;
  self = oldself105;
  selfslot = oldselfslot105;
  stackframe = oldstackframe105;
// compiled object node returning obj105 (depth = 5)
  *var_MultiLineStringToken = obj105;
  if (obj105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject131 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj131 = alloc_userobj2(2,4, objclass131);
  gc_frame_newslot(obj131);
// OBJECT OUTER DEC outer
  adddatum2(obj131, self, 0);
  addmethodreal(obj131,"outer", &reader_lexer_outer_132);
  Object oldself131 = self;
  struct StackFrameObject *oldstackframe131 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe131);
  gc_frame_newslot((Object)stackframe);
  self = obj131;
  Object *oldselfslot131 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter131 = (*(struct UserObject *)self).data[0], lowerouter131 = thisouter131;
  if (inheritingObject131) {
    struct UserObject *inho131 = (struct UserObject *)inheritingObject131;
    while (inho131->super != GraceDefaultObject) inho131 = (struct UserObject *)inho131->super;
    inho131->super = obj131;
    self = inheritingObject131;
    *selfslot = self;
    lowerouter131 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter131;
  }
// method new
  block_savedest(obj131);
  Object closure133 = createclosure(1, "new");
  setclosureframe(closure133, stackframe);
  addtoclosure(closure133, var_Token);
  struct UserObject *uo133 = (struct UserObject*)obj131;
  uo133->data[1] = (Object)closure133;
  Method *meth_meth_lexer_new133 = addmethod2pos(obj131, "new", &meth_lexer_new133, 1);
  int argcv_meth_lexer_new133[] = {1};
  meth_meth_lexer_new133->type = alloc_MethodType(1, argcv_meth_lexer_new133);
  meth_meth_lexer_new133->definitionModule = modulename;
  meth_meth_lexer_new133->definitionLine = 69;
  block_savedest(obj131);
  Object closure148 = createclosure(1, "new()object");
  setclosureframe(closure148, stackframe);
  addtoclosure(closure148, var_Token);
  Method *meth_meth_lexer_new133_object = addmethod2pos(obj131, "new()object", &meth_lexer_new133_object, 1);
  meth_meth_lexer_new133_object->definitionModule = modulename;
  meth_meth_lexer_new133_object->definitionLine = 69;
  sourceObject = obj131;
objclass131 = obj131->class;
  objclass131->definitionModule = modulename;
  objclass131->definitionLine = 69;
  (*(struct UserObject *)self).data[0] = lowerouter131;
  self = oldself131;
  selfslot = oldselfslot131;
  stackframe = oldstackframe131;
// compiled object node returning obj131 (depth = 5)
  *var_CommentToken = obj131;
  if (obj131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject149 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj149 = alloc_userobj2(2,4, objclass149);
  gc_frame_newslot(obj149);
// OBJECT OUTER DEC outer
  adddatum2(obj149, self, 0);
  addmethodreal(obj149,"outer", &reader_lexer_outer_150);
  Object oldself149 = self;
  struct StackFrameObject *oldstackframe149 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe149);
  gc_frame_newslot((Object)stackframe);
  self = obj149;
  Object *oldselfslot149 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter149 = (*(struct UserObject *)self).data[0], lowerouter149 = thisouter149;
  if (inheritingObject149) {
    struct UserObject *inho149 = (struct UserObject *)inheritingObject149;
    while (inho149->super != GraceDefaultObject) inho149 = (struct UserObject *)inho149->super;
    inho149->super = obj149;
    self = inheritingObject149;
    *selfslot = self;
    lowerouter149 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter149;
  }
// method new
  block_savedest(obj149);
  Object closure151 = createclosure(1, "new");
  setclosureframe(closure151, stackframe);
  addtoclosure(closure151, var_Token);
  struct UserObject *uo151 = (struct UserObject*)obj149;
  uo151->data[1] = (Object)closure151;
  Method *meth_meth_lexer_new151 = addmethod2pos(obj149, "new", &meth_lexer_new151, 1);
  int argcv_meth_lexer_new151[] = {0};
  meth_meth_lexer_new151->type = alloc_MethodType(1, argcv_meth_lexer_new151);
  meth_meth_lexer_new151->definitionModule = modulename;
  meth_meth_lexer_new151->definitionLine = 75;
  block_savedest(obj149);
  Object closure162 = createclosure(1, "new()object");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_Token);
  Method *meth_meth_lexer_new151_object = addmethod2pos(obj149, "new()object", &meth_lexer_new151_object, 1);
  meth_meth_lexer_new151_object->definitionModule = modulename;
  meth_meth_lexer_new151_object->definitionLine = 75;
  sourceObject = obj149;
objclass149 = obj149->class;
  objclass149->definitionModule = modulename;
  objclass149->definitionLine = 75;
  (*(struct UserObject *)self).data[0] = lowerouter149;
  self = oldself149;
  selfslot = oldselfslot149;
  stackframe = oldstackframe149;
// compiled object node returning obj149 (depth = 5)
  *var_LBraceToken = obj149;
  if (obj149 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject163 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj163 = alloc_userobj2(2,4, objclass163);
  gc_frame_newslot(obj163);
// OBJECT OUTER DEC outer
  adddatum2(obj163, self, 0);
  addmethodreal(obj163,"outer", &reader_lexer_outer_164);
  Object oldself163 = self;
  struct StackFrameObject *oldstackframe163 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe163);
  gc_frame_newslot((Object)stackframe);
  self = obj163;
  Object *oldselfslot163 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter163 = (*(struct UserObject *)self).data[0], lowerouter163 = thisouter163;
  if (inheritingObject163) {
    struct UserObject *inho163 = (struct UserObject *)inheritingObject163;
    while (inho163->super != GraceDefaultObject) inho163 = (struct UserObject *)inho163->super;
    inho163->super = obj163;
    self = inheritingObject163;
    *selfslot = self;
    lowerouter163 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter163;
  }
// method new
  block_savedest(obj163);
  Object closure165 = createclosure(1, "new");
  setclosureframe(closure165, stackframe);
  addtoclosure(closure165, var_Token);
  struct UserObject *uo165 = (struct UserObject*)obj163;
  uo165->data[1] = (Object)closure165;
  Method *meth_meth_lexer_new165 = addmethod2pos(obj163, "new", &meth_lexer_new165, 1);
  int argcv_meth_lexer_new165[] = {0};
  meth_meth_lexer_new165->type = alloc_MethodType(1, argcv_meth_lexer_new165);
  meth_meth_lexer_new165->definitionModule = modulename;
  meth_meth_lexer_new165->definitionLine = 81;
  block_savedest(obj163);
  Object closure176 = createclosure(1, "new()object");
  setclosureframe(closure176, stackframe);
  addtoclosure(closure176, var_Token);
  Method *meth_meth_lexer_new165_object = addmethod2pos(obj163, "new()object", &meth_lexer_new165_object, 1);
  meth_meth_lexer_new165_object->definitionModule = modulename;
  meth_meth_lexer_new165_object->definitionLine = 81;
  sourceObject = obj163;
objclass163 = obj163->class;
  objclass163->definitionModule = modulename;
  objclass163->definitionLine = 81;
  (*(struct UserObject *)self).data[0] = lowerouter163;
  self = oldself163;
  selfslot = oldselfslot163;
  stackframe = oldstackframe163;
// compiled object node returning obj163 (depth = 5)
  *var_RBraceToken = obj163;
  if (obj163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject177 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj177 = alloc_userobj2(2,4, objclass177);
  gc_frame_newslot(obj177);
// OBJECT OUTER DEC outer
  adddatum2(obj177, self, 0);
  addmethodreal(obj177,"outer", &reader_lexer_outer_178);
  Object oldself177 = self;
  struct StackFrameObject *oldstackframe177 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe177);
  gc_frame_newslot((Object)stackframe);
  self = obj177;
  Object *oldselfslot177 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter177 = (*(struct UserObject *)self).data[0], lowerouter177 = thisouter177;
  if (inheritingObject177) {
    struct UserObject *inho177 = (struct UserObject *)inheritingObject177;
    while (inho177->super != GraceDefaultObject) inho177 = (struct UserObject *)inho177->super;
    inho177->super = obj177;
    self = inheritingObject177;
    *selfslot = self;
    lowerouter177 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter177;
  }
// method new
  block_savedest(obj177);
  Object closure179 = createclosure(1, "new");
  setclosureframe(closure179, stackframe);
  addtoclosure(closure179, var_Token);
  struct UserObject *uo179 = (struct UserObject*)obj177;
  uo179->data[1] = (Object)closure179;
  Method *meth_meth_lexer_new179 = addmethod2pos(obj177, "new", &meth_lexer_new179, 1);
  int argcv_meth_lexer_new179[] = {0};
  meth_meth_lexer_new179->type = alloc_MethodType(1, argcv_meth_lexer_new179);
  meth_meth_lexer_new179->definitionModule = modulename;
  meth_meth_lexer_new179->definitionLine = 87;
  block_savedest(obj177);
  Object closure190 = createclosure(1, "new()object");
  setclosureframe(closure190, stackframe);
  addtoclosure(closure190, var_Token);
  Method *meth_meth_lexer_new179_object = addmethod2pos(obj177, "new()object", &meth_lexer_new179_object, 1);
  meth_meth_lexer_new179_object->definitionModule = modulename;
  meth_meth_lexer_new179_object->definitionLine = 87;
  sourceObject = obj177;
objclass177 = obj177->class;
  objclass177->definitionModule = modulename;
  objclass177->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter177;
  self = oldself177;
  selfslot = oldselfslot177;
  stackframe = oldstackframe177;
// compiled object node returning obj177 (depth = 5)
  *var_LParenToken = obj177;
  if (obj177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj191 = alloc_userobj2(2,4, objclass191);
  gc_frame_newslot(obj191);
// OBJECT OUTER DEC outer
  adddatum2(obj191, self, 0);
  addmethodreal(obj191,"outer", &reader_lexer_outer_192);
  Object oldself191 = self;
  struct StackFrameObject *oldstackframe191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe191);
  gc_frame_newslot((Object)stackframe);
  self = obj191;
  Object *oldselfslot191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter191 = (*(struct UserObject *)self).data[0], lowerouter191 = thisouter191;
  if (inheritingObject191) {
    struct UserObject *inho191 = (struct UserObject *)inheritingObject191;
    while (inho191->super != GraceDefaultObject) inho191 = (struct UserObject *)inho191->super;
    inho191->super = obj191;
    self = inheritingObject191;
    *selfslot = self;
    lowerouter191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter191;
  }
// method new
  block_savedest(obj191);
  Object closure193 = createclosure(1, "new");
  setclosureframe(closure193, stackframe);
  addtoclosure(closure193, var_Token);
  struct UserObject *uo193 = (struct UserObject*)obj191;
  uo193->data[1] = (Object)closure193;
  Method *meth_meth_lexer_new193 = addmethod2pos(obj191, "new", &meth_lexer_new193, 1);
  int argcv_meth_lexer_new193[] = {0};
  meth_meth_lexer_new193->type = alloc_MethodType(1, argcv_meth_lexer_new193);
  meth_meth_lexer_new193->definitionModule = modulename;
  meth_meth_lexer_new193->definitionLine = 93;
  block_savedest(obj191);
  Object closure204 = createclosure(1, "new()object");
  setclosureframe(closure204, stackframe);
  addtoclosure(closure204, var_Token);
  Method *meth_meth_lexer_new193_object = addmethod2pos(obj191, "new()object", &meth_lexer_new193_object, 1);
  meth_meth_lexer_new193_object->definitionModule = modulename;
  meth_meth_lexer_new193_object->definitionLine = 93;
  sourceObject = obj191;
objclass191 = obj191->class;
  objclass191->definitionModule = modulename;
  objclass191->definitionLine = 93;
  (*(struct UserObject *)self).data[0] = lowerouter191;
  self = oldself191;
  selfslot = oldselfslot191;
  stackframe = oldstackframe191;
// compiled object node returning obj191 (depth = 5)
  *var_RParenToken = obj191;
  if (obj191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject205 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj205 = alloc_userobj2(2,4, objclass205);
  gc_frame_newslot(obj205);
// OBJECT OUTER DEC outer
  adddatum2(obj205, self, 0);
  addmethodreal(obj205,"outer", &reader_lexer_outer_206);
  Object oldself205 = self;
  struct StackFrameObject *oldstackframe205 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe205);
  gc_frame_newslot((Object)stackframe);
  self = obj205;
  Object *oldselfslot205 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter205 = (*(struct UserObject *)self).data[0], lowerouter205 = thisouter205;
  if (inheritingObject205) {
    struct UserObject *inho205 = (struct UserObject *)inheritingObject205;
    while (inho205->super != GraceDefaultObject) inho205 = (struct UserObject *)inho205->super;
    inho205->super = obj205;
    self = inheritingObject205;
    *selfslot = self;
    lowerouter205 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter205;
  }
// method new
  block_savedest(obj205);
  Object closure207 = createclosure(1, "new");
  setclosureframe(closure207, stackframe);
  addtoclosure(closure207, var_Token);
  struct UserObject *uo207 = (struct UserObject*)obj205;
  uo207->data[1] = (Object)closure207;
  Method *meth_meth_lexer_new207 = addmethod2pos(obj205, "new", &meth_lexer_new207, 1);
  int argcv_meth_lexer_new207[] = {0};
  meth_meth_lexer_new207->type = alloc_MethodType(1, argcv_meth_lexer_new207);
  meth_meth_lexer_new207->definitionModule = modulename;
  meth_meth_lexer_new207->definitionLine = 99;
  block_savedest(obj205);
  Object closure218 = createclosure(1, "new()object");
  setclosureframe(closure218, stackframe);
  addtoclosure(closure218, var_Token);
  Method *meth_meth_lexer_new207_object = addmethod2pos(obj205, "new()object", &meth_lexer_new207_object, 1);
  meth_meth_lexer_new207_object->definitionModule = modulename;
  meth_meth_lexer_new207_object->definitionLine = 99;
  sourceObject = obj205;
objclass205 = obj205->class;
  objclass205->definitionModule = modulename;
  objclass205->definitionLine = 99;
  (*(struct UserObject *)self).data[0] = lowerouter205;
  self = oldself205;
  selfslot = oldselfslot205;
  stackframe = oldstackframe205;
// compiled object node returning obj205 (depth = 5)
  *var_LSquareToken = obj205;
  if (obj205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject219 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj219 = alloc_userobj2(2,4, objclass219);
  gc_frame_newslot(obj219);
// OBJECT OUTER DEC outer
  adddatum2(obj219, self, 0);
  addmethodreal(obj219,"outer", &reader_lexer_outer_220);
  Object oldself219 = self;
  struct StackFrameObject *oldstackframe219 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe219);
  gc_frame_newslot((Object)stackframe);
  self = obj219;
  Object *oldselfslot219 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter219 = (*(struct UserObject *)self).data[0], lowerouter219 = thisouter219;
  if (inheritingObject219) {
    struct UserObject *inho219 = (struct UserObject *)inheritingObject219;
    while (inho219->super != GraceDefaultObject) inho219 = (struct UserObject *)inho219->super;
    inho219->super = obj219;
    self = inheritingObject219;
    *selfslot = self;
    lowerouter219 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter219;
  }
// method new
  block_savedest(obj219);
  Object closure221 = createclosure(1, "new");
  setclosureframe(closure221, stackframe);
  addtoclosure(closure221, var_Token);
  struct UserObject *uo221 = (struct UserObject*)obj219;
  uo221->data[1] = (Object)closure221;
  Method *meth_meth_lexer_new221 = addmethod2pos(obj219, "new", &meth_lexer_new221, 1);
  int argcv_meth_lexer_new221[] = {0};
  meth_meth_lexer_new221->type = alloc_MethodType(1, argcv_meth_lexer_new221);
  meth_meth_lexer_new221->definitionModule = modulename;
  meth_meth_lexer_new221->definitionLine = 105;
  block_savedest(obj219);
  Object closure232 = createclosure(1, "new()object");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_Token);
  Method *meth_meth_lexer_new221_object = addmethod2pos(obj219, "new()object", &meth_lexer_new221_object, 1);
  meth_meth_lexer_new221_object->definitionModule = modulename;
  meth_meth_lexer_new221_object->definitionLine = 105;
  sourceObject = obj219;
objclass219 = obj219->class;
  objclass219->definitionModule = modulename;
  objclass219->definitionLine = 105;
  (*(struct UserObject *)self).data[0] = lowerouter219;
  self = oldself219;
  selfslot = oldselfslot219;
  stackframe = oldstackframe219;
// compiled object node returning obj219 (depth = 5)
  *var_RSquareToken = obj219;
  if (obj219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject233 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj233 = alloc_userobj2(2,4, objclass233);
  gc_frame_newslot(obj233);
// OBJECT OUTER DEC outer
  adddatum2(obj233, self, 0);
  addmethodreal(obj233,"outer", &reader_lexer_outer_234);
  Object oldself233 = self;
  struct StackFrameObject *oldstackframe233 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe233);
  gc_frame_newslot((Object)stackframe);
  self = obj233;
  Object *oldselfslot233 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter233 = (*(struct UserObject *)self).data[0], lowerouter233 = thisouter233;
  if (inheritingObject233) {
    struct UserObject *inho233 = (struct UserObject *)inheritingObject233;
    while (inho233->super != GraceDefaultObject) inho233 = (struct UserObject *)inho233->super;
    inho233->super = obj233;
    self = inheritingObject233;
    *selfslot = self;
    lowerouter233 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter233;
  }
// method new
  block_savedest(obj233);
  Object closure235 = createclosure(1, "new");
  setclosureframe(closure235, stackframe);
  addtoclosure(closure235, var_Token);
  struct UserObject *uo235 = (struct UserObject*)obj233;
  uo235->data[1] = (Object)closure235;
  Method *meth_meth_lexer_new235 = addmethod2pos(obj233, "new", &meth_lexer_new235, 1);
  int argcv_meth_lexer_new235[] = {0};
  meth_meth_lexer_new235->type = alloc_MethodType(1, argcv_meth_lexer_new235);
  meth_meth_lexer_new235->definitionModule = modulename;
  meth_meth_lexer_new235->definitionLine = 111;
  block_savedest(obj233);
  Object closure246 = createclosure(1, "new()object");
  setclosureframe(closure246, stackframe);
  addtoclosure(closure246, var_Token);
  Method *meth_meth_lexer_new235_object = addmethod2pos(obj233, "new()object", &meth_lexer_new235_object, 1);
  meth_meth_lexer_new235_object->definitionModule = modulename;
  meth_meth_lexer_new235_object->definitionLine = 111;
  sourceObject = obj233;
objclass233 = obj233->class;
  objclass233->definitionModule = modulename;
  objclass233->definitionLine = 111;
  (*(struct UserObject *)self).data[0] = lowerouter233;
  self = oldself233;
  selfslot = oldselfslot233;
  stackframe = oldstackframe233;
// compiled object node returning obj233 (depth = 5)
  *var_CommaToken = obj233;
  if (obj233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj247 = alloc_userobj2(2,4, objclass247);
  gc_frame_newslot(obj247);
// OBJECT OUTER DEC outer
  adddatum2(obj247, self, 0);
  addmethodreal(obj247,"outer", &reader_lexer_outer_248);
  Object oldself247 = self;
  struct StackFrameObject *oldstackframe247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe247);
  gc_frame_newslot((Object)stackframe);
  self = obj247;
  Object *oldselfslot247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter247 = (*(struct UserObject *)self).data[0], lowerouter247 = thisouter247;
  if (inheritingObject247) {
    struct UserObject *inho247 = (struct UserObject *)inheritingObject247;
    while (inho247->super != GraceDefaultObject) inho247 = (struct UserObject *)inho247->super;
    inho247->super = obj247;
    self = inheritingObject247;
    *selfslot = self;
    lowerouter247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter247;
  }
// method new
  block_savedest(obj247);
  Object closure249 = createclosure(1, "new");
  setclosureframe(closure249, stackframe);
  addtoclosure(closure249, var_Token);
  struct UserObject *uo249 = (struct UserObject*)obj247;
  uo249->data[1] = (Object)closure249;
  Method *meth_meth_lexer_new249 = addmethod2pos(obj247, "new", &meth_lexer_new249, 1);
  int argcv_meth_lexer_new249[] = {0};
  meth_meth_lexer_new249->type = alloc_MethodType(1, argcv_meth_lexer_new249);
  meth_meth_lexer_new249->definitionModule = modulename;
  meth_meth_lexer_new249->definitionLine = 117;
  block_savedest(obj247);
  Object closure260 = createclosure(1, "new()object");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_Token);
  Method *meth_meth_lexer_new249_object = addmethod2pos(obj247, "new()object", &meth_lexer_new249_object, 1);
  meth_meth_lexer_new249_object->definitionModule = modulename;
  meth_meth_lexer_new249_object->definitionLine = 117;
  sourceObject = obj247;
objclass247 = obj247->class;
  objclass247->definitionModule = modulename;
  objclass247->definitionLine = 117;
  (*(struct UserObject *)self).data[0] = lowerouter247;
  self = oldself247;
  selfslot = oldselfslot247;
  stackframe = oldstackframe247;
// compiled object node returning obj247 (depth = 5)
  *var_ColonToken = obj247;
  if (obj247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject261 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj261 = alloc_userobj2(2,4, objclass261);
  gc_frame_newslot(obj261);
// OBJECT OUTER DEC outer
  adddatum2(obj261, self, 0);
  addmethodreal(obj261,"outer", &reader_lexer_outer_262);
  Object oldself261 = self;
  struct StackFrameObject *oldstackframe261 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe261);
  gc_frame_newslot((Object)stackframe);
  self = obj261;
  Object *oldselfslot261 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter261 = (*(struct UserObject *)self).data[0], lowerouter261 = thisouter261;
  if (inheritingObject261) {
    struct UserObject *inho261 = (struct UserObject *)inheritingObject261;
    while (inho261->super != GraceDefaultObject) inho261 = (struct UserObject *)inho261->super;
    inho261->super = obj261;
    self = inheritingObject261;
    *selfslot = self;
    lowerouter261 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter261;
  }
// method new
  block_savedest(obj261);
  Object closure263 = createclosure(1, "new");
  setclosureframe(closure263, stackframe);
  addtoclosure(closure263, var_Token);
  struct UserObject *uo263 = (struct UserObject*)obj261;
  uo263->data[1] = (Object)closure263;
  Method *meth_meth_lexer_new263 = addmethod2pos(obj261, "new", &meth_lexer_new263, 1);
  int argcv_meth_lexer_new263[] = {0};
  meth_meth_lexer_new263->type = alloc_MethodType(1, argcv_meth_lexer_new263);
  meth_meth_lexer_new263->definitionModule = modulename;
  meth_meth_lexer_new263->definitionLine = 123;
  block_savedest(obj261);
  Object closure274 = createclosure(1, "new()object");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_Token);
  Method *meth_meth_lexer_new263_object = addmethod2pos(obj261, "new()object", &meth_lexer_new263_object, 1);
  meth_meth_lexer_new263_object->definitionModule = modulename;
  meth_meth_lexer_new263_object->definitionLine = 123;
  sourceObject = obj261;
objclass261 = obj261->class;
  objclass261->definitionModule = modulename;
  objclass261->definitionLine = 123;
  (*(struct UserObject *)self).data[0] = lowerouter261;
  self = oldself261;
  selfslot = oldselfslot261;
  stackframe = oldstackframe261;
// compiled object node returning obj261 (depth = 5)
  *var_DotToken = obj261;
  if (obj261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj275 = alloc_userobj2(2,4, objclass275);
  gc_frame_newslot(obj275);
// OBJECT OUTER DEC outer
  adddatum2(obj275, self, 0);
  addmethodreal(obj275,"outer", &reader_lexer_outer_276);
  Object oldself275 = self;
  struct StackFrameObject *oldstackframe275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe275);
  gc_frame_newslot((Object)stackframe);
  self = obj275;
  Object *oldselfslot275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter275 = (*(struct UserObject *)self).data[0], lowerouter275 = thisouter275;
  if (inheritingObject275) {
    struct UserObject *inho275 = (struct UserObject *)inheritingObject275;
    while (inho275->super != GraceDefaultObject) inho275 = (struct UserObject *)inho275->super;
    inho275->super = obj275;
    self = inheritingObject275;
    *selfslot = self;
    lowerouter275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter275;
  }
// method new
  block_savedest(obj275);
  Object closure277 = createclosure(3, "new");
  setclosureframe(closure277, stackframe);
  addtoclosure(closure277, var_Token);
  addtoclosure(closure277, var_startPosition);
  addtoclosure(closure277, var_linePosition);
  struct UserObject *uo277 = (struct UserObject*)obj275;
  uo277->data[1] = (Object)closure277;
  Method *meth_meth_lexer_new277 = addmethod2pos(obj275, "new", &meth_lexer_new277, 1);
  int argcv_meth_lexer_new277[] = {2};
  meth_meth_lexer_new277->type = alloc_MethodType(1, argcv_meth_lexer_new277);
  meth_meth_lexer_new277->definitionModule = modulename;
  meth_meth_lexer_new277->definitionLine = 129;
  block_savedest(obj275);
  Object closure290 = createclosure(3, "new()object");
  setclosureframe(closure290, stackframe);
  addtoclosure(closure290, var_Token);
  addtoclosure(closure290, var_startPosition);
  addtoclosure(closure290, var_linePosition);
  Method *meth_meth_lexer_new277_object = addmethod2pos(obj275, "new()object", &meth_lexer_new277_object, 1);
  meth_meth_lexer_new277_object->definitionModule = modulename;
  meth_meth_lexer_new277_object->definitionLine = 129;
  sourceObject = obj275;
objclass275 = obj275->class;
  objclass275->definitionModule = modulename;
  objclass275->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter275;
  self = oldself275;
  selfslot = oldselfslot275;
  stackframe = oldstackframe275;
// compiled object node returning obj275 (depth = 5)
  *var_NumToken = obj275;
  if (obj275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject291 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj291 = alloc_userobj2(2,4, objclass291);
  gc_frame_newslot(obj291);
// OBJECT OUTER DEC outer
  adddatum2(obj291, self, 0);
  addmethodreal(obj291,"outer", &reader_lexer_outer_292);
  Object oldself291 = self;
  struct StackFrameObject *oldstackframe291 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe291);
  gc_frame_newslot((Object)stackframe);
  self = obj291;
  Object *oldselfslot291 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter291 = (*(struct UserObject *)self).data[0], lowerouter291 = thisouter291;
  if (inheritingObject291) {
    struct UserObject *inho291 = (struct UserObject *)inheritingObject291;
    while (inho291->super != GraceDefaultObject) inho291 = (struct UserObject *)inho291->super;
    inho291->super = obj291;
    self = inheritingObject291;
    *selfslot = self;
    lowerouter291 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter291;
  }
// method new
  block_savedest(obj291);
  Object closure293 = createclosure(1, "new");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_Token);
  struct UserObject *uo293 = (struct UserObject*)obj291;
  uo293->data[1] = (Object)closure293;
  Method *meth_meth_lexer_new293 = addmethod2pos(obj291, "new", &meth_lexer_new293, 1);
  int argcv_meth_lexer_new293[] = {1};
  meth_meth_lexer_new293->type = alloc_MethodType(1, argcv_meth_lexer_new293);
  meth_meth_lexer_new293->definitionModule = modulename;
  meth_meth_lexer_new293->definitionLine = 136;
  block_savedest(obj291);
  Object closure304 = createclosure(1, "new()object");
  setclosureframe(closure304, stackframe);
  addtoclosure(closure304, var_Token);
  Method *meth_meth_lexer_new293_object = addmethod2pos(obj291, "new()object", &meth_lexer_new293_object, 1);
  meth_meth_lexer_new293_object->definitionModule = modulename;
  meth_meth_lexer_new293_object->definitionLine = 136;
  sourceObject = obj291;
objclass291 = obj291->class;
  objclass291->definitionModule = modulename;
  objclass291->definitionLine = 136;
  (*(struct UserObject *)self).data[0] = lowerouter291;
  self = oldself291;
  selfslot = oldselfslot291;
  stackframe = oldstackframe291;
// compiled object node returning obj291 (depth = 5)
  *var_KeywordToken = obj291;
  if (obj291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject305 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj305 = alloc_userobj2(2,4, objclass305);
  gc_frame_newslot(obj305);
// OBJECT OUTER DEC outer
  adddatum2(obj305, self, 0);
  addmethodreal(obj305,"outer", &reader_lexer_outer_306);
  Object oldself305 = self;
  struct StackFrameObject *oldstackframe305 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe305);
  gc_frame_newslot((Object)stackframe);
  self = obj305;
  Object *oldselfslot305 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter305 = (*(struct UserObject *)self).data[0], lowerouter305 = thisouter305;
  if (inheritingObject305) {
    struct UserObject *inho305 = (struct UserObject *)inheritingObject305;
    while (inho305->super != GraceDefaultObject) inho305 = (struct UserObject *)inho305->super;
    inho305->super = obj305;
    self = inheritingObject305;
    *selfslot = self;
    lowerouter305 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter305;
  }
// method new
  block_savedest(obj305);
  Object closure307 = createclosure(1, "new");
  setclosureframe(closure307, stackframe);
  addtoclosure(closure307, var_Token);
  struct UserObject *uo307 = (struct UserObject*)obj305;
  uo307->data[1] = (Object)closure307;
  Method *meth_meth_lexer_new307 = addmethod2pos(obj305, "new", &meth_lexer_new307, 1);
  int argcv_meth_lexer_new307[] = {1};
  meth_meth_lexer_new307->type = alloc_MethodType(1, argcv_meth_lexer_new307);
  meth_meth_lexer_new307->definitionModule = modulename;
  meth_meth_lexer_new307->definitionLine = 142;
  block_savedest(obj305);
  Object closure318 = createclosure(1, "new()object");
  setclosureframe(closure318, stackframe);
  addtoclosure(closure318, var_Token);
  Method *meth_meth_lexer_new307_object = addmethod2pos(obj305, "new()object", &meth_lexer_new307_object, 1);
  meth_meth_lexer_new307_object->definitionModule = modulename;
  meth_meth_lexer_new307_object->definitionLine = 142;
  sourceObject = obj305;
objclass305 = obj305->class;
  objclass305->definitionModule = modulename;
  objclass305->definitionLine = 142;
  (*(struct UserObject *)self).data[0] = lowerouter305;
  self = oldself305;
  selfslot = oldselfslot305;
  stackframe = oldstackframe305;
// compiled object node returning obj305 (depth = 5)
  *var_OpToken = obj305;
  if (obj305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject319 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj319 = alloc_userobj2(2,4, objclass319);
  gc_frame_newslot(obj319);
// OBJECT OUTER DEC outer
  adddatum2(obj319, self, 0);
  addmethodreal(obj319,"outer", &reader_lexer_outer_320);
  Object oldself319 = self;
  struct StackFrameObject *oldstackframe319 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe319);
  gc_frame_newslot((Object)stackframe);
  self = obj319;
  Object *oldselfslot319 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter319 = (*(struct UserObject *)self).data[0], lowerouter319 = thisouter319;
  if (inheritingObject319) {
    struct UserObject *inho319 = (struct UserObject *)inheritingObject319;
    while (inho319->super != GraceDefaultObject) inho319 = (struct UserObject *)inho319->super;
    inho319->super = obj319;
    self = inheritingObject319;
    *selfslot = self;
    lowerouter319 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter319;
  }
// method new
  block_savedest(obj319);
  Object closure321 = createclosure(1, "new");
  setclosureframe(closure321, stackframe);
  addtoclosure(closure321, var_Token);
  struct UserObject *uo321 = (struct UserObject*)obj319;
  uo321->data[1] = (Object)closure321;
  Method *meth_meth_lexer_new321 = addmethod2pos(obj319, "new", &meth_lexer_new321, 1);
  int argcv_meth_lexer_new321[] = {0};
  meth_meth_lexer_new321->type = alloc_MethodType(1, argcv_meth_lexer_new321);
  meth_meth_lexer_new321->definitionModule = modulename;
  meth_meth_lexer_new321->definitionLine = 148;
  block_savedest(obj319);
  Object closure332 = createclosure(1, "new()object");
  setclosureframe(closure332, stackframe);
  addtoclosure(closure332, var_Token);
  Method *meth_meth_lexer_new321_object = addmethod2pos(obj319, "new()object", &meth_lexer_new321_object, 1);
  meth_meth_lexer_new321_object->definitionModule = modulename;
  meth_meth_lexer_new321_object->definitionLine = 148;
  sourceObject = obj319;
objclass319 = obj319->class;
  objclass319->definitionModule = modulename;
  objclass319->definitionLine = 148;
  (*(struct UserObject *)self).data[0] = lowerouter319;
  self = oldself319;
  selfslot = oldselfslot319;
  stackframe = oldstackframe319;
// compiled object node returning obj319 (depth = 5)
  *var_ArrowToken = obj319;
  if (obj319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj333 = alloc_userobj2(2,4, objclass333);
  gc_frame_newslot(obj333);
// OBJECT OUTER DEC outer
  adddatum2(obj333, self, 0);
  addmethodreal(obj333,"outer", &reader_lexer_outer_334);
  Object oldself333 = self;
  struct StackFrameObject *oldstackframe333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe333);
  gc_frame_newslot((Object)stackframe);
  self = obj333;
  Object *oldselfslot333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter333 = (*(struct UserObject *)self).data[0], lowerouter333 = thisouter333;
  if (inheritingObject333) {
    struct UserObject *inho333 = (struct UserObject *)inheritingObject333;
    while (inho333->super != GraceDefaultObject) inho333 = (struct UserObject *)inho333->super;
    inho333->super = obj333;
    self = inheritingObject333;
    *selfslot = self;
    lowerouter333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter333;
  }
// method new
  block_savedest(obj333);
  Object closure335 = createclosure(1, "new");
  setclosureframe(closure335, stackframe);
  addtoclosure(closure335, var_Token);
  struct UserObject *uo335 = (struct UserObject*)obj333;
  uo335->data[1] = (Object)closure335;
  Method *meth_meth_lexer_new335 = addmethod2pos(obj333, "new", &meth_lexer_new335, 1);
  int argcv_meth_lexer_new335[] = {0};
  meth_meth_lexer_new335->type = alloc_MethodType(1, argcv_meth_lexer_new335);
  meth_meth_lexer_new335->definitionModule = modulename;
  meth_meth_lexer_new335->definitionLine = 154;
  block_savedest(obj333);
  Object closure346 = createclosure(1, "new()object");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_Token);
  Method *meth_meth_lexer_new335_object = addmethod2pos(obj333, "new()object", &meth_lexer_new335_object, 1);
  meth_meth_lexer_new335_object->definitionModule = modulename;
  meth_meth_lexer_new335_object->definitionLine = 154;
  sourceObject = obj333;
objclass333 = obj333->class;
  objclass333->definitionModule = modulename;
  objclass333->definitionLine = 154;
  (*(struct UserObject *)self).data[0] = lowerouter333;
  self = oldself333;
  selfslot = oldselfslot333;
  stackframe = oldstackframe333;
// compiled object node returning obj333 (depth = 5)
  *var_BindToken = obj333;
  if (obj333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(2,4, objclass347);
  gc_frame_newslot(obj347);
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_lexer_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
// method new
  block_savedest(obj347);
  Object closure349 = createclosure(1, "new");
  setclosureframe(closure349, stackframe);
  addtoclosure(closure349, var_Token);
  struct UserObject *uo349 = (struct UserObject*)obj347;
  uo349->data[1] = (Object)closure349;
  Method *meth_meth_lexer_new349 = addmethod2pos(obj347, "new", &meth_lexer_new349, 1);
  int argcv_meth_lexer_new349[] = {0};
  meth_meth_lexer_new349->type = alloc_MethodType(1, argcv_meth_lexer_new349);
  meth_meth_lexer_new349->definitionModule = modulename;
  meth_meth_lexer_new349->definitionLine = 160;
  block_savedest(obj347);
  Object closure360 = createclosure(1, "new()object");
  setclosureframe(closure360, stackframe);
  addtoclosure(closure360, var_Token);
  Method *meth_meth_lexer_new349_object = addmethod2pos(obj347, "new()object", &meth_lexer_new349_object, 1);
  meth_meth_lexer_new349_object->definitionModule = modulename;
  meth_meth_lexer_new349_object->definitionLine = 160;
  sourceObject = obj347;
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 160;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
// compiled object node returning obj347 (depth = 5)
  *var_SemicolonToken = obj347;
  if (obj347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject361 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj361 = alloc_userobj2(2,4, objclass361);
  gc_frame_newslot(obj361);
// OBJECT OUTER DEC outer
  adddatum2(obj361, self, 0);
  addmethodreal(obj361,"outer", &reader_lexer_outer_362);
  Object oldself361 = self;
  struct StackFrameObject *oldstackframe361 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe361);
  gc_frame_newslot((Object)stackframe);
  self = obj361;
  Object *oldselfslot361 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter361 = (*(struct UserObject *)self).data[0], lowerouter361 = thisouter361;
  if (inheritingObject361) {
    struct UserObject *inho361 = (struct UserObject *)inheritingObject361;
    while (inho361->super != GraceDefaultObject) inho361 = (struct UserObject *)inho361->super;
    inho361->super = obj361;
    self = inheritingObject361;
    *selfslot = self;
    lowerouter361 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter361;
  }
// method new
  block_savedest(obj361);
  Object closure363 = createclosure(1, "new");
  setclosureframe(closure363, stackframe);
  addtoclosure(closure363, var_Token);
  struct UserObject *uo363 = (struct UserObject*)obj361;
  uo363->data[1] = (Object)closure363;
  Method *meth_meth_lexer_new363 = addmethod2pos(obj361, "new", &meth_lexer_new363, 1);
  int argcv_meth_lexer_new363[] = {0};
  meth_meth_lexer_new363->type = alloc_MethodType(1, argcv_meth_lexer_new363);
  meth_meth_lexer_new363->definitionModule = modulename;
  meth_meth_lexer_new363->definitionLine = 166;
  block_savedest(obj361);
  Object closure374 = createclosure(1, "new()object");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_Token);
  Method *meth_meth_lexer_new363_object = addmethod2pos(obj361, "new()object", &meth_lexer_new363_object, 1);
  meth_meth_lexer_new363_object->definitionModule = modulename;
  meth_meth_lexer_new363_object->definitionLine = 166;
  sourceObject = obj361;
objclass361 = obj361->class;
  objclass361->definitionModule = modulename;
  objclass361->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter361;
  self = oldself361;
  selfslot = oldselfslot361;
  stackframe = oldstackframe361;
// compiled object node returning obj361 (depth = 5)
  *var_LGenericToken = obj361;
  if (obj361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject375 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj375 = alloc_userobj2(2,4, objclass375);
  gc_frame_newslot(obj375);
// OBJECT OUTER DEC outer
  adddatum2(obj375, self, 0);
  addmethodreal(obj375,"outer", &reader_lexer_outer_376);
  Object oldself375 = self;
  struct StackFrameObject *oldstackframe375 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe375);
  gc_frame_newslot((Object)stackframe);
  self = obj375;
  Object *oldselfslot375 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter375 = (*(struct UserObject *)self).data[0], lowerouter375 = thisouter375;
  if (inheritingObject375) {
    struct UserObject *inho375 = (struct UserObject *)inheritingObject375;
    while (inho375->super != GraceDefaultObject) inho375 = (struct UserObject *)inho375->super;
    inho375->super = obj375;
    self = inheritingObject375;
    *selfslot = self;
    lowerouter375 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter375;
  }
// method new
  block_savedest(obj375);
  Object closure377 = createclosure(1, "new");
  setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_Token);
  struct UserObject *uo377 = (struct UserObject*)obj375;
  uo377->data[1] = (Object)closure377;
  Method *meth_meth_lexer_new377 = addmethod2pos(obj375, "new", &meth_lexer_new377, 1);
  int argcv_meth_lexer_new377[] = {0};
  meth_meth_lexer_new377->type = alloc_MethodType(1, argcv_meth_lexer_new377);
  meth_meth_lexer_new377->definitionModule = modulename;
  meth_meth_lexer_new377->definitionLine = 172;
  block_savedest(obj375);
  Object closure388 = createclosure(1, "new()object");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_Token);
  Method *meth_meth_lexer_new377_object = addmethod2pos(obj375, "new()object", &meth_lexer_new377_object, 1);
  meth_meth_lexer_new377_object->definitionModule = modulename;
  meth_meth_lexer_new377_object->definitionLine = 172;
  sourceObject = obj375;
objclass375 = obj375->class;
  objclass375->definitionModule = modulename;
  objclass375->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter375;
  self = oldself375;
  selfslot = oldselfslot375;
  stackframe = oldstackframe375;
// compiled object node returning obj375 (depth = 5)
  *var_RGenericToken = obj375;
  if (obj375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject389 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj389 = alloc_userobj2(8,9, objclass389);
  gc_frame_newslot(obj389);
if (objclass389 == NULL) {
  glfree(obj389->class->name);
  obj389->class->name = "obj25.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj389, self, 0);
  addmethodreal(obj389,"outer", &reader_lexer_outer_390);
  Object oldself389 = self;
  struct StackFrameObject *oldstackframe389 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe389);
  gc_frame_newslot((Object)stackframe);
  self = obj389;
  Object *oldselfslot389 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter389 = (*(struct UserObject *)self).data[0], lowerouter389 = thisouter389;
  if (inheritingObject389) {
    struct UserObject *inho389 = (struct UserObject *)inheritingObject389;
    while (inho389->super != GraceDefaultObject) inho389 = (struct UserObject *)inho389->super;
    inho389->super = obj389;
    self = inheritingObject389;
    *selfslot = self;
    lowerouter389 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter389;
  }
// method modechange
  block_savedest(obj389);
  Object closure391 = createclosure(27, "modechange");
  setclosureframe(closure391, stackframe);
  addtoclosure(closure391, var_IdentifierToken);
  addtoclosure(closure391, var_KeywordToken);
  addtoclosure(closure391, var_StringToken);
  addtoclosure(closure391, var_MultiLineStringToken);
  addtoclosure(closure391, var_CommaToken);
  addtoclosure(closure391, var_DotToken);
  addtoclosure(closure391, var_LBraceToken);
  addtoclosure(closure391, var_RBraceToken);
  addtoclosure(closure391, var_LParenToken);
  addtoclosure(closure391, var_RParenToken);
  addtoclosure(closure391, var_LSquareToken);
  addtoclosure(closure391, var_RSquareToken);
  addtoclosure(closure391, var_LGenericToken);
  addtoclosure(closure391, var_RGenericToken);
  addtoclosure(closure391, var_SemicolonToken);
  addtoclosure(closure391, var_NumToken);
  addtoclosure(closure391, var_errormessages);
  addtoclosure(closure391, var_linePosition);
  addtoclosure(closure391, var_lineNumber);
  addtoclosure(closure391, var_OpToken);
  addtoclosure(closure391, var_ArrowToken);
  addtoclosure(closure391, var_BindToken);
  addtoclosure(closure391, var_ColonToken);
  addtoclosure(closure391, var_indentLevel);
  addtoclosure(closure391, var_CommentToken);
  addtoclosure(closure391, var_util);
  addtoclosure(closure391, var_startPosition);
  struct UserObject *uo391 = (struct UserObject*)obj389;
  uo391->data[1] = (Object)closure391;
  Method *meth_meth_lexer_modechange391 = addmethod2pos(obj389, "modechange", &meth_lexer_modechange391, 1);
  int argcv_meth_lexer_modechange391[] = {3};
  meth_meth_lexer_modechange391->type = alloc_MethodType(1, argcv_meth_lexer_modechange391);
  meth_meth_lexer_modechange391->definitionModule = modulename;
  meth_meth_lexer_modechange391->definitionLine = 196;
// method fromBase
  block_savedest(obj389);
  Object closure1129 = createclosure(4, "fromBase");
  setclosureframe(closure1129, stackframe);
  addtoclosure(closure1129, var_errormessages);
  addtoclosure(closure1129, var_linePosition);
  addtoclosure(closure1129, var_lineNumber);
  addtoclosure(closure1129, var_unicode);
  struct UserObject *uo1129 = (struct UserObject*)obj389;
  uo1129->data[2] = (Object)closure1129;
  Method *meth_meth_lexer_fromBase1129 = addmethod2pos(obj389, "fromBase", &meth_lexer_fromBase1129, 2);
  int argcv_meth_lexer_fromBase1129[] = {2};
  meth_meth_lexer_fromBase1129->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1129);
  meth_meth_lexer_fromBase1129->definitionModule = modulename;
  meth_meth_lexer_fromBase1129->definitionLine = 373;
// method hexdecchar
  block_savedest(obj389);
  Object closure1345 = createclosure(3, "hexdecchar");
  setclosureframe(closure1345, stackframe);
  addtoclosure(closure1345, var_lineNumber);
  addtoclosure(closure1345, var_linePosition);
  addtoclosure(closure1345, var_errormessages);
  struct UserObject *uo1345 = (struct UserObject*)obj389;
  uo1345->data[3] = (Object)closure1345;
  Method *meth_meth_lexer_hexdecchar1345 = addmethod2pos(obj389, "hexdecchar", &meth_lexer_hexdecchar1345, 3);
  int argcv_meth_lexer_hexdecchar1345[] = {1};
  meth_meth_lexer_hexdecchar1345->type = alloc_MethodType(1, argcv_meth_lexer_hexdecchar1345);
  meth_meth_lexer_hexdecchar1345->definitionModule = modulename;
  meth_meth_lexer_hexdecchar1345->definitionLine = 415;
// method makeNumToken
  block_savedest(obj389);
  Object closure1423 = createclosure(4, "makeNumToken");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_errormessages);
  addtoclosure(closure1423, var_linePosition);
  addtoclosure(closure1423, var_lineNumber);
  addtoclosure(closure1423, var_NumToken);
  struct UserObject *uo1423 = (struct UserObject*)obj389;
  uo1423->data[4] = (Object)closure1423;
  Method *meth_meth_lexer_makeNumToken1423 = addmethod2pos(obj389, "makeNumToken", &meth_lexer_makeNumToken1423, 4);
  int argcv_meth_lexer_makeNumToken1423[] = {1};
  meth_meth_lexer_makeNumToken1423->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1423);
  meth_meth_lexer_makeNumToken1423->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1423->definitionLine = 433;
// method isidentifierchar
  block_savedest(obj389);
  Object closure1602 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1602, stackframe);
  addtoclosure(closure1602, var_unicode);
  struct UserObject *uo1602 = (struct UserObject*)obj389;
  uo1602->data[5] = (Object)closure1602;
  Method *meth_meth_lexer_isidentifierchar1602 = addmethod2pos(obj389, "isidentifierchar", &meth_lexer_isidentifierchar1602, 5);
  int argcv_meth_lexer_isidentifierchar1602[] = {1};
  meth_meth_lexer_isidentifierchar1602->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1602);
  meth_meth_lexer_isidentifierchar1602->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1602->definitionLine = 478;
// method isoperatorchar
  block_savedest(obj389);
  Object closure1625 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1625, stackframe);
  addtoclosure(closure1625, var_unicode);
  struct UserObject *uo1625 = (struct UserObject*)obj389;
  uo1625->data[6] = (Object)closure1625;
  Method *meth_meth_lexer_isoperatorchar1625 = addmethod2pos(obj389, "isoperatorchar", &meth_lexer_isoperatorchar1625, 6);
  int argcv_meth_lexer_isoperatorchar1625[] = {2};
  meth_meth_lexer_isoperatorchar1625->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1625);
  meth_meth_lexer_isoperatorchar1625->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1625->definitionLine = 494;
// method lexfile
  block_savedest(obj389);
  Object closure1719 = createclosure(1, "lexfile");
  setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, var_util);
  struct UserObject *uo1719 = (struct UserObject*)obj389;
  uo1719->data[7] = (Object)closure1719;
  Method *meth_meth_lexer_lexfile1719 = addmethod2pos(obj389, "lexfile", &meth_lexer_lexfile1719, 7);
  int argcv_meth_lexer_lexfile1719[] = {1};
  meth_meth_lexer_lexfile1719->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1719);
  meth_meth_lexer_lexfile1719->definitionModule = modulename;
  meth_meth_lexer_lexfile1719->definitionLine = 511;
// method lexinput
  block_savedest(obj389);
  Object closure1817 = createclosure(8, "lexinput");
  setclosureframe(closure1817, stackframe);
  addtoclosure(closure1817, var_linePosition);
  addtoclosure(closure1817, var_util);
  addtoclosure(closure1817, var_unicode);
  addtoclosure(closure1817, var_errormessages);
  addtoclosure(closure1817, var_lineNumber);
  addtoclosure(closure1817, var_stringStart);
  addtoclosure(closure1817, var_startLine);
  addtoclosure(closure1817, var_startPosition);
  struct UserObject *uo1817 = (struct UserObject*)obj389;
  uo1817->data[8] = (Object)closure1817;
  Method *meth_meth_lexer_lexinput1817 = addmethod2pos(obj389, "lexinput", &meth_lexer_lexinput1817, 8);
  int argcv_meth_lexer_lexinput1817[] = {1};
  meth_meth_lexer_lexinput1817->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1817);
  meth_meth_lexer_lexinput1817->definitionModule = modulename;
  meth_meth_lexer_lexinput1817->definitionLine = 546;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
objclass389 = obj389->class;
  objclass389->definitionModule = modulename;
  objclass389->definitionLine = 179;
  (*(struct UserObject *)self).data[0] = lowerouter389;
  self = oldself389;
  selfslot = oldselfslot389;
  stackframe = oldstackframe389;
  gc_frame_end(frame);
  return obj389;
}
Object meth_lexer_new29_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_startLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "startLine");
  Object *var_stringStart = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "stringStart");
  Object *var_Token = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "StringToken");
  Object *var_MultiLineStringToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "MultiLineStringToken");
  Object *var_CommentToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "CommentToken");
  Object *var_LBraceToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "DotToken");
  Object *var_NumToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "RGenericToken");
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num30 = alloc_Float64(1);
// compiled num node returning num30 (depth = 4)
  *var_lineNumber = num30;
  if (num30 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num31 = alloc_Float64(0);
// compiled num node returning num31 (depth = 4)
  *var_linePosition = num31;
  if (num31 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num32 = alloc_Float64(1);
// compiled num node returning num32 (depth = 4)
  *var_startPosition = num32;
  if (num32 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num33 = alloc_Float64(0);
// compiled num node returning num33 (depth = 4)
  *var_indentLevel = num33;
  if (num33 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num34 = alloc_Float64(1);
// compiled num node returning num34 (depth = 4)
  *var_startLine = num34;
  if (num34 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_stringStart = undefined;
// compiled vardec node returning done (depth = 3)
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject35 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj35 = alloc_userobj2(2,4, objclass35);
  gc_frame_newslot(obj35);
// OBJECT OUTER DEC outer
  adddatum2(obj35, self, 0);
  addmethodreal(obj35,"outer", &reader_lexer_outer_36);
  Object oldself35 = self;
  struct StackFrameObject *oldstackframe35 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe35);
  gc_frame_newslot((Object)stackframe);
  self = obj35;
  Object *oldselfslot35 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter35 = (*(struct UserObject *)self).data[0], lowerouter35 = thisouter35;
  if (inheritingObject35) {
    struct UserObject *inho35 = (struct UserObject *)inheritingObject35;
    while (inho35->super != GraceDefaultObject) inho35 = (struct UserObject *)inho35->super;
    inho35->super = obj35;
    self = inheritingObject35;
    *selfslot = self;
    lowerouter35 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter35;
  }
// method new
  block_savedest(obj35);
  Object closure37 = createclosure(3, "new");
  setclosureframe(closure37, stackframe);
  addtoclosure(closure37, var_lineNumber);
  addtoclosure(closure37, var_indentLevel);
  addtoclosure(closure37, var_startPosition);
  struct UserObject *uo37 = (struct UserObject*)obj35;
  uo37->data[1] = (Object)closure37;
  Method *meth_meth_lexer_new37 = addmethod2pos(obj35, "new", &meth_lexer_new37, 1);
  int argcv_meth_lexer_new37[] = {0};
  meth_meth_lexer_new37->type = alloc_MethodType(1, argcv_meth_lexer_new37);
  meth_meth_lexer_new37->definitionModule = modulename;
  meth_meth_lexer_new37->definitionLine = 30;
  block_savedest(obj35);
  Object closure71 = createclosure(3, "new()object");
  setclosureframe(closure71, stackframe);
  addtoclosure(closure71, var_lineNumber);
  addtoclosure(closure71, var_indentLevel);
  addtoclosure(closure71, var_startPosition);
  Method *meth_meth_lexer_new37_object = addmethod2pos(obj35, "new()object", &meth_lexer_new37_object, 1);
  meth_meth_lexer_new37_object->definitionModule = modulename;
  meth_meth_lexer_new37_object->definitionLine = 30;
  sourceObject = obj35;
objclass35 = obj35->class;
  objclass35->definitionModule = modulename;
  objclass35->definitionLine = 30;
  (*(struct UserObject *)self).data[0] = lowerouter35;
  self = oldself35;
  selfslot = oldselfslot35;
  stackframe = oldstackframe35;
// compiled object node returning obj35 (depth = 5)
  *var_Token = obj35;
  if (obj35 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject72 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj72 = alloc_userobj2(2,4, objclass72);
  gc_frame_newslot(obj72);
// OBJECT OUTER DEC outer
  adddatum2(obj72, self, 0);
  addmethodreal(obj72,"outer", &reader_lexer_outer_73);
  Object oldself72 = self;
  struct StackFrameObject *oldstackframe72 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe72);
  gc_frame_newslot((Object)stackframe);
  self = obj72;
  Object *oldselfslot72 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter72 = (*(struct UserObject *)self).data[0], lowerouter72 = thisouter72;
  if (inheritingObject72) {
    struct UserObject *inho72 = (struct UserObject *)inheritingObject72;
    while (inho72->super != GraceDefaultObject) inho72 = (struct UserObject *)inho72->super;
    inho72->super = obj72;
    self = inheritingObject72;
    *selfslot = self;
    lowerouter72 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter72;
  }
// method new
  block_savedest(obj72);
  Object closure74 = createclosure(1, "new");
  setclosureframe(closure74, stackframe);
  addtoclosure(closure74, var_Token);
  struct UserObject *uo74 = (struct UserObject*)obj72;
  uo74->data[1] = (Object)closure74;
  Method *meth_meth_lexer_new74 = addmethod2pos(obj72, "new", &meth_lexer_new74, 1);
  int argcv_meth_lexer_new74[] = {1};
  meth_meth_lexer_new74->type = alloc_MethodType(1, argcv_meth_lexer_new74);
  meth_meth_lexer_new74->definitionModule = modulename;
  meth_meth_lexer_new74->definitionLine = 47;
  block_savedest(obj72);
  Object closure85 = createclosure(1, "new()object");
  setclosureframe(closure85, stackframe);
  addtoclosure(closure85, var_Token);
  Method *meth_meth_lexer_new74_object = addmethod2pos(obj72, "new()object", &meth_lexer_new74_object, 1);
  meth_meth_lexer_new74_object->definitionModule = modulename;
  meth_meth_lexer_new74_object->definitionLine = 47;
  sourceObject = obj72;
objclass72 = obj72->class;
  objclass72->definitionModule = modulename;
  objclass72->definitionLine = 47;
  (*(struct UserObject *)self).data[0] = lowerouter72;
  self = oldself72;
  selfslot = oldselfslot72;
  stackframe = oldstackframe72;
// compiled object node returning obj72 (depth = 5)
  *var_IdentifierToken = obj72;
  if (obj72 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject86 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj86 = alloc_userobj2(2,4, objclass86);
  gc_frame_newslot(obj86);
// OBJECT OUTER DEC outer
  adddatum2(obj86, self, 0);
  addmethodreal(obj86,"outer", &reader_lexer_outer_87);
  Object oldself86 = self;
  struct StackFrameObject *oldstackframe86 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe86);
  gc_frame_newslot((Object)stackframe);
  self = obj86;
  Object *oldselfslot86 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter86 = (*(struct UserObject *)self).data[0], lowerouter86 = thisouter86;
  if (inheritingObject86) {
    struct UserObject *inho86 = (struct UserObject *)inheritingObject86;
    while (inho86->super != GraceDefaultObject) inho86 = (struct UserObject *)inho86->super;
    inho86->super = obj86;
    self = inheritingObject86;
    *selfslot = self;
    lowerouter86 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter86;
  }
// method new
  block_savedest(obj86);
  Object closure88 = createclosure(3, "new");
  setclosureframe(closure88, stackframe);
  addtoclosure(closure88, var_Token);
  addtoclosure(closure88, var_stringStart);
  addtoclosure(closure88, var_linePosition);
  struct UserObject *uo88 = (struct UserObject*)obj86;
  uo88->data[1] = (Object)closure88;
  Method *meth_meth_lexer_new88 = addmethod2pos(obj86, "new", &meth_lexer_new88, 1);
  int argcv_meth_lexer_new88[] = {1};
  meth_meth_lexer_new88->type = alloc_MethodType(1, argcv_meth_lexer_new88);
  meth_meth_lexer_new88->definitionModule = modulename;
  meth_meth_lexer_new88->definitionLine = 53;
  block_savedest(obj86);
  Object closure104 = createclosure(3, "new()object");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_Token);
  addtoclosure(closure104, var_stringStart);
  addtoclosure(closure104, var_linePosition);
  Method *meth_meth_lexer_new88_object = addmethod2pos(obj86, "new()object", &meth_lexer_new88_object, 1);
  meth_meth_lexer_new88_object->definitionModule = modulename;
  meth_meth_lexer_new88_object->definitionLine = 53;
  sourceObject = obj86;
objclass86 = obj86->class;
  objclass86->definitionModule = modulename;
  objclass86->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter86;
  self = oldself86;
  selfslot = oldselfslot86;
  stackframe = oldstackframe86;
// compiled object node returning obj86 (depth = 5)
  *var_StringToken = obj86;
  if (obj86 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject105 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj105 = alloc_userobj2(2,4, objclass105);
  gc_frame_newslot(obj105);
// OBJECT OUTER DEC outer
  adddatum2(obj105, self, 0);
  addmethodreal(obj105,"outer", &reader_lexer_outer_106);
  Object oldself105 = self;
  struct StackFrameObject *oldstackframe105 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe105);
  gc_frame_newslot((Object)stackframe);
  self = obj105;
  Object *oldselfslot105 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter105 = (*(struct UserObject *)self).data[0], lowerouter105 = thisouter105;
  if (inheritingObject105) {
    struct UserObject *inho105 = (struct UserObject *)inheritingObject105;
    while (inho105->super != GraceDefaultObject) inho105 = (struct UserObject *)inho105->super;
    inho105->super = obj105;
    self = inheritingObject105;
    *selfslot = self;
    lowerouter105 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter105;
  }
// method new
  block_savedest(obj105);
  Object closure107 = createclosure(3, "new");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_Token);
  addtoclosure(closure107, var_startLine);
  addtoclosure(closure107, var_stringStart);
  struct UserObject *uo107 = (struct UserObject*)obj105;
  uo107->data[1] = (Object)closure107;
  Method *meth_meth_lexer_new107 = addmethod2pos(obj105, "new", &meth_lexer_new107, 1);
  int argcv_meth_lexer_new107[] = {1};
  meth_meth_lexer_new107->type = alloc_MethodType(1, argcv_meth_lexer_new107);
  meth_meth_lexer_new107->definitionModule = modulename;
  meth_meth_lexer_new107->definitionLine = 59;
  block_savedest(obj105);
  Object closure130 = createclosure(3, "new()object");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_Token);
  addtoclosure(closure130, var_startLine);
  addtoclosure(closure130, var_stringStart);
  Method *meth_meth_lexer_new107_object = addmethod2pos(obj105, "new()object", &meth_lexer_new107_object, 1);
  meth_meth_lexer_new107_object->definitionModule = modulename;
  meth_meth_lexer_new107_object->definitionLine = 59;
  sourceObject = obj105;
objclass105 = obj105->class;
  objclass105->definitionModule = modulename;
  objclass105->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter105;
  self = oldself105;
  selfslot = oldselfslot105;
  stackframe = oldstackframe105;
// compiled object node returning obj105 (depth = 5)
  *var_MultiLineStringToken = obj105;
  if (obj105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject131 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj131 = alloc_userobj2(2,4, objclass131);
  gc_frame_newslot(obj131);
// OBJECT OUTER DEC outer
  adddatum2(obj131, self, 0);
  addmethodreal(obj131,"outer", &reader_lexer_outer_132);
  Object oldself131 = self;
  struct StackFrameObject *oldstackframe131 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe131);
  gc_frame_newslot((Object)stackframe);
  self = obj131;
  Object *oldselfslot131 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter131 = (*(struct UserObject *)self).data[0], lowerouter131 = thisouter131;
  if (inheritingObject131) {
    struct UserObject *inho131 = (struct UserObject *)inheritingObject131;
    while (inho131->super != GraceDefaultObject) inho131 = (struct UserObject *)inho131->super;
    inho131->super = obj131;
    self = inheritingObject131;
    *selfslot = self;
    lowerouter131 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter131;
  }
// method new
  block_savedest(obj131);
  Object closure133 = createclosure(1, "new");
  setclosureframe(closure133, stackframe);
  addtoclosure(closure133, var_Token);
  struct UserObject *uo133 = (struct UserObject*)obj131;
  uo133->data[1] = (Object)closure133;
  Method *meth_meth_lexer_new133 = addmethod2pos(obj131, "new", &meth_lexer_new133, 1);
  int argcv_meth_lexer_new133[] = {1};
  meth_meth_lexer_new133->type = alloc_MethodType(1, argcv_meth_lexer_new133);
  meth_meth_lexer_new133->definitionModule = modulename;
  meth_meth_lexer_new133->definitionLine = 69;
  block_savedest(obj131);
  Object closure148 = createclosure(1, "new()object");
  setclosureframe(closure148, stackframe);
  addtoclosure(closure148, var_Token);
  Method *meth_meth_lexer_new133_object = addmethod2pos(obj131, "new()object", &meth_lexer_new133_object, 1);
  meth_meth_lexer_new133_object->definitionModule = modulename;
  meth_meth_lexer_new133_object->definitionLine = 69;
  sourceObject = obj131;
objclass131 = obj131->class;
  objclass131->definitionModule = modulename;
  objclass131->definitionLine = 69;
  (*(struct UserObject *)self).data[0] = lowerouter131;
  self = oldself131;
  selfslot = oldselfslot131;
  stackframe = oldstackframe131;
// compiled object node returning obj131 (depth = 5)
  *var_CommentToken = obj131;
  if (obj131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject149 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj149 = alloc_userobj2(2,4, objclass149);
  gc_frame_newslot(obj149);
// OBJECT OUTER DEC outer
  adddatum2(obj149, self, 0);
  addmethodreal(obj149,"outer", &reader_lexer_outer_150);
  Object oldself149 = self;
  struct StackFrameObject *oldstackframe149 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe149);
  gc_frame_newslot((Object)stackframe);
  self = obj149;
  Object *oldselfslot149 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter149 = (*(struct UserObject *)self).data[0], lowerouter149 = thisouter149;
  if (inheritingObject149) {
    struct UserObject *inho149 = (struct UserObject *)inheritingObject149;
    while (inho149->super != GraceDefaultObject) inho149 = (struct UserObject *)inho149->super;
    inho149->super = obj149;
    self = inheritingObject149;
    *selfslot = self;
    lowerouter149 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter149;
  }
// method new
  block_savedest(obj149);
  Object closure151 = createclosure(1, "new");
  setclosureframe(closure151, stackframe);
  addtoclosure(closure151, var_Token);
  struct UserObject *uo151 = (struct UserObject*)obj149;
  uo151->data[1] = (Object)closure151;
  Method *meth_meth_lexer_new151 = addmethod2pos(obj149, "new", &meth_lexer_new151, 1);
  int argcv_meth_lexer_new151[] = {0};
  meth_meth_lexer_new151->type = alloc_MethodType(1, argcv_meth_lexer_new151);
  meth_meth_lexer_new151->definitionModule = modulename;
  meth_meth_lexer_new151->definitionLine = 75;
  block_savedest(obj149);
  Object closure162 = createclosure(1, "new()object");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_Token);
  Method *meth_meth_lexer_new151_object = addmethod2pos(obj149, "new()object", &meth_lexer_new151_object, 1);
  meth_meth_lexer_new151_object->definitionModule = modulename;
  meth_meth_lexer_new151_object->definitionLine = 75;
  sourceObject = obj149;
objclass149 = obj149->class;
  objclass149->definitionModule = modulename;
  objclass149->definitionLine = 75;
  (*(struct UserObject *)self).data[0] = lowerouter149;
  self = oldself149;
  selfslot = oldselfslot149;
  stackframe = oldstackframe149;
// compiled object node returning obj149 (depth = 5)
  *var_LBraceToken = obj149;
  if (obj149 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject163 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj163 = alloc_userobj2(2,4, objclass163);
  gc_frame_newslot(obj163);
// OBJECT OUTER DEC outer
  adddatum2(obj163, self, 0);
  addmethodreal(obj163,"outer", &reader_lexer_outer_164);
  Object oldself163 = self;
  struct StackFrameObject *oldstackframe163 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe163);
  gc_frame_newslot((Object)stackframe);
  self = obj163;
  Object *oldselfslot163 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter163 = (*(struct UserObject *)self).data[0], lowerouter163 = thisouter163;
  if (inheritingObject163) {
    struct UserObject *inho163 = (struct UserObject *)inheritingObject163;
    while (inho163->super != GraceDefaultObject) inho163 = (struct UserObject *)inho163->super;
    inho163->super = obj163;
    self = inheritingObject163;
    *selfslot = self;
    lowerouter163 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter163;
  }
// method new
  block_savedest(obj163);
  Object closure165 = createclosure(1, "new");
  setclosureframe(closure165, stackframe);
  addtoclosure(closure165, var_Token);
  struct UserObject *uo165 = (struct UserObject*)obj163;
  uo165->data[1] = (Object)closure165;
  Method *meth_meth_lexer_new165 = addmethod2pos(obj163, "new", &meth_lexer_new165, 1);
  int argcv_meth_lexer_new165[] = {0};
  meth_meth_lexer_new165->type = alloc_MethodType(1, argcv_meth_lexer_new165);
  meth_meth_lexer_new165->definitionModule = modulename;
  meth_meth_lexer_new165->definitionLine = 81;
  block_savedest(obj163);
  Object closure176 = createclosure(1, "new()object");
  setclosureframe(closure176, stackframe);
  addtoclosure(closure176, var_Token);
  Method *meth_meth_lexer_new165_object = addmethod2pos(obj163, "new()object", &meth_lexer_new165_object, 1);
  meth_meth_lexer_new165_object->definitionModule = modulename;
  meth_meth_lexer_new165_object->definitionLine = 81;
  sourceObject = obj163;
objclass163 = obj163->class;
  objclass163->definitionModule = modulename;
  objclass163->definitionLine = 81;
  (*(struct UserObject *)self).data[0] = lowerouter163;
  self = oldself163;
  selfslot = oldselfslot163;
  stackframe = oldstackframe163;
// compiled object node returning obj163 (depth = 5)
  *var_RBraceToken = obj163;
  if (obj163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject177 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj177 = alloc_userobj2(2,4, objclass177);
  gc_frame_newslot(obj177);
// OBJECT OUTER DEC outer
  adddatum2(obj177, self, 0);
  addmethodreal(obj177,"outer", &reader_lexer_outer_178);
  Object oldself177 = self;
  struct StackFrameObject *oldstackframe177 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe177);
  gc_frame_newslot((Object)stackframe);
  self = obj177;
  Object *oldselfslot177 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter177 = (*(struct UserObject *)self).data[0], lowerouter177 = thisouter177;
  if (inheritingObject177) {
    struct UserObject *inho177 = (struct UserObject *)inheritingObject177;
    while (inho177->super != GraceDefaultObject) inho177 = (struct UserObject *)inho177->super;
    inho177->super = obj177;
    self = inheritingObject177;
    *selfslot = self;
    lowerouter177 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter177;
  }
// method new
  block_savedest(obj177);
  Object closure179 = createclosure(1, "new");
  setclosureframe(closure179, stackframe);
  addtoclosure(closure179, var_Token);
  struct UserObject *uo179 = (struct UserObject*)obj177;
  uo179->data[1] = (Object)closure179;
  Method *meth_meth_lexer_new179 = addmethod2pos(obj177, "new", &meth_lexer_new179, 1);
  int argcv_meth_lexer_new179[] = {0};
  meth_meth_lexer_new179->type = alloc_MethodType(1, argcv_meth_lexer_new179);
  meth_meth_lexer_new179->definitionModule = modulename;
  meth_meth_lexer_new179->definitionLine = 87;
  block_savedest(obj177);
  Object closure190 = createclosure(1, "new()object");
  setclosureframe(closure190, stackframe);
  addtoclosure(closure190, var_Token);
  Method *meth_meth_lexer_new179_object = addmethod2pos(obj177, "new()object", &meth_lexer_new179_object, 1);
  meth_meth_lexer_new179_object->definitionModule = modulename;
  meth_meth_lexer_new179_object->definitionLine = 87;
  sourceObject = obj177;
objclass177 = obj177->class;
  objclass177->definitionModule = modulename;
  objclass177->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter177;
  self = oldself177;
  selfslot = oldselfslot177;
  stackframe = oldstackframe177;
// compiled object node returning obj177 (depth = 5)
  *var_LParenToken = obj177;
  if (obj177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj191 = alloc_userobj2(2,4, objclass191);
  gc_frame_newslot(obj191);
// OBJECT OUTER DEC outer
  adddatum2(obj191, self, 0);
  addmethodreal(obj191,"outer", &reader_lexer_outer_192);
  Object oldself191 = self;
  struct StackFrameObject *oldstackframe191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe191);
  gc_frame_newslot((Object)stackframe);
  self = obj191;
  Object *oldselfslot191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter191 = (*(struct UserObject *)self).data[0], lowerouter191 = thisouter191;
  if (inheritingObject191) {
    struct UserObject *inho191 = (struct UserObject *)inheritingObject191;
    while (inho191->super != GraceDefaultObject) inho191 = (struct UserObject *)inho191->super;
    inho191->super = obj191;
    self = inheritingObject191;
    *selfslot = self;
    lowerouter191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter191;
  }
// method new
  block_savedest(obj191);
  Object closure193 = createclosure(1, "new");
  setclosureframe(closure193, stackframe);
  addtoclosure(closure193, var_Token);
  struct UserObject *uo193 = (struct UserObject*)obj191;
  uo193->data[1] = (Object)closure193;
  Method *meth_meth_lexer_new193 = addmethod2pos(obj191, "new", &meth_lexer_new193, 1);
  int argcv_meth_lexer_new193[] = {0};
  meth_meth_lexer_new193->type = alloc_MethodType(1, argcv_meth_lexer_new193);
  meth_meth_lexer_new193->definitionModule = modulename;
  meth_meth_lexer_new193->definitionLine = 93;
  block_savedest(obj191);
  Object closure204 = createclosure(1, "new()object");
  setclosureframe(closure204, stackframe);
  addtoclosure(closure204, var_Token);
  Method *meth_meth_lexer_new193_object = addmethod2pos(obj191, "new()object", &meth_lexer_new193_object, 1);
  meth_meth_lexer_new193_object->definitionModule = modulename;
  meth_meth_lexer_new193_object->definitionLine = 93;
  sourceObject = obj191;
objclass191 = obj191->class;
  objclass191->definitionModule = modulename;
  objclass191->definitionLine = 93;
  (*(struct UserObject *)self).data[0] = lowerouter191;
  self = oldself191;
  selfslot = oldselfslot191;
  stackframe = oldstackframe191;
// compiled object node returning obj191 (depth = 5)
  *var_RParenToken = obj191;
  if (obj191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject205 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj205 = alloc_userobj2(2,4, objclass205);
  gc_frame_newslot(obj205);
// OBJECT OUTER DEC outer
  adddatum2(obj205, self, 0);
  addmethodreal(obj205,"outer", &reader_lexer_outer_206);
  Object oldself205 = self;
  struct StackFrameObject *oldstackframe205 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe205);
  gc_frame_newslot((Object)stackframe);
  self = obj205;
  Object *oldselfslot205 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter205 = (*(struct UserObject *)self).data[0], lowerouter205 = thisouter205;
  if (inheritingObject205) {
    struct UserObject *inho205 = (struct UserObject *)inheritingObject205;
    while (inho205->super != GraceDefaultObject) inho205 = (struct UserObject *)inho205->super;
    inho205->super = obj205;
    self = inheritingObject205;
    *selfslot = self;
    lowerouter205 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter205;
  }
// method new
  block_savedest(obj205);
  Object closure207 = createclosure(1, "new");
  setclosureframe(closure207, stackframe);
  addtoclosure(closure207, var_Token);
  struct UserObject *uo207 = (struct UserObject*)obj205;
  uo207->data[1] = (Object)closure207;
  Method *meth_meth_lexer_new207 = addmethod2pos(obj205, "new", &meth_lexer_new207, 1);
  int argcv_meth_lexer_new207[] = {0};
  meth_meth_lexer_new207->type = alloc_MethodType(1, argcv_meth_lexer_new207);
  meth_meth_lexer_new207->definitionModule = modulename;
  meth_meth_lexer_new207->definitionLine = 99;
  block_savedest(obj205);
  Object closure218 = createclosure(1, "new()object");
  setclosureframe(closure218, stackframe);
  addtoclosure(closure218, var_Token);
  Method *meth_meth_lexer_new207_object = addmethod2pos(obj205, "new()object", &meth_lexer_new207_object, 1);
  meth_meth_lexer_new207_object->definitionModule = modulename;
  meth_meth_lexer_new207_object->definitionLine = 99;
  sourceObject = obj205;
objclass205 = obj205->class;
  objclass205->definitionModule = modulename;
  objclass205->definitionLine = 99;
  (*(struct UserObject *)self).data[0] = lowerouter205;
  self = oldself205;
  selfslot = oldselfslot205;
  stackframe = oldstackframe205;
// compiled object node returning obj205 (depth = 5)
  *var_LSquareToken = obj205;
  if (obj205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject219 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj219 = alloc_userobj2(2,4, objclass219);
  gc_frame_newslot(obj219);
// OBJECT OUTER DEC outer
  adddatum2(obj219, self, 0);
  addmethodreal(obj219,"outer", &reader_lexer_outer_220);
  Object oldself219 = self;
  struct StackFrameObject *oldstackframe219 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe219);
  gc_frame_newslot((Object)stackframe);
  self = obj219;
  Object *oldselfslot219 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter219 = (*(struct UserObject *)self).data[0], lowerouter219 = thisouter219;
  if (inheritingObject219) {
    struct UserObject *inho219 = (struct UserObject *)inheritingObject219;
    while (inho219->super != GraceDefaultObject) inho219 = (struct UserObject *)inho219->super;
    inho219->super = obj219;
    self = inheritingObject219;
    *selfslot = self;
    lowerouter219 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter219;
  }
// method new
  block_savedest(obj219);
  Object closure221 = createclosure(1, "new");
  setclosureframe(closure221, stackframe);
  addtoclosure(closure221, var_Token);
  struct UserObject *uo221 = (struct UserObject*)obj219;
  uo221->data[1] = (Object)closure221;
  Method *meth_meth_lexer_new221 = addmethod2pos(obj219, "new", &meth_lexer_new221, 1);
  int argcv_meth_lexer_new221[] = {0};
  meth_meth_lexer_new221->type = alloc_MethodType(1, argcv_meth_lexer_new221);
  meth_meth_lexer_new221->definitionModule = modulename;
  meth_meth_lexer_new221->definitionLine = 105;
  block_savedest(obj219);
  Object closure232 = createclosure(1, "new()object");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_Token);
  Method *meth_meth_lexer_new221_object = addmethod2pos(obj219, "new()object", &meth_lexer_new221_object, 1);
  meth_meth_lexer_new221_object->definitionModule = modulename;
  meth_meth_lexer_new221_object->definitionLine = 105;
  sourceObject = obj219;
objclass219 = obj219->class;
  objclass219->definitionModule = modulename;
  objclass219->definitionLine = 105;
  (*(struct UserObject *)self).data[0] = lowerouter219;
  self = oldself219;
  selfslot = oldselfslot219;
  stackframe = oldstackframe219;
// compiled object node returning obj219 (depth = 5)
  *var_RSquareToken = obj219;
  if (obj219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject233 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj233 = alloc_userobj2(2,4, objclass233);
  gc_frame_newslot(obj233);
// OBJECT OUTER DEC outer
  adddatum2(obj233, self, 0);
  addmethodreal(obj233,"outer", &reader_lexer_outer_234);
  Object oldself233 = self;
  struct StackFrameObject *oldstackframe233 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe233);
  gc_frame_newslot((Object)stackframe);
  self = obj233;
  Object *oldselfslot233 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter233 = (*(struct UserObject *)self).data[0], lowerouter233 = thisouter233;
  if (inheritingObject233) {
    struct UserObject *inho233 = (struct UserObject *)inheritingObject233;
    while (inho233->super != GraceDefaultObject) inho233 = (struct UserObject *)inho233->super;
    inho233->super = obj233;
    self = inheritingObject233;
    *selfslot = self;
    lowerouter233 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter233;
  }
// method new
  block_savedest(obj233);
  Object closure235 = createclosure(1, "new");
  setclosureframe(closure235, stackframe);
  addtoclosure(closure235, var_Token);
  struct UserObject *uo235 = (struct UserObject*)obj233;
  uo235->data[1] = (Object)closure235;
  Method *meth_meth_lexer_new235 = addmethod2pos(obj233, "new", &meth_lexer_new235, 1);
  int argcv_meth_lexer_new235[] = {0};
  meth_meth_lexer_new235->type = alloc_MethodType(1, argcv_meth_lexer_new235);
  meth_meth_lexer_new235->definitionModule = modulename;
  meth_meth_lexer_new235->definitionLine = 111;
  block_savedest(obj233);
  Object closure246 = createclosure(1, "new()object");
  setclosureframe(closure246, stackframe);
  addtoclosure(closure246, var_Token);
  Method *meth_meth_lexer_new235_object = addmethod2pos(obj233, "new()object", &meth_lexer_new235_object, 1);
  meth_meth_lexer_new235_object->definitionModule = modulename;
  meth_meth_lexer_new235_object->definitionLine = 111;
  sourceObject = obj233;
objclass233 = obj233->class;
  objclass233->definitionModule = modulename;
  objclass233->definitionLine = 111;
  (*(struct UserObject *)self).data[0] = lowerouter233;
  self = oldself233;
  selfslot = oldselfslot233;
  stackframe = oldstackframe233;
// compiled object node returning obj233 (depth = 5)
  *var_CommaToken = obj233;
  if (obj233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj247 = alloc_userobj2(2,4, objclass247);
  gc_frame_newslot(obj247);
// OBJECT OUTER DEC outer
  adddatum2(obj247, self, 0);
  addmethodreal(obj247,"outer", &reader_lexer_outer_248);
  Object oldself247 = self;
  struct StackFrameObject *oldstackframe247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe247);
  gc_frame_newslot((Object)stackframe);
  self = obj247;
  Object *oldselfslot247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter247 = (*(struct UserObject *)self).data[0], lowerouter247 = thisouter247;
  if (inheritingObject247) {
    struct UserObject *inho247 = (struct UserObject *)inheritingObject247;
    while (inho247->super != GraceDefaultObject) inho247 = (struct UserObject *)inho247->super;
    inho247->super = obj247;
    self = inheritingObject247;
    *selfslot = self;
    lowerouter247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter247;
  }
// method new
  block_savedest(obj247);
  Object closure249 = createclosure(1, "new");
  setclosureframe(closure249, stackframe);
  addtoclosure(closure249, var_Token);
  struct UserObject *uo249 = (struct UserObject*)obj247;
  uo249->data[1] = (Object)closure249;
  Method *meth_meth_lexer_new249 = addmethod2pos(obj247, "new", &meth_lexer_new249, 1);
  int argcv_meth_lexer_new249[] = {0};
  meth_meth_lexer_new249->type = alloc_MethodType(1, argcv_meth_lexer_new249);
  meth_meth_lexer_new249->definitionModule = modulename;
  meth_meth_lexer_new249->definitionLine = 117;
  block_savedest(obj247);
  Object closure260 = createclosure(1, "new()object");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_Token);
  Method *meth_meth_lexer_new249_object = addmethod2pos(obj247, "new()object", &meth_lexer_new249_object, 1);
  meth_meth_lexer_new249_object->definitionModule = modulename;
  meth_meth_lexer_new249_object->definitionLine = 117;
  sourceObject = obj247;
objclass247 = obj247->class;
  objclass247->definitionModule = modulename;
  objclass247->definitionLine = 117;
  (*(struct UserObject *)self).data[0] = lowerouter247;
  self = oldself247;
  selfslot = oldselfslot247;
  stackframe = oldstackframe247;
// compiled object node returning obj247 (depth = 5)
  *var_ColonToken = obj247;
  if (obj247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject261 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj261 = alloc_userobj2(2,4, objclass261);
  gc_frame_newslot(obj261);
// OBJECT OUTER DEC outer
  adddatum2(obj261, self, 0);
  addmethodreal(obj261,"outer", &reader_lexer_outer_262);
  Object oldself261 = self;
  struct StackFrameObject *oldstackframe261 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe261);
  gc_frame_newslot((Object)stackframe);
  self = obj261;
  Object *oldselfslot261 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter261 = (*(struct UserObject *)self).data[0], lowerouter261 = thisouter261;
  if (inheritingObject261) {
    struct UserObject *inho261 = (struct UserObject *)inheritingObject261;
    while (inho261->super != GraceDefaultObject) inho261 = (struct UserObject *)inho261->super;
    inho261->super = obj261;
    self = inheritingObject261;
    *selfslot = self;
    lowerouter261 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter261;
  }
// method new
  block_savedest(obj261);
  Object closure263 = createclosure(1, "new");
  setclosureframe(closure263, stackframe);
  addtoclosure(closure263, var_Token);
  struct UserObject *uo263 = (struct UserObject*)obj261;
  uo263->data[1] = (Object)closure263;
  Method *meth_meth_lexer_new263 = addmethod2pos(obj261, "new", &meth_lexer_new263, 1);
  int argcv_meth_lexer_new263[] = {0};
  meth_meth_lexer_new263->type = alloc_MethodType(1, argcv_meth_lexer_new263);
  meth_meth_lexer_new263->definitionModule = modulename;
  meth_meth_lexer_new263->definitionLine = 123;
  block_savedest(obj261);
  Object closure274 = createclosure(1, "new()object");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_Token);
  Method *meth_meth_lexer_new263_object = addmethod2pos(obj261, "new()object", &meth_lexer_new263_object, 1);
  meth_meth_lexer_new263_object->definitionModule = modulename;
  meth_meth_lexer_new263_object->definitionLine = 123;
  sourceObject = obj261;
objclass261 = obj261->class;
  objclass261->definitionModule = modulename;
  objclass261->definitionLine = 123;
  (*(struct UserObject *)self).data[0] = lowerouter261;
  self = oldself261;
  selfslot = oldselfslot261;
  stackframe = oldstackframe261;
// compiled object node returning obj261 (depth = 5)
  *var_DotToken = obj261;
  if (obj261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj275 = alloc_userobj2(2,4, objclass275);
  gc_frame_newslot(obj275);
// OBJECT OUTER DEC outer
  adddatum2(obj275, self, 0);
  addmethodreal(obj275,"outer", &reader_lexer_outer_276);
  Object oldself275 = self;
  struct StackFrameObject *oldstackframe275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe275);
  gc_frame_newslot((Object)stackframe);
  self = obj275;
  Object *oldselfslot275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter275 = (*(struct UserObject *)self).data[0], lowerouter275 = thisouter275;
  if (inheritingObject275) {
    struct UserObject *inho275 = (struct UserObject *)inheritingObject275;
    while (inho275->super != GraceDefaultObject) inho275 = (struct UserObject *)inho275->super;
    inho275->super = obj275;
    self = inheritingObject275;
    *selfslot = self;
    lowerouter275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter275;
  }
// method new
  block_savedest(obj275);
  Object closure277 = createclosure(3, "new");
  setclosureframe(closure277, stackframe);
  addtoclosure(closure277, var_Token);
  addtoclosure(closure277, var_startPosition);
  addtoclosure(closure277, var_linePosition);
  struct UserObject *uo277 = (struct UserObject*)obj275;
  uo277->data[1] = (Object)closure277;
  Method *meth_meth_lexer_new277 = addmethod2pos(obj275, "new", &meth_lexer_new277, 1);
  int argcv_meth_lexer_new277[] = {2};
  meth_meth_lexer_new277->type = alloc_MethodType(1, argcv_meth_lexer_new277);
  meth_meth_lexer_new277->definitionModule = modulename;
  meth_meth_lexer_new277->definitionLine = 129;
  block_savedest(obj275);
  Object closure290 = createclosure(3, "new()object");
  setclosureframe(closure290, stackframe);
  addtoclosure(closure290, var_Token);
  addtoclosure(closure290, var_startPosition);
  addtoclosure(closure290, var_linePosition);
  Method *meth_meth_lexer_new277_object = addmethod2pos(obj275, "new()object", &meth_lexer_new277_object, 1);
  meth_meth_lexer_new277_object->definitionModule = modulename;
  meth_meth_lexer_new277_object->definitionLine = 129;
  sourceObject = obj275;
objclass275 = obj275->class;
  objclass275->definitionModule = modulename;
  objclass275->definitionLine = 129;
  (*(struct UserObject *)self).data[0] = lowerouter275;
  self = oldself275;
  selfslot = oldselfslot275;
  stackframe = oldstackframe275;
// compiled object node returning obj275 (depth = 5)
  *var_NumToken = obj275;
  if (obj275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject291 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj291 = alloc_userobj2(2,4, objclass291);
  gc_frame_newslot(obj291);
// OBJECT OUTER DEC outer
  adddatum2(obj291, self, 0);
  addmethodreal(obj291,"outer", &reader_lexer_outer_292);
  Object oldself291 = self;
  struct StackFrameObject *oldstackframe291 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe291);
  gc_frame_newslot((Object)stackframe);
  self = obj291;
  Object *oldselfslot291 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter291 = (*(struct UserObject *)self).data[0], lowerouter291 = thisouter291;
  if (inheritingObject291) {
    struct UserObject *inho291 = (struct UserObject *)inheritingObject291;
    while (inho291->super != GraceDefaultObject) inho291 = (struct UserObject *)inho291->super;
    inho291->super = obj291;
    self = inheritingObject291;
    *selfslot = self;
    lowerouter291 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter291;
  }
// method new
  block_savedest(obj291);
  Object closure293 = createclosure(1, "new");
  setclosureframe(closure293, stackframe);
  addtoclosure(closure293, var_Token);
  struct UserObject *uo293 = (struct UserObject*)obj291;
  uo293->data[1] = (Object)closure293;
  Method *meth_meth_lexer_new293 = addmethod2pos(obj291, "new", &meth_lexer_new293, 1);
  int argcv_meth_lexer_new293[] = {1};
  meth_meth_lexer_new293->type = alloc_MethodType(1, argcv_meth_lexer_new293);
  meth_meth_lexer_new293->definitionModule = modulename;
  meth_meth_lexer_new293->definitionLine = 136;
  block_savedest(obj291);
  Object closure304 = createclosure(1, "new()object");
  setclosureframe(closure304, stackframe);
  addtoclosure(closure304, var_Token);
  Method *meth_meth_lexer_new293_object = addmethod2pos(obj291, "new()object", &meth_lexer_new293_object, 1);
  meth_meth_lexer_new293_object->definitionModule = modulename;
  meth_meth_lexer_new293_object->definitionLine = 136;
  sourceObject = obj291;
objclass291 = obj291->class;
  objclass291->definitionModule = modulename;
  objclass291->definitionLine = 136;
  (*(struct UserObject *)self).data[0] = lowerouter291;
  self = oldself291;
  selfslot = oldselfslot291;
  stackframe = oldstackframe291;
// compiled object node returning obj291 (depth = 5)
  *var_KeywordToken = obj291;
  if (obj291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject305 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj305 = alloc_userobj2(2,4, objclass305);
  gc_frame_newslot(obj305);
// OBJECT OUTER DEC outer
  adddatum2(obj305, self, 0);
  addmethodreal(obj305,"outer", &reader_lexer_outer_306);
  Object oldself305 = self;
  struct StackFrameObject *oldstackframe305 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe305);
  gc_frame_newslot((Object)stackframe);
  self = obj305;
  Object *oldselfslot305 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter305 = (*(struct UserObject *)self).data[0], lowerouter305 = thisouter305;
  if (inheritingObject305) {
    struct UserObject *inho305 = (struct UserObject *)inheritingObject305;
    while (inho305->super != GraceDefaultObject) inho305 = (struct UserObject *)inho305->super;
    inho305->super = obj305;
    self = inheritingObject305;
    *selfslot = self;
    lowerouter305 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter305;
  }
// method new
  block_savedest(obj305);
  Object closure307 = createclosure(1, "new");
  setclosureframe(closure307, stackframe);
  addtoclosure(closure307, var_Token);
  struct UserObject *uo307 = (struct UserObject*)obj305;
  uo307->data[1] = (Object)closure307;
  Method *meth_meth_lexer_new307 = addmethod2pos(obj305, "new", &meth_lexer_new307, 1);
  int argcv_meth_lexer_new307[] = {1};
  meth_meth_lexer_new307->type = alloc_MethodType(1, argcv_meth_lexer_new307);
  meth_meth_lexer_new307->definitionModule = modulename;
  meth_meth_lexer_new307->definitionLine = 142;
  block_savedest(obj305);
  Object closure318 = createclosure(1, "new()object");
  setclosureframe(closure318, stackframe);
  addtoclosure(closure318, var_Token);
  Method *meth_meth_lexer_new307_object = addmethod2pos(obj305, "new()object", &meth_lexer_new307_object, 1);
  meth_meth_lexer_new307_object->definitionModule = modulename;
  meth_meth_lexer_new307_object->definitionLine = 142;
  sourceObject = obj305;
objclass305 = obj305->class;
  objclass305->definitionModule = modulename;
  objclass305->definitionLine = 142;
  (*(struct UserObject *)self).data[0] = lowerouter305;
  self = oldself305;
  selfslot = oldselfslot305;
  stackframe = oldstackframe305;
// compiled object node returning obj305 (depth = 5)
  *var_OpToken = obj305;
  if (obj305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject319 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj319 = alloc_userobj2(2,4, objclass319);
  gc_frame_newslot(obj319);
// OBJECT OUTER DEC outer
  adddatum2(obj319, self, 0);
  addmethodreal(obj319,"outer", &reader_lexer_outer_320);
  Object oldself319 = self;
  struct StackFrameObject *oldstackframe319 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe319);
  gc_frame_newslot((Object)stackframe);
  self = obj319;
  Object *oldselfslot319 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter319 = (*(struct UserObject *)self).data[0], lowerouter319 = thisouter319;
  if (inheritingObject319) {
    struct UserObject *inho319 = (struct UserObject *)inheritingObject319;
    while (inho319->super != GraceDefaultObject) inho319 = (struct UserObject *)inho319->super;
    inho319->super = obj319;
    self = inheritingObject319;
    *selfslot = self;
    lowerouter319 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter319;
  }
// method new
  block_savedest(obj319);
  Object closure321 = createclosure(1, "new");
  setclosureframe(closure321, stackframe);
  addtoclosure(closure321, var_Token);
  struct UserObject *uo321 = (struct UserObject*)obj319;
  uo321->data[1] = (Object)closure321;
  Method *meth_meth_lexer_new321 = addmethod2pos(obj319, "new", &meth_lexer_new321, 1);
  int argcv_meth_lexer_new321[] = {0};
  meth_meth_lexer_new321->type = alloc_MethodType(1, argcv_meth_lexer_new321);
  meth_meth_lexer_new321->definitionModule = modulename;
  meth_meth_lexer_new321->definitionLine = 148;
  block_savedest(obj319);
  Object closure332 = createclosure(1, "new()object");
  setclosureframe(closure332, stackframe);
  addtoclosure(closure332, var_Token);
  Method *meth_meth_lexer_new321_object = addmethod2pos(obj319, "new()object", &meth_lexer_new321_object, 1);
  meth_meth_lexer_new321_object->definitionModule = modulename;
  meth_meth_lexer_new321_object->definitionLine = 148;
  sourceObject = obj319;
objclass319 = obj319->class;
  objclass319->definitionModule = modulename;
  objclass319->definitionLine = 148;
  (*(struct UserObject *)self).data[0] = lowerouter319;
  self = oldself319;
  selfslot = oldselfslot319;
  stackframe = oldstackframe319;
// compiled object node returning obj319 (depth = 5)
  *var_ArrowToken = obj319;
  if (obj319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj333 = alloc_userobj2(2,4, objclass333);
  gc_frame_newslot(obj333);
// OBJECT OUTER DEC outer
  adddatum2(obj333, self, 0);
  addmethodreal(obj333,"outer", &reader_lexer_outer_334);
  Object oldself333 = self;
  struct StackFrameObject *oldstackframe333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe333);
  gc_frame_newslot((Object)stackframe);
  self = obj333;
  Object *oldselfslot333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter333 = (*(struct UserObject *)self).data[0], lowerouter333 = thisouter333;
  if (inheritingObject333) {
    struct UserObject *inho333 = (struct UserObject *)inheritingObject333;
    while (inho333->super != GraceDefaultObject) inho333 = (struct UserObject *)inho333->super;
    inho333->super = obj333;
    self = inheritingObject333;
    *selfslot = self;
    lowerouter333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter333;
  }
// method new
  block_savedest(obj333);
  Object closure335 = createclosure(1, "new");
  setclosureframe(closure335, stackframe);
  addtoclosure(closure335, var_Token);
  struct UserObject *uo335 = (struct UserObject*)obj333;
  uo335->data[1] = (Object)closure335;
  Method *meth_meth_lexer_new335 = addmethod2pos(obj333, "new", &meth_lexer_new335, 1);
  int argcv_meth_lexer_new335[] = {0};
  meth_meth_lexer_new335->type = alloc_MethodType(1, argcv_meth_lexer_new335);
  meth_meth_lexer_new335->definitionModule = modulename;
  meth_meth_lexer_new335->definitionLine = 154;
  block_savedest(obj333);
  Object closure346 = createclosure(1, "new()object");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_Token);
  Method *meth_meth_lexer_new335_object = addmethod2pos(obj333, "new()object", &meth_lexer_new335_object, 1);
  meth_meth_lexer_new335_object->definitionModule = modulename;
  meth_meth_lexer_new335_object->definitionLine = 154;
  sourceObject = obj333;
objclass333 = obj333->class;
  objclass333->definitionModule = modulename;
  objclass333->definitionLine = 154;
  (*(struct UserObject *)self).data[0] = lowerouter333;
  self = oldself333;
  selfslot = oldselfslot333;
  stackframe = oldstackframe333;
// compiled object node returning obj333 (depth = 5)
  *var_BindToken = obj333;
  if (obj333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(2,4, objclass347);
  gc_frame_newslot(obj347);
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_lexer_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
// method new
  block_savedest(obj347);
  Object closure349 = createclosure(1, "new");
  setclosureframe(closure349, stackframe);
  addtoclosure(closure349, var_Token);
  struct UserObject *uo349 = (struct UserObject*)obj347;
  uo349->data[1] = (Object)closure349;
  Method *meth_meth_lexer_new349 = addmethod2pos(obj347, "new", &meth_lexer_new349, 1);
  int argcv_meth_lexer_new349[] = {0};
  meth_meth_lexer_new349->type = alloc_MethodType(1, argcv_meth_lexer_new349);
  meth_meth_lexer_new349->definitionModule = modulename;
  meth_meth_lexer_new349->definitionLine = 160;
  block_savedest(obj347);
  Object closure360 = createclosure(1, "new()object");
  setclosureframe(closure360, stackframe);
  addtoclosure(closure360, var_Token);
  Method *meth_meth_lexer_new349_object = addmethod2pos(obj347, "new()object", &meth_lexer_new349_object, 1);
  meth_meth_lexer_new349_object->definitionModule = modulename;
  meth_meth_lexer_new349_object->definitionLine = 160;
  sourceObject = obj347;
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 160;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
// compiled object node returning obj347 (depth = 5)
  *var_SemicolonToken = obj347;
  if (obj347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject361 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj361 = alloc_userobj2(2,4, objclass361);
  gc_frame_newslot(obj361);
// OBJECT OUTER DEC outer
  adddatum2(obj361, self, 0);
  addmethodreal(obj361,"outer", &reader_lexer_outer_362);
  Object oldself361 = self;
  struct StackFrameObject *oldstackframe361 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe361);
  gc_frame_newslot((Object)stackframe);
  self = obj361;
  Object *oldselfslot361 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter361 = (*(struct UserObject *)self).data[0], lowerouter361 = thisouter361;
  if (inheritingObject361) {
    struct UserObject *inho361 = (struct UserObject *)inheritingObject361;
    while (inho361->super != GraceDefaultObject) inho361 = (struct UserObject *)inho361->super;
    inho361->super = obj361;
    self = inheritingObject361;
    *selfslot = self;
    lowerouter361 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter361;
  }
// method new
  block_savedest(obj361);
  Object closure363 = createclosure(1, "new");
  setclosureframe(closure363, stackframe);
  addtoclosure(closure363, var_Token);
  struct UserObject *uo363 = (struct UserObject*)obj361;
  uo363->data[1] = (Object)closure363;
  Method *meth_meth_lexer_new363 = addmethod2pos(obj361, "new", &meth_lexer_new363, 1);
  int argcv_meth_lexer_new363[] = {0};
  meth_meth_lexer_new363->type = alloc_MethodType(1, argcv_meth_lexer_new363);
  meth_meth_lexer_new363->definitionModule = modulename;
  meth_meth_lexer_new363->definitionLine = 166;
  block_savedest(obj361);
  Object closure374 = createclosure(1, "new()object");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_Token);
  Method *meth_meth_lexer_new363_object = addmethod2pos(obj361, "new()object", &meth_lexer_new363_object, 1);
  meth_meth_lexer_new363_object->definitionModule = modulename;
  meth_meth_lexer_new363_object->definitionLine = 166;
  sourceObject = obj361;
objclass361 = obj361->class;
  objclass361->definitionModule = modulename;
  objclass361->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter361;
  self = oldself361;
  selfslot = oldselfslot361;
  stackframe = oldstackframe361;
// compiled object node returning obj361 (depth = 5)
  *var_LGenericToken = obj361;
  if (obj361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject375 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj375 = alloc_userobj2(2,4, objclass375);
  gc_frame_newslot(obj375);
// OBJECT OUTER DEC outer
  adddatum2(obj375, self, 0);
  addmethodreal(obj375,"outer", &reader_lexer_outer_376);
  Object oldself375 = self;
  struct StackFrameObject *oldstackframe375 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe375);
  gc_frame_newslot((Object)stackframe);
  self = obj375;
  Object *oldselfslot375 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter375 = (*(struct UserObject *)self).data[0], lowerouter375 = thisouter375;
  if (inheritingObject375) {
    struct UserObject *inho375 = (struct UserObject *)inheritingObject375;
    while (inho375->super != GraceDefaultObject) inho375 = (struct UserObject *)inho375->super;
    inho375->super = obj375;
    self = inheritingObject375;
    *selfslot = self;
    lowerouter375 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter375;
  }
// method new
  block_savedest(obj375);
  Object closure377 = createclosure(1, "new");
  setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_Token);
  struct UserObject *uo377 = (struct UserObject*)obj375;
  uo377->data[1] = (Object)closure377;
  Method *meth_meth_lexer_new377 = addmethod2pos(obj375, "new", &meth_lexer_new377, 1);
  int argcv_meth_lexer_new377[] = {0};
  meth_meth_lexer_new377->type = alloc_MethodType(1, argcv_meth_lexer_new377);
  meth_meth_lexer_new377->definitionModule = modulename;
  meth_meth_lexer_new377->definitionLine = 172;
  block_savedest(obj375);
  Object closure388 = createclosure(1, "new()object");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_Token);
  Method *meth_meth_lexer_new377_object = addmethod2pos(obj375, "new()object", &meth_lexer_new377_object, 1);
  meth_meth_lexer_new377_object->definitionModule = modulename;
  meth_meth_lexer_new377_object->definitionLine = 172;
  sourceObject = obj375;
objclass375 = obj375->class;
  objclass375->definitionModule = modulename;
  objclass375->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter375;
  self = oldself375;
  selfslot = oldselfslot375;
  stackframe = oldstackframe375;
// compiled object node returning obj375 (depth = 5)
  *var_RGenericToken = obj375;
  if (obj375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject389 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj389 = alloc_userobj2(8,9, objclass389);
  gc_frame_newslot(obj389);
if (objclass389 == NULL) {
  glfree(obj389->class->name);
  obj389->class->name = "obj25.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj389, self, 0);
  addmethodreal(obj389,"outer", &reader_lexer_outer_390);
  Object oldself389 = self;
  struct StackFrameObject *oldstackframe389 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe389);
  gc_frame_newslot((Object)stackframe);
  self = obj389;
  Object *oldselfslot389 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter389 = (*(struct UserObject *)self).data[0], lowerouter389 = thisouter389;
  if (inheritingObject389) {
    struct UserObject *inho389 = (struct UserObject *)inheritingObject389;
    while (inho389->super != GraceDefaultObject) inho389 = (struct UserObject *)inho389->super;
    inho389->super = obj389;
    self = inheritingObject389;
    *selfslot = self;
    lowerouter389 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter389;
  }
// method modechange
  block_savedest(obj389);
  Object closure391 = createclosure(27, "modechange");
  setclosureframe(closure391, stackframe);
  addtoclosure(closure391, var_IdentifierToken);
  addtoclosure(closure391, var_KeywordToken);
  addtoclosure(closure391, var_StringToken);
  addtoclosure(closure391, var_MultiLineStringToken);
  addtoclosure(closure391, var_CommaToken);
  addtoclosure(closure391, var_DotToken);
  addtoclosure(closure391, var_LBraceToken);
  addtoclosure(closure391, var_RBraceToken);
  addtoclosure(closure391, var_LParenToken);
  addtoclosure(closure391, var_RParenToken);
  addtoclosure(closure391, var_LSquareToken);
  addtoclosure(closure391, var_RSquareToken);
  addtoclosure(closure391, var_LGenericToken);
  addtoclosure(closure391, var_RGenericToken);
  addtoclosure(closure391, var_SemicolonToken);
  addtoclosure(closure391, var_NumToken);
  addtoclosure(closure391, var_errormessages);
  addtoclosure(closure391, var_linePosition);
  addtoclosure(closure391, var_lineNumber);
  addtoclosure(closure391, var_OpToken);
  addtoclosure(closure391, var_ArrowToken);
  addtoclosure(closure391, var_BindToken);
  addtoclosure(closure391, var_ColonToken);
  addtoclosure(closure391, var_indentLevel);
  addtoclosure(closure391, var_CommentToken);
  addtoclosure(closure391, var_util);
  addtoclosure(closure391, var_startPosition);
  struct UserObject *uo391 = (struct UserObject*)obj389;
  uo391->data[1] = (Object)closure391;
  Method *meth_meth_lexer_modechange391 = addmethod2pos(obj389, "modechange", &meth_lexer_modechange391, 1);
  int argcv_meth_lexer_modechange391[] = {3};
  meth_meth_lexer_modechange391->type = alloc_MethodType(1, argcv_meth_lexer_modechange391);
  meth_meth_lexer_modechange391->definitionModule = modulename;
  meth_meth_lexer_modechange391->definitionLine = 196;
// method fromBase
  block_savedest(obj389);
  Object closure1129 = createclosure(4, "fromBase");
  setclosureframe(closure1129, stackframe);
  addtoclosure(closure1129, var_errormessages);
  addtoclosure(closure1129, var_linePosition);
  addtoclosure(closure1129, var_lineNumber);
  addtoclosure(closure1129, var_unicode);
  struct UserObject *uo1129 = (struct UserObject*)obj389;
  uo1129->data[2] = (Object)closure1129;
  Method *meth_meth_lexer_fromBase1129 = addmethod2pos(obj389, "fromBase", &meth_lexer_fromBase1129, 2);
  int argcv_meth_lexer_fromBase1129[] = {2};
  meth_meth_lexer_fromBase1129->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1129);
  meth_meth_lexer_fromBase1129->definitionModule = modulename;
  meth_meth_lexer_fromBase1129->definitionLine = 373;
// method hexdecchar
  block_savedest(obj389);
  Object closure1345 = createclosure(3, "hexdecchar");
  setclosureframe(closure1345, stackframe);
  addtoclosure(closure1345, var_lineNumber);
  addtoclosure(closure1345, var_linePosition);
  addtoclosure(closure1345, var_errormessages);
  struct UserObject *uo1345 = (struct UserObject*)obj389;
  uo1345->data[3] = (Object)closure1345;
  Method *meth_meth_lexer_hexdecchar1345 = addmethod2pos(obj389, "hexdecchar", &meth_lexer_hexdecchar1345, 3);
  int argcv_meth_lexer_hexdecchar1345[] = {1};
  meth_meth_lexer_hexdecchar1345->type = alloc_MethodType(1, argcv_meth_lexer_hexdecchar1345);
  meth_meth_lexer_hexdecchar1345->definitionModule = modulename;
  meth_meth_lexer_hexdecchar1345->definitionLine = 415;
// method makeNumToken
  block_savedest(obj389);
  Object closure1423 = createclosure(4, "makeNumToken");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_errormessages);
  addtoclosure(closure1423, var_linePosition);
  addtoclosure(closure1423, var_lineNumber);
  addtoclosure(closure1423, var_NumToken);
  struct UserObject *uo1423 = (struct UserObject*)obj389;
  uo1423->data[4] = (Object)closure1423;
  Method *meth_meth_lexer_makeNumToken1423 = addmethod2pos(obj389, "makeNumToken", &meth_lexer_makeNumToken1423, 4);
  int argcv_meth_lexer_makeNumToken1423[] = {1};
  meth_meth_lexer_makeNumToken1423->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1423);
  meth_meth_lexer_makeNumToken1423->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1423->definitionLine = 433;
// method isidentifierchar
  block_savedest(obj389);
  Object closure1602 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1602, stackframe);
  addtoclosure(closure1602, var_unicode);
  struct UserObject *uo1602 = (struct UserObject*)obj389;
  uo1602->data[5] = (Object)closure1602;
  Method *meth_meth_lexer_isidentifierchar1602 = addmethod2pos(obj389, "isidentifierchar", &meth_lexer_isidentifierchar1602, 5);
  int argcv_meth_lexer_isidentifierchar1602[] = {1};
  meth_meth_lexer_isidentifierchar1602->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1602);
  meth_meth_lexer_isidentifierchar1602->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1602->definitionLine = 478;
// method isoperatorchar
  block_savedest(obj389);
  Object closure1625 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1625, stackframe);
  addtoclosure(closure1625, var_unicode);
  struct UserObject *uo1625 = (struct UserObject*)obj389;
  uo1625->data[6] = (Object)closure1625;
  Method *meth_meth_lexer_isoperatorchar1625 = addmethod2pos(obj389, "isoperatorchar", &meth_lexer_isoperatorchar1625, 6);
  int argcv_meth_lexer_isoperatorchar1625[] = {2};
  meth_meth_lexer_isoperatorchar1625->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1625);
  meth_meth_lexer_isoperatorchar1625->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1625->definitionLine = 494;
// method lexfile
  block_savedest(obj389);
  Object closure1719 = createclosure(1, "lexfile");
  setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, var_util);
  struct UserObject *uo1719 = (struct UserObject*)obj389;
  uo1719->data[7] = (Object)closure1719;
  Method *meth_meth_lexer_lexfile1719 = addmethod2pos(obj389, "lexfile", &meth_lexer_lexfile1719, 7);
  int argcv_meth_lexer_lexfile1719[] = {1};
  meth_meth_lexer_lexfile1719->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1719);
  meth_meth_lexer_lexfile1719->definitionModule = modulename;
  meth_meth_lexer_lexfile1719->definitionLine = 511;
// method lexinput
  block_savedest(obj389);
  Object closure1817 = createclosure(8, "lexinput");
  setclosureframe(closure1817, stackframe);
  addtoclosure(closure1817, var_linePosition);
  addtoclosure(closure1817, var_util);
  addtoclosure(closure1817, var_unicode);
  addtoclosure(closure1817, var_errormessages);
  addtoclosure(closure1817, var_lineNumber);
  addtoclosure(closure1817, var_stringStart);
  addtoclosure(closure1817, var_startLine);
  addtoclosure(closure1817, var_startPosition);
  struct UserObject *uo1817 = (struct UserObject*)obj389;
  uo1817->data[8] = (Object)closure1817;
  Method *meth_meth_lexer_lexinput1817 = addmethod2pos(obj389, "lexinput", &meth_lexer_lexinput1817, 8);
  int argcv_meth_lexer_lexinput1817[] = {1};
  meth_meth_lexer_lexinput1817->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1817);
  meth_meth_lexer_lexinput1817->definitionModule = modulename;
  meth_meth_lexer_lexinput1817->definitionLine = 546;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
  sourceObject = obj389;
objclass389 = obj389->class;
  objclass389->definitionModule = modulename;
  objclass389->definitionLine = 179;
  (*(struct UserObject *)self).data[0] = lowerouter389;
  self = oldself389;
  selfslot = oldselfslot389;
  stackframe = oldstackframe389;
  gc_frame_end(frame);
  return obj389;
}
Object meth_lexer_LexerClass3548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "LexerClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_LexerClass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for LexerClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹LexerClass›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_LexerClass (depth = 3)
  gc_frame_end(frame);
  return *var_LexerClass;
}
Object module_lexer_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(5, 5);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<lexer>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
Object *var_io = alloc_var();
Object *var_sys = alloc_var();
Object *var_util = alloc_var();
Object *var_unicode = alloc_var();
Object *var_collections = alloc_var();
Object *var_errormessages = alloc_var();
  Object *var_LexerClass = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "LexerClass");
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method padl
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = emptyclosure;
  Method *meth_meth_lexer_padl0 = addmethod2pos(self, "padl", &meth_lexer_padl0, 1);
  int argcv_meth_lexer_padl0[] = {3};
  meth_meth_lexer_padl0->type = alloc_MethodType(1, argcv_meth_lexer_padl0);
  meth_meth_lexer_padl0->definitionModule = modulename;
  meth_meth_lexer_padl0->definitionLine = 9;
// compiled method node returning  (depth = 1)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method Lexer
  block_savedest(self);
  Object closure24 = createclosure(1, "Lexer");
  setclosureframe(closure24, stackframe);
  addtoclosure(closure24, var_LexerClass);
  struct UserObject *uo24 = (struct UserObject*)self;
  uo24->data[2] = (Object)closure24;
  Method *meth_meth_lexer_Lexer24 = addmethod2pos(self, "Lexer", &meth_lexer_Lexer24, 2);
  int argcv_meth_lexer_Lexer24[] = {0};
  meth_meth_lexer_Lexer24->type = alloc_MethodType(1, argcv_meth_lexer_Lexer24);
  meth_meth_lexer_Lexer24->definitionModule = modulename;
  meth_meth_lexer_Lexer24->definitionLine = 1098;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of unicode as unicode
  if (module_unicode == NULL)
    module_unicode = dlmodule("unicode");
  *var_unicode = module_unicode;
// compiled import node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = module_errormessages_init();
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject25 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj25 = alloc_userobj2(3,4, objclass25);
  gc_frame_newslot(obj25);
// OBJECT OUTER DEC outer
  adddatum2(obj25, self, 0);
  addmethodreal(obj25,"outer", &reader_lexer_outer_26);
  Object oldself25 = self;
  struct StackFrameObject *oldstackframe25 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe25);
  gc_frame_newslot((Object)stackframe);
  self = obj25;
  Object *oldselfslot25 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter25 = (*(struct UserObject *)self).data[0], lowerouter25 = thisouter25;
  if (inheritingObject25) {
    struct UserObject *inho25 = (struct UserObject *)inheritingObject25;
    while (inho25->super != GraceDefaultObject) inho25 = (struct UserObject *)inho25->super;
    inho25->super = obj25;
    self = inheritingObject25;
    *selfslot = self;
    lowerouter25 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter25;
  }
// method asString
  struct UserObject *uo27 = (struct UserObject*)obj25;
  uo27->data[1] = emptyclosure;
  Method *meth_meth_lexer_asString27 = addmethod2pos(obj25, "asString", &meth_lexer_asString27, 1);
  int argcv_meth_lexer_asString27[] = {0};
  meth_meth_lexer_asString27->type = alloc_MethodType(1, argcv_meth_lexer_asString27);
  meth_meth_lexer_asString27->definitionModule = modulename;
  meth_meth_lexer_asString27->definitionLine = 21;
// method new
  block_savedest(obj25);
  Object closure29 = createclosure(3, "new");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_errormessages);
  addtoclosure(closure29, var_util);
  addtoclosure(closure29, var_unicode);
  struct UserObject *uo29 = (struct UserObject*)obj25;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_lexer_new29 = addmethod2pos(obj25, "new", &meth_lexer_new29, 2);
  int argcv_meth_lexer_new29[] = {0};
  meth_meth_lexer_new29->type = alloc_MethodType(1, argcv_meth_lexer_new29);
  meth_meth_lexer_new29->definitionModule = modulename;
  meth_meth_lexer_new29->definitionLine = 22;
  block_savedest(obj25);
  Object closure3547 = createclosure(3, "new()object");
  setclosureframe(closure3547, stackframe);
  addtoclosure(closure3547, var_errormessages);
  addtoclosure(closure3547, var_util);
  addtoclosure(closure3547, var_unicode);
  Method *meth_meth_lexer_new29_object = addmethod2pos(obj25, "new()object", &meth_lexer_new29_object, 2);
  meth_meth_lexer_new29_object->definitionModule = modulename;
  meth_meth_lexer_new29_object->definitionLine = 22;
  sourceObject = obj25;
  sourceObject = obj25;
objclass25 = obj25->class;
  objclass25->definitionModule = modulename;
  objclass25->definitionLine = 20;
  (*(struct UserObject *)self).data[0] = lowerouter25;
  self = oldself25;
  selfslot = oldselfslot25;
  stackframe = oldstackframe25;
// compiled object node returning obj25 (depth = 2)
  *var_LexerClass = obj25;
  if (obj25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method LexerClass
  block_savedest(self);
  Object closure3548 = createclosure(1, "LexerClass");
  setclosureframe(closure3548, stackframe);
  addtoclosure(closure3548, var_LexerClass);
  struct UserObject *uo3548 = (struct UserObject*)self;
  uo3548->data[3] = (Object)closure3548;
  Method *meth_meth_lexer_LexerClass3548 = addmethod2pos(self, "LexerClass", &meth_lexer_LexerClass3548, 3);
  int argcv_meth_lexer_LexerClass3548[] = {0};
  meth_meth_lexer_LexerClass3548->type = alloc_MethodType(1, argcv_meth_lexer_LexerClass3548);
  meth_meth_lexer_LexerClass3548->definitionModule = modulename;
  meth_meth_lexer_LexerClass3548->definitionLine = 1088;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
